C 	COPYRIGHT (C) 1981 BY BOARD OF TRUSTEES,
C 	LELAND STANFORD JUNIOR UNIVERSITY
C
      SUBROUTINE CORNER (DUMP,NRS,ATRNG)
C
C     SPECIAL TREATMENT FOR SMALL CYCLES: COMPUTE 1,3 DISTANCES
C     USING NON-STANDARD BOND ANGLES.
C
      DIMENSION ATRNG(10)
      LOGICAL DUMP
      INTEGER ATRNG
C
      COMMON /ATOMS/ NAT,ICONN(4,72),NCONN(72),NAMES(72),NCNT(72),
     1 ITYPE(72)
      COMMON /BNDS/ NPNTS,BND(72,72)
C
      DIMENSION LM(2),IK(2)
      EQUIVALENCE (IK(1),II), (IK(2),KK), (LM(1),LL), (LM(2),MM)
C
 3000 DO 3500 J = 1,NRS
      JJ = ATRNG(J)
      LIM = NCONN(JJ)
      IF (LIM.LE.2.AND.NRS.EQ.3) GO TO 3500
C  DO NOT COMPUTE 1,3 DISTANCES ON NON-SUBSTITUTED CY-PROP CORNERS
C  ONLY, BUT COMPUTE THESE DISTANCES (I.E. DIAGONALS) FOR CY-BUT.
      I = J - 1
      IF (I.EQ.0) I = NRS
      II = ATRNG(I)
      K = J + 1
      IF (K.GT.NRS) K = 1
      KK = ATRNG(K)
      DIST1 = BND(II,JJ)
      DIST2 = BND(JJ,KK)
      IF (NRS.EQ.4) GO TO 3400
      DIST3 = BND(II,KK)
      COSINT = (DIST1**2+DIST2**2-DIST3**2)/(2.0*DIST1*DIST2)
      COSEXT = COSD(120.0)
      GO TO 3450
 3400 COSINT = 0.0
      COSEXT = COSD(113.0)
      DIST3 = SQRT(DIST1**2+DIST2**2)
      BND(II,KK) = DIST3
      BND(KK,II) = DIST3
 3450 COSMID = -SQRT((COSINT+1.0)*COSEXT+COSINT+1.0)/2.0
      IVAL = 4
      NAMEJ = NAMES(JJ)
      IF (NAMEJ.EQ.'N'.OR.NAMEJ.EQ.'P') IVAL = 3
      IF (ITYPE(JJ).EQ.IVAL) GO TO 3800
      COSMID = -SQRT((1.0+COSINT)/2.0)
 3800 IF (DUMP) WRITE(20,13000) II,DIST1,JJ,DIST2,KK,DIST3,
     1                          COSINT,COSMID,COSEXT
      IF (LIM.LE.2) GO TO 3500
C
C     LOOK FOR NEIGHBORS OF JJ WHICH ARE NOT IN THE CYCLE
C
      NLM = 0
      IPREV = 0
      DO 3100 I = 1,LIM
      L = ICONN(I,JJ)
      IF (L.EQ.IPREV) GO TO 3100
      IF (L.EQ.II.OR.L.EQ.KK) GO TO 3100
      NLM = NLM + 1
      LM(NLM) = L
      IPREV = L
 3100 CONTINUE
      IF (NLM.EQ.0) GO TO 3500
      DO 3250 N1 = 1,2
      DO 3200 N2 = 1,NLM
      DIST1 = BND(IK(N1),JJ)
      DIST2 = BND(JJ,LM(N2))
      DIST3 = SQRT(DIST1**2+DIST2**2-2.0*DIST1*DIST2*COSMID)
      BND(IK(N1),LM(N2)) = DIST3
      BND(LM(N2),IK(N1)) = DIST3
      IF (DUMP) WRITE(20,13000) IK(N1),DIST1,JJ,DIST2,LM(N2),DIST3,
     1                          COSINT,COSMID,COSEXT
13000 FORMAT (6X,3(I4,F12.5),3(2X,F12.5))
 3200 CONTINUE
 3250 CONTINUE
      IF (NLM.LT.2) GO TO 3500
      DIST1 = BND(LL,JJ)
      DIST2 = BND(JJ,MM)
      DIST3 = SQRT(DIST1**2+DIST2**2-2.0*DIST1*DIST2*COSEXT)
      BND(LL,MM) = DIST3
      BND(MM,LL) = DIST3
      IF (DUMP) WRITE(20,13000) LL,DIST1,JJ,DIST2,MM,DIST3,
     1                          COSINT,COSMID,COSEXT
 3500 CONTINUE
      RETURN
      END
