C 	COPYRIGHT (C) 1981 BY BOARD OF TRUSTEES,
C 	LELAND STANFORD JUNIOR UNIVERSITY
C
      PROGRAM BUILD
C
C  BUILD IS THE MAIN PROGRAM WHICH CALLS THE EMBED ROUTINE,
C  PROVIDED BY KUNTZ, HAVEL ET AL. AT UCSF.
C  WHAT IT DOES, IS JUST INITIALISE SOME PARAMETERS AND CONTROL
C  THE FLOW OF THE OPERATIONS, BY CALLING THE RIGHT ROUTINE AT
C  THE RIGHT TIME.
C  THE REQUIRED INPUT IS MAINLY THE XXXSC1.CG COMMUNICATION FILE
C  ISSUED BY STRCHK. ITS OUTPUT IS A SET OF CARTESIAN COORDINATES
C  TO BE USED BY THE DRAWING PACKAGE AND BY SOME OTHER PROGRAMS
C  AS WELL (GEOMETRY OPTIMISATION PROGRAMS FOR INSTANCE)
C
C  COPYRIGHT 1980, BOARD OF TRUSTEES, LEYLAND STANFORD JUNIOR
C  UNIVERSITY
C

C  COMMON BLOCKS
      COMMON /XYZS/ NXYZ,XYZ(3,72)
C  XYZ CONTAINS THE OUTPUT COORDINATES
      COMMON /BNDS/ NPNTS,BND(72,72)
C  NPTS CONTAINS THE NUMBER OF GEOMETRIC POINTS = NATOMS FOR
C  OUR CURRENT APPLICATION, AND THE BND MATRIX THE UPPER BOUNDS
C  ABOVE THE MAIN DIAGONAL AND LOWER BOUNDS BELOW. NOTE THAT
C  THESE VALUES ARE RETURNED SQUARED AFTER CALLING EMBED.
      COMMON /EMBD/ DUMP,NDIM,NTRY,SMALL,DWK(72),EWK(72,72)
      LOGICAL DUMP
      COMMON /ATOMS/ NAT,ICONN(4,72),NCONN(72),NAMES(72),NCNT(72),
     1 ITYPE(72)
C  NAT IS THE NUMBER OF ATOMS IN THE CONNECTION TABLE ICONN.
C  NCONN(I) IS THE NUMBER OF ENTRIES IN I-TH ROW OF THE CT.
C  NAMES ARE ATOM NAMES, WITH THE NAME'S CHARACTER COUNT IN NCNT
C  (USEFULL IN THE DRAW ROUTINES). ITYPE CONTAINS THE EXPECTED
C  ATOM VALENCES, IN A FIRST STAGE, THEN THE ACTUAL NUMBER OF
C  NEIGHBORS, HYDROGENS INCLUDED.
      COMMON /RETINF/ IJN,IPART,IDEV,IPPN,ISAV
C  THIS IS THE INFORMATION NEEDED TO RECALL THE PROGRAM WHICH
C  CALLED BUILD
      COMMON /LABEL/ TITLE(16),LTITLE
C  SOME GENERAL INFORMATION: THE TITLE AND ITS LENGTH.
      COMMON /BONDS/ NBNDS, BNDAT(2,72),BTYPE(72)
      INTEGER BNDAT,BTYPE
C  THE BOND DEFINITIONS
      COMMON /STEREO/ ISTER(72)
      COMMON /PARA/ GESFCT,STPMIN,STPMAX,CAPPA,DELTA,EPSLN,
     1 FAST,SLOW,ANGMAX,INTMAX,RESTAR
      INTEGER RESTAR
      COMMON /CTRL/ SLFCOR,IFREQ,ITNLIM,FCTMIN,GRDMIN
      LOGICAL SLFCOR
      DOUBLE PRECISION DMPFIL, OUTFIL, TOPFIL, TYPTRM, TTYPE
      DOUBLE PRECISION IDISP
      LOGICAL LPUNCH, LPLOT, IOPN1, IOPN2
      COMMON /TRMTYP/ NTERM
C  THE ABOVE ARE CONTROL PARAMETERS AD USUM EMBED AND SCCG. FOR
C  AN EXPLANATION, SEE EMBED.
C
C     SUGGESTED VALUES FOR PARAMETERS FOR OPTIMIZATION ROUTINE SCCG.
C     THESE ARE FOR COMMON BLOCK /PARA/
C
      DATA GESFCT/5.E-1/, STPMIN/1.E-3/, STPMAX/1.E00/, CAPPA/5.E-1/,
     1 DELTA/1.E-6/, EPSLN/1.E-5/, FAST/5.E-1/, SLOW/1.E-3/,
     2 ANGMAX/88.00/, INTMAX/5/, RESTAR/50/
C
C     TRIAL VALUES FOR COMMON BLOCK CTRL FOR SCCG.
C
      DATA SLFCOR/.FALSE./, IFREQ/1/, ITNLIM/50/, FCTMIN/0.01/,
     1 GRDMIN/0.002/
C
C     TRIAL VALUE OF SMALL FOR EMBED - ON ADVICE THAT
C     FCTMIN = SMALL * GRDMIN.  ALSO, SET NDIM = 72 AND NTRY = 10
C
      DATA SMALL/5.0/
C
      DATA TOPFIL /'000TOP.CG'/ ,TYPTRM /'TERMTYPE'/
      DATA OUTFIL /'000XYZ.CG'/ ,DMPFIL /'000DMP.CG'/
      IOPN1 = .FALSE.
      IOPN2 = .FALSE.
      NDIM = 72
      NTRY = 10
 1020 FORMAT (A10)
      DUMP = .true. 
      IF (DUMP) OPEN (UNIT=20,DEVICE='DSK',FILE=DMPFIL,ACCESS='SEQOUT')
      CALL PREL1 (IOPN1,DUMP,NDIM,IERR)
      CALL MAKFIL (OUTFIL)
      LPUNCH = .FALSE.
      OPEN (UNIT=21,DEVICE='DSK',FILE=OUTFIL,ACCESS='SEQOUT')
 1050 FORMAT (I)
      CALL MAKFIL (TOPFIL)
      OPEN (UNIT=2,DEVICE='DSK',FILE=TOPFIL,ACCESS='SEQIN')
      IOPN2 = .TRUE.
    5 READ (2,1061) TTYPE
 1061 FORMAT (A10)
      IF (TTYPE.EQ.TYPTRM) GO TO 6
      GO TO 5
    6 READ (2,1050) NTERM
      CLOSE (UNIT=2)
      IOPN2 = .FALSE.
      LPLOT = .TRUE.
      IF (NTERM.EQ.4.OR.NTERM.EQ.5) GO TO 10
      LPLOT = .FALSE.
      WRITE(5,1070)
 1070 FORMAT (' TERMINAL IS NOT DEFINED AS GRAPHIC.'/
     1 ' CANNOT CONTINUE . SORRY...'//)
      GO TO 9000
C
C
   10 CALL PREL1(IOPN1,DUMP,NDIM,IERR)
      IF (.NOT.IOPN1.OR.IERR.GT.0) GO TO 9000
      NXYZ = NAT
      NPNTS = NAT
      CALL PREL2(DUMP,NDIM)
C
C  LOOP NSTRUC TIMES, TRYING TO GET THIS MUCH DIFFERENT STRUCTURES
C
      KSTRUC = 0
  500 KSTRUC = KSTRUC + 1
      IF (KSTRUC.EQ.1) 501,502
  501 CALL EMBED (ISSUE)
      GO TO 503
  502 CALL EMBED2(ISSUE)
  503 IF (ISSUE) 520,530,540
C
C  FAILURE EXIT
C
  520 WRITE (5,5020) KSTRUC
 5020 FORMAT (' EMBED FAILED AT KSTRUC =',I3)
      GO TO 541
C
C  EMBEDDING INDETERMINATE. WRITE OUT THE RESULT, AND
C  KEEP PUMPING...
C
  530 WRITE (5,5030) KSTRUC
 5030 FORMAT (' EMBED SITS ON THE FENCE AT KSTRUC =',I3)
      GO TO 541
C
C  EMBEDDING SUCCESSFUL: CALL DRAW TO SHOW THIS MASTERPIECE
C
  540 WRITE (5,5040) KSTRUC
 5040 FORMAT (' SUCCESS AT KSTRUC =',I3,$)
      WRITE (5,5041)
 5041 FORMAT ('+ LOOK AT THIS !!')
  541 CALL CMDRAW (KSTRUC,ISSUE,LASUIT,LPUNCH)
      IF (LASUIT.EQ.'DONE') GO TO 10
      IF (LASUIT.EQ.'MORE') GO TO 500
C
 9000 IF (DUMP) CLOSE(UNIT=20)
      IDISP = 'SAVE'
      IF (.NOT.LPUNCH) IDISP = 'DELETE'
      CLOSE (UNIT=21,DISPOSE=IDISP)
      IF (IOPN1) CLOSE (UNIT=1)
      IF (IOPN2) CLOSE (UNIT=2)
      CALL RUNNER (IPART,IDEV,IPPN,ISAV)
      END
      SUBROUTINE MAKFIL (FILNAM)
      INTEGER FILNAM(2)
      INTEGER SHIFT
      IJN = JOBNO(IDUMM)
      IFN = FILNAM(1)
      IFN = IFN.OR.SHIFT(IJN/100,29)
      IJN = MOD(IJN,100)
      IFN = IFN.OR.SHIFT(IJN/10,22)
      IJN = MOD(IJN,10)
      IFN = IFN.OR.SHIFT(IJN,15)
      FILNAM(1) = IFN
      RETURN
      END
