C  THIS IS FILE MINFU4.F4  --  MINIMIZATION FUNCTION SUBROUTINES
C  W. TODD WIPKE, DEPARTMENT OF CHEMISTRY
C  PRINCETON UNIVERSITY, PRINCETON, N.J.  08540
C
C  ###
	SUBROUTINE BONDS(I,MP)
	COMMON/MZCONN/MNA,MNB,MNDB,MNXH,MATYP(30),MNATCH(30),MATBD(30,4)
	1,MBTYP(30,4),MHOLD(30),XM(30),YM(30),ZM(30),JSTOP,GFACTR(30)
	COMMON/GEN/TOTALE,INVATM,ISTAGE,IROOT/DISTX/DIST/BOND/
	1BNRG,NTYPE,BCONST,ADIS,UBCONST
	1/ALENG/TUBNRG,OTANRG,TANRG,TBNRG,OUBNRG,OTBNRG
	COMMON/DEBUG/DEBUG(16)
	DIMENSION DIST(30,30),TUBNRG(30),OTANRG(30),TANRG(30),TBNRG(30),
	1BNRG(30,30),NTYPE(30,30),OUBNRG(30),OTBNRG(30)
	IF(MP.NE.-1)TBNRG(I)=0.
	NNB=MNATCH(I)
	DO 50 J=1,MNA
	IF(I.EQ.J) GO TO 50
	IF(MP.NE.2.AND.DIST(I,J).NE.(0.0)) GO TO 50
	CALL	DISTN(I,J)
   50	CONTINUE
	DO 200	M=1,NNB
	LPA=MATBD(I,M)
	IF (I.GT.LPA.AND.MP.NE.2) GO TO 100
	CALL BDNRG(I,LPA)
	BNRG(I,LPA)=BNRG(I,LPA)*BCONST
C  100	IF(DEBUG(13))WRITE(5,300)I,LPA,DIST(I,LPA),BNRG(I,LPA)
C300	FORMAT(' BOND ',I2,'-',I2,' DIST ',F8.4,' BNRG ',F8.2)
100	IF(MP.EQ.-1)GO TO 150
	TBNRG(I)=TBNRG(I)+BNRG(I,LPA)
C	IF(DEBUG(13))WRITE(5,400)I,TBNRG(I)
C400	FORMAT(' ATM ',I2,' TBNRG ',F9.3)
	IF(MP.EQ.2)GO TO 200
150	TOTALE=TOTALE+BNRG(I,LPA)
	BNRG(LPA,I)=BNRG(I,LPA)
  200	 CONTINUE
	RETURN
	END
C  ###
	SUBROUTINE ANGLES(I,MP)
	LOGICAL DOSUM
	COMMON/MZCONN/MNA,MNB,MNDB,MNXH,MATYP(30),MNATCH(30),MATBD(30,4)
	1,MBTYP(30,4),MHOLD(30),XM(30),YM(30),ZM(30),JSTOP,GFACTR(30)
	COMMON/HCONST/HCONST,SUMA(30),HNRG(30),OHNRG(30)
	COMMON/GEN/TOTALE,INVATM,ISTAGE,IROOT/DEBUG/DEBUG(16)
	1/ANGL/THETA,NAA,N1,N2,ANRG,NTYPEA,ACONST,ATETC,ANAT3
	2/BOND/BNRG,NTYPE,BCONST,ADIS,UBCONST
	COMMON/ALENG/TUBNRG,OTANRG,TANRG,TBNRG,OUBNRG,OTBNRG
	COMMON/PLUSDA/PLUSDA,PLUSCH,PLUSHYB
	DIMENSION THETA(30,6),NAA(30),N1(30,6),N2(30,6),TUBNRG(30),
	1ANRG(30,6),BNRG(30,30),TANRG(30),TBNRG(30),OUBNRG(30),OTBNRG(30
	2),OTANRG(30)
	DIMENSION NTYPE(30,30),NTYPEA(30)
	DOSUM=.TRUE.
	SUMA(I)=0.
	IF(.NOT.PLUSHYB)GO TO 10
	HNRG(I)=0.
	IF(MNATCH(I).LT.3.OR.NTYPEA(I).NE.0)DOSUM=.FALSE.
10	IF(MP.NE.-1)TANRG(I)=0.
	NA=NAA(I)
	IF (NA.EQ.0) GO TO 250
C
C  CALCULATE NEW BOND ANGLES AROUND ATOM I
C
C	IF(DEBUG(14))WRITE(5,2000)
C2000	FORMAT(' ATM ANGLE DEGREES ANRG')
	DO 210	N=1,NA
	CALL ANGLE(I,N1(I,N),N2(I,N),N)
	IF (MNATCH(I).EQ.4) GO TO 100
	IF (NTYPEA(I).EQ.1) GO TO 150
	ANRG(I,N)=ACONST*ANRG(I,N)
	GO TO 200
  100	ANRG(I,N)=ATETC*ANRG(I,N)
	GO TO 200
  150	ANRG(I,N)=ANAT3*ANRG(I,N)
200	IF(MP.NE.2)TOTALE=TOTALE+ANRG(I,N)
	IF(MP.NE.-1)TANRG(I)=TANRG(I)+ANRG(I,N)
	IF(.NOT.DEBUG(14))GO TO 210
C	D=57.3*THETA(I,N)
C	WRITE(5,1000)I,N,D,ANRG(I,N)
C1000	FORMAT(1X,I2,I2,F7.2,F10.5)
210	CONTINUE
	IF(.NOT.DOSUM.OR..NOT.PLUSHYB)GO TO 250
	CALL	ANGSUM(I)
	IF(SUMA(I).NE.0.)HNRG(I)=HCONST*SUMA(I)**2
C	IF(DEBUG(14))WRITE(5,4000)I,SUMA(I),HNRG(I)
C4000	FORMAT(' ATM ',I2,' ANGDIF ',F9.2,' HNRG ',F9.3)
	IF(MP.EQ.2)GO TO 500
	TOTALE=TOTALE+HNRG(I)
250	IF(MP.NE.2)RETURN
C
C  INCLUDE STRAIN ENERGY CONTRIBUTION FROM ANGLES OF
C  ALPHA ATOMS SINCE THESE CHANGE ALSO UPON MOVING ORIGINAL ATOM.
C
500	NNB=MNATCH(I)
	DO 410	J=1,NNB
	DOSUM=.TRUE.
	JJ=MATBD(I,J)
	NJ=NAA(JJ)
	IF (NJ.EQ.0) GO TO 410
	SUMA(JJ)=0.
	IF(.NOT.PLUSHYB)GO TO 20
	IF(MNATCH(JJ).LT.3.OR.NTYPEA(JJ).NE.0)DOSUM=.FALSE.
20	DO 420 L=1,NJ
	CALL ANGLE(JJ,N1(JJ,L),N2(JJ,L),L)
	IF (MNATCH(JJ).EQ.4) GO TO 300
	IF (NTYPEA(JJ).EQ.1) GO TO 350
	ANRG(JJ,L)=ACONST*ANRG(JJ,L)
	GO TO 400
  300	ANRG(JJ,L)=ATETC*ANRG(JJ,L)
	GO TO 400
  350	ANRG(JJ,L)=ANAT3*ANRG(JJ,L)
  400	IF(N1(JJ,L).NE.I.AND.N2(JJ,L).NE.I)GO TO 420
	TANRG(I)=TANRG(I)+ANRG(JJ,L)
	IF(.NOT.DEBUG(14))GO TO 420
C	D=57.3*THETA(JJ,L)
C	WRITE(5,1000)JJ,L,D,ANRG(JJ,L)
420	CONTINUE
	IF(.NOT.DOSUM.OR..NOT.PLUSHYB)GO TO 410
	CALL	ANGSUM(JJ)
	HNRG(I)=HNRG(I)+HCONST*SUMA(JJ)**2
C	IF(DEBUG(14))WRITE(5,5000)I,JJ,SUMA(JJ),HNRG(I)
C5000	FORMAT(' I ',I2,' JJ ',I2,' ANGDIF ',F7.2,' HNRG(I) ',F9.2)
  410	CONTINUE
C	IF(DEBUG(14))WRITE(5,3000)I,TANRG(I)
C3000	FORMAT(' ATM ',I2,' TANRG ',F9.3)
	RETURN
	END
C  ###
	SUBROUTINE BDNRG(I,J)
C
C  CALCULATES BOND STRAIN ENERGY
C
	COMMON/MZCONN/MNA,MNB,MNDB,MNXH,MATYP(30),MNATCH(30),MATBD(30,4)
	1,MBTYP(30,4),MHOLD(30),XM(30),YM(30),ZM(30),JSTOP,GFACTR(30)
	COMMON/DISTX/DIST/BOND/BNRG,NTYPE,BCONST,ADIS,UBCONST
	1/DEBUG/DEBUG(16)
	COMMON/GEN/TOTALE,INVATM,ISTAGE,IROOT
	DIMENSION DIST(30,30),BNRG(30,30),NTYPE(30,30),BLO(21),BFORC(21)
	DATA BLO/1.533,1.33,1.29,1.22,1.5,1.07,1.69,1.5,1.5,1.46
	1,0.,1.47,1.43,1.76,1.09,1.01,.96,0.,1.2,1.16,1.39/
	DATA BFORC/300.,3*640.,300.,330.,4*300.,0.,3*300.,310.,2*300.
	1,0.,2*900.,800./
	NTYPEO=NTYPE(I,J)+1
	IF(NTYPEO.EQ.11.OR.NTYPEO.EQ.18)GO TO 900
	BLOW=BLO(NTYPEO)
	IF(ISTAGE.NE.4)GO TO 100
	BFORCE=BFORC(NTYPEO)
	GO TO 850
100	BFORCE=300.
  850	DELLEN=(DIST(I,J)-BLOW)**2.0
	BNRG(I,J)=(BFORCE*DELLEN)/2.0
  900	CONTINUE
C	IF(DEBUG(13))WRITE(5,2000)I,J,NTYPE(I,J),BLOW,BFORCE,DELLEN,
C	1BNRG(I,J)
C2000	FORMAT(' BOND ',I2,'-',I2,' NTYPE ',I2,' BLOW ',F4.2,' BFORCE ',
C	1F5.1,' DELLEN ',F8.3,' BNRG ',F8.2)
	RETURN
	END
C  ###
	SUBROUTINE NONBND(I,MP)
C
C  CALCULATES NONBONDED STRAIN ENERGY
C
	COMMON/MZCONN/MNA,MNB,MNDB,MNXH,MATYP(30),MNATCH(30),MATBD(30,4)
	1,MBTYP(30,4),MHOLD(30),XM(30),YM(30),ZM(30),JSTOP,GFACTR(30)
	COMMON/DEBUG/DEBUG(16)
	COMMON/DISTX/DIST/BOND/BNRG,NTYPE,BCONST,ADIS,UBCONST/
	1ALENG/TUBNRG,OTANRG,TANRG,TBNRG,OUBNRG,OTBNRG/
	2GEN/TOTALE,INVATM,ISTAGE,IROOT
	DIMENSION DIST(30,30),BNRG(30,30),TUBNRG(30),OTANRG(30),TANRG(30
	1),TBNRG(30),OUBNRG(30),OTBNRG(30),NTYPE(30,30)
	KONST=2
	IF(ISTAGE.EQ.4)KONST=6
	TUBNRG(I)=0.0
	DO 250	J=1,MNA
	IF (J.EQ.I) GO TO 250
	DO 50	K=1,MNATCH(I)
   50	IF (J.EQ.MATBD(I,K)) GO TO 250
	IF (MP.EQ.1.AND.I.GT.J) GO TO 200
	IF (NTYPE(I,J).EQ.17) GO TO 250
	ALPHA=ADIS
	IF (NTYPE(I,J).NE.10) GO TO 100
	ALPHA=2.25
	IF(MOD(MATYP(I),10).EQ.1.AND.MOD(MATYP(J),10).EQ.1)ALPHA=2.52
	IF(MOD(MATYP(I),10).EQ.2.OR.MOD(MATYP(J),10).EQ.2)ALPHA=1.75
100	DELLEN=ALPHA-DIST(I,J)
	IF (DELLEN.LE.(0.0)) DELLEN=0.0
	BNRG(I,J)=UBCONST*(14.38)*(DELLEN**KONST)
	BNRG(J,I)=BNRG(I,J)
  200	TUBNRG(I)=TUBNRG(I)+BNRG(I,J)
250	CONTINUE
	IF(MP.EQ.1)TOTALE=TOTALE+TUBNRG(I)
	IF(.NOT.DEBUG(12))RETURN
C	DO 300 J=1,MNA
C	IF(BNRG(I,J).GT.1.E-10)WRITE(5,2000)I,J,DIST(I,J),BNRG(I,J)
C2000	FORMAT(' I ',I2,' J ',I2,' DIST ',F5.2,' UBNRG ',F8.3)
C300	CONTINUE
	RETURN
	END
C  ###
	SUBROUTINE SINENG
C
C  CALCULATES ANGLE STRAIN AND HYBRIDIZATION STRAIN CONTRIBUTIONS
C  TO ALPHA ATOMS
C
	LOGICAL DOSUM
	COMMON/MZCONN/MNA,MNB,MNDB,MNXH,MATYP(30),MNATCH(30),MATBD(30,4)
	1,MBTYP(30,4),MHOLD(30),XM(30),YM(30),ZM(30),JSTOP,GFACTR(30)
	COMMON/ANGL/THETA,NAA,N1,N2,ANRG,NTYPEA,ACONST,ATETC,ANAT3/BOND/
	1BNRG,NTYPE,BCONST,ADIS,UBCONST
	2/ALENG/TUBNRG,OTANRG,TANRG,TBNRG,OUBNRG,OTBNRG
	COMMON/HCONST/HCONST,SUMA(30),HNRG(30),OHNRG(30)
	COMMON/PLUSDA/PLUSDA,PLUSCH,PLUSHYB
	COMMON/DEBUG/DEBUG(16)
	DIMENSION THETA(30,6),NAA(30),N1(30,6),N2(30,6),ANRG(30,6),
	1BNRG(30,30),TEMP(30),
	2TUBNRG(30),OTANRG(30),TANRG(30),TBNRG(30),OUBNRG(30),
	3OTBNRG(30),NTYPE(30,30),NTYPEA(30)
	IF(.NOT.PLUSHYB)GO TO 10
	DO 400 I=1,MNA
400	TEMP(I)=HNRG(I)
10	DO 300 I=1,MNA
	NNB=MNATCH(I)
	DO 250	L=1,NNB
	LL=MATBD(I,L)
	NS=NAA(LL)
	IF (NS.EQ.0) GO TO 250
	DO 200 M=1,NS
	IF (N1(LL,M).NE.I.AND.N2(LL,M).NE.I) GO TO 200
	TANRG(I)=TANRG(I)+ANRG(LL,M)
C	IF(DEBUG(14))WRITE(5,3000)I,L,M,ANRG(LL,M),TANRG(I)
C3000	FORMAT(' ATM ',I2,' ALPHA ',I2,' ANGL ',I1,' ANRG ',F8.2,' TANRG
C	1 ',F8.2)
  200	CONTINUE
	IF(PLUSHYB)HNRG(I)=HNRG(I)+TEMP(LL)
  250	CONTINUE
300	CONTINUE
C	IF(DEBUG(14).AND.PLUSHYB)WRITE(5,4000)(HNRG(I),I=1,MNA)
C4000	FORMAT(' HNRG TOTALS',6F10.3,3(/2X,7F10.3))
	RETURN
	END
C  ###
	SUBROUTINE DANGLS(I1,LPA)
C
C  CALCULATES ALL DIHEDRAL ANGLES(IF LPA=1) OR THOSE AFFECTING
C  ENERGY OF ATOM I (IF LPA=2); AND DIHEDRAL STRAIN ENERGY
C  CONTRIBUTIONS TO INDIVIDUAL ATOMS.  
C  EXPRESSION FOR SINGLE BOND:  S.E. = 0.5*(1.+COS(3.*A)) [A<OR=PI/3.]
C  EXPRESSION FOR DOUBLE BOND: S.E. =30.*(57.3*A)**2 [IF A>PI/2.,A=PI-A]
C
	INTEGER HWPK,HWUNPK
	LOGICAL PLUSCH
	COMMON/PLUSDA/PLUSDA,PLUSCH,PLUSHYB
	COMMON/DANGL/DANGL(120),NTYPDA(120),ND1(120),ND2(120),ND3(120)
	1,ND4(120),DCONST,DNRG(120),TDNRG(30),OTDNRG(30),NDA,ND0(30,20)
	2,ITEMP(40),SDCONST
	COMMON/MZCONN/MNA,MNB,MNDB,MNXH,MATYP(30),MNATCH(30),MATBD(30,4)
	1,MBTYP(30,4),MHOLD(30),XM(30),YM(30),ZM(30),JSTOP,GFACTR(30)
	COMMON/GEN/TOTALE,INVATM,ISTAGE,IROOT
	COMMON/DEBUG/DEBUG(16)
	DATA FCONST/200./
	IF(NDA.EQ.0)RETURN
	IF(MNDB.EQ.0.AND.SDCONST.EQ.0)RETURN
	IF(LPA.EQ.2)GO TO 25
	CALL	ZEROM(DNRG,100)
	DO 10 I=1,NDA
10	IF(NTYPDA(I).GT.0)CALL	DANGLE(I)
	I=0
35	I=I+1
	GO TO 30
25	I=I1
30	TDNRG(I)=0.
C
C  UNPACK ND0
C
	CALL	ZEROM(ITEMP,40)
	DO 70 J=1,40,2
	J1=J+1
	J2=(J/2)+1
70	CALL	HWUNPK(ND0(I,J2),ITEMP(J),ITEMP(J1))
	J=0
40	J=J+1
	IF(J.GT.40)GO TO 50
	K=ITEMP(J)
	IF(K.EQ.0)GO TO 50
	IF(LPA.EQ.1.AND.DNRG(K).NE.0.)GO TO 120
	NTYPO=MOD(NTYPDA(K),10)+4
	DHOLD=DNRG(K)
	AHOLD=DANGL(K)
	DNRG(K)=0.
	GO TO(130,130,130,65,300,400,400,400,400,400),NTYPO
C
C  WE HAVE A TERMINAL OLEFIN; FORCE INTO A PLANE
C
130	L=MATYP(I)/1000
	IF(L.NE.2.AND.L.NE.1)GO TO 65
	IF(NTYPO-2)140,150,140
140	L1=ND1(K)
	IF(L1.NE.I)GO TO 60
	L2=ND2(K)
	L3=ND3(K)
	GO TO 160
150	L1=ND4(K)
	IF(L1.NE.I)GO TO 60
	L2=ND3(K)
	L3=ND2(K)
160	L4=MATBD(L2,1)
	IF(L4.NE.L1.AND.L4.NE.L3)GO TO 165
	L4=MATBD(L2,2)
	IF(L4.EQ.L1.OR.L4.EQ.L3)L4=MATBD(L2,3)
165	CALL	FLATTN(L1,L2,L3,L4,THETA)
	DNRG(K)=DNRG(K)+FCONST*(THETA**2)
	IF(NTYPO.EQ.1)GO TO 150
	GO TO 60
C
C  WE HAVE A SATURATED LINKAGE; OPTIMIZE TO 60 DEGREES.
C  (SKIP IN EARLY STAGES)
C
300	IF(SDCONST.EQ.0.)GO TO 65
	IF(LPA.EQ.2)CALL	DANGLE(K)
	IF(DANGL(K).GE.1.0472)GO TO 65
	DNRG(K)=1.0*((-DANGL(K)+1.0472)**2)*SDCONST
	GO TO 60
C
C  FOLLOWING IS FOR OLEFINIC DIHEDRAL ANGLES
C
400	IF(LPA.EQ.2)CALL	DANGLE(K)
C
C  CONVERT TRANS ANGLES TO CIS, UNLESS PART OF ALLENE, OR UNLESS PART
C  OF CIS OLEFIN.
C
	IF(NTYPO.EQ.10)GO TO 170
	D=DANGL(K)
	IF(.NOT.PLUSCH)GO TO 175
	IF(NTYPDA(K)/100.EQ.1)GO TO 175
	IF(MOD(NTYPDA(K),100)-10)170,170,185
175	IF(D.LT.1.5708)GO TO 170
185	DANGL(K)=3.141593-D
170	CONST=15.
	NTYPO=NTYPO-5

	GO TO(500,600,800,700,900),NTYPO
C
C  QUADRUPLE THE CONSTANT FOR DISUBSTITUTED OLEFINS
C
500	CONST=4.*CONST
	GO TO 600
C
C  USE SMALLER CONSTANT FOR DIENE
C
700	CONST=.003
	GO TO 600
C
C  DOUBLE THE CONSTANT FOR TRISUBSTITUTED OLEFINS
C
800	CONST=2.*CONST
	GO TO 600
C
C  HERE FOR ALLENE PSEUDO-DIHEDRAL ANGLES; OPTIMIZE TO 90 DEGREES
C
900	DNRG(K)=CONST*1.6*((1.5708-DANGL(K))**2)
	GO TO 60
C
C  HERE DIRECTLY FOR TETRASUBSTITUTED OLEFINS
C
600	DNRG(K)=1.628*CONST*(DANGL(K)**2)
	GO TO 60
C
C  NO ENERGY BARRIER FOR C-C(SP2)-C-C
C
65	DNRG(K)=0.
60	CONTINUE
	DNRG(K)=DCONST*DNRG(K)
120	TDNRG(I)=TDNRG(I)+DNRG(K)
C	IF(.NOT.DEBUG(9))GO TO 180
C	D=57.3*DANGL(K)
C	WRITE(5,1030)I,K,D,DNRG(K),TDNRG(I)
C1030	FORMAT(' ATM ',I2,' DANGL ',I3,' DEG ',F6.2,' DNRG ',F10.4,
C	1' TDNRG ',F10.4)
C
C  FOR ENERGY PARTIAL CALCULATION, RESTORE ANGLE AND ENERGY TERMS
C
180	IF(LPA.NE.2)GO TO 40
	DANGL(K)=AHOLD
	DNRG(K)=DHOLD
	GO TO 40
50	IF(LPA.EQ.2)GO TO 100
	TOTALE=TOTALE+TDNRG(I)
	IF(I.LT.MNA)GO TO 35
C100	IF(.NOT.DEBUG(9))RETURN
C	IF(LPA.EQ.2.AND.TDNRG(I).NE.0.)WRITE(5,1020)I,TDNRG(I)
C	IF(LPA.EQ.1)WRITE(5,1010)(TDNRG(I),I=1,MNA)
C1010	FORMAT(' TDNRG'/10(1X,7F8.3/))
C1020	FORMAT(' TDNRG(',I2,')=',F8.3)
100	RETURN
	END
C  ###
	SUBROUTINE MCHIRAL(IATOM,MP)
C
C  ROUTINE TO INTRODUCE STEP FUNCTION TO ENSURE PROPER STEREOCHEMISTRY
C  IS MAINTAINED DURING MINIMIZATION
	COMMON/MZCONN/MNA,MNB,MNDB,MNXH,MATYP(30),MNATCH(30),MATBD(30,4)
	1,MBTYP(30,4),MHOLD(30),XM(30),YM(30),ZM(30),JSTOP,GFACTR(30)
	COMMON/DEBUG/DEBUG(16)
	COMMON/CHRL/CNRG(30),OCNRG(30),CCONST
	COMMON/GEN/TOTALE,INVATM,ISTAGE,IROOT
	CNRG(IATOM)=0.
C
C  IF CHIRALITY IS WRONG, ADD STRAIN ENERGY TERM
C
	ICHIRAL=MOD(MATYP(IATOM),1000)/100
	IF(ICHIRAL.NE.1)GO TO 20
	IF(MATYP(IATOM).GE.1000.AND.MATYP(IATOM).LT.4000)GO TO 20
	TEMP=STERFIX(IATOM)
	IF(TEMP.EQ.0.)GO TO 20
	CNRG(IATOM)=CNRG(IATOM)+2.*CCONST*TEMP
	INVATM=1
C	IF(DEBUG(10))WRITE(5,2000)IATOM
	IF(MP.NE.2)TOTALE=TOTALE+CNRG(IATOM)
C
C  CHECK IF MOVING IATOM CHANGES STEREO OF ADJACENT ATOMS
C
20	IF(MP.EQ.-1)RETURN
	NAT=MNATCH(IATOM)
	DO 10 I=1,NAT
	J=MATBD(IATOM,I)
	ICHIRAL=MOD(MATYP(J),1000)/100
	IF(ICHIRAL.NE.1)GO TO 10
	IF(MATYP(J).GE.1000.AND.MATYP(J).LT.4000)GO TO 10
	TEMP=STERFIX(J)
	IF(TEMP.EQ.0.)GO TO 10
	CNRG(IATOM)=CNRG(IATOM)+CCONST*TEMP
	INVATM=1
C	IF(DEBUG(10))WRITE(5,2000)J
10	CONTINUE
	RETURN
C2000	FORMAT(1X,I2,' INVERTED')
	END
C  ###
	SUBROUTINE DISTN(I,J)
	COMMON/MZCONN/MNA,MNB,MNDB,MNXH,MATYP(30),MNATCH(30),MATBD(30,4)
	1,MBTYP(30,4),MHOLD(30),XM(30),YM(30),ZM(30),JSTOP,GFACTR(30)
	COMMON/DISTX/DIST
	DIMENSION DIST(30,30)
	X2=(XM(I)-XM(J))**2.0
	Y2=(YM(I)-YM(J))**2.0
	Z2=(ZM(I)-ZM(J))**2.0
	SUM=X2+Y2+Z2
	DIST(I,J)=SQRT(SUM)
	DIST(J,I)=DIST(I,J)
	RETURN
	END
C  ###
	SUBROUTINE ANGLE(I,J,K,L)
C
C  CALCULATES BOND ANGLE IN RADIANS
C
	COMMON/DISTX/DIST/ANGL/THETA,NAA,N1,N2,ANRG,NTYPEA,ACONST,ATETC,
	1ANAT3/GEN/TOTALE,INVATM,ISTAGE,IROOT
	DIMENSION DIST(30,30),THETA(30,6),
	1NAA(30),N1(30,6),N2(30,6),ANRG(30,6),NTYPEA(30)
	SIDE=(DIST(I,J)+DIST(I,K)+DIST(J,K))/2
	A=SIDE-DIST(I,J)
	B=SIDE-DIST(I,K)
	C=SIDE-DIST(J,K)
	RADA=ABS((A*B*C)/SIDE)
	RAD=SQRT(RADA)
	THETA(I,L)=2*(ATAN(RAD/C))
	NANGLO=NTYPEA(I)+1
	GO TO(50,100,200),NANGLO
   50	ALOW=(109.5)*(0.0174533)
	AFORCE=80.10
	GO TO 150
  100	ALOW=(120.0)*(0.0174533)
	AFORCE=100.
	GO TO 150
200	ALOW=(180.)*(0.0174533)
	AFORCE=150.
  150	DELTHA=(THETA(I,L)-ALOW)**2
	ANRG(I,L)=(AFORCE*DELTHA)/2.0
	RETURN
	END
C  ###
	SUBROUTINE ANGSUM(I)
C
C  COMPUTES A DIFFERENCE BETWEEN TOTAL OF 4 SMALLEST ANGLES AND 380
C  DEGREES FOR TETRASUBSTITUTED ATOMS, AND BETWEEN TOTAL ANGLES AND
C  335 DEGREES FOR TRISUBSTITUTED SATURATED ATOMS.  USED TO CALCULATE
C  "HYBRIDIZATION STRAIN" ENERGY, HNRG.
C
	COMMON/GEN/TOTALE,INVATM,ISTAGE,IROOT
	COMMON/HCONST/HCONST,SUMA(30),HNRG(30),OHNRG(30)
	COMMON/MZCONN/MNA,MNB,MNDB,MNXH,MATYP(30),MNATCH(30),MATBD(30,4)
	1,MBTYP(30,4),MHOLD(30),XM(30),YM(30),ZM(30),JSTOP,GFACTR(30)
	COMMON/ANGL/THETA,NAA,N1,N2,ANRG,NTYPEA,ACONST,ATETC,ANAT3
	DIMENSION THETA(30,6),NAA(30),N1(30,6),N2(30,6),
	1ANRG(30,6),NTYPEA(30),TEMP(4)
	SUM=0.
	N=NAA(I)
	IF(N.GT.3)GO TO 100
C
C  HERE FOR TRISUBSTITUTED ATOMS, BUT ONLY IN LATER STAGES
C
	DO 30 J=1,N
30	SUM=SUM+THETA(I,J)
	SUM=10.*(SUM-5.846)
	GO TO 200
C
C  HERE FOR TETRASUBSTITUTED ATOMS
C
100	DO 40 J=1,4
40	TEMP(J)=THETA(I,J)
	DO 50 J=5,6
	THET=THETA(I,J)
	DO 60 K=1,4
	IF(THET.GE.TEMP(K))GO TO 60
	TEM=TEMP(K)
	TEMP(K)=THET
	THET=TEM
60	CONTINUE
50	CONTINUE
	DO 70 J=1,4
70	SUM=SUM+TEMP(J)
	SUM=10.*(6.632-SUM)
200	CONTINUE
	IF(SUM.LT.0.)SUM=0.
	SUMA(I)=SUM
	IF(SUM.GT.2.0)INVATM=1
	RETURN
	END
C  ###
	SUBROUTINE DANGLE(I)
C
C  CALCULATES DIHEDRAL ANGLE I IN RADIANS.   AFTER WIBERG.
C
	COMMON/MZCONN/MNA,MNB,MNDB,MNXH,MATYP(30),MNATCH(30),MATBD(30,4)
	1,MBTYP(30,4),MHOLD(30),XM(30),YM(30),ZM(30),JSTOP,GFACTR(30)
	COMMON/DANGL/DANGL(120),NTYPDA(120),ND1(120),ND2(120),ND3(120)
	1,ND4(120),DCONST,DNRG(120),TDNRG(30),OTDNRG(30),NDA,ND0(30,20)
	2,ITEMP(40),SDCONST
	I1=ND1(I)
	I2=ND2(I)
	I3=ND3(I)
	I4=ND4(I)
	X1=XM(I1)
	X2=XM(I2)
	X3=XM(I3)
	X4=XM(I4)
	Y1=YM(I1)
	Y2=YM(I2)
	Y3=YM(I3)
	Y4=YM(I4)
	Z1=ZM(I1)
	Z2=ZM(I2)
	Z3=ZM(I3)
	Z4=ZM(I4)
	X12=X1-X2
	X23=X2-X3
	X43=X4-X3
	Y12=Y1-Y2
	Y23=Y2-Y3
	Y43=Y4-Y3
	Z12=Z1-Z2
	Z23=Z2-Z3
	Z43=Z4-Z3
	CNUM=(Y12*Z23-Z12*Y23)*(Y43*Z23-Z43*Y23)+(Z12*X23-X12*Z23)*
	1(Z43*X23-X43*Z23)+(X12*Y23-Y12*X23)*(X43*Y23-Y43*X23)
	DNOM=(SQRT((Y12*Z23-Z12*Y23)**2+(Z12*X23-X12*Z23)**2+(X12*Y23
	1-Y12*X23)**2))*(SQRT((Y43*Z23-Z43*Y23)**2+(Z43*X23-X43*Z23)
	2**2+(X43*Y23-Y43*X23)**2))
	IF(ABS(DNOM).LT..00000001)WRITE(5,801)ND1(I),ND2(I),ND3(I),ND4(I)
801	FORMAT(' DIHEDRAL ANGLE WITH DNOM OF ZERO FOR ATOMS',4I3)
	CHECK=CNUM/DNOM
	IF(ABS(CHECK)-1.)22,22,23
23	CHECK=CHECK/ABS(CHECK)
22	DANGL(I)=ACOS(CHECK)
	RETURN
	END
C  ###
	SUBROUTINE FLATTN(L1,L2,L3,L4,THETA)
C
C  ROUTINE TO CALCULATE THE ANGLE BETWEEN BOND <L1,L2> AND A
C  PERPENDICULAR TO THE PLANE CONTAINING THE ATOMS <L2,L3,L4>
C
	COMMON/DEBUG/DEBUG(16)
	COMMON/MZCONN/MNA,MNB,MNDB,MNXH,MATYP(30),MNATCH(30),MATBD(30,4)
	1,MBTYP(30,4),MHOLD(30),XM(30),YM(30),ZM(30),JSTOP,GFACTR(30)
C
C  GET COORDINATES, SHIFT ORIGIN TO ATOM L2, THE CENTRAL ATOM
C
	IF(L1.NE.0.AND.L2.NE.0.AND.L3.NE.0.AND.L4.NE.0)GO TO 10
	WRITE(5,1100)L1,L2,L3,L4
1100	FORMAT(' ERROR IN FLATTEN FOR ATOMS ',4I3)
	PAUSE
10	X2=XM(L2)
	Y2=YM(L2)
	Z2=ZM(L2)
	X1=XM(L1)-X2
	Y1=YM(L1)-Y2
	Z1=ZM(L1)-Z2
	X3=XM(L3)-X2
	Y3=YM(L3)-Y2
	Z3=ZM(L3)-Z2
	X4=XM(L4)-X2
	Y4=YM(L4)-Y2
	Z4=ZM(L4)-Z2
C
C  FIND CROSS PRODUCT OF BONDS <L2,L3> AND <L2,L4>
C
	XP=Y3*Z4-Y4*Z3
	YP=Z3*X4-Z4*X3
	ZP=X3*Y4-X4*Y3
C
C  FIND DISTANCE OF BOND <L1,L2> AND OF CROSS PRODUCT VECTOR
C
	DB=SQRT(X1*X1+Y1*Y1+Z1*Z1)
	DP=SQRT(XP*XP+YP*YP+ZP*ZP)
C
C  NOW FIND ANGLE
C
	THET=ACOS((XP*X1+YP*Y1+ZP*Z1)/(DB*DP))
C
C  SUBTRACT 90 DEGREES, MINIMIZE RESULTING ANGLE
	THETA=ABS(THET-1.5708)
C	IF(.NOT.DEBUG(9))RETURN
C	T=57.3*THET
C	WRITE(5,1000)L1,L2,L3,L4,T
C1000	FORMAT(' ATOM ',I2,' FORMS ANGLE WITH NORMAL OF ATOMS',3I3,
C	1' OF ',F6.2,' DEGREES')
	RETURN
	END
C  ###
	FUNCTION STERFIX(IATOM)
C
C  RETURNS 0. IF ATTACHMENTS TO IATOM ARE IN PROPER ORDER,
C  OTHERWISE RETURNS A VALUE PROPORTIONAL TO DEVIATIONS FROM THE
C  PLANE OF THE OTHER THREE ATTACHMENTS.  ALGORITHM IS THE
C  SAME AS TCHIRAL, BUT USES ARRAYS AND ATOM NUMBERS PASSED TO THE
C  MINIMIZATION ROUTINE IN MZCONN.
	COMMON/MZCONN/MNA,MNB,MNDB,MNXH,MATYP(30),MNATCH(30),MATBD(30,4)
	1,MBTYP(30,4),MHOLD(30),XM(30),YM(30),ZM(30),JSTOP,GFACTR(30)
	COMMON/DEBUG/DEBUG(16)
	DIMENSION V(4,3),VC(4),VXPROD(4),VC4(4),UNIT(4)
	EQUIVALENCE(UNIT,VXPROD)

	VC(1)=XM(IATOM)
	VC(2)=YM(IATOM)
	VC(3)=ZM(IATOM)
	NATMS=MNATCH(IATOM)
C
C  GET COORDINATES OF SUBSTITUENTS
C
	DO 50 I=1,NATMS
	ISUB=MATBD(IATOM,I)
	V(I,1)=XM(ISUB)
	V(I,2)=YM(ISUB)
	V(I,3)=ZM(ISUB)
50	CONTINUE
C
C  IF ONLY 3 SUBSTITUENTS PRESENT, MAKE COORDINATES FOR THE FOURTH
C
	IF(NATMS.EQ.4)GO TO 150
	DO 75 I=1,3
	V(4,I)=-(V(1,I)+V(2,I)+V(3,I))+4.*VC(I)
75	CONTINUE
C
C  MOVE ORIGIN TO 1 TO SIMPLIFY CALCULATIONS, ALSO GET VECTOR C4
C
150	DO 110 J=1,3
	V(2,J)=V(2,J)-V(1,J)
	V(3,J)=V(3,J)-V(1,J)
	VC4(J)=V(4,J)-VC(J)
	VC(J)=VC(J)-V(1,J)
110	CONTINUE
C
C  GET CROSS PRODUCT V2 X V3
C
	VXPROD(1)=V(2,2)*V(3,3)-V(2,3)*V(3,2)
	VXPROD(2)=V(2,3)*V(3,1)-V(2,1)*V(3,3)
	VXPROD(3)=V(2,1)*V(3,2)-V(2,2)*V(3,1)
C
C  GET THE LENGTH OF THE CROSS PRODUCT
C
	VLXPROD=SQRT(VXPROD(1)**2+VXPROD(2)**2+VXPROD(3)**2)
C
C  GET THE UNIT VECTOR PERPENDICULAR TO THE 1-2-3 PLANE THAT IS IN
C  THE DIRECTION OF WHERE 4 SHOULD BE
C
	UNIT(1)=VXPROD(1)/VLXPROD
	UNIT(2)=VXPROD(2)/VLXPROD
	UNIT(3)=VXPROD(3)/VLXPROD
C
C  GET H THE HEIGHTS FROM 4 & C TO A PLANE THROUGH C PARALLEL TO THE
C  1-2-3 PLANE.
C
	H=-(VC4(1)*UNIT(1)+VC4(2)*UNIT(2)+VC4(3)*UNIT(3))
	HC=-(VC(1)*UNIT(1)+VC(2)*UNIT(2)+VC(3)*UNIT(3))
C
C  NOW USE THIS TO ARIVE AT A VALUE TO RETURN
C
	STERFIX=0.
	IF(H.LE.-0.2) GO TO 250
C
C  STRAINED
C
	STERFIX=.5+20.*(H+0.3)**2
250	IF(HC.LE.-0.2) GO TO 270
	STERFIX=STERFIX+.5+20.*(HC+.3)**2
C270	IF(DEBUG(10).AND.STERFIX.NE.0.)WRITE(5,300)IATOM,STERFIX
C300	FORMAT(' ATOM ',I2,' STERFIX = ',F8.3)
270	RETURN
	END
