	SUBROUTINE MINIMZ(ANAMES,NUMU,XXXX)
C  CLASSICAL STRAIN ENERGY MINIMIZATION ROUTINE FOR SYNTHESIS PROGRAM.
C  BASED ON J. VERBALIS, SENIOR THESIS, PRINCETON 1971
C  EXPANDED AND ADAPTED BY P. GUND  1971-2
C  CLEANED UP, MADE STAND-ALONE BY T. WIPKE, A. ZELICOFF 1973
C  VERSION 12    12/16/73
C  EDIT 12/16/73  REMOVED FROM SECS COMPLETELY.  WTW
C
	INTEGER GET,HWPK
	COMMON/MOVEDA/MOVEDA
      COMMON/GEN/TOTALE,INVATM,ISTAGE,IROOT/DISTX/DIST/
	1ANGL/THETA,NAA,N1,N2,ANRG,NTYPEA,ACONST,ATETC,ANAT3/
	2BOND/BNRG,NTYPE,BCONST,ADIS,UBCONST/
	3ALENG/TUBNRG,OTANRG,TANRG,TBNRG,OUBNRG,OTBNRG
	COMMON/CHRL/CNRG(30),OCNRG(30),CCONST
	COMMON/PLUSDA/PLUSDA,PLUSCH,PLUSHYB,GWGHT
	COMMON/DANGL/DANGL(120),NTYPDA(120),ND1(120),ND2(120),ND3(120)
	1,ND4(120),DCONST,DNRG(120),TDNRG(30),OTDNRG(30),NDA,ND0(30,20)
	2,ITEMP(40),SDCONST
	INTEGER ANAMES(4,MNA)
	DIMENSION DIST(30,30),BNRG(30,30),N1(30,6),N2(30,6),NAA(30),
	2ANRG(30,6),THETA(30,6),
	3OTBNRG(30),OTANRG(30),TANRG(30),TBNRG(30),OUBNRG(30),TUBNRG(30)
	4,PART(30,3),NTYPE(30,30),NTYPEA(30)
	COMMON/DEBUG/DEBUG(16)
	COMMON/MZCONN/MNA,MNB,MNDB,MNXH,MATYP(30),MNATCH(30),MATBD(30,4)
	1,MBTYP(30,4),MHOLD(30),XM(30),YM(30),ZM(30),JSTOP,GFACTR(30)
	COMMON/PERDON/PERDON,NRAND
	COMMON/HCONST/HCONST,SUMA(30),HNRG(30),OHNRG(30)
	COMMON/MWAT/CUTO,REMS,STEP,PSTEP,BMAX,KNOZ,APART,BPART,UBPART,
	1DPART,CPART,HPART,PART,NTOTLE
	DIMENSION BM(4),ST(4),AC(4),BC(4),EC(5),CC(4),HC(4),
	1APART(30,3),BPART(30,3),UBPART(30,3),
	2THA(6),CPART(30,3),DC(4),DPART(30,3),SDC(4),HPART(30,3)
	DIMENSION NTC(4),AD(4),UBC(4)
	DIMENSION XTOT1(30),YTOT1(30),ZTOT1(30),NT3(4)
	COMMON/MMODE/MMODE,ITMAX,TMAX,IFIN,MFIX,MARRAY(30),
	1 DELE,EFIN,TBEG
	COMMON /ROTATE/NRTFLG,TRMAT(4,4)
	COMMON /DISPTY/NFLAG,NCSWIT
	DIMENSION ODIST(30),CORD(3)
	DATA CORD /'X','Y','Z'/
	LOGICAL NSTO,PLUSDA,GWGHT,PLUSHYB
	DATA EC/10000.,100.,25.,2.5,0./,BM/5.,10.,5.,2./
	1,ST/.0005,3*.0001/,AC/4*1./,BC/.1,.2,.5,1./
	2,NTC/4*1/,AD/3.5,3*3./,UBC/10.,5.,3.,1./,NT3/2*2,2,1/
	3,SDC/2*0.,2.,1./,DC/.005,.01,.05,1./,CC/4*1./,HC/4*1./
C
C  JUMP TO APPROPRIATE LOCATION (I=0,1 OR 2 FOR BEGIN, CONTINUE,
C  OR RESUME MINIMIZATION, RESPECTIVELY.)
C
98765	IF(MOVEDA.EQ.1)IFIN=3
	MOVEDA=0
	I=IFIN+1
	IF(IFIN.EQ.2)IFIN=IFINN+1
	GO TO (1,10,5600,1,10), I
C-----	INITIALIZE VARIOUS THINGS
1	PLUSDA=.TRUE.
	IFINN=IFIN
	IFIN=IFIN+1
	NSTO=.FALSE.
	SCALO=1000.0
	PLUSCH=.TRUE.
	IF(NRAND.EQ.1.OR.MMODE.EQ.-1)PLUSCH=.FALSE.
   50	CALL	ZEROM(NTYPE,900)
	CALL	ZEROM(NTYPEA,30)
	CALL	ZEROM(ND0,600)
	CALL	ZEROM(NTYPDA,120)
	GWGHT=.TRUE.
	IF(IROOT.EQ.0.OR.MMODE.EQ.3)GWGHT=.FALSE.
	PLUSHYB=.TRUE.
	MNOMIN=0
	ISTAGE=0
	NSTAGE=0
	KSTAGE=0
	LNOCON=0
	KNOZ=3
	NTOTLE=0
	CUTO=0.5
	REMS=2.0
	 IF (NRAND.NE.1) GO TO 105
C
C  USE DIFFERENT CONSTANTS FOR MINIMIZATION FROM RANDOM COORDINATES
C
C	IF(DEBUG(8))CALL ERROR(6,'USING RANDOM COORD. CONSTANTS',1)
	HC(1)=5.
	HC(2)=2.
	HC(3)=2.
	ST(1)=0.25
	GO TO 2300
105	DO 200 I=1,3
200	HC(I)=1.
	ST(1)=.0005
2300	CONTINUE
	CALL	MINIT
C
C  SET CONSTANTS FOR FIRST STAGE
C
7375	ISTOP=1
	ISTAGE=1
	 NINCR=0
	JSTOP=1
	BCONST=BC(1)
	ACONST=AC(1)
	UBCONST=UBC(1)
	ANAT3=NT3(1)
	ATETC=NTC(1)
	ADIS=AD(1)
	STEP=ST(1)
	PSTEP=STEP
	BMAX=BM(1)
	CCONST=CC(1)
	DCONST=DC(1)
	SDCONST=SDC(1)
	HCONST=HC(1)
C	IF(DEBUG(14))WRITE(5,7485)(I,XM(I),YM(I),ZM(I),I=1,MNA)
C7485	FORMAT(' COORDS'/30(1X,I2,3F10.5/))
C
C  CALCULATE ENERGY FOR THE FIRST TIME
C
C	IF(DEBUG(8))CALL	ERROR(5,'CALLED ALLES FIRST TIME',1)
	CALL ALLES(ISTOP)
C	IF(DEBUG(8))WRITE(5,4150)TOTALE,BMAX
C	IF(.NOT.DEBUG(9).OR.(.NOT.PLUSDA))GO TO 7460
C	WRITE(5,7470)
C	DO 7480 I=1,NDA
C	DAN=57.3*DANGL(I)
C7480	WRITE(5,7490)I,ND1(I),ND2(I),ND3(I),ND4(I),NTYPDA(I),DAN,DNRG(I)
C7470	FORMAT(' DANGLE  ATOMS 1-4  NTYPDA  DEG.  DNRG')
C7490	FORMAT(1X,I3,1X,4I3,I5,F8.3,1X,F8.3)
7460	WRITE(5,9700)
	CALL	ZEROM(XTOT1,MNA)
	CALL	ZEROM(YTOT1,MNA)
	CALL	ZEROM(ZTOT1,MNA)
	TOT1=0.0
	TOT2=0.0
C
C  JUMP TO WAIT STATE AFTER OUTPUTTING INITIAL ENERGY
C
	GO TO 5200
C
C  RETURN HERE FROM WAIT STATE
C
 3400	IF(MOVEDA.EQ.1)GOTO 98765
	ATMN=MNA
C
C  ADJUST STEPPING CONSTANT ACCORDING TO STRAIN ENERGY/ATOM
C
	BM(1)=5.0
	TTENG=TOTALE/ATMN
C	IF(DEBUG(8))WRITE(5,3410)TTENG
C3410	FORMAT(' TTENG',F8.4)
	IF (LNOCON.EQ.1) GO TO 3550
	IF(ISTAGE.EQ.4)GO TO 3500
	K = ISTAGE+ 1
	IF (EC(K)-TTENG) 3500,3500,3450
 3450	STEP=ST(K)
	BMAX=BM(K)
 3500	CONTINUE
	PSTEP=STEP
C	IF(.NOT.DEBUG(8))GO TO 3550
C	WRITE(5,3430)ISTAGE,KSTAGE,KOUNT
3430	FORMAT(' STAGE ',I1,' KSTAGE ',I2,' KOUNT ',I2)
C	WRITE(5,3460)BMAX
C3460	FORMAT(' BMAX ',G9.4)
 3550	 C=BMAX/(5000.0)
C
C  SAVE ENERGY AND COORDINATES OF PREVIOUS STEP
C
3560	TOT2=TOT1
	TOT1=TOTALE
	CALL	COPYARY(XTOT1,XM,MNA)
	CALL	COPYARY(YTOT1,YM,MNA)
	CALL	COPYARY(ZTOT1,ZM,MNA)
	KOUNT=0
C
C  STEP ATOM I SEQUENTIALLY IN X,Y,Z DIRECTION, CALCULATING
C  RESULTING PARTIALS AND FINALLY RESTORE THE COORDINATES.
C
C	IF(DEBUG(8))CALL ERROR(3,'CALC. PARTIALS',1)
3565	CONTINUE
C3565	IF(DEBUG(15))WRITE(5,3710)
C3710	FORMAT(5X,' ATM DIR TANRG TBNRG TUBNRG TDNRG CNRG HNRG')
3600	DO 3900	I=1,MNA
	IF (MHOLD(I).EQ.1) GO TO 3900
	DO 3660 M=1,MNA
	ODIST(M)=DIST(I,M)
3660	CONTINUE
 3650	XO=XM(I)
	YO=YM(I)
	ZO=ZM(I)
	DO 3850	J=1,KNOZ
	SIGNN = 1.0
	IF(RAN(DUMMY).GT. 0.5) SIGNN = -1.0
	IF (J.EQ.1) XM(I)=XO+PSTEP*SIGNN
	IF (J.EQ.2) YM(I)=YO+PSTEP*SIGNN
	IF (J.EQ.3) ZM(I)=ZO+PSTEP*SIGNN
C	IF(DEBUG(16))WRITE(5,3670)I,J,SIGNN,PSTEP
C3670	FORMAT(' ATM ',I2,' DIR ',I1,' MOVED ',F3.0,'*',F7.5,' A.')
	CALL BONDS(I,2)
	CALL ANGLES(I,2)
	CALL NONBND(I,2)
3800	IF(PLUSDA)CALL	DANGLS(I,2)
	IF(.NOT.PLUSCH.OR.ISTAGE.EQ.4)GO TO 3825
	CALL	MCHIRAL(I,2)
	CPART(I,J)=(CNRG(I)-OCNRG(I))/(STEP*SIGNN)
3825	BPART(I,J)=(TBNRG(I)-OTBNRG(I))/(STEP*SIGNN)
	APART(I,J)=(TANRG(I)-OTANRG(I))/(STEP*SIGNN)
	IF(PLUSHYB)HPART(I,J)=(HNRG(I)-OHNRG(I))/(STEP*SIGNN)
	UBPART(I,J)=(TUBNRG(I)-OUBNRG(I))/(STEP*SIGNN)
	IF(PLUSDA)DPART(I,J)=(TDNRG(I)-OTDNRG(I))/(STEP*SIGNN)
	PART(I,J)=BPART(I,J)+APART(I,J)+UBPART(I,J)+DPART(I,J)+CPART
	1(I,J)+HPART(I,J)
	IF(GWGHT)PART(I,J)=PART(I,J)*GFACTR(I)
	IF(J.EQ.1)XN=XM(I)
	IF(J.EQ.2)YN=YM(I)
	IF(J.EQ.3)ZN=ZM(I)
	XM(I)=XO
	YM(I)=YO
	ZM(I)=ZO
C	IF(.NOT.DEBUG(15))GO TO 3850
C	WRITE(5,3720)I,J,OTANRG(I),OTBNRG(I),OUBNRG(I),OTDNRG(I),OCNRG(I
C	1),OHNRG(I)
C	WRITE(5,3730)I,J,TANRG(I),TBNRG(I),TUBNRG(I),TDNRG(I),CNRG(I)
C	1,HNRG(I)
C3720	FORMAT(' OLD NRGS',2I2,6F10.4)
C3730	FORMAT(' NEW NRGS',2I2,6F10.4)
3850	CONTINUE
C	IF(DEBUG(16))WRITE(5,3840)I,XO,YO,ZO,XN,YN,ZN
C3840	FORMAT(I3,' OLD COORD ',3F10.5/10X,'NEW ',3F10.5)
	DO 3875 M=1,MNA
3880	A=ODIST(M)
	DIST(I,M)=A
	DIST(M,I)=A
3875	CONTINUE
 3900	CONTINUE
C	IF(DEBUG(14))WRITE(5,7485)(I,XM(I),YM(I),ZM(I),I=1,MNA)
C	IF(.NOT.DEBUG(11))GO TO 3910
C	WRITE(5,3930)
C	DO 3920 I=1,MNA
C3920	WRITE(5,10350)I,(CORD(J),APART(I,J),BPART(I,J),UBPART(I,J),
C	1DPART(I,J),CPART(I,J),HPART(I,J),PART(I,J),J=1,3)
C10350	FORMAT(' ',I2,1X,A1,7(1X,F8.2),2(/4X,A1,7(1X,F8.2)))
C3930	FORMAT(' ATM DIR APART BPART UBPART DPART CPART HPART PARTIALS')
3910	JSTOP=ISTOP
	ISTOP=ISTOP+1
	KSTAGE=KSTAGE+1
	FACTR=0.
C	IF(DEBUG(8))WRITE(5,3430)ISTAGE,KSTAGE,KOUNT
C 3950	IF(DEBUG(8))CALL	ERROR(5,'MOVE ATOMS BY PARTIALS',1)
3950	DO 4050	I=1,MNA
	IF (MHOLD(I).EQ.1) GO TO 4050
C
C  ADJUST COORDINATES ON BASIS OF CALCULATED PARTIALS
C
 4000	XM(I)=XM(I)-(C*PART(I,1))
	YM(I)=YM(I)-(C*PART(I,2))
	IF (KNOZ.EQ.2.OR.MHOLD(I).EQ.2) GO TO 4050
	ZM(I)=ZM(I)-(C*PART(I,3))
C	IF(.NOT.DEBUG(16))GO TO 4050
C	XN=C*PART(I,1)
C	YN=C*PART(I,2)
C	ZN=C*PART(I,3)
C	WRITE(5,4060)I,XM(I),XN,YM(I),YN,ZM(I),ZN
C4060	FORMAT(' ATM ',I2,' NEW COORD DECREMENT'/' X ',2F10.5/
C	1' Y ',2F10.5/' Z ',2F10.5)
 4050	CONTINUE
C	IF(DEBUG(14))WRITE(5,7485)(I,XM(I),YM(I),ZM(I),I=1,MNA)
C
C  CALCULATE NEW TOTAL ENERGY
C
 4100	 CALL ALLES(-1)
C	IF ((.NOT.DEBUG(8)).AND.NTOTLE.EQ.0) GO TO 4210
C	WRITE(5,4150) TOTALE,BMAX
C 4150	FORMAT(1H ,F9.2,F6.2)
C
C  DO VARIOUS TESTS ON THE STRAIN ENERGY; THEN EITHER JUMP OUT,
C  OR ADJUST CONSTANTS AND DO ANOTHER 'REMOVEMENT'
C
4210	IF(TOTALE.LT.EFIN)GO TO 4220
C	IF(JTIME(DUM)/1000.-TBEG.GT.TMAX) GO TO 4220
	IF(ISTAGE.NE.4.OR.ABS(TOTALE-TOT1).GT.DELE)GO TO 4200
4220	WRITE(5,4140)TOTALE,JSTOP
4140	FORMAT(' FINAL STRAIN OF ',F7.3,' KCAL. AFTER ',I4,' ITERATIONS'
	1/)
	GO TO 9490
4200	IF(ISTAGE.EQ.4.AND.TOTALE.GT.(TOT1+2.))GO TO 4250
	IF (TOT1.GT.(0.0).AND.TOTALE.GT.(2.0*TOT1).AND.TTENG.LT.EC(2))
	1GO TO 4250
	IF (TOT2.GT.(0.0).AND.TOTALE.GT.(4.0*TOT2).AND.TTENG.LT.EC(2))
	1GO TO 4250
	IF (TOT1.GT.(0.0).AND.TOTALE.GT.(4.0*TOT1)) GO TO 4250
	IF (TOT2.GT.(0.0).AND.TOTALE.GT.(8.0*TOT2)) GO TO 4250
C	IF(DEBUG(8))CALL	ERROR(4,'PASSED REM NRG TEST',1)
	GO TO 4400
C
C  ENERGY INCREASED TOO MUCH; RESTORE COORDINATES, DECREASE
C  MOVEMENT CONSTANT AND DO 'REMOVEMENT' AGAIN.
C
 4250	CALL	COPYARY(XM,XTOT1,MNA)
	CALL	COPYARY(YM,YTOT1,MNA)
	CALL	COPYARY(ZM,ZTOT1,MNA)
	KOUNT=KOUNT+1
C	IF(DEBUG(8))WRITE(5,4260) KOUNT
C4260	FORMAT(' KOUNT ',I2)
	IF(KOUNT.GT.8)GO TO 4850
	IF(MOD(KOUNT,5).NE.0)GO TO 4370
C
C  ENERGY CHANGE TOO GREAT.  DECREASE STEPPING CONSTANT AND RECALCULATE
C  PARTIALS.
C
	PSTEP=0.5*PSTEP
	CALL	ALLES(ISTOP)
C	IF(DEBUG(8))CALL ERROR(4,'RECALC. PARTIALS',1)
	GO TO 3565
4370	IF(FACTR-1.)4350,4355,4360
4360	FACTR=1.
	GO TO 4355
 4350	FACTR=0.2*TOTALE/TOT1
	IF(FACTR.LE.3.)FACTR=1.
	IF(FACTR.EQ.1.)GO TO 4355
C	IF(DEBUG(8))WRITE(5,4380)FACTR
	BMAX=BMAX/FACTR
	C=C/FACTR
	GO TO 3950
C4380	FORMAT(' FACTR ',G8.3)
4355	BMAX=(0.8)*BMAX
	C=(0.8)*C
C	IF(DEBUG(8))CALL	ERROR(3,'BMAX DECR.*0.8',1)
	GO TO 3950
C
C  DO 'REMOVEMENT', MOVING ATOMS ACCORDING TO PARTIALS,
C  UNTIL ENERGY GOES UP OR IT HAS BEEN DONE MREMS TIMES.
C
 4400	KTESTB=0
	TTENG=TOTALE/ATMN
C	IF(DEBUG(8))WRITE(5,3410)TTENG
	C=BMAX/(REMS*(5000.0))
	MREMS=2.0*REMS
	KREMS=MREMS
 4450	TOTR=TOTALE
C	IF(DEBUG(14))WRITE(5,7485)(I,XM(I),YM(I),ZM(I),I=1,MNA)
	CALL	COPYARY(XTOT1,XM,MNA)
	CALL	COPYARY(YTOT1,YM,MNA)
	CALL	COPYARY(ZTOT1,ZM,MNA)
C	IF(DEBUG(8))CALL	ERROR(5,'RE-MOVE ATOMS BY PARTIALS',1)
	DO 4550	I=1,MNA
	IF (MHOLD(I).EQ.1) GO TO 4550
	XM(I)=XM(I)-(C*PART(I,1))
	YM(I)=YM(I)-(C*PART(I,2))
	IF (KNOZ.EQ.2.OR.MHOLD(I).EQ.2) GO TO 4550
	ZM(I)=ZM(I)-(C*PART(I,3))
 4550	CONTINUE
	CALL ALLES(-1)
C	IF(DEBUG(8))WRITE(5,4150)TOTALE,BMAX
	IF(TOTALE.GE.TOTR)GO TO 4750
	KTESTB=KTESTB+1
	IF (KTESTB.EQ.(MREMS+1)) GO TO 4600
	IF (KTESTB.GT.KREMS) GO TO 4650
	GO TO 4450
C
C  IF ENERGY STILL DECREASING AFTER (MREMS+1) 'REMOVEMENTS',
C  INCREASE MOVEMENT CONSTANT BY 25% AND CONTINUE.
C
4600	BM(ISTAGE) = 1.25*BM(ISTAGE)
	BMAX=1.25*BMAX
	C=1.25*C

C	IF(DEBUG(8))CALL	ERROR(3,'BMAX INCR.*1.25',1)
 4650	KREMS=KREMS+MREMS
	IF (KREMS.GT.(3*MREMS)) GO TO 4700
	GO TO 4450
 4700	TTENG=TOTALE/ATMN
C	IF(DEBUG(8))WRITE(5,3410)TTENG
	GO TO 4855
C
C  ENERGY WENT UP DURING LAST 'REMOVEMENT'; RESTORE ENERGY
C  AND COORDINATES.
C
 4750	CALL	COPYARY(XM,XTOT1,MNA)
	CALL	COPYARY(YM,YTOT1,MNA)
	CALL	COPYARY(ZM,ZTOT1,MNA)
C	IF(DEBUG(8))WRITE(5,4760)TOTALE
C4760	FORMAT(' NEW ENERGY TOO HIGH ',F8.3)
	TOTALE=TOTR
	TTENG=TOTR/ATMN
4855	BMAX=BM(ISTAGE)
C
C  TEST ENERGY TO DETERMINE IF WE SHOULD ADVANCE TO THE NEXT STAGE.
C  BUT NOT IF AN ATOM IS INVERTED IN CONFIGURATION.
C
 4850	IF(ISTAGE.EQ.4)GO TO 5055
	IF(INVATM.GT.0)GO TO 5055
	IF(NRAND.EQ.1.AND.KSTAGE.LT.10)GO TO 5055
	IF(KSTAGE.LT.5)GO TO 5000
	DIFSQ2=(TOTALE-TOT2)**2.0
	DIFSQ=(TOTALE-TOT1)**2.0
	DIFS=(DIFSQ+DIFSQ2)/2.0
C	IF(DEBUG(8))WRITE(5,4860)DIFSQ2,DIFSQ,DIFS,CUTO
C4860	FORMAT(' DIFSQ2',F9.3,' DIFSQ',F9.3,' DIFS',F9.3,' CUTO',F9.3)
	IF(DIFS.GE.CUTO)GO TO 5000
5120	KSTAGE=0
	ISTAGE=ISTAGE+1
C	IF((NSTAGE.EQ.1).OR.DEBUG(8))WRITE(5,3430)ISTAGE,KSTAGE,KOUNT
	GO TO 5050
5000	IF(LNOCON.EQ.1)GO TO 5055
	IF(ISTAGE.EQ.4)GO TO 5055
	L=ISTAGE+1
	IF(TTENG.GE.EC(L))GO TO 5055
C	IF(DEBUG(11))WRITE(5,5051)TTENG,EC(L)
C5051	FORMAT(' TTENG ',F8.2,' EC(L) ',F8.2)
C
C  CHANGE STAGE IF ENERGY WARRANTS
C
	ISTAGE=L
	IF(NSTAGE.EQ.1)WRITE(5,3430)ISTAGE,KSTAGE,KOUNT
	KSTAGE=0
5050	IF(MOVEDA.EQ.1)GOTO 98765
	BMAX = BM(ISTAGE)
	ACONST=AC(ISTAGE)
	BCONST=BC(ISTAGE)
	UBCONST=UBC(ISTAGE)
	HCONST=HC(ISTAGE)
	ADIS=AD(ISTAGE)
	ANAT3=NT3(ISTAGE)
	ATETC=NTC(ISTAGE)
	CCONST=CC(ISTAGE)
	DCONST=DC(ISTAGE)
	SDCONST=SDC(ISTAGE)
	STEP=ST(ISTAGE)
	PSTEP=STEP
	TOT1=0.0
	GO TO 5060
C
C  CHANGE STAGE IF OVER 25 ITERATIONS AT PRESENT STAGE
C
5055	IF(JSTOP.EQ.ITMAX)GO TO 5080
	GO TO 5100
5080	WRITE(5,5070)
5070	FORMAT(' TOO SLOW ')
	CALL ALLES(ISTOP)
	GO TO 4220
5060	IF(DEBUG(8))WRITE(5,3430)ISTAGE,KSTAGE,KOUNT
C
C  CALCULATE NEW ENERGY
C
 5100	CALL ALLES(ISTOP)
C	IF(DEBUG(8))WRITE(5,5110)TOTALE
C5110	FORMAT(' NEW ENERGY',F9.3)
	IF (NTOTLE.EQ.0) GO TO 5200
	WRITE(5,5150) TOTALE,BMAX,JSTOP,KTESTB,ISTAGE
 5150	FORMAT(1H ,F8.2,F6.2,1X,I3,1X,I2,1X,I1)
C
C  OUTPUT RESULT TO DISPLAY, READ KNOBS
C
 5200	IF(NTOTLE.NE.2)GO TO 5300
	WRITE(5,5310)
5310	FORMAT(' ATM: ANG, BND, NONB, DAN, STER, HYBR TERMS')
	DO 5320 I=1,MNA
5320	WRITE(5,5330)I,TANRG(I),TBNRG(I),TUBNRG(I),TDNRG(I),CNRG(I),HNRG(
	1I)
5330	FORMAT(1X,I2,6F8.3)
5300	CONTINUE
	IF (NUMU.GT.20) RETURN
	NRTFLG=0
	CALL OMOUT(JSTOP)
	NCSWIT=2
	CALL DMOL(MNA,XXXX,XM,YM,ZM,ANAMES)
	NCSWIT=0
	RETURN
C
C  EXIT TO UPDATE DISPLAY, THEN RETURN HERE.
C
10	IF (JSTOP.EQ.0.AND.MNOMIN.NE.1) GO TO 5600
	IF (MNOMIN.EQ.2) GO TO 5600
	 IF (MNOMIN.EQ.1) GO TO 5900
C
C  TEST FOR TELETYPE INPUT; ENTER WAIT STATE IF TRUE OR IF
C  REQUESTED NUMBER OF INCREMENTS HAVE BEEN COMPLETED.
C
	 NSTO=STOP(1)
	IF (NSTO) GO TO 5600
 5550	NINCR=NINCR-1
	IF (NINCR.EQ.1) GO TO 5600
	GO TO 3400
 5600	NINCR=0
	IF (NTOTLE.EQ.0) GO TO 5650
	WRITE(5,9700)
9700	FORMAT(' ',//)
	NSTO=.FALSE.
	GO TO 5700
 5650	IF (NSTO) GO TO 5800
5700	IF (NUMU.LT.20)WRITE (5,5701)
5701	FORMAT(//)
	WRITE(5,5750) JSTOP,TOTALE
 5750	FORMAT(' -STEP ',I4,':',F10.2,' KCALS'/)
	GO TO 5900
 5800	WRITE(5,5850) JSTOP,TOTALE
 5850	FORMAT(1H+,'STEP ',I4,':',F10.2,' KCALS'/)
	NSTO=.FALSE.
 5900	WRITE(5,5950)
 5950	FORMAT(1H+,'-',$)
C
C  ENTER WAIT MODE
C
	CALL MWAIT(I,MNOMIN,NSCALL,NTOTLE,ANAMES,XXXX)
	GO TO(9490,5900,12050,5050),I
9490	IFIN=-1
	RETURN
12050	IF (NACALL.EQ.1) CALL ALLES(ISTOP)
	IF (NSCALL.EQ.1) GO TO 5200
	IF (MNOMIN.NE.0.AND.NINCR.EQ.0) GO TO 5900
	KOUNT=0
	GO TO 3400
	END
C  ###
	SUBROUTINE ALLES(ISTOP)
	COMMON/GEN/TOTALE,INVATM,ISTAGE,IROOT/DISTX/DIST/ALENG/
	1TUBNRG,OTANRG,TANRG,TBNRG,OUBNRG,OTBNRG
	2/BOND/BNRG,NTYPE,BCONST,ADIS,UBCONST/
	4ANGL/THETA,NAA,N1,N2,ANRG,NTYPEA,ACONST,ATETC,ANAT3
	COMMON/HCONST/HCONST,SUMA(30),HNRG(30),OHNRG(30)
	COMMON/PLUSDA/PLUSDA,PLUSCH,PLUSHYB
	COMMON/CHRL/CNRG(30),OCNRG(30),CCONST
	COMMON/DEBUG/DEBUG(16)
	COMMON/MZCONN/MNA,MNB,MNDB,MNXH,MATYP(30),MNATCH(30),MATBD(30,4)
	1,MBTYP(30,4),MHOLD(30),XM(30),YM(30),ZM(30),JSTOP
	COMMON/DANGL/DANGL(120),NTYPDA(120),ND1(120),ND2(120),ND3(120)
	1,ND4(120),DCONST,DNRG(120),TDNRG(30),OTDNRG(30),NDA,ND0(30,20)
	2,ITEMP(40),SDCONST
	DIMENSION DIST(30,30),TUBNRG(30),OTANRG(30),
	1TANRG(30),TBNRG(30),OUBNRG(30),OTBNRG(30),
	2BNRG(30,30),NTYPE(30,30)
	DIMENSION THETA(30,6),NAA(30),N1(30,6),N2(30,6),
	1ANRG(30,6),NTYPEA(30)
C	IF(DEBUG(8))CALL	ERROR(1,'ALLES',1)
	TOTALE=0.0
	MP=1
	IF(ISTOP.EQ.-1)MP=-1
	INVATM=0

	CALL	ZEROM(DIST,900)
	CALL	ZEROM(BNRG,900)
	CALL	ZEROM(DNRG,120)
	CALL	ZEROM(CNRG,30)
	CALL	ZEROM(HNRG,30)
	DO 150	I=1,MNA
  150	CALL BONDS(I,MP)
C	IF(DEBUG(8))WRITE(5,950)TOTALE
C950	FORMAT(' TOTALE AFTER BONDS ',F10.5)
	DO 200	I=1,MNA
  200	CALL ANGLES(I,MP)
C	IF(DEBUG(8))WRITE(5,1000)TOTALE
C1000	FORMAT(' TOTALE AFTER ANGLES ',F10.5)
	DO 250	I=1,MNA
  250	CALL NONBND(I,1)
C	IF(DEBUG(12))WRITE(5,900)(TUBNRG(I),I=1,MNA)
C900	FORMAT(' TUBNRG '/10(1X,7F9.5))
C	IF(DEBUG(8))WRITE(5,1050)TOTALE
C1050	FORMAT(' TOTALE AFTER NONBND ',F10.5)
	IF(PLUSDA)CALL	DANGLS(I,1)
C	IF(DEBUG(8))WRITE(5,1100)TOTALE
C1100	FORMAT(' TOTALE AFTER DANGLS ',F10.5)
	IF(.NOT.PLUSCH.OR.ISTAGE.EQ.4)GO TO 270
	DO 260 I=1,MNA
	CALL	MCHIRAL(I,MP)
260	CONTINUE
C	IF(DEBUG(8))WRITE(5,1150)TOTALE
C1150	FORMAT(' TOTALE AFTER MCHIRAL ',F10.5)
270	IF (ISTOP.EQ.-1) GO TO 800
	CALL SINENG
	CALL	COPYARY(OTANRG,TANRG,MNA)
	CALL	COPYARY(OTBNRG,TBNRG,MNA)
	CALL	COPYARY(OUBNRG,TUBNRG,MNA)
	IF(PLUSHYB)CALL	COPYARY(OHNRG,HNRG,MNA)
	IF(PLUSDA)CALL	COPYARY(OTDNRG,TDNRG,MNA)
	IF(PLUSCH)CALL	COPYARY(OCNRG,CNRG,MNA)
800	CONTINUE
	RETURN
	END
