      SUBROUTINE NAMODI (CO,IE,NUATOM,PERS,THICK,RADIUS)
C
C     CHIEF SUBROUTINE OF NAGOYA MOLECULAR DISPLAY.
C     ATOMS ARE REPRESENTED BY CIRCLES.
C     BONDS ARE REPRESENTED BY TWO LINES WHICH ARE IDENTICAL WITH
C     THE TWO NON-PARALLEL SIDES OF ISOSCELES TRAPEZOIDS.
C
      DIMENSION  CO(3,72),IE(72)
      COMMON /BONDS/ NBNDS,BNDAT(2,72),BTYPE(72)
      INTEGER BNDAT, BTYPE
      COMMON /ATOMS/ NAT,ICONN(4,72),NCONN(72),NAMES(72),NCNT(72),
     1               ITYPE(72)
      COMMON /NAREAL/ FORINI(50),FORFIN(50),ALLINI(50),ALLFIN(50)     ,
     1                XREC(5),YREC(5),CT(36),ST(36),DTHETA,CD,SD    ,
     2                A,COEFF1,COEFF2,COEFF3,R(72),BOND(3,288)
      COMMON /NAINTE/ NUSIDE,NO,NUBOND,INDCL
      NUSIDE = 24
      IF (PERS.LE.0.0) PERS = 1.0
      IF (THICK.LE.0.0) THICK = 1.0
      IF (RADIUS.LE.0.0) RADIUS = 1.0
      NO = 0
      ZMIN = CO(3,1)
      ZMAX = CO(3,1)
      DO 10 IA = 2,NUATOM
      IF (CO(3,IA).LT.ZMIN) ZMIN = CO(3,IA)
      IF (CO(3,IA).GT.ZMAX) ZMAX = CO(3,IA)
   10 CONTINUE
      DO 20 IA = 1,NUATOM
   20 CO(3,IA) = CO(3,IA)-ZMIN
      ZMAX = ZMAX-ZMIN
      IF (ABS(ZMAX).LT.0.01) ZMAX = 0.1
      A = 0.2*PERS/ZMAX
      CALL NACSCA
      CALL NARACA (CO,IE,NUATOM,RADIUS)
      COEFF1 = 1.28*THICK*A
      COEFF2 = 0.2*THICK
      COEFF3 = 1.55*THICK
      DO 30 I = 1,NBNDS
      KA = BNDAT(1,I)
      KB = BNDAT(2,I)
      DIST = (CO(1,KA)-CO(1,KB))**2 + (CO(2,KA)-CO(2,KB))**2
      CALL NAPOCA (KA,KB,CO,IE,NUATOM,DIST)
   30 CONTINUE
      NUBOND = NO/4
      CALL DOPEN(1)
      CALL NACIDI (CO,NUATOM)
      CALL NALIDI (CO,NUATOM)
      CALL DCLOSE(1)
      CALL DPOST(1)
      CALL DDONE
      DO 50 IA = 1,NUATOM
   50 CO(3,IA) = CO(3,IA)+ZMIN
      RETURN
      END
      SUBROUTINE NACSCA
C
C     CT AND ST FOR DRAWING CIRCLES ARE CALCULATED.
C
      COMMON /NAREAL/ FORINI(50),FORFIN(50),ALLINI(50),ALLFIN(50)     ,
     1                XREC(5),YREC(5),CT(36),ST(36),DTHETA,CD,SD    ,
     2                A,COEFF1,COEFF2,COEFF3,R(72),BOND(3,288)
      COMMON /NAINTE/ NUSIDE,NO,NUBOND,INDCL
      NSIDE = NUSIDE
      IF (NUSIDE.GT.36) NSIDE = 36
      DTHETA = 6.282/FLOAT(NSIDE)
      CD = COS(DTHETA)
      SD = SIN(DTHETA)
      COSOLD = 1.0
      SINOLD = 0.
      DO 10 I = 1,NUSIDE
      COSTHE = COSOLD*CD-SINOLD*SD
      SINTHE = SINOLD*CD+COSOLD*SD
      CT(I) = COSTHE
      ST(I) = SINTHE
      COSOLD = COSTHE
   10 SINOLD = SINTHE
      RETURN
      END
      SUBROUTINE NARACA (CO,IE,NUATOM,RADIUS)
C
C     RADII OF CIRCLES WHICH REPRESENT ATOMS ARE CALCULATED, USING
C
      COMMON /NAREAL/ FORINI(50),FORFIN(50),ALLINI(50),ALLFIN(50)     ,
     1                XREC(5),YREC(5),CT(36),ST(36),DTHETA,CD,SD    ,
     2                A,COEFF1,COEFF2,COEFF3,R(72),BOND(3,288)
      COMMON /NAINTE/ NUSIDE,NO,NUBOND,INDCL
      DIMENSION  CO(3,72),IE(72)
      DO 10 IA = 1,NUATOM
      R(IA) = RADIUS
      IF (A.GT.0.0) R(IA) = RADIUS * (A*CO(3,IA)+0.185)
      IF (IE(IA).EQ.1) R(IA) = 0.5*R(IA)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE NAPOCA (IA,IB,CO,IE,NUATOM,D2D2AB)
C
C     COORDINATES OF INITIAL AND FINAL POINTS OF THE LINES
C    WHICH REPRESENT THE BONDS ARE CALCULATED.
C     IA<IB
C     COZ(JA).GT.COZ(JB)
C     THE NUMBERING OF 4 POINTS,NO1-NO2-NO3-NO4,IS CLOCKWISE.  PIVOT IS
C    ON ATOM-JA.
C
      DIMENSION  CO(3,72),IE(72)
      COMMON /NAREAL/ FORINI(50),FORFIN(50),ALLINI(50),ALLFIN(50)     ,
     1                XREC(5),YREC(5),CT(36),ST(36),DTHETA,CD,SD    ,
     2                A,COEFF1,COEFF2,COEFF3,R(72),BOND(3,288)
      COMMON /NAINTE/ NUSIDE,NO,NUBOND,INDCL
      IF (NO.GE.288) RETURN
      RR = R(IA)+R(IB)
      RR2 = RR*RR
      IF (RR2.GT.D2D2AB) RETURN
      D2IAIB = SQRT(D2D2AB)
      IF (CO(3,IA).GT.CO(3,IB)) GO TO 70
      JA = IB
      JB = IA
      GO TO 80
   70 JA = IA
      JB = IB
   80 IF (D2IAIB.LT.0.001) RETURN
      RD2 = R(JA)/D2IAIB
      EQAX = (CO(1,JB)-CO(1,JA))*RD2
      EQAY = (CO(2,JB)-CO(2,JA))*RD2
      EQAZ = (CO(3,JB)-CO(3,JA))*RD2 + CO(3,JA)
      THETAA = COEFF1*CO(3,JA)+COEFF2
      IF (IE(JA).EQ.1) THETAA = COEFF3*THETAA
      COTHEA = COS(THETAA)
      SITHEA = SIN(THETAA)
      AA = COTHEA*EQAX
      BB = SITHEA*EQAY
      CC = SITHEA*EQAX
      DD = COTHEA*EQAY
      NO1 = NO+1
      BOND(1,NO1) = AA-BB+CO(1,JA)
      BOND(2,NO1) = CC+DD+CO(2,JA)
      BOND(3,NO1) = EQAZ
      NO4 = NO+4
      BOND(1,NO4) = AA+BB+CO(1,JA)
      BOND(2,NO4) = DD-CC+CO(2,JA)
      RD2 = R(JB)/D2IAIB
      EQBX = (CO(1,JA)-CO(1,JB))*RD2
      EQBY = (CO(2,JA)-CO(2,JB))*RD2
      EQBZ = (CO(3,JA)-CO(3,JB))*RD2 + CO(3,JB)
      THETAB = COEFF1*CO(3,JB)+COEFF2
      IF (IE(JB).EQ.1) THETAB = COEFF3*THETAB
      COTHEB = COS(THETAB)
      SITHEB = SIN(THETAB)
      AA = COTHEB*EQBX
      BB = SITHEB*EQBY
      CC = SITHEB*EQBX
      DD = COTHEB*EQBY
      NO3 = NO+3
      BOND(1,NO3) = AA-BB+CO(1,JB)
      BOND(2,NO3) = CC+DD+CO(2,JB)
      BOND(3,NO3) = EQBZ
      NO2 = NO+2
      BOND(1,NO2) = AA+BB+CO(1,JB)
      BOND(2,NO2) = DD-CC+CO(2,JB)
      BOND(3,NO2) = FLOAT(JB)
      NO = NO4
      BOND(3,NO4) = 5.
      IF (ABS(EQBX-EQAX).LT.0.005) RETURN
      IF (ABS(EQBY-EQAY).LT.0.005) RETURN
      BOND(3,NO4) = 3.
      IF (EQBX.GT.EQAX) GO TO 90
      BOND(3,NO4) = 1.
      IF (EQBY.GT.EQAY) BOND(3,NO4) = 4.
      RETURN
   90 IF (EQBY.LT.EQAY) BOND(3,NO4) = 2.
      RETURN
      END
      SUBROUTINE NAPLOT (X,Y,IND)
      IF (IND.EQ.2) CALL DDRAW(X,Y)
      IF (IND.EQ.3) CALL DMOVE(X,Y)
      RETURN
      END
