C 	COPYRIGHT (C) 1981 BY BOARD OF TRUSTEES,
C 	LELAND STANFORD JUNIOR UNIVERSITY
C
      SUBROUTINE PREL1(IOPN1,DUMP,NDIM,IERR)
C  PRELIMINARY OPERATIONS, BEFORE CALLING EMBED.
C PERFORMS ALL INPUT OPERATIONS ON XXXSC1.CG FILE
C CHECK AND RESET STEREOFLAGS ACCORDING TO THE NEW NUMBERING
C DEFINE ATOM TYPES, NUMBER OF NEIGHBORS
C DEFINE ALL 1,2 BONDS
      COMMON /ATOMS/ NAT,ICONN(4,72),NCONN(72),NAMES(72),NCNT(72),
     1 ITYPE(72)
      COMMON /LABEL/ TITLE(16),LTITLE
      COMMON /ATSPEC/ NSPEC,ANAM(10),AVAL(10),IOLD(72),INEW(72)
      COMMON /JUNK/ IJUNK,IDUNNO(72)
      COMMON /RETINF/ IJN,IPART,IDEV,IPPN,ISAV
      COMMON /BONDS/ NBNDS,BNDAT(2,72),BTYPE(72)
      INTEGER BNDAT,BTYPE
      INTEGER ANAM,AVAL,TITLE,BLANK
      DOUBLE PRECISION FILNAM
      EQUIVALENCE (IFN,FILNAM)
      DIMENSION LINE(160)
      COMMON /STEREO/ ISTER(72)
      INTEGER AFT(4),BEF(4)
      LOGICAL IOPN1,DUMP,WORRY,DBOND,UNFLIP
      DATA FILNAM /'000SC1.CG'/, BLANK /'     '/
      DATA MAXLN /160/, MAXAT, MAXBND /72,72/
C
      CALL ZEROM(ICONN,8*NDIM)
      NAT = 0
      CALL ZEROM(BNDAT,3*NDIM)
      NBNDS = 0
      CALL ZEROM(ISTER,NDIM)
      CALL ZEROM(TITLE,16)
      LTITLE = 0
      IERR = 0
C
      IF (IOPN1) GO TO 100
C 1)  SETUP FILE NAME AND OPEN
      CALL MAKFIL (FILNAM)
      OPEN(UNIT=1,FILE=FILNAM,DEVICE='DSK',MODE='ASCII',ACCESS='SEQIN')
      IOPN1 = .TRUE.
C 2)  READ RETURN INFORMATION AND NUMBER OF ATOM SPECS
      READ(1,1000)(LINE(I),I=1,160)
 1000 FORMAT (160A1)
      IPNT = 1
      IPART = LOP6B(LINE,IPNT,MAXLN,ICNT)
      IDEV = LOPNUM(LINE,IPNT,MAXLN)
      IPPN = LOPNUM(LINE,IPNT,MAXLN)
      ISAV = LOPNUM(LINE,IPNT,MAXLN)
      NSPEC = LOPNUM(LINE,IPNT,MAXLN)
C 3)  READ ATOM DEFINITIONS (NAMES AND USUAL VALENCE)
      READ(1,1000)(LINE(I),I=1,160)
      IPNT = 1
      DO 10 I = 1,NSPEC
      ANAM(I) = LOPWRD(LINE,IPNT,MAXLN,ICNT)
      AVAL(I) = LOPNUM(LINE,IPNT,MAXLN)
   10 CONTINUE
C
      READ(1,1000)(LINE(I),I=1,160)
      IPNT = 1
      IJUNK = LOPNUM(LINE,IPNT,MAXLN)
      RETURN
C 4)  READ NUMBER OF ATOMS
  100 READ(1,1000)(LINE(I),I=1,160)
      IPNT = 1
      NAT = LOPNUM(LINE,IPNT,MAXLN)
      IF (NAT.LE.0) GO TO 9999
      IF (NAT.GT.MAXAT) GO TO 8000
C 5)  READ CONNECTION TABLE
      DO 30 I = 1,NAT
      DO 1020 J = 1,4
      ICONN(J,I) = 0
 1020 CONTINUE
      READ(1,1000) (LINE(J),J=1,160)
      IPNT = 1
C  NAMES CONTAINS ATOM NAMES AND NCNT THE CHARACTER COUNT OF NAME.
      NAMES(I) = LOPWRD(LINE,IPNT,MAXLN,ICNT)
      NCNT(I) = ICNT
      ISTER(I) = LOPNUM(LINE,IPNT,MAXLN)
      IDUNNO(I) = LOPNUM(LINE,IPNT,MAXLN)
C  FIND ATOM'S "NORMAL" VALENCE, STORE IN ITYPE
      DO 22 J = 1,NSPEC
      IVAL = AVAL(J)
      IF (NAMES(I).EQ.ANAM(J)) GO TO 23
   22 CONTINUE
C  ASSUME A DEFAULT VALENCE OF 4 FOR UNIDENTIFIED ATOMS
C  (THOU SHALST NOT HAVE UNIDENTIFIED ATOMS !!!!)
      IVAL = 4
   23 ITYPE(I) = IVAL
      NCONNI = 0
      DO 24 J = 1,4
      IC = LOPNUM(LINE,IPNT,MAXLN)
      IF (IC.LE.0) GO TO 25
      NCONNI = NCONNI + 1
      ICONN(J,I) = IC
   24 CONTINUE
   25 CONTINUE
C  MAKE SURE THAT THE NEIGHBORS OF I ARE LISTED IN ASCENDING ORDER
      NCM1 = NCONNI - 1
      IF (NCM1.LE.0) GO TO 29
      DO 27 J = 1,NCM1
      JJ = J + 1
      DO 26 K = JJ,NCONNI
      IF (ICONN(K,I).GE.ICONN(J,I)) GO TO 26
      ITEMP = ICONN(K,I)
      ICONN(K,I) = ICONN(J,I)
      ICONN(J,I) = ITEMP
   26 CONTINUE
   27 CONTINUE
   29 CONTINUE
C  NCONN(I) IS THE NUMBER OF CONNECTIONS TO I
      NCONN(I) = NCONNI
C  TO MAKE A STEREOCENTER, ONE MUST HAVE AT LEAST 3 NEIGHBORS ON A
C  CARBON ATOM, AND 3 ON NITROGEN AND PHOSPHORUS, TOO.
      IF (NCONNI.GE.3) GO TO 30
      ISTER(I) = -1
   30 CONTINUE
C
      READ(1,1100) (TITLE(I),I=1,16)
 1100 FORMAT (16A5)
C FIND LENGTH OF TITLE LINE (IN WORDS)
      LTITLE = 0
      DO 35 I = 1,16
      IF (TITLE(I).EQ.BLANK) GO TO 36
      LTITLE = LTITLE + 1
   35 CONTINUE
   36 CONTINUE
C 6)  READ RENUMBERING TABLE
      DO 40 I = 1,NAT
      READ(1,1000) (LINE(J),J=1,160)
      IPNT = 1
      INEW(I) = LOPNUM(LINE,IPNT,MAXLN)
      IOLD(I) = LOPNUM(LINE,IPNT,MAXLN)
   40 CONTINUE
C  TEST IF NEW NUMBERING GOES IN THE SAME SENSE AS THE OLD ONE. IF
C  THIS IS THE CASE, SKIP THE NEXT SECTION.
      UNFLIP = ((IOLD(1).LT.IOLD(NAT).AND.INEW(1).LT.INEW(NAT)) .OR.
     1  (IOLD(1).GT.IOLD(NAT).AND.INEW(1).GT.INEW(NAT)))
      IF (UNFLIP) GO TO 175
C
C  FLIP ALL PERTINENT ARRAYS IF RENUMBERING GOES BACKWARDS.
C
      NAT2 = NAT/2
      DO 120 I1 = 1,NAT2
      I2 = NAT+1 - I1
      ITEMP = NAMES(I1)
      NAMES(I1) = NAMES(I2)
      NAMES(I2) = ITEMP
      ITEMP = NCNT(I1)
      NCNT(I1) = NCNT(I2)
      NCNT(I2) = ITEMP
      ITEMP = ISTER(I1)
      ISTER(I1) = ISTER(I2)
      ISTER(I2) = ITEMP
      ITEMP = IDUNNO(I1)
      IDUNNO(I1) = IDUNNO(I2)
      IDUNNO(I2) = ITEMP
      ITEMP = NCONN(I1)
      NCONN(I1) = NCONN(I2)
      NCONN(I2) = ITEMP
      ITEMP = ITYPE(I1)
      ITYPE(I1) = ITYPE(I2)
      ITYPE(I2) = ITEMP
      DO 110 J = 1,4
      ITEMP = ICONN(J,I1)
      ICONN(J,I1) = ICONN(J,I2)
      ICONN(J,I2) = ITEMP
  110 CONTINUE
  120 CONTINUE
      DO 170 I = 1,NAT
      DO 130 J = 1,4
      AFT(J) = ICONN(J,I)
  130 CONTINUE
      LIM = NCONN(I)
      DO 140 J = 1,LIM
      JJ = LIM+1 - J
      ICONN(JJ,I) = NAT+1 - AFT(J)
  140 CONTINUE
  170 CONTINUE
C
C  COMPLETE THE CONNECTION TABLE WITH HYDROGENS ON THE CHIRAL
C  CENTERS. ACHIRAL CENTERS WHOSE STEREOFLAG IS NOT -1 WILL BE
C  COMPLETED TOO.
C
  175 NHYD = 0
      DO 190 I = 1,NAT
      IF (ISTER(I).LT.0) GO TO 190
      LIM = NCONN(I) + 1
      IVAL = ITYPE(I)
      IF (LIM.GT.IVAL) GO TO 190
      DO 180 J = LIM,IVAL
      NHYD = NHYD + 1
      INDXH = NAT + NHYD
      IF (INDXH.GT.MAXAT) GO TO 8100
      ICONN(J,I) = INDXH
      ICONN(1,INDXH) = I
      NCONN(I) = NCONN(I) + 1
      NAMES(INDXH) = 'H'
      NCNT(INDXH) = 1
      ISTER(INDXH) = -1
      IDUNNO(INDXH) = 1
      ITYPE(INDXH) = 1
  180 CONTINUE
  190 CONTINUE
      ONAT = NAT
      NAT = NAT + NHYD
C  INVERT STEREOFLAGS ...
      DO 195 I = 1,ONAT
      IF (ISTER(I).LT.0) GO TO 195
C  ... IF HYDROGEN ATOM HAS BEEN ADDED ON A TETRAVALENT ATOM...
      IF (ICONN(4,I).GT.ONAT) ISTER(I) = 1 - ISTER(I)
C  ... OR IF TERTIARY TRIVALENT (N,P)
      IF (ITYPE(I).NE.3) GO TO 195
      IF (NAMES(I).EQ.'N'.OR.NAMES(I).EQ.'P') ISTER(I) = 1 - ISTER(I)
  195 CONTINUE
C
      IF (.NOT.DUMP) GO TO 200
      WRITE (20,2000) (TITLE(I),I=1,LTITLE)
 2000 FORMAT (1H1,120(1H-)//' DATA HAS BEEN READ FOR ',16A5)
      WRITE (20,2010) NAT
 2010 FORMAT (' THERE ARE ',I2,' ATOMS IN THE MOLECULE'/
     1 ' THE MODIFIED CONNECTION TABLE IS:')
      DO 198 I = 1,NAT
      LIM = NCONN(I)
      WRITE (20,2020) I,NAMES(I),ISTER(I),(ICONN(J,I),J=1,LIM)
 2020 FORMAT (2X,I3,2X,A4,2X,5I4)
  198 CONTINUE
C
C  NOW DEFINE BONDS. BNDAT(1,I) AND BNDAT(2,I) ARE THE TWO ENDS OF
C  BOND I. BTYPE(I) IS THE MULTIPLICITY
C
  200 NBNDS = 0
      DO 210 I = 1,MAXBND
      BNDAT(1,I) = 0
      BNDAT(2,I) = 0
      BTYPE(I) = 0
  210 CONTINUE
      DO 250 J = 1,NAT
      LIM = NCONN(J)
      IPREV = 0
      DO 240 K = 1,LIM
      IKJ = ICONN(K,J)
      IF (IKJ.LT.J) GO TO 240
      IF (IKJ.EQ.IPREV) GO TO 230
      NBNDS = NBNDS + 1
      IF (NBNDS.GT.MAXBND) GO TO 8200
      BNDAT(1,NBNDS) = J
      BNDAT(2,NBNDS) = IKJ
      BTYPE(NBNDS) = 1
      IPREV = IKJ
      GO TO 240
  230 BTYPE(NBNDS) = BTYPE(NBNDS) + 1
C FOR EACH MULTIPLE BOND, DECREASE ITYPE, SO THAT ITYPE BECOMES
C THE NUMBER OF ATOMS CONNECTED TO J AND IKJ, HYDROGENS INCLUDED
      ITYPE(J) = ITYPE(J) - 1
      ITYPE(IKJ) = ITYPE(IKJ) - 1
  240 CONTINUE
  250 CONTINUE
C
      RETURN
 8000 IERR = 1
      WRITE(5,18000)
18000 FORMAT (' SIZE OF MOLECULE EXCEEDS STORAGE CAPACITY'/)
      GO TO 9999
 8100 IERR = 2
      WRITE(5,18100)
18100 FORMAT (' STORAGE OVERFLOW DURING HYDROGEN ADDITION'/)
      GO TO 9999
 8200 IERR = 3
      WRITE(5,18200)
18200 FORMAT (' BOND STORAGE OVERFLOW'/)
C
 9999 CLOSE(UNIT=1)
      IOPN1 = .FALSE.
      RETURN
      END
