      SUBROUTINE RINGGG (NODE,BRATAR,BRATC,RET)
C
C      THIS SUBROUTINE IS DESIGNED TO LAYOUT A PARTICULAR
C      NUCLEUS WITHIN THE STRUCTURAL IMAGE BEING GENERATED.
C      ALL ACYCLIC BRANCH POINTS FROM THE RINGS ARE ALSO SAVED.
C      THE ARGUMENTS TO THIS ROUTINE ARE DEFINED AS:
C
C      NODE   - NODE NUMBER OF A MEMBER OF THE NUCLEUS TO BE
C               POSITIONED.
C      BRATAR - ARRAY CONTAINING NODE NUMBERS OF ACYCLIC BRANCH
C               POINTS (ACYCLIC NODES CONNECTED TO CYCLIC NODES)
C      BRATC  - NUMBER OF ACYCLIC BRANCH POINTS.
C      RET    - SUCCESS INDICATOR (0 - SUCCESSFUL ; 1 - NOT
C               SUCCESSFUL).
C
      IMPLICIT INTEGER (A-Z)
      REAL XANG
      COMMON /RECC/ RECCNT,RECLIM
      DIMENSION BRATAR(10)
      COMMON /OTHRIN/ ORC,ORING(100)
      COMMON /PUSH/ PUSH1(100),PUSH2(200),PUSH3(100)
      COMMON /PUSLIM/ P1LIM,P2LIM,P3LIM
      COMMON /CASA/ NUMB,AR(10,100),BCDER(6,100)
      COMMON /LAYSCR/ SMRAR(90),TEMAR(70),PRING(20)
      COMMON /FRDIR/ FRDIR
      DIMENSION UNPAK(4)
      EQUIVALENCE (UNPAK(1),IC),(UNPAK(2),ID),(UNPAK(3),NP),
     1  (UNPAK(4),ICL)
      DATA BGRNG/5HBGRNG/ , OVFL1/5HOVFL1/
C
C      INITIALIZE PARAMETERS, SET STARTING POINT IN CON-
C      NECTION TABLE.
C
      IC=0
      BRATC=0
      NRING = 0
      NXTR = 1
      NUCNUM = ORING(NODE)
      PC = 1
C
C      EXAMINE NEXT NODE IN CONNECTION TABLE (RETURN TO
C      CALLING PROGRAM WHEN NO MORE). IGNORE NODE IF IT IS NOT
C      A MEMBER OF THE DESIGNATED NUCLEUS, OR IF IT HAS ALREADY
C      BEEN POSITIONED. OTHERWISE, BEGIN PUSHDOWN TRACING OF
C      RING.
C
   10 CONTINUE
      SMRL = 8
      IC=IC+1
      IF(IC .GT. NUMB) GO TO 11
      IF (ORING(IC).NE.NUCNUM) GO TO 10
      IF (AR(3,IC).NE.0) GO TO 10
      DO 20 II=5,10
      IF (AR(II,IC).EQ.0) GO TO 10
      III = AR(II,IC)
      IF (AR(3,III).NE.0) GO TO 30
   20 CONTINUE
      GO TO 10
   30 CONTINUE
      CALL REGPS (9)
      CALL REGP (PUSH1(1),IC)
      CALL REGP (PUSH1(1),0)
      CALL REGP (PUSH1(1),0)
      CALL REGP (PUSH1(1),0)
      ICL=0
      I2=PC+1
      IT = 2
      NP = 1
      TEMAR(1)=IC
      TEMAR(2) = III
      ICL = IC
      IC = III
      SMR=1000
C
C      PREPARE TO EXAMINE ALL NEIGHBORS TO IC'TH NODE.
C
  400 CONTINUE
      ID=4
C
C      OBTAIN NEXT NEIGHBOR TO IC'TH NODE, IGNORE IF AL-
C      READY MARKED ACYCLIC. IF NO MORE NEIGHBORS, GO TO RESUME
C      TRACING FROM LAST BRANCH POINT. ALSO PREVENT RETRACING
C      THE INVERSE CONNECTION TO THE PREVIOUS NODE.
C
  200 CONTINUE
      ID=ID+1
      IF(ID .GT. 10) GO TO 500
      I31=AR(ID,IC)
      IF(I31 .EQ. 0 )GO TO 500
      IF (ORING(I31).EQ.0) GO TO 200
      IF(I31 .EQ. ICL) GO TO 200
C
C      IF THE ADDITION OF THIS NODE TO THE PATH DOES NOT
C      CAUSE RING CLOSURE, ADD THE POINT AS A POTENTIAL BRANCH
C      POINT TO THE PUSHDOWN STACK (ERROR IF PUSHDOWN STACK CA-
C      PACITY IS EXCEEDED) AND PREPARE TO CONTINUE PATH BY
C      TRACING NEIGHBORS TO NODE JUST ADDED TO PATH. DO NOT
C      CONTINUE PATH, HOWEVER, IF ADDING ANOTHER NODE WOULD
C      CAUSE THE PATH TO BE LARGER THAN THE PREFERRED PATH
C      (RING) SIZE.
C
      DO 301 I3=1,IT
      IF(TEMAR(I3) .EQ. I31) GO TO 302
  301 CONTINUE
      IT=IT+1
      TEMAR(IT)=I31
      CALL REGPS (9)
      CALL REGP (PUSH1(I2),IC)
      CALL REGP (PUSH1(I2),ID)
      CALL REGP (PUSH1(I2),NP)
      CALL REGP (PUSH1(I2),ICL)
      I2=I2+PC
      IF(I2 .LE. P1LIM) GO TO 5051
      CALL WO (OVFL1)
      RECCNT=1000000
      RETURN
 5051 CONTINUE
      IF (IT.GT.SMRL) GO TO 500
      ICL=IC
      IC=I31
      IF (AR(3,IC).NE.0) NP = NP+1
      GO TO 400
C
C      NODE JUST ADDED TO PATH CAUSES RING CLOSURE. IGNORE
C      NODE IF NOT PROPER RING CLOSURE (TO FIRST NODE IN PATH).
C      IF A SIX-MEMBERED RING, SAVE AND IMMEDIATELY POSITION IT
C      (IT IS PREFERRABLE TO POSITION SIX-MEMBER RINGS FIRST IN
C      A MULTI-RING NUCLEUS). IF SMALLER THAN A SIX-MEMBERED
C      RING, SAVE IF IT IS THE LARGEST RING SO FAR; OTHERWISE
C      SAVE IF IT IS THE SMALLEST.
C
  302 CONTINUE
      IF(I3 .NE. 1) GO TO 200
      IF (SMR.GE.6) GO TO 310
      IF (NP.GT.2) GO TO 310
      IF (IT.EQ.3) GO TO 320
      IF (IT.LE.SMR) GO TO 200
      GO TO 320
  310 CONTINUE
      IF(IT .GE. SMR) GO TO 200
  320 CONTINUE
      SMR=IT
      SMRL = AMAX0(SMR,6)
      DO 304 I32=1,IT
      II = MOD(I32,IT)+1
      III = TEMAR(II)
      SMRAR(NXTR+I32-1) = III
  304 CONTINUE
      NPOS = NP
      III = NXTR+IT-1
      IF (SMR.EQ.3) GO TO 77
      IF (SMR.EQ.6.AND.NPOS.LE.2) GO TO 77
      GO TO 200
C
C      PATH CANNOT BE CONTINUED FROM CURRENT NODE. OBTAIN
C      LAST POTENTIAL BRANCH POINT FROM PUSHDOWN STACK AND CON-
C      TINUE TRACING IT. WHEN ALL POTENTIAL BRANCH POINTS HAVE
C      BEEN TRACED, THE SHORTEST RING, IF ANY, HAS BEEN FOUND.
C
  500 CONTINUE
      I2=I2-PC
      CALL REGUPS (9)
      CALL REGUP (PUSH1(I2),UNPAK)
      IT = I2
      IF(I2 .NE. 1) GO TO 200
C
C      IF NO SUITABLE RING HAS BEEN FOUND, NUCLEUS CANNOT
C      BE POSITIONED; CALL ERROR ROUTINE AND RETURN.
C
      IF (SMR.LT.1000) GO TO 77
      CALL WO (BGRNG)
      GO TO 11
C
C      A SUITABLE RING HAS BEEN FOUND. IF MORE THAN TWO
C      NODES IN THIS RING ARE ALREADY POSITIONED, INITIATE A
C      PROCEDURE TO DETERMINE IF THIS RING IS BRIDGING AN AL-
C      READY POSITIONED RING. THIS IS DETERMINED BY COMPARING
C      THIS RING WITH ALL PREVIOUSLY POSITIONED RINGS. IF IT
C      HAS MORE THAN TWO NODES IN COMMON WITH ANY ONE RING,
C      ASSUME THAT THIS RING IS BRIDGING THE OTHER RING.
C
   77 CONTINUE
      III = NXTR+SMR-1
      NRING = NRING+1
      PRING(NRING) = NXTR+SMR-1
      IF (NPOS.LE.2) GO TO 380
      FNOD = 1
      II = NRING-1
      DO 350 I1=1,II
      NCOM = 0
      III = PRING(I1)
      DO 340 I2=FNOD,III
      DO 330 I3=1,SMR
      IF (SMRAR(I2).NE.SMRAR(NXTR+I3-1)) GO TO 330
      NCOM = NCOM+1
      GO TO 340
  330 CONTINUE
  340 CONTINUE
      IF (NCOM.GT.2) GO TO 360
      FNOD = III+1
  350 CONTINUE
      GO TO 380
C
C      A BRIDGED RING STRUCTURE HAS BEEN FOUND. SIMPLY
C      TAKE ALL UNPOSITIONED BRIDGING ELEMENTS AND LAY THEM OUT
C      IN A STRAIGHT LINE BETWEEN ALREADY POSITIONED NODES.
C      THEN SAVE THE FORWARD AND BACKWARD DIRECTIONS ASSOCIATED
C      WITH THESE NODES.
C
  360 CONTINUE
C
C     PROBLEMS, SO FOR NOW (11/20/80) MAKE THE BRIDGED-RING CASE AN
C     "ERROR" BY THE TWO FOLLOWING STATEMENTS:
C
      CALL WO(BGRNG)
      GO TO 11
      I1 = SMRAR(NXTR+NCOM-1)
      I2 = SMRAR(NXTR)
      XANG = -ATAN2(FLOAT(AR(4,I2)-AR(4,I1)),FLOAT(AR(3,I2)-AR(3,I1)))
     1  *180./3.141592654
      DIR = MOD(IFIX(XANG+202.5)/45+6,8)+1
      RDIR = MOD(DIR+3,8)+1
      NINS = SMR-NCOM
      II = NXTR+NCOM
      III = PRING(NRING)+1
      IP = I1
      SMRAR(III) = I2
      DO 370 I3=II,III
      I4 = SMRAR(I3)
      IF (I3.EQ.III) GO TO 362
      AR(3,I4) = AR(3,I1)+(AR(3,I2)-AR(3,I1))*(I3-II+1)/(NINS+1)
      AR(4,I4) = AR(4,I1)+(AR(4,I2)-AR(4,I1))*(I3-II+1)/(NINS+1)
  362 CONTINUE
      DO 365 I5=5,10
      IF (AR(I5,IP).EQ.I4) GO TO 366
  365 CONTINUE
  366 CONTINUE
      BCDER(I5-4,IP) = 512*(BCDER(I5-4,IP)/512)+DIR
      DO 367 I5=5,10
      IF (AR(I5,I4).EQ.IP) GO TO 368
  367 CONTINUE
  368 CONTINUE
      BCDER(I5-4,I4) = 512*(BCDER(I5-4,I4)/512)+RDIR
      IP = I4
  370 CONTINUE
      GO TO 390
C
C      RING IS READY FOR POSITIONING. FIRST CHECK TO SEE
C      IF IT IS SPIRO ATTACHED TO AN ALREADY POSITIONED RING.
C      IF SO, SET THE LAYOUT DIRECTION TO AVOID FOULING THAT
C      RING.
C
  380 CONTINUE
      IF (NRING.EQ.1) GO TO 385
      IF (NPOS.NE.1) GO TO 385
      DIR1 = 0
      DIR2 = 0
      I2 = SMRAR(NXTR)
      DO 382 I1=5,10
      I3 = AR(I1,I2)
      IF (ORING(I3).NE.ORING(I2)) GO TO 382
      IF (AR(3,I3).EQ.0) GO TO 382
      IF (DIR1.NE.0) GO TO 381
      DIR1 = EXTRA9(BCDER(I1-4,I2),4)
      GO TO 382
  381 CONTINUE
      DIR2 = EXTRA9(BCDER(I1-4,I2),4)
      GO TO 383
  382 CONTINUE
  383 CONTINUE
      FRDIR = (DIR1+DIR2)/2
      IF (IABS(DIR1-DIR2).LT.4) FRDIR = MOD(FRDIR+3,8)+1
C
C      EITHER A FUSED RING OR A SPIRO ATTACHED RING IS
C      INDICATED, USE POSITI ROUTINE TO POSITION THIS RING. IF
C      UNSUCCESSFUL, RETURN TO CALLING PROGRAM.
C
  385 CONTINUE
      CALL POSITI (SMR,SMRAR(NXTR),0,RET)
386   IF(RET .NE. 0) RETURN
C
C      RING HAS BEEN POSITIONED, NOW INITIATE LOOP TO EXA-
C      MINE EACH RING MEMBER.
C
  390 CONTINUE
      III = PRING(NRING)
      DO 601 I6=NXTR,III
      I61=SMRAR(I6)
C
C      FOR EACH RING MEMBER, ADD ANY NEIGHBORING NODES
C      NOT IN THE SAME NUCLEUS TO THE ACYCLIC BRANCH POINT
C      TABLE, IF NOT ALREADY IN THAT TABLE.
C
      DO 602 I62=5,10
      I622=AR(I62,I61)
      IF (I622.EQ.0) GO TO 602
      IF (ORING(I622).EQ.NUCNUM) GO TO 602
      IF (BRATC.EQ.0) GO TO 80
      DO 6022 I6022=1,BRATC
      IF(BRATAR(I6022) .EQ. I622) GO TO 602
 6022 CONTINUE
   80 CONTINUE
      BRATC=BRATC+1
      BRATAR(BRATC)=I622
  602 CONTINUE
  601 CONTINUE
      NXTR = PRING(NRING)+1
C
C      CURRENT RING HAS NOW BEEN PROCESSED, REPEAT PROCE-
C      DURE TO IDENTIFY AND POSITION OTHER RINGS IN NUCLEUS.
C
      IC = 0
      GO TO 10
C
C      ALL PROCESSING COMPLETED, RETURN TO CALLING PROGRAM
C
   11 CONTINUE
      RETURN
      END
