C 	COPYRIGHT (C) 1981 BY BOARD OF TRUSTEES,
C 	LELAND STANFORD JUNIOR UNIVERSITY
C
      SUBROUTINE RINGS (NRG,RNGAT,RSIZE)
C
      IMPLICIT INTEGER (A-R,T-Z), DOUBLE PRECISION (S)
      INTEGER SETLEN,S
      LOGICAL ON,OFF,SUB,DELFLG,ISM
      DOUBLE PRECISION AND,OR,XOR,NOT,ATLEFT,BDLEFT,INC(72)
      DOUBLE PRECISION QSETS(612),CLBASR(50),BASR(50),NOMEM(5)
      DIMENSION S(30),SRAT(50),SRBD(50),LABEL(72),SCLRG(20)
      DIMENSION RSIZE(20),RNGAT(10,20)
C
      COMMON /STLN/ SETLEN
      COMMON /BONDS/ NBNDS,BNDAT(2,72),BTYPE(72)
      COMMON /ATOMS/ NAT,ICONN(4,72),NCONN(72),NAMES(72),NCNT(72),
     1               ITYPE(72)
C
      EQUIVALENCE (INC,QSETS),(LABEL(1),QSETS(73)),
     1            (BASR,SRAT)
C
      SETLEN = 2
      NRG = 0
      SNULL = 0
      SMSPR = SNULL
      SALLR = SNULL
      SRINGA = SNULL
      SRINGB = SNULL
      SBRHDA = SNULL
      SOCUPA = SNULL
      SOCUPB = SNULL
      CALL ZEROM(SRAT,100)
      CALL ZEROM(SRBD,100)
      CALL ZEROM(RNGAT,200)
      CALL ZEROM(RSIZE,20)
C
C     IF NO RING POSSIBLE, RETURN
C
      IF (NBNDS.EQ.NAT-1) RETURN
C
C     FILL INC, THE INCIDENCE MATRIX
C
      CALL ZEROM (INC,144)
      DO 10 NB = 1,NBNDS
      CALL ON(SOCUPB,NB)
      CALL ON(INC(BNDAT(1,NB)),NB)
      CALL ON(INC(BNDAT(2,NB)),NB)
   10 CONTINUE
      DO 20 NA = 1,NAT
      CALL ON (SOCUPA,NA)
   20 CONTINUE
      ATLEFT = SOCUPA
      BDLEFT = SOCUPB
C
C     WELCH'S ALGORITHM
C
      BOND = 0
   30 BOND = NXM(SOCUPB,BOND)
      IF (BOND.LE.0) GO TO 60
C
C     LOOK FOR AN UNCHOSEN ATOM ON BOND. IF THERE IS NONE, THE BOND
C     IS A RING CLOSURE BOND.
C
      ATOM = 0
   40 ATOM = NXM(ATLEFT,ATOM)
      IF (ATOM.LE.0) GO TO 30
      IF (.NOT.ISM(INC(ATOM),BOND)) GO TO 40
C
C     FOUND AN ATOM ON THIS BOND WHICH HAS NOT YET BEEN CHOSEN.
C     SO EXTEND THE SPANNING TREE OUT OF THAT ATOM. THIS IS DONE
C     BY LABELING THE ATOM WITH THE BOND NUMBER.
C
      LABEL(ATOM) = BOND
C
C     REMOVE THIS ATOM AND BOND FROM THE SETS OF THOSE UNCHOSEN.
C
      CALL OFF(ATLEFT,ATOM)
      CALL OFF(BDLEFT,BOND)
      ATOM2 = 0
   50 ATOM2 = NXM(SOCUPA,ATOM2)
      IF (ATOM2.LE.0) GO TO 30
C
C     IF THIS IS THE ATOM JUST CHOSEN, DO NOTHING
C
      IF (ATOM.EQ.ATOM2) GO TO 50
C
C     IF ATOMS ARE INCIDENT TO THE SAME EDGE, XOR THEM
C
      IF (ISM(INC(ATOM2),BOND)) INC(ATOM2) = XOR(INC(ATOM2),INC(ATOM))
      GO TO 50
C
C     COLLECT BASIS RINGS. THE BONDS LEFT ARE THE RING-CLOSURES
C
   60 NBR = 0
      BOND = 0
   70 BOND = NXM(BDLEFT,BOND)
      IF (BOND.LE.0) GO TO 90
C
C     START A NEW BASIS RING WITH THIS RING-CLOSURE
C
      NBR = NBR + 1
      CALL ON(BASR(NBR),BOND)
      ATOM = 0
   80 ATOM = NXM(SOCUPA,ATOM)
      IF (ATOM.LE.0) GO TO 85
C
C     IF ATOM IS ON BOND, PUT THE BOND LABELING THE ATOM IN RING SET
C
      IF (ISM(INC(ATOM),BOND)) CALL ON(BASR(NBR),LABEL(ATOM))
      GO TO 80
C
C     THIS BASIS RING IS COMPLETE. PUT IT INTO THE SET OF RING BONDS
C
   85 SRINGB = OR(SRINGB,BASR(NBR))
      GO TO 70
C
C     END OF WELCH'S ALGORITHM
C
   90 CONTINUE
C
C     THIS SECTION ATTEMPTS TO  FIND RING CLUSTERS.
C
      STEMP = SNULL
      DO 220 I = 1,NBR
      CALL ON(STEMP,I)
  220 CONTINUE
      I = 0
      NCL = 0
C
C     TAKE A BASIS RING
C
  222 I = NXM(STEMP,I)
      IF (I.LE.0) GO TO 226
      NCL = NCL + 1
C
C     BEGIN A NEW CLUSTER
C
      SCLRG(NCL) = SNULL
      CALL ON(SCLRG(NCL),I)
      SCLBD = BASR(I)
  223 J = I
      DELFLG = .FALSE.
  224 J = NXM(STEMP,J)
      IF (J.LE.0) GO TO 225
      IF (AND(SCLBD,BASR(J)).EQ.SNULL) GO TO 224
C
C     ADD THIS RING TO THE CLUSTER
C
      DELFLG = .TRUE.
      CALL ON(SCLRG(NCL),J)
      CALL OFF(STEMP,J)
      SCLBD = OR(SCLBD,BASR(J))
      GO TO 224
C
C     IF ADDED MORE RINGS TO CLUSTER REPEAT
C
  225 IF (DELFLG) GO TO 223
      GO TO 222
C
C   NOW, ALL CLUSTERS HAVE BEEN FOUND. PROCESS EACH OF THEM
C
  226 DO 1630 INDEX = 1,NCL
      SETLEN = 2
      RNCL = CNT(SCLRG(INDEX))
C
C     THE MAXIMUM IS TEN BASIS RINGS PER CLUSTER
C
      IF (RNCL.GT.10) RNCL = 10
      I = 0
      J = 0
  230 I = NXM(SCLRG(INDEX),I)
      IF (I.LE.0) GO TO 235
      J = J + 1
      CLBASR(J) = BASR(I)
      GO TO 230
  235 CONTINUE
C
C     THIS SECTION IS USED TO CALCULATE THE REDUCED BASIS SET FROM
C     THE ARBITRARY BASIS SET THAT WE JUST OBTAINED.
C
C     THIS IS NOT NECESSARY IF THERE IS ONLY ONE RING.
C
      IF (RNCL.LE.1) GO TO 280
      N2 = RNCL - 1
  245 DELFLG = .FALSE.
      DO 270 J = 1,N2
      CNTRJ = CNT(CLBASR(J))
      I2 = J + 1
      DO 270 I = I2,RNCL
      CNTRI = CNT(CLBASR(I))
      STEMP = XOR(CLBASR(I),CLBASR(J))
      CNTRIJ = CNT(STEMP)
C
C     IF THE XOR IS SMALLER THAN EITHER OF THE ORIGINAL TWO BASIS
C     RINGS, REPLACE THE LARGER OF THE TWO BASIS RINGS WITH IT.
C
      IF (CNTRIJ.GE.CNTRI) GO TO 250
      DELFLG = .TRUE.
      TEMP = CNTRI
      CNTRI = CNTRIJ
      CNTRIJ = TEMP
      STEMP2 = CLBASR(I)
      CLBASR(I) = STEMP
      STEMP = STEMP2
  250 IF (CNTRIJ.GE.CNTRJ) GO TO 270
      DELFLG = .TRUE.
      CNTRJ = CNTRIJ
      CLBASR(J) = STEMP
  270 CONTINUE
      IF (DELFLG) GO TO 245
C
C     GIBB'S ALGORITHM.
C     QSETS ARE ALL OF THE COMBINATIONS OF CLBASR BOND SETS.
C     QFREE IS A POINTER TO THE NEXT FREE LOCATION IN QSETS TABLE
C     RNCL IS THE NUMBER OF BASIS RINGS IN THE CLUSTER
C     S IS THE SET THAT EVENTUALLY CONTAINS ALL OF THE RINGS
C
  280 LENSET = (2**RNCL)/36 + 1
      SETLEN = LENSET
      CALL ZEROM(S,LENSET)
      QFREE = 1
C
      DO 120 I = 1,RNCL
      IF (I.EQ.1) GO TO 115
      LAST = QFREE - 1
      DO 110 J = 1,LAST
      SXOR = XOR(QSETS(J),CLBASR(I))
C
C     IF NO INTERSECTION, THEN NOT A NEW RING
C
      IF (AND(CLBASR(I),QSETS(J)).EQ.SNULL) GO TO 106
C
C     IF ANOTHER SET IS A SUBSET OF THIS SET, THEN NOT NEW RING.
C     IF THIS SET IS A SUBSET OF ANOTHER SET, REMOVE THE OTHER.
C
      K = LAST
  102 K = NXM(S,K)
      IF (K.LE.0) GO TO 104
      IF (SUB(QSETS(K),SXOR)) GO TO 106
      IF (SUB(SXOR,QSETS(K))) CALL OFF(S,K)
      GO TO 102
  104 CALL ON(S,QFREE)
      GO TO 108
  106 IF (I.EQ.RNCL) GO TO 110
  108 QSETS(QFREE) = SXOR
      QFREE = QFREE + 1
  110 CONTINUE
C
C     ADD THE CLBASR TO THE S SET NOW, TOO
C
  115 QSETS(QFREE) = CLBASR(I)
      CALL ON(S,QFREE)
  120 QFREE = QFREE + 1
C
C     THE ALGORITHM IS NOW FINISHED.
C
      I = 0
      LOWNRG = NRG + 1
  152 SETLEN = LENSET
      I = NXM(S,I)
      SETLEN = 2
      IF (I.LE.0) GO TO 162
C
C     ONLY KEEP THE RING IF IT IS IN THE REDUCED BASIS SET OR
C     SMALLER THAN 10.
C
      DO 154 K = 1,RNCL
      IF (QSETS(I).EQ.CLBASR(K)) GO TO 155
  154 CONTINUE
C
C     NOT A REDUCED BASIS SET RING
C
      IF (CNT(QSETS(I)).LE.10) GO TO 156
C
C     RING LARGER THAN ALLOWED FOR A NON-BASIS RING.
C
      GO TO 152
C
C     PUT RING BOND SET IN FINAL ARRAY.
C
  155 CALL ON(SMSPR,NRG+1)
  156 NRG = NRG + 1
      SRBD(NRG) = QSETS(I)
      GO TO 152
C
C     LOOK FOR BRIDGE-HEAD ATOMS IN THIS CLUSTER
C
  162 NRGM1 = NRG - 1
      DO 163 I = LOWNRG,NRGM1
      SATR1 = SAASB(SRBD(I))
      DO 163 K = I+1,NRG
      SATR2 = SAASB(SRBD(K))
      SBOTH = AND(SATR1,SATR2)
      IF (CNT(SBOTH).LE.3) GO TO 163
      SATOR1 = AND(SATR1,NOT(SBOTH))
      SATOR2 = AND(SATR2,NOT(SBOTH))
      IF (SATOR1.EQ.SNULL.OR.SATOR2.EQ.SNULL) GO TO 163
      SBRAT = AND(SBOTH,SAASA(SATOR1))
      SBRHDA = OR(SBRHDA,SBRAT)
  163 CONTINUE
 1630 CONTINUE
C
C     NOW, GET THE ATOM SETS AND LISTS OF ATOMS IN ORDER FOR THE RINGS
C
  164 LERR = 0
      SETLEN = 2
      DO 175 I = 1,NRG
      TEMP = 0
      STEMP = SRBD(I)
C
C     GET FIRST BOND OF THIS RING
C
      BND1 = NXM(STEMP,0)
C
C     REMOVE FROM RING BOND SET
C
      CALL OFF(STEMP,BND1)
C
C     GET SECOND BOND
C
      BND = NXM(AND(SBAB(BND1),STEMP),0)
C
C     GET FIRST ATOM AT INTERSECTION OF FIRST TWO BONDS
C
      SRAT(I) = AND(SAAB(BND),SAAB(BND1))
C
C     GET NUMBER OF FIRST ATOM
C
      TATM = NXM(SRAT(I),0)
C
C     PUT ON LIST OF ATOMS
C
      TEMP = TEMP + 1
      RNGAT(TEMP,I) = TATM
C
C     GET NEXT ATOM

  170 TATM = ADJAT(TATM,BND)
C
C     TURN ON IN SET
C
      CALL ON(SRAT(I),TATM)
C
C     PUT ON LIST OF ATOMS
C
      TEMP = TEMP + 1
      RNGAT(TEMP,I) = TATM
C
C     REMOVE CURRENT BOND FROM SET OF RING BONDS LEFT
C
      CALL OFF(STEMP,BND)
C
C     GET NEXT BOND
C
      BND = NXM(AND(SBAB(BND),STEMP),0)
C
C     DONE WITH ALL BONDS ON ATOM YET
C
      IF (BND.GT.0) GO TO 170
  175 CONTINUE
C
C     GET SET OF RING ATOMS AND RING SIZE SETS
C
      DO 176 I = 1,NRG
      SRINGA = OR(SRINGA,SRAT(I))
      RS = CNT(SRAT(I))
      RSIZE(I) = RS
  176 CONTINUE
      RETURN
      END
