C  W. TODD WIPKE, DEPT OF CHEMISTRY
C  PRINCETON UNIVERSITY, PRINCETON, N.J.  08540
C  EDIT 12/17/73  ADDED ITMAX,TMAX,DELE,EFIN  TERMINATION CNDS
C  EDIT 12/11/73  REMOVED ALL SECS RELATED REFERENCES COMPLETELY
C    IFIN    = -1, 0, 1, 2 OR 3 TO CONCLUDE MINIMIZATION; BEGIN
C		 NORMAL MINIMIZATION; CONTINUE MINIMIZATION; 
C                RESUME
C		 MINIMIZATION; AND BEGIN NONSTOP MINIMIZATION
C		 WHICH DOES NOT RETURN TO MAIN PROGRAM AFTER 
C                EACH ITERATION; RESPECTIVELY.
C
C	MMODE  = 0 FOR NORMAL MINIMIZATION OF ALL ATOMS.
C	       = 1 FOR PARTIAL MINIMIZATION HOLDING FIXED THE
C                   'NFIX' ATOMS IN MARRAY.
C	       = 2 FOR PARTIAL MINIMIZATION HOLDING MARRAY ATOM
C                  IN THE XY PLANE.S 
C
C	T E R M I N A T I O N   C O N D I T I O N S
C
C	ITMAX  =  MAXIMUM NUMBER OF ITERATIONS PERMITTED
C
C	TMAX   =  MAXIMUM TIME ALLOWED (RUNTIME IN MILLISECONDS)
C
C	DELE   =  TERMINATES WHEN CHANGE IN ENERGY < DELE
C
C	EFIN   -  TERMINATES BUILDING WHEN ENERGY < EFIN
C	=======================================================
C	MFIX   =  NUMBER OF ATOMS NOT TO BE MINIMIZED 
C                 (WHEN MMODE.NE.0)
C
C	MARRAY(I), I=1,MFIX  CONTAINS INDICES OF ATOMS TO BE 
C                 HELD FIXED.

	SUBROUTINE SYMX(NATS,NAM,ITRMAX,ATCON,X,Y,Z,ANAMES,NUMU)
	IMPLICIT INTEGER(A-C,E-O,Q-S)
	INTEGER ATCON(6,NATS),ANAMES(4,NATS)
	DIMENSION X(NATS),Y(NATS),Z(NATS)
	COMMON/MZCONN/MNA,MNB,MNDB,MNXH,MATYP(30),MNATCH(30),MATBD(30,4)
	1,MBTYP(30,4),MHOLD(30),XM(30),YM(30),ZM(30),JSTOP,GFACTR(30)
	COMMON/GEN/TOTALE,INVATM,ISTAGE,IROOT
	COMMON/DEBUG/DEBUG(16)
	COMMON/MMODE/MMODE,ITMAX,TMAX,IFIN,MFIX,MARRAY(30),
	1 DELE,EFIN,TBEG
	COMMON /DISTX/DIST(30,30)
	COMMON /ANGL/THETA(30,6),NAA(30),NX1(30,6),NX2(30,6),
	1ANRG(30,6),NTYPEA(30),ACONST,ATETC,ANAT3
	DIMENSION THA(6)
	REAL APART,BPART,UBPART,DPART,CPART,HPART,PART
	COMMON /MWAT/DUM6(6),APART(30,3),BPART(30,3),UBPART(30,3),
	1DPART(30,3),CPART(30,3),HPART(30,3),PART(30,3),NTOTLE
	COMMON /DANGL/DANGL(120),NTYPDA(120),ND1(120),ND2(120),ND3(120),
	1ND4(120),DCONST,DNRG(120),TDNRG(30),OTDNRG(30),NDA,ND0(30,20),
	2ITEMP(40),SDCONST
	COMMON/ALENG/TUBNRG(30),OTANRG(30),TANRG(30),TBNRG(30),
	1OUBNRG(30),OTBNRG(30)
	INTEGER YESGO,NOGO,BADGO
	REAL CNRG
	COMMON/CHRL/CNRG(30),OCNRG(30),CCONST
	REAL HNRG
	COMMON/HCONST/HCONST,SUMA(30),HNRG(30),OHNRG(30)
	COMMON /DISPTY/NFLAG,NCSWIT
	DIMENSION CORD(3)
	DIMENSION ATLITS(7)
	DIMENSION NAM(4)
	DOUBLE PRECISION FILE1,FILE2
	DATA CORD/'X','Y','Z'/
	DATA ATLITS /'C','H','N','O','S','P','X'/
	DATA INVHOLD/0/,MNAMAX/30/
C
C  HERE FOR INITIALIZING ARRAYS AND BEGINNING MINIMIZATION
C
C  RECORD STARTING RUNTIME
C
	TBEG=JTIME(DUM)/1000.
	IER=0
1105	CALL	ZEROM(MATYP,30)
	CALL	ZEROM(MNATCH,30)
	CALL	ZEROM(MATBD,120)
	CALL	ZEROM(MBTYP,120)
	CALL	ZEROM(MHOLD,30)
	CALL	ZEROM(XM,30)
	CALL	ZEROM(YM,30)
	CALL	ZEROM(ZM,30)
C
C  INITIALIZE MODELLING INFO
C
	DELE=.1
	EFIN=1.0
	MNA=NATS
C	ITMAX=ITRMAX
	ITMAX=-1
	IFIN=3
	MMODE=0
	IF (MNA.GT.MNAMAX) GO TO 900
	MFIX=0
C
C  CONNECTION TABLE CONVERSION
C
	DO 250 I=1,MNA
	NBNDS=0
	DO 240 K=1,6
	IF (ATCON(K,I).EQ.0) GO TO 240
	IF (K.EQ.1) GO TO 220
	DO 210 J=1,NBNDS
	IF (ATCON(K,I).EQ.MATBD(I,J)) GO TO 230
210	CONTINUE
220	NBNDS=NBNDS+1
	MATBD(I,NBNDS)=ATCON(K,I)
	MBTYP(I,NBNDS)=1
	GO TO 240
230	MBTYP(I,J)=MBTYP(I,J)+1
240	CONTINUE
	DO 245 K=1,7
	IF (ANAMES(2,I).EQ.ATLITS(K)) GO TO 246
245	CONTINUE
	MATYP(I)=1
	GO TO 247
246	MATYP(I)=K
247	XM(I)=X(I)
	YM(I)=Y(I)
	ZM(I)=Z(I)
	MNATCH(I)=NBNDS
250	CONTINUE
C
C  CONVERT XM,YM,ZM TO GIVE AVERAGE C-C BOND LENGTH OF 1.54 ANGSTROMS
C
170	CALL	BSCALE(DSCALE)
	IF(DEBUG(7))WRITE(5,9995)DSCALE
9995	FORMAT(' DSCALE ='F15.7)
	IF(DSCALE.GT.0.8.AND.DSCALE.LT.1.2)DSCALE=1.0
C
C
C  SCALE THE COORDINATES TO ANGSTROMS
C
	DO 10 I=1,MNA
	XM(I)=XM(I)*DSCALE
	YM(I)=YM(I)*DSCALE
	ZM(I)=ZM(I)*DSCALE
261	FORMAT (A1,'   ')
	IF(DEBUG(7))WRITE(5,9990)I,XM(I),YM(I),ZM(I)
9990	FORMAT(I3,6F9.2)
10	CONTINUE
C
C  SETUP GT40 PICTURE
C
	IF (NUMU.LT.20)CALL OMSET(NUMU,XM,YM,ZM,XXXX)
C  NOW FILL VARIOUS ATOM ARRAYS
C  MATYP IS OF THE FORM KLMN WHERE N=ATYPE, M=CHG, L=ISTER, AND
C  K=1,2, OR 3 FOR ATOMS ALPHA TO DOUBLE BOND, ON DOUBLE BOND,
C  OR ON CONJUGATED DOUBLE BOND, RESPECTIVELY.
C

C
C  FILL MBTYP, WHICH IS INDEXED BY ATOM & ATTACHMENT.
C  MBTYP IS OF FORM JKL WHERE J=1 FOR AROMATIC BONDS OR 0;
C  L=BTYPE; AND K=0,1 OR 2 FOR C-C, C-H OR C-HET BONDS, RESPECTIVELY.
C
	MNB=0
	MNDB=0
	DO 80 I=1,MNA
	A1TY=MOD(MATYP(I),10)-1
	A1TY=MIN0(A1TY,2)
	M=MNATCH(I)
	DO 80 J=1,M
	MNB=MNB+1
	MTYPE=MBTYP(I,J)
	IF(MTYPE.GT.3) MTYPE=100+MTYPE-3
	K=MATBD(I,J)
	A2TY=MOD(MATYP(K),10)-1
	A2TY=MIN0(A2TY,2)
	BTYPE=MAX0(A1TY,A2TY)
	IF(A2TY.EQ.1.OR.A1TY.EQ.1)BTYPE=1
	MBTYP(I,J)=MTYPE+10*BTYPE
C  MARK DOUBLE BONDS
	IF(MOD(MTYPE,10).NE.2) GO TO 70
	MATYP(I)=MATYP(I)+1000
	MNDB=MNDB+1
C  MARK TRIPLE BONDS
70	IF(MTYPE.EQ.3) MATYP(I)=MATYP(I)+3000
80	CONTINUE
	MNDB=MNDB/2
	MNB=MNB/2
	IF(MNB.GT.45)GO TO 910
C
C  FIND ATOMS ON CONJUGATED DOUBLE BONDS
C  FIND ATOMS ON TRIPLE BONDS
C  FIND ATOMS ALLYLIC TO UNSATURATION
C  FIND TOTAL NUMBER OF EXPLICIT H ATOMS
C
	MNXH=0
	DO 300 I=1,MNA
	N=MNATCH(I)
	IF(DEBUG(7))WRITE(5,9005)I,MATYP(I),(MATBD(I,L),L=1,N)
9005	FORMAT(' I='I3,' TYPE='I4,5I5)
C  IS IT A HYDROGEN?
	IF(MOD(MATYP(I),10).EQ.2) MNXH=MNXH+1
	IA=MATYP(I)/1000
	IF(IA.EQ.0.OR.IA.EQ.4) GO TO 300
	DO 270 J=1,N
	IB=MOD(MBTYP(I,J),10)
	IF(DEBUG(7))WRITE(5,9006)J,IB
9006	FORMAT(' I='I3,'  IB='I5)
	IF(IB.EQ.1) GO TO 270
	AT2=MATBD(I,J)
C
C  GROW THROUGH DOUBLE BOND
C
	N1=MNATCH(AT2)
	DO 120 K=1,N1
	AT3=MATBD(AT2,K)
C  IGNORE ATOM FROM WHENCE JUST CAME
	IF(AT3.EQ.I) GO TO 120
	IA1=MATYP(AT3)/1000
	IB1=MOD(MBTYP(AT2,K),10)
	IF(DEBUG(7)) WRITE(5,9007)I,AT2,AT3,IA1,IB1
9007	FORMAT(' **  AT1,AT2,AT3='3I5,'  IA1='I5,'  IB1='I5)
	IF(IB1.NE.1) GO TO 120
C
C  IF NEXT BOND SINGLE AND SP3 ATOM THEN K IS ALLYLIC
C
	IF(IA1.EQ.0) MATYP(AT3)=MATYP(AT3)+4000
	IF(IB.NE.2.OR.IA1.LT.1.OR.IA1.GT.2) GO TO 120
C
C  IF C=C-C= THEN I, AND J ARE CONJUGATED
C
	MATYP(I)=MOD(MATYP(I),1000)+2000
	MATYP(AT2)=MOD(MATYP(AT2),1000)+2000
120	CONTINUE
270	CONTINUE
300	CONTINUE
C
C  LABEL ATOMS TO BE HELD FIXED
C
455	IF(MMODE.NE.1.AND.MMODE.NE.2)GO TO 460
	DO 465 I=1,MFIX
	J=MARRAY(I)
	MHOLD(J)=MMODE
465	CONTINUE
460	CONTINUE
C460	IF(DEBUG(7))TYPE 10130,(MHOLD(I),I=1,MNA)
C10130	FORMAT(' MHOLD ',30I2)
C
7000	CONTINUE
C  DEBUG OUTPUT OF INITIAL STATUS OF COMMON
	IF (NUMU.GT.20) GO TO 7003
	NCSWIT=2
	CALL DMOL(MNA,XXXX,XM,YM,ZM,ANAMES)
	NCSWIT=0

7003	ASSIGN 7005 TO YESGO
	ASSIGN 5 TO NOGO
	ASSIGN 70030 TO BADGO

70030	WRITE (5,7001)
7001	FORMAT (/'0DO YOU WISH TO ALTER YOUR STRUCTURE FIRST?: '$)
	READ (5,7002)ANSER
7002	FORMAT(A5)

	GO TO 84102

C	IF (ANSER.NE.'Y'.AND.ANSER.NE.'YES') GO TO 5

7005	WRITE (5,831)
	CALL MWAIT(IDUM1,IDUM2,IDUM3,IDUM4,ANAMES,XXXX)
	IF (IDUM1.NE.1.AND.IDUM1.NE.3) GO TO 7005
	IF(.NOT.DEBUG(7))GO TO 5
	TYPE 10081
10081	FORMAT(' MATYP')
	TYPE 10080,(MATYP(I),I=1,MNA)
10080	FORMAT(1X,30I5)
	TYPE 10082
10082	FORMAT(' MBTYP')
	DO 502 I=1,MNA
	J1=MNATCH(I)
	TYPE 10090,(MBTYP(I,J),J=1,J1)
502	CONTINUE
10090	FORMAT(1X,5I3)
	TYPE 10075
10075	FORMAT(' START MINIMIZATION')
C
C  CALL MINIMIZATION
C
5	CONTINUE
C	DO 9991 I=1,MNA
C9991	WRITE(5,9990)I,X(I),Y(I),Z(I),XM(I),YM(I),ZM(I)
6	CONTINUE
	CALL MINIMZ(ANAMES,NUMU,XXXX)
	IF(IFIN.EQ.'ERROR')GO TO 920
	IF(IFIN.EQ.0) GO TO 925
C
C  HERE CAN OUTPUT EACH ITERATION RESULTS IF DESIRED
C
	IF(IFIN.EQ.4)GO TO 6
C
C  TERMINATE BUILDING, OUTPUT SYMOU.DAT
C
	IF(INVATM.NE.0)GO TO 915
800	CONTINUE
C	WRITE (5,801)
C801	FORMAT (' MODELLING COMPLETED.  DO YOU WANT TO EXAMINE THE'/
C       1' FINAL MODEL BEFORE I ERASE IT? (Y OR CR)'$)
C	READ (5,842)ANSER
C	IF (ANSER.NE.'Y'.AND.ANSER.NE.'YES') GO TO 84099
C	WRITE (5,802)
C802	FORMAT (' HOW MANY MORE ITERATIONS? '$)
C	READ (5,803) IMORE
C803	FORMAT (I)
C	ITMAX=ITMAX+IMORE
C805	IFIN=4
C	GO TO 6
830	WRITE (5,831)
	CALL MWAIT(IDUM1,IDUM2,IDUM3,IDUM4,ANAMES,XXXX)
	IF (IDUM1.EQ.3) GO TO 84090
	IF (IDUM1.NE.1) GO TO 830
	GOTO 84099
831	FORMAT (' -'$)
C84090	WRITE(5,84095)
C84095	FORMAT(' SORRY, I CANNOT RESUME MODELLING AT THIS POINT')
C	GO TO 830
84090	IFIN=4
	GO TO 6

84099	ASSIGN 8420 TO YESGO
	ASSIGN 850 TO NOGO
	ASSIGN 84100 TO BADGO

C	WRITE (5,84101)
C	FORMAT(' WANT TO WRITE GEOMETRIC DATA TO A FILE?:'$)

84100	WRITE (5,841)
841	FORMAT (' OUTPUT A FILE OF X, Y, Z COORDINATES?:'$)
	READ (5,842)ANSER

84102	IF (ANSER.EQ.'Y'.OR.ANSER.EQ.'YES'.OR.ANSER.EQ.'y'.
	1OR.ANSER.EQ.'yes') GO TO YESGO
	IF (ANSER.EQ.'N'.OR.ANSER.EQ.'NO'.OR.ANSER.EQ.'n'.
	1OR.ANSER.EQ.'no') GO TO NOGO
	WRITE (5,84103)
	GO TO BADGO
84103	FORMAT (' PLEASE ANSWER YES OR NO')

C	IF (ANSER.NE.'Y'.AND.ANSER.NE.'YES')RETURN
C
C	READ (5,842)ANSER
C	IF (ANSER.NE.'Y'.AND.ANSER.NE.'YES') GO TO 850
C
C841	FORMAT (' OUTPUT A FILE OF X, Y, Z COORDINATES? (Y OR CR)'$)
C

842	FORMAT(A5)
8420	WRITE (5,843)
	READ (5,844)FILE1
844	FORMAT(A10)
843	FORMAT (' ENTER FILE NAME.EXT (IF NO EXT., .DAT ASSUMED):'$)
	OPEN(UNIT=23, MODE='ASCII', ACCESS='SEQOUT', FILE=FILE1)
	WRITE(23,12000)NAM,MMODE,IER,ITMAX,TMAX,DELE,EFIN,TOTALE
12000	FORMAT(4A5,3I3,4F10.4)
	WRITE(23,12005)MNA
12005	FORMAT(15I3)
	DO 750 I=1,MNA
	ATYPE=MOD(MATYP(I),10)
	CHG=MOD(MATYP(I),100)/10
	ISTER=MOD(MATYP(I),1000)/100
	NATCH=MNATCH(I)
	DO 745 J=1,NATCH
	LAROM=MBTYP(I,J)/100
745	MBTYP(I,J)=MOD(MBTYP(I,J),10)+3*LAROM
	FIX=0
	DO 746 J=1,MFIX
	IF(MARRAY(J).EQ.I) FIX=1
746	CONTINUE
	WRITE(23,12005) ATYPE,ISTER,CHG,FIX,NATCH,
	1 (MATBD(I,J),MBTYP(I,J),J=1,NATCH)
	WRITE(23,12006)XM(I),YM(I),ZM(I)
12006	FORMAT(3F10.2)
750	CONTINUE
	CLOSE (UNIT=23)

850	ASSIGN 8504 TO YESGO
	ASSIGN 8502 TO NOGO
	ASSIGN 8500 TO BADGO

8500	WRITE (5,851)
	READ (5,842) ANSER
C	IF (ANSER.NE.'Y'.AND.ANSER.NE.'YES') RETURN

	GO TO 84102
8502	RETURN

8504	WRITE (5,843)
C	WRITE (5,852)
851	FORMAT (' WOULD YOU LIKE A FILE WITH OTHER INFO.?:'$)
C852	FORMAT (' ENTER THE FILE NAME.EXT (DAT ASSUMED)')
	READ (5,844)FILE2
	OPEN(UNIT=23, MODE='ASCII', ACCESS='SEQOUT', FILE=FILE2)

8520	ASSIGN 8530 TO YESGO
	ASSIGN 860 TO NOGO
	ASSIGN 8522 TO BADGO

8522	WRITE (5,853)

853	FORMAT (' BOND LENGTHS?:'$)
	READ (5,842)ANSER

	GO TO 84102

C	IF (ANSER.NE.'Y'.AND.ANSER.NE.'YES') GO TO 860

8530	DO 855 I=1,MNA
	DO 854 J=1,MNATCH(I)
	K=MATBD(I,J)
	IF (K.LT.I) GO TO 854
	WRITE (23,856) I,K,DIST(I,K)
854	CONTINUE
855	CONTINUE
856	FORMAT('  BOND (',I2,'-',I2,')=',F5.2)
	WRITE (23,857)
857	FORMAT(' ',//)

860	ASSIGN 8610 TO YESGO
	ASSIGN 865 TO NOGO
	ASSIGN 8600 TO BADGO

8600	WRITE (5,861)
861	FORMAT (' DISTANCES BETWEEN ATOMS?:'$)
	READ (5,842)ANSER

	GO TO 84102

C	IF (ANSER.NE.'Y'.AND.ANSER.NE.'YES') GO TO 865

8610	DO 862 I=1,MNA
862	WRITE (23,863) I,(DIST(I,J),J=1,MNA)
863	FORMAT ('  ATOM ',I2,3(5X,F10.5))
	WRITE (23,857)

865	ASSIGN 8660 TO YESGO
C	ASSIGN 870 TO NOGO
	ASSIGN 875 TO NOGO
	ASSIGN 8650 TO BADGO

8650	WRITE (5,866)
866	FORMAT(' BOND ANGLES?:'$)
	READ (5,842)ANSER

	GO TO 84102

C	IF (ANSER.NE.'Y'.AND.ANSER.NE.'YES') GO TO 870

8660	DO 867 I=1,MNA
	NA=NAA(I)
	IF (NA.EQ.0) GO TO 867
	DO 868 J=1,NA
868	THA(J)=(180.0/3.14)*THETA(I,J)
	WRITE (23,869) I,(NX1(I,J),NX2(I,J),THA(J),J=1,NA)
867	CONTINUE
869	FORMAT ('  ATOM ',I2,1X,3('(',I2,'-',I2,')=',F5.1,1X)/
	110X,3('(',I2,'-',I2,')=',F5.1,1X))
	WRITE (23,857)

C870	WRITE (5,871)
C871	FORMAT (' DIHEDRAL ANGLES? '$)
C	READ (5,842)ANSER
C	IF (ANSER.NE.'Y'.AND.ANSER.NE.'YES') GO TO 875
C	CONTINUE

875	ASSIGN 8760 TO YESGO
	ASSIGN 880 TO NOGO
	ASSIGN 8750 TO BADGO

8750	WRITE (5,876)
876	FORMAT(' PARTIAL DERIVATIVES OF ENERGY TERMS?:'$)
	READ (5,842) ANSER

	GO TO 84102

C	IF (ANSER.NE.'Y'.AND.ANSER.NE.'YES') GO TO 880

8760	WRITE(23,877)
877	FORMAT (' ATM DIR APART    BPART    UBPART'
	1,'    DPART    CPART    HPART    PARTIALS')
	DO 878 I=1,MNA
878	WRITE (23,879) I,(CORD(J),APART(I,J),BPART(I,J),UBPART(I,J),
	1DPART(I,J),CPART(I,J),HPART(I,J),PART(I,J),J=1,3)
879	FORMAT (' ',I2,2X,A1,7(1X,F8.2),2(/5X,A1,7(1X,F8.2)))
	WRITE (23,857)

880	ASSIGN 8910 TO YESGO
	ASSIGN 890 TO NOGO
	ASSIGN 8800 TO BADGO

8800	WRITE (5,891)
891	FORMAT (' INDIVIDUAL ENERGY COMPONENTS?:'$)
	READ (5,842)ANSER

	GO TO 84102

C	IF (ANSER.NE.'Y'.AND.ANSER.NE.'YES') GO TO 890

8910	WRITE (23,882)
882	FORMAT (' ATM:  ANG     BND     NONB    DAN     STER' 
	1,'    HYBR   TERMS')
	DO 893 I=1,MNA
893	WRITE (23,894) I,TANRG(I),TBNRG(I),TUBNRG(I),TDNRG(I),
	1CNRG(I),HNRG(I)
894	FORMAT (1X,I2,6F8.3)
890	CLOSE (UNIT=23)
	RETURN
C
C  ERROR RETURNS
C
C  TOO MANY ATOMS TO MINIMIZE, > MNAMAX
900	IER=1
	WRITE(5,10031)
10031	FORMAT(' TOO MANY ATOMS TO MINIMZE')
	GO TO 800
C  NATCH TOO LARGE, ZERO OR NEGATIVE
905	IER=2
	WRITE(5,10032)
10032	FORMAT(' NATCH >4 OR <=0')
	GO TO 800
C  #BONDS GREATER THAN MAX ALLOWED (45)
910	IER=3
	WRITE(5,10033)
10033	FORMAT(' TOO MANY BONDS TO MINIMZE')
	GO TO 800
C  ATOM IS INVERTED, MODEL UNRELIABLE
915	IER=4
	WRITE(5,10034)
10034	FORMAT(' ATOM INVERTED, MODEL UNRELIABLE')
	GO TO 800
C  ERROR FROM MINIMIZATION
920	IER=5
	WRITE(5,10035)
10035	FORMAT(' ERROR FROM MINIMIZATION')
	GO TO 800
C  ERROR FROM INITIALIZATION
925	IER=6
	WRITE(5,10036)
10036	FORMAT(' ERROR FROM INIT')
	GO TO 800
	END

	SUBROUTINE BSCALE(FACTOR)
C
C  RETURNS SCALING FACTOR TO CONVERT SAVED COORDINATES TO ANGSTROMS
C
	COMMON/MZCONN/MNA,MNB,MNDB,MNXH,MATYP(30),MNATCH(30),MATBD(30,4)
	1,MBTYP(30,4),MHOLD(30),XM(30),YM(30),ZM(30),JSTOP,GFACTR(30)
	COMMON/DEBUG/DEBUG(16)
	DIST(I,J)=SQRT((XM(I)-XM(J))**2+(YM(I)-YM(J))**2
	1 +(ZM(I)-ZM(J))**2)
	FACTOR=0.
	IF(MNA.EQ.0)RETURN
	TOT=0.
	IF(DEBUG(7))TYPE 300
300	FORMAT(' BND AT1 AT2 TOT')
	IB=0
	DO 10 I=1,MNA
	IF(MOD(MATYP(I),10).NE.1) GO TO 10
	NATCH=MNATCH(I)
	DO 10 K=1,NATCH
	J=MATBD(I,K)
	IF(MOD(MATYP(J),10).NE.1) GO TO 10
	IF(MOD(MBTYP(I,K),10).NE.1) GO TO 10
	IB=IB+1
	TOT=TOT+DIST(I,J)
	IF(DEBUG(7))TYPE 200,I,J,K,TOT
200	FORMAT(1X,3I3,F10.3)
10	CONTINUE
	IF(TOT.EQ.0.)GO TO 50
	BDNO=IB
60	FACTOR=BDNO*1.54/TOT
	RETURN
50	DO 30 I=1,MINA2
	NATCH=MNATCH(I)
	DO 30 K=1,NATCH
	IF(MOD(MBTYP(I,K),10).EQ.1) GO TO 40
30	CONTINUE
	GO TO 20
40	J=MATBD(I,K)
	TOT=DIST(I,J)
	BDNO=1.
	GO TO 60
20	TYPE 100
100	FORMAT(' NO C-C SINGLE BONDS, BSCALE COULD NOT COMPUTE A FACTOR')
	FACTOR=1.
	RETURN
	END

	SUBROUTINE ERROR(NWD,TEXT,IVAL)
	IMPLICIT INTEGER(A-Z)
	DIMENSION TEXT(NWD)
	WRITE(5,900)(TEXT(I),I=1,NWD)
900	FORMAT(' '14A5)
	RETURN
	END
