	PROGRAM TR3TST
C	*****************************************************************
C	*								*
C	*								*
C	*			MEGATEK WAND 7200			*
C	*								*
C	*								*
C	*	NAME:	TRN3TST.FOR			301-XXXX	*
C	*								*
C	*	ERROR CODE:	XXXX					*
C	*								*
C	*	DESCR:							*
C	*								*
C	*	    THIS ROUTINE TESTS THE WAND 7200 3-D TRANSFORMATION	*
C	*	ROUTINE 'MW3SMT'. A CUBE IS WRITTEN TO A GRAPHICS	*
C	*	MEMORY IN A TRANSFORMED SEGMENT. MW3SMT IS THEN CALLED	*
C	*	TO ROTATE THE CUBE 90 DEGREES IN 1 DEGREE INCREMENTS.	*
C	*								*
C	*								*
C	*	ROUTINES CALLED:					*
C	*								*
C	*	REVISION HISTORY:					*
C	*								*
C	*	REV	DATE		DESCRIPTION			*
C	*	00	XX-XXX-80	ORIGINAL VERSION		*
C	*								*
C	*	  THIS PROGRAM IS PROPRIETARY TO MEGATEK CORPORATION	*
C	*	  AND IS  DISTRIBUTED  UNDER  A  LICENSE  AGREEMENT.	*
C	*	  REPRODUCTION, DISCLOSURE, OR USE, IN  WHOLE  OR IN	*
C	*	  PART, OTHER THAN AS  SPECIFIED  IN THE LICENSE ARE	*
C	*	  NOT TO BE  UNDERTAKEN  EXCEPT  WITH  PRIOR WRITTEN	*
C	*	  AUTHORIZATION OF MEGATEK CORPORATION.			*
C	*								*
C	*		   COPYRIGHT (C) MEGATEK CORP., 1980		*
C	*			  ALL RIGHTS RESERVED			*
C	*								*
C	*****************************************************************
C
C
C	THIS PROGRAM TESTS THE OPERATION OF THE WAND 3-D TRANSFORMATION
C	ROUTINES.
C
C======================================================================
C
	REAL MTX4X4(4,4)
C
	IN = 5
	IOUT = 5
	WRITE(IOUT,1000)
1000	FORMAT(' DISPLAY NUMBER - ',$)
	READ (IN,1010) IDISP
C
	ISIZE = 2000
C
 1010	FORMAT(I1)
	ISHARE=  0
	ITRAN =  1
C
	CALL MWINIT
	CALL MWALDS( IDISP, ISHARE )
	CALL MWSLCT( IDISP )
C
C	SET UP JOYSTICK TO STOP PROGRAM.
C	--------------------------------
C
	CALL MWALPR( 2HJO, 1, IJOYID )
	CALL MWECHO( IJOYID, 1, 0 )
C	CALL MWENLC( IJOYID, 0, 0 )
C
	CALL MWCATT (2HCS,4)
	CALL MW2MOV (-800,1950)
	CALL MWTEXT ('TO EXIT PUSH THE JOYSTICK BUTTON\')
C	SET HEADER ATTRIBUTE TO 'TRANSFORMED'.
C	--------------------------------------
C
	CALL MWCATT( 2HHE, ITRAN )
C
	CALL MWOPEN( 2HSE, 1 )
C
C
	CALL RCUBE( ISIZE )
C
C	WRITE A STRING TO THE CENTER.
C	-----------------------------
C
	ICENTR = ISIZE / 2
	MAXSZ  = (ISIZE/48)
C
	IF( MAXSZ .GT. 8 ) MAXSZ = 8
C
	IDX = ICENTR - ( MAXSZ * 24 )
	IDY = ICENTR - ( MAXSZ * 9 )
	IDZ = -ICENTR
C
	CALL MWCATT(2HCO, 8 )
	CALL MW3MOV( IDX, IDY, IDZ )
C
	CALL MWCATT( 2HCS, IABS(MAXSZ) )
	CALL MWTEXT( 'WAND\' )
C
	CALL MWCLOS
C
C
C	SET UP THE TRANSFORMATION MATRIX PARAMETERS.
C	--------------------------------------------
C
	SCALE = 0.1
C
	SCLCTR = 0.0
C
	ROTCTR =  0.0
C
	XLATE  = 00.0
C
	IORDER = 2
C
C
C	ROTATE THE CUBE ABOUT THE LOWER LEFT BACK CORNER.
C	---------------------------------------------------
C
	ANGLE = 0.0
C
      call mwsclp(1,-1000,1000,-1000,1000)
 100	ANGLE = ANGLE + 0.05
C
C
	    CALL GETMTX( SCALE, SCALE, SCALE, SCLCTR, SCLCTR, SCLCTR,
     $			  ANGLE,  ANGLE,  ANGLE, ROTCTR, ROTCTR, ROTCTR,
     $			  XLATE,  XLATE, IORDER, MTX4X4 )
C
	     CALL MWBUFR (2)
C
	    CALL MW3SMT( 1, MTX4X4 )
C
	    CALL MWECPS( IJOYID, 1, 0, 0 )
	    CALL MWENLC( IJOYID, 0, 0 )
	    CALL MWSMLC( IJOYID, IX, IY, IBUTON )
	    CALL MWDSLC( IJOYID )
C
            IF( IY .LT. 0 ) SCALE = SCALE + 0.01
            IF( IY .GT. 0 ) SCALE = SCALE - 0.01
	    IF( IAND(IBUTON,1) .EQ. 0 ) GO TO 100
C
C
	CALL MWBUFR (2)
C
	CALL MWTERM
	STOP
	END
	SUBROUTINE RCUBE( ISIZE )
C
C======================================================================
C
C	THIS SUBROUTINE DRAWS A CUBE USING WAND 3-D OUTPUT PRIMITIVES.
C	THE CUBE IS DRAWN RELATIVE TO THE CURRENT POSITION IN THE
C	POSITIVE X AND Y PLANES, AND IN THE NEGATIVE Z PLANE USING
C	ONLY RELATIVE VECTORS. ISIZE IS THE LENGTH OF EACH SIDE OF THE
C	CUBE IN SCREEN UNITS.
C
C----------------------------------------------------------------------
C
C
	INTEGER ISIZE
C
C	LOCAL VARIABLES:
C	----------------
C
C	ISAVE   - STORES THE CURRENT COORDINATE.
C	IRELTV	- CONSTANT 8, MWCATT 'COORDINATE TYPE' OPTION
C		  SPECIFYING ALL RELATIVE VECTORS.
C
	INTEGER	ISAVE, IRELTV
C
C======================================================================
C
	IRELTV = 8
C
C	SAVE THE CURRENT COORDINATE TYPE AND SET FOR RELATIVE VECTORS.
C
	CALL MWQCAT( 2HCO, ISAVE )
	CALL MWCATT( 2HCO, IRELTV )
C
C	DRAW THE FORE GROUND SQUARE.
C
	CALL MW3DRW( ISIZE,     0,     0 )
	CALL MW3DRW(     0, ISIZE,     0 )
	CALL MW3DRW(-ISIZE,     0,     0 )
	CALL MW3DRW(     0,-ISIZE,     0 )
C
C	DRAW TO Z - PLANE.
C
	CALL MW3DRW(     0,     0,-ISIZE )
C
C	DRAW THE BACK GROUND SQUARE.
C
	CALL MW3DRW( ISIZE,     0,     0 )
	CALL MW3DRW(     0, ISIZE,     0 )
	CALL MW3DRW(-ISIZE,     0,     0 )
	CALL MW3DRW(     0,-ISIZE,     0 )
C
C	DRAW THE MISSING VERTICE'S.
C
	CALL MW3MOV( ISIZE,     0,     0 )
	CALL MW3DRW(     0,     0, ISIZE )
C
	CALL MW3MOV(     0, ISIZE,     0 )
	CALL MW3DRW(     0,     0,-ISIZE )
C
	CALL MW3MOV(-ISIZE,     0,     0 )
	CALL MW3DRW(     0,     0, ISIZE )
C
	CALL MW3MOV(     0,-ISIZE,    0 )
C
C
C	RESTORE THE ORIGINAL COORDINATE TYPE.
C
	CALL MWCATT( 2HCO, ISAVE )
C
	RETURN
	END
C
	SUBROUTINE GETMTX( SCLX, SCLY, SCLZ, SCTRX, SCTRY, SCTRZ,
     1 ROTX, ROTY, ROTZ, RCTRX, RCTRY, RCTRZ, TRX, TRY, ORDER, TRAN1 )
	REAL SCLX, SCLY, SCLZ
	REAL SCTRX, SCTRY, SCTRZ
	REAL ROTX, ROTY, ROTZ
	REAL RCTRX, RCTRY, RCTRZ
	REAL TRX, TRY
	INTEGER ORDER
	REAL M(8)
C
	REAL TRAN1(4, 3), TRAN2(4, 3), ROTM(3, 3, 3)
	REAL S, C
	INTEGER IUNIT, IADDR, I
	INTEGER AXIS
C
C CONSTANTS:
	COMMON /CPTRN/ X, Y, Z, ORMAP
	INTEGER X, Y, Z
	INTEGER ORMAP(6, 3)
	DATA X/1/, Y/2/, Z/3/
	DATA ORMAP(1, 1)/3/, ORMAP(1, 2)/2/, ORMAP(1, 3)/1/
	DATA ORMAP(2, 1)/3/, ORMAP(2, 2)/1/, ORMAP(2, 3)/2/
	DATA ORMAP(3, 1)/2/, ORMAP(3, 2)/3/, ORMAP(3, 3)/1/
	DATA ORMAP(4, 1)/2/, ORMAP(4, 2)/1/, ORMAP(4, 3)/3/
	DATA ORMAP(5, 1)/1/, ORMAP(5, 2)/3/, ORMAP(5, 3)/2/
	DATA ORMAP(6, 1)/1/, ORMAP(6, 2)/2/, ORMAP(6, 3)/3/
C
C
C SET UP TRAN2= SCALE_AND_CENTER MATRIX
	CALL ZRNX3(TRAN2, 4)
	TRAN2(1, 1)= SCLX
	TRAN2(2, 2)= SCLY
	TRAN2(3, 3)= SCLZ
	TRAN2(4, 1)= SCTRX - SCLX * SCTRX - RCTRX
	TRAN2(4, 2)= SCTRY - SCLY * SCTRY - RCTRY
	TRAN2(4, 3)= SCTRZ - SCLZ * SCTRZ - RCTRZ
C
C INITIALIZE THE THREE ROTATION MATRICES TO IDENTITIES
	DO 110 AXIS= X, Z
		CALL ZRNX3(ROTM(1, 1, AXIS), 3)
		DO 120 I= 1, 3
			ROTM(I, I, AXIS)= 1.0
120			CONTINUE
110		CONTINUE
C
C CREATE X AXIS ROTATION MATRIX
	C= COS(ROTX)
	S= SIN(ROTX)
	ROTM(2, 2, X)= C
	ROTM(2, 3, X)= S
	ROTM(3, 2, X)= -S
	ROTM(3, 3, X)= C
C
C CREATE Y AXIS ROTATION MATRIX
	C= COS(ROTY)
	S= SIN(ROTY)
	ROTM(1, 1, Y)= C
	ROTM(1, 3, Y)= S
	ROTM(3, 1, Y)= -S
	ROTM(3, 3, Y)= C
C
C CREATE Z AXIS ROTATION MATRIX
	C= COS(ROTZ)
	S= SIN(ROTZ)
	ROTM(1, 1, Z)= C
	ROTM(1, 2, Z)= S
	ROTM(2, 1, Z)= -S
	ROTM(2, 2, Z)= C
C
C PERFORM 1ST ROTATION -> TRAN1= SCALE_AND_CENTER * ROTATE_1
	CALL M4333(TRAN1, TRAN2, ROTM(1, 1, ORMAP(ORDER, X)))
C
C PERFORM 2ND ROTATION -> TRAN2= TRAN1 * ROTATE_2
	CALL M4333(TRAN2, TRAN1, ROTM(1, 1, ORMAP(ORDER, Y)))
C
C PERFORM 3RD ROTATION -> TRAN1= TRAN2 * ROTATE_3
	CALL M4333(TRAN1, TRAN2, ROTM(1, 1, ORMAP(ORDER, Z)))
C
C PERFORM FINAL TRANSLATION
C
	TRAN1(4, 1)= TRAN1(4, 1) + RCTRX + TRX
	TRAN1(4, 2)= TRAN1(4, 2) + RCTRY + TRY
C
C SELECT MATRIX ELEMENTS AND FORM M VECTOR
C
	M(1) = TRAN1(1, 1)
	M(2) = TRAN1(2, 1)
	M(3) = TRAN1(4, 1)
	M(4) = TRAN1(1, 2)
	M(5) = TRAN1(2, 2)
	M(6) = TRAN1(4, 2)
	M(7) = TRAN1(3, 1)
	M(8) = TRAN1(3, 2)
	RETURN
C
	END
	SUBROUTINE ZRNX3(A, N)
	REAL A(N, 3)
	INTEGER N

C
	INTEGER I, J
C
	DO 10 I= 1, N
		DO 20 J= 1, 3
			A(I, J)= 0.0
20			CONTINUE
10		CONTINUE
	RETURN
	END
	SUBROUTINE M4333(P, M1, M2)
	REAL P(4, 3), M1(4, 3), M2(3, 3)
C
	REAL SUM
	INTEGER I, J, SINDX
C
	DO 10 I= 1, 4
		DO 20 J= 1, 3
			SUM= 0.0
			DO 30 SINDX= 1, 3
				SUM= SUM + M1(I, SINDX) * M2(SINDX, J)
30				CONTINUE
			P(I, J)= SUM
20			CONTINUE
10		CONTINUE
	RETURN
	END
