      SUBROUTINE MEGCCF(IFILCD)
C
C         FUNCTION:  THIS ROUTINE CLOSES A COMMUNICATION FILE
C                    BETWEEN GCS AND A TERMINAL.
C
C  THIS ROUTINE IS A NO-OP ON THE PDP, BECAUSE THERE IS NO NEED
C  TO CLOSE OR OPEN THE TERMINAL.
C
      RETURN
      END
      SUBROUTINE MEGCVT(IN,IOUT)
C
C         FUNCTION:  THIS ROUTINE MAPS INTERNAL COMPUTER SET
C                    CHARACTERS TO GCS-INTERNAL (ASCII) CHARACTERS.
C
C         LOCAL VARIABLES:
C
C              IN    - IS THE INPUT CHARACTER IN COMPUTER
C                      INTERNAL CHARACTER FORMAT (PERHAPS
C                      WITH SHIFT APPLIED).
C
C              IOUT  - IS THE OUTPUT CHARACTER AFTER CONVERSION
C                      TO THE GCS-INTERNAL CHARACTER SET (ASCII)
C
C         DETERMINE IF CASE SHIFT HAS BEEN APPLIED
C
      IF (IN.LE.127) GO TO 10
C
C         ACCOMMODATE CASE SHIFTING--UPPER CASE CHARACTERS BECOME LOWER CASE
C
      IOUT=IN-128
      IF(IOUT.GT.64.AND.IOUT.LT.91)IOUT=IOUT+32
      GO TO 20
C
C         ELSE CHARACTER IS ALREADY ASCII
C
   10 IOUT=IN
C
C         TERMINATE
C
   20 RETURN
      END
        SUBROUTINE MEGERP(IETYP)
C
C       FUNCTION: PRINTS THE WAND 7232 ERROR REPORT. THIS ROUTINE
C       IS ALSO COMPUTER WORD SIZE DEPENDENT.
C
C
C               TRACEBACK ROUTINE ID STORAGE.
        COMMON /M72ERR/ INXRC, NRTNS, IREPNT, ITRCE, ICNTU, I2ERW,
     1                  ISZE, IERRBF(10)
C
C               COMPUTER DEPENDENT ELEMENTS
        COMMON /M72CDV/ KTERM, KUCASE, KLCASE, KSUBCH, KSUPCH, KWRTFL
        COMMON /M72CDV/ KRDFL, KOUTFL, KINFL, KWRDSZ, KBYTEL, KCPW
        COMMON /M72CDV/ KSHFTC, KBLKPD, KFILL, KDEL
C
C
C
        INTEGER LINE(16)
C
C
C               CHECK THE ERROR TYPE
C
        IF (IETYP.GT.0) GO TO 500
40          CALL MEGTXT(I2ERW, LINE)
C
            WRITE(KOUTFL, 100)
100         FORMAT(' ',34H*** WAND SERIAL GRAPHICS ERROR ***)
            WRITE(KOUTFL, 110) LINE, IERRBF(INXRC)
110         FORMAT(' ','  THE FOLLOWING ERROR:',/,
     1      ' ',2X,16A5,/,
     2       ' ','  WAS GENERATED FROM ROUTINE NUMBER ->',I6)
            GO TO 2000
500         WRITE(KOUTFL, 100)
            WRITE(KOUTFL, 510) LINE
510         FORMAT(' ','  THE FOLLOWING ERROR:',/,
     1      ' ',2X, 16A5,/,
     2      ' ','  WAS USER GENERATED. ')
2000    RETURN
        END
      SUBROUTINE MEGOCF(IFILCD,IRECSZ,IRDWRT)
C
C         FUNCTION:  THIS ROUTINE OPENS A COMMUNICATION LINE
C                    BETWEEN GCS AND THE TERMINAL.
C
C  THIS ROUTINE IS A NO-OP ON THE PDP, BECAUSE THERE IS NO NEED
C  TO CLOSE OR OPEN THE TERMINAL.
C
      RETURN
      END
      SUBROUTINE MEGRCF(IFILCD,ICOUNT,IBUFFR,IPRMPT)
C
C         FUNCTION:  THIS ROUTINE OBTAINS ASCII CHARACTERS FROM
C                    THE INDICATED FILE.
C
C
C               COMPUTER DEPENDENT ELEMENTS
        COMMON /M72CDV/ KTERM, KUCASE, KLCASE, KSUBCH, KSUPCH, KWRTFL
        COMMON /M72CDV/ KRDFL, KOUTFL, KINFL, KWRDSZ, KBYTEL, KCPW
        COMMON /M72CDV/ KSHFTC, KBLKPD, KFILL, KDEL
      DIMENSION IBUFFR(256), IPRMPT(1)
C
C  FLUSH OUTPUT BUFFER
C
      CALL MEGWCF(KOUTFL,0,0)
      IPCHCT=IPRMPT(1)
      IF (IPCHCT.LE.0) GO TO 50
C
C    SEND PROMPT
C
      CALL BUFFOU (IPRMPT(2),IPCHCT)
C
   50 CONTINUE
C
C  ACCEPT UP TO ONE LINE OF DATA AFTER SENDING PROMPT
C
      ICHRCT = ICOUNT
      CALL BUFFIN(IBUFFR,ICHRCT)
      IF (ICHRCT.EQ.ICOUNT) GO TO 999
C
C  PAD WITH ZEROES IF RECEIVED LESS CHARACTERS THAN EXPECTED
C
      DO 150 I = ICHRCT+1,ICOUNT
      IBUFFR(I) = 0
  150 CONTINUE
C
C  TERMINATE
C
 999  CONTINUE
      RETURN
      END
      SUBROUTINE MEGRVT(IN,IOUT)
C
C         FUNCTION:  THIS ROUTINE CONVERTS FROM GCS-INTERNAL
C                    CHARACTER SET (ASCII) TO COMPUTER-
C                    INTERNAL CHARACTER SET.
C
C         LOCAL VARIABLES:
C
C              IN    - IS THE CHARACTER IN GCS-INTERNAL
C                      CHARACTER SET, RIGHT-JUSTIFIED,
C                      ZERO-FILL.
C
C              IOUT  - IS AN INTEGER VARIABLE IN WHICH WILL
C                      BE PLACED THE INTERNAL CHARACTER SET
C                      EQUIVALENT OF 'IN'.
C
C         FOR THE PDP COMPUTER, THE GCS-INTERNAL CHARACTER SET AND
C         THE COMPUTER-INTERNAL CHARACTER SET ARE IDENTICAL.
C
      IOUT=IN
C
C         TERMINATE
C
 9999 RETURN
      END
      SUBROUTINE MEGSTD(N,ISTRNG,NUSTRG)
C
C         FUNCTION:  THIS ROUTINE PLACES THE N LEFT-MOST
C                    CHARACTERS IN THE INPUT STRING (ISTRNG)
C                    IN THE OUTPUT STRING (NUSTRG).  IF
C                    NUSTRG IS NOT FULL, IT PADS WITH ZERO BITS.
C
C         LOCAL VARIABLES:
C
C              ISTRNG- IS THE INPUT CHARACTER STRING.
C
C              MASKS - AN ARRAY WHICH CONTAINS THE BIT MASKS
C                      FOR EXTRACTING THE LEFT-MOST N
C                      CHARACTERS.
C
C              N     - IS THE NUMBER OF CHARACTERS TO BE
C                      RETRIEVED FROM THE LEFT-MOST POSITIONS
C                      OF ISTRNG.
C
C              NUSTRG- IS THE OUTPUT CHARACTER
C                      STRING PADDED WITH ZERO BITS IF NECESSARY
C                      TO FILL THE WORD.
C
C         DEFINE THE MASKS
C
      INTEGER MASKS(5)
      DATA MASKS /"774000000000, "777760000000, "777777700000,
     1            "777777777400, "777777777776/
C
C         MASK POSITIONS
C
      NUSTRG=IAND(ISTRNG,MASKS(N))
      RETURN
      END
      SUBROUTINE MEGTBK(IERROR)
C
C         FUNCTION:  THIS ROUTINE DISPLAYS GCS ERROR MESSAGES AND A
C                    TRACEBACK OF NESTED SUBPROGRAM CALLS.  IF A
C                    TRACEBACK FEATURE IS NOT AVAILABLE IN THE
C                    COMPUTER'S OPERATING SYSTEM, THEN THIS
C                    BECOMES A NO-OP PROCEDURE.
C
      RETURN
      END
        SUBROUTINE MEGTXT( IERNO, LINE)
C
C       FUNCTION: THIS SUBROUTINE GETS THE ERROR MESSAGE TEXT FROM
C                 THE ERROR FILE. THIS IS A COMPUTER DEPENDENT
C                 ROUTINE.
C
C               COMPUTER DEPENDENT ELEMENTS
        COMMON /M72CDV/ KTERM, KUCASE, KLCASE, KSUBCH, KSUPCH, KWRTFL
        COMMON /M72CDV/ KRDFL, KOUTFL, KINFL, KWRDSZ, KBYTEL, KCPW
        COMMON /M72CDV/ KSHFTC, KBLKPD, KFILL, KDEL
C
C
C
        INTEGER LINE(16)
C
C               OPEN THE ERROR MESSAGE FILE.
C
      OPEN (UNIT=KRDFL,DEVICE='DSK',FILE='W72ERR.DAT',ACCESS='SEQIN',
     1 DIRECTORY='1,643')
C
C
  100 READ(KRDFL, 110, ERR=9000, END=9999) NERR,  LINE
110   FORMAT (I3,1X,16A5)
      IF (NERR.LT.IERNO) GO TO 100
      IF (NERR.EQ.IERNO) GO TO 10000
C               STILL HAVEN'T READ THE CORRECT MESSAGE.
C
9000    PAUSE 'ERROR MESSAGE FILE NOT FOUND.'
        GO TO 10000
C
9999    PAUSE 'NON-EXISTANT ERROR #.'
C
10000 CLOSE (UNIT=KRDFL)
C
        RETURN
C
        END
      SUBROUTINE MEGWCF(IFILCD,ICOUNT,IBUFFR)
C
C         FUNCTION:  THIS ROUTINE SENDS ASCII CHARACTERS TO THE
C                    TERMINAL.  NO EXTRANEOUS CHARACTERS ARE
C                    ALLOWED TO BE INSERTED.
C
C               COMPUTER DEPENDENT ELEMENTS
        COMMON /M72CDV/ KTERM, KUCASE, KLCASE, KSUBCH, KSUPCH, KWRTFL
        COMMON /M72CDV/ KRDFL, KOUTFL, KINFL, KWRDSZ, KBYTEL, KCPW
        COMMON /M72CDV/ KSHFTC, KBLKPD, KFILL, KDEL
      INTEGER IBUFFR(1)
      INTEGER OUTCHR(200)
      DATA ICHRCT/0/
      DATA MAXCHR /200/
C
C  CHECK FOR BUFFER FLUSH
C
      IF (ICOUNT.GT.0) GO TO 50
C
C  PROCESS ONLY IF BUFFER CONTAINS CHARACTERS
C
      IF (ICHRCT.EQ.0) GO TO 40
C
C  WRITE BUFFER TO TERMINAL
C
      CALL BUFFOU (OUTCHR,ICHRCT)
      ICHRCT=0
   40 RETURN
C
C  PLACE CHARACTERS IN BUFFER
C
   50 DO 100 ICT=1,ICOUNT
C
C  INCREMENT BUFFER LOCATION POINTER
C
      ICHRCT=ICHRCT+1
      OUTCHR(ICHRCT) = IBUFFR(ICT)
C
C  FLUSH BUFFER IF FULL
C
      IF (ICHRCT.LT.MAXCHR) GO TO 100
C
C  OUTPUT CONTENTS OF BUFFER WHEN BUFFER IS FULL
C
      CALL BUFFOU (OUTCHR,ICHRCT)
      ICHRCT=0
  100 CONTINUE
C
C  TERMINATION
C
      RETURN
      END
