C
        SUBROUTINE MW2CAL( ISBNAM, IX, IY, ISBCTL, ICALID)
C
C                       COMMON.
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               COMPUTER DEPENDENT ELEMENTS
        COMMON /M72CDV/ KTERM, KUCASE, KLCASE, KSUBCH, KSUPCH, KWRTFL
        COMMON /M72CDV/ KRDFL, KOUTFL, KINFL, KWRDSZ, KBYTEL, KCPW
        COMMON /M72CDV/ KSHFTC, KBLKPD, KFILL, KDEL
C
C
C               INTERACTION PROMPT BUFFER.
        COMMON /M72PMT/ IPRMPT(10)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C       COTYPE - COORDINATE TYPE ( 1-8 ).
        INTEGER COTYPE
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
        CALL MIERST( 2100)
C
C               CHECK FOR THE SUBROUTINE NAME IN RANGE ( 0 - 4095 ).
C
        IF(ISBNAM .LT. 0 .OR. ISBNAM .GT. 4095)         GO TO 100
                                                        GO TO 200
C       THEN:
C           ERROR:  THE SUBROUTINE NAME IS OUT OF RANGE.
100         IERW2 = 9
            GO TO 500
C       ENDIF:
C
C               CHECK THE CONTROL PARAMETER, PLACE THE REQUIRED MOVE OR
C
C               READ THE CURRENT POSITION LABEL USE IT AS THE CALLID.
C
200     IPRMPT( 1) = 2
        IPRMPT( 2) = 124
        IPRMPT( 3) = 64
C
        CALL MEGRCF(KINFL, 7, MACIO, IPRMPT)
C
        IF(IAND(MACIO( 1), 32) .EQ. 32)                 GO TO 230
                                                        GO TO 240
C       THEN:
C           ERROR:  INVALID READ - DATA TERMINATOR.
230         IERW2 = 73
            GO TO 500
C       ENDIF:
C
240     ICALID = ISHFT(IAND(MACIO( 4), 15), 12) +
     1           ISHFT(IAND(MACIO( 5), 63), 6)   +
     2           IAND(MACIO( 6), 63)
C
        IF(ISBCTL .EQ. 0)                               GO TO 340
                                                        GO TO 380
C       THEN:
C           IT'S A MOVE TO THE SUBROUTINE POSITION.
340         CALL MW2MOV( IX, IY)
            GO TO 400
C       ELSE:
C           IT'S A DRAW TO THE SUBROUTINE POSITION.
380         CALL MW2DRW( IX, IY)
C       ENDIF:
C
C               CREATE THE COMMANDS NECESSARY TO CALL THE SUBROUTINE.
C               (THE FIRST IS ESSENTIALLY A NOOP -- A RELATIVE MOVE OF
C               ZERO.  THIS IS TO PLACE THE JSR 2 WORDS AFTER ICALID,
C               WHICH IS HOW IT IS FOR THE 3-D SUBROUTINE CALL)
C
C
 400    MACIO(1) = 18
        MACIO(2) = 0
        MACIO(3) = 0
        MACIO(4) = 0
        MACIO(5) = 0
        MACIO(6) = 37
        MACIO(7) = IAND(ISHFT( ISBNAM, -6), 63)
        MACIO(8) = IAND( ISBNAM, 63)
C
C               SEND THE COMMANDS OUT.
C
        CALL MIOUT( 8, 0, 0)
C
        GO TO 600
C
500     CALL MIERR( IERW2)
C
600     RETURN
C
        END
        SUBROUTINE MW2CMT(RMX3X3)
C
C       INPUT PARAMETERS:
C       =================
C
C               RMX3X3 - A 3 BY 3 ARRAY CONTAINING THE TRANSFORMATION
C                        MATRIX ELEMENTS TO BE OUTPUT.
C
                REAL RMX3X3( 3, 3)
C
C       COMMON PARAMETERS:
C       ==================
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C
C       LOCAL VARIABLES:
C       ================
C
C               WORDNO - NEXT WORD OF OUTPUT BUFFER TO RECEIVE DATA.
C               INDEX  - INDEX'S LOOP TO TRANSFER DATA TO OUTPUT BUFFER.
C               MTX3X3 - TRANSFORMATION MATRIX WITH BINARY SHIFTS.
C
                INTEGER WORDNO,INDEX, MTX3X3( 9)
C
C-----------------------------------------------------------------------
C
C
C       STACK ROUTINE ID FOR ERROR TRACEBACK.
C
        CALL MIERST(5020)
C
C       PUT TRANSFORM ENABLE CODE INTO OUTPUT BUFFER
C
        MACIO(1)=11
        MACIO(2)=48
C
C       PUT 2-D TRANSFORM INSTRUCTION INTO OUTPUT BUFFER.
C
        MACIO(3)=13
        MACIO(4)=4
C
C               PERFORM THE BINARY SHIFTS AND MOVE TO MTX3X3.
C
        MTX3X3( 1) = IFIX(0.5 + RMX3X3( 1, 1) * 2048.)
        MTX3X3( 2) = IFIX(0.5 + RMX3X3( 2, 1) * 2048.)
        MTX3X3( 3) = IFIX(0.5 + RMX3X3( 3, 1))
        MTX3X3( 4) = IFIX(0.5 + RMX3X3( 1, 2) * 2048.)
        MTX3X3( 5) = IFIX(0.5 + RMX3X3( 2, 2) * 2048.)
        MTX3X3( 6) = IFIX(0.5 + RMX3X3( 3, 2))
C
C       PUT THE MATRIX ELEMENTS INTO THE OUTPUT BUFFER.
C
        INDEX=0
        DO 100 WORDNO=5,22,3
                INDEX=INDEX+1
                MACIO(WORDNO  )= IAND(ISHFT(MTX3X3(INDEX),-12), 15)
                MACIO(WORDNO+1)= IAND(ISHFT(MTX3X3(INDEX),-6), 63)
                MACIO(WORDNO+2)= IAND(MTX3X3(INDEX), 63)
 100    CONTINUE
C
C       OUTPUT THE INSTRUCTION TO THE 7232.
C
        CALL MIOUT(22,0,0)
C
        RETURN
        END
        SUBROUTINE MW2COR(IX,IY)
C
C
C       INPUT PARAMETERS:
C       =================
C               IX - ABSOLUTE X COORDINATE OF NEW ORIGIN WITH RESPECT
C                    TO THE CURRENT ORIGIN.
C               IY - ABSOLUTE Y COORDINATE OF NEW ORIGIN WITH RESPECT
C                    TO THE CURRENT ORIGIN.
C
                INTEGER IX,IY
C
C       COMMON PARAMETERS:
C       ==================
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C
C       LOCAL VARIABLES:
C       ================
C
C-----------------------------------------------------------------------
C
C
C       STACK ROUTINE ID FOR ERROR TRACEBACK.
C
        CALL MIERST(5120)
C
C       PUT 'INSERT XFORM ENABLE' INTO OUTPUT BUFFER.
C
            MACIO(1)=11
            MACIO(2)=49
C
C       PUT 'INSERT XFORM', AND '2-D XFORM FORMAT' INTO OUTPUT BUFFER.
C
            MACIO(3)=13
            MACIO(4)=0
C
C       PUT ORIGIN COORDINATES INTO THE OUTPUT BUFFER.
C
            MACIO(5) = IAND(ISHFT(IX, -6), 63)
            MACIO(6) = IAND(IX, 63)
C
            MACIO(7) = IAND(ISHFT(IY, -6), 63)
            MACIO(8) = IAND( IY,   63)
C
C       SEND INSTRUCTION TO THE 7232 AND UPDATE THE CURRENT POSITION.
C
        CALL MIOUT(8,0,0)
C
        RETURN
        END
        SUBROUTINE MW2DRW(IX,IY)
C
C       INPUT PARAMETERS:
C       =================
C               COORDINATES TO BE DRAWN TO.
C
                INTEGER IX,IY
C
C       COMMON PARAMETERS:
C       ==================
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C       LOCAL VARIABLES:
C       ================
C               COTYPE - RECEIVES CURRENT COORDINATE TYPE.
C
                INTEGER COTYPE
C
C-----------------------------------------------------------------------
C
C       STACK ROUTINE ID FOR ERROR TRACEBACK.
C
                CALL MIERST(4020)
C
C       GET CURRENT COORDINATE TYPE INTO 'COTYPE' .
C
                CALL MIGVAL(ISYMCO, COTYPE)
C
C       SET UP THE 7232 OP CODE AND UPDATE THE CURRENT POSITION.
C
        MACIO(1) = 17
        IF (COTYPE.EQ.7.OR.COTYPE.EQ.8) MACIO(1) = 19
C
C               CONVERT THE COORDINATES:
C                       COTYPE = 1 TO 6 USE ABSOLUTE
C                       COTYPE = 7 OR 8 USE RELATIVE
C
        ICX = IX
        ICY = IY
        CALL MI2POS (ICX,ICY)
C       PUT THE DRAW TO COORDINATES INTO THE 7232 OUTPUT BUFFER.
C
                MACIO(2)= IAND(ISHFT(ICX,-6), 63)
                MACIO(3)=IAND(ICX, 63)
C
                MACIO(4)= IAND(ISHFT(ICY,-6), 63)
                MACIO(5)=IAND(ICY, 63)
C
C       OUTPUT THE INSTRUCTION TO THE 7232.
C
                CALL MIOUT(5,0,0)
C
                RETURN
                END
        SUBROUTINE MW2DSR(IDX,IDY)
C
C       INPUT PARAMETERS.
C       =================
C               RELATIVE DISPLACEMENT OF THE DRAW TO COORDINATES.
C
                INTEGER IDX,IDY
C
C       COMMON PARAMETERS:
C       ==================
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C
C       LOCAL VARIABLES:
C       ================
C
C               MODE   - CURRENT 7232 OUTPUT MODE.
C               MSX    - MOST SIGNIFICANT BIT OF IDX.
C               MSY    - MOST SIGNIFICANT BIT OF IDY.
C
                INTEGER MODE,MSX,MSY
C
C-----------------------------------------------------------------------
C
C
C       STACK ROUTINE ID FOR ERROR TRACEBACK.
C
                CALL MIERST(4060)
C
C               CHECK THE VECTOR MAGNITUDE.
C
        IF (IDX.GE.-64.AND.IDX.LE.63) GO TO 10
C
C               ERROR -- THE VECTOR IS OUT OF RANGE
C
                        CALL MIERR (7)
                        GO TO 9999
 10     IF (IDY.GE.-64.AND.IDY.LE.63) GO TO 20
C
C               ERROR -- THE VECTOR IS OUT OF RANGE
C
                        CALL MIERR (7)
                        GO TO 9999
C
C       GET THE CURRENT 7232 OUTPUT MODE.
C
 20             CALL MIGVAL(ISYMCM, MODE)
C
C       TEST MODE.
C       IF NOT CURRENTLY IN SRV OUTPUT MODE THEN
C               INITIATE SRV MODE BY OUTPUTTING SRV OP CODE AND SIZE.
C
                IF(MODE.EQ.-1) GOTO 100
                        MACIO(1)=25
                        CALL MIGVAL(ISYMSI, MACIO(2))
                        MACIO(2) = IAND((MACIO(2) -1), 7)
                        CALL MIOUT(2,-1,0)
C
C       PUT THE VECTOR INFORMATION INTO THE OUTPUT BUFFER.
C
100             MSX=ISHFT( IAND(IDX, 64),-4)
                MSY=ISHFT( IAND(IDY, 64),-2)
C
                MACIO(1)=IOR( IOR(40, MSX), MSY)
                MACIO(2)=IAND(IDX,63)
                MACIO(3)=IDY
                MACIO(3)=IAND(IDY,63)
C
C       OUTPUT THE VECTOR DATA TO THE 7232, THEN UPDATE CURRENT POSITION
C
        IATT(ISYMIX) = IATT(ISYMIX) + IDX * IATT(ISYMSI)
        IATT(ISYMIY) = IATT(ISYMIY) + IDY * IATT(ISYMSI)
C
                CALL MIOUT(3,-1,0)
9999            RETURN
                END
        SUBROUTINE MW2MOV(IX,IY)
C
C       INPUT PARAMETERS:
C       =================
C               COORDINATES TO BE DRAWN TO.
C
                INTEGER IX,IY
C
C       COMMON PARAMETERS:
C       ==================
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C       LOCAL VARIABLES:
C       ================
C               COTYPE - RECEIVES CURRENT COORDINATE TYPE.
C
                INTEGER COTYPE
C
C-----------------------------------------------------------------------
C
C       STACK ROUTINE ID FOR ERROR TRACEBACK.
C
                CALL MIERST(4000)
C
C       GET CURRENT COORDINATE TYPE INTO 'COTYPE' .
C
                CALL MIGVAL(ISYMCO, COTYPE)
C
C       SET UP THE 7232 OP CODE AND UPDATE THE CURRENT POSITION.
C
        MACIO(1) = 16
        IF (COTYPE.EQ.7.OR.COTYPE.EQ.8) MACIO(1) = 18
C
C               CONVERT THE COORDINATES:
C                       COTYPE = 1 TO 6 ABSOLUTE
C                       COTYPE = 7 OR 8 RELATIVE
C
        ICX = IX
        ICY = IY
C
        CALL MI2POS (ICX,ICY)
C
                MACIO(2)=IAND(ISHFT(ICX,-6), 63)
                MACIO(3)=IAND(ICX, 63)
C
                MACIO(4)=IAND(ISHFT(ICY,-6), 63)
                MACIO(5)=IAND(ICY, 63)
C
C       OUTPUT THE INSTRUCTION TO THE 7232.
C
                CALL MIOUT(5,0,0)
C
                RETURN
                END
C
        SUBROUTINE MW2MRK( IX, IY)
C
C                       COMMON.
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               MARKER TABLE.
        COMMON /M72MTB/ MARKTB(16)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
        CALL MIERST(4080)
C
C               GET THE CURRENT MARKER INFORMATION.
        CALL MIGVAL( ISYMMA, IMRKER)
        CALL MIGVAL( ISYMMS, IMRKSZ)
        CALL MIGVAL( ISYMMO, IMRKOR)
C
C               GET THE CURRENT MARKER VALUE
C
        MARKER = IAND(MARKTB(IMRKER), 255)
C
        CALL MEGCVT( MARKER, MARKER)
C
C               MOVE TO THE MARKER POSITION
C
            CALL MW2MOV( IX, IY)
C
C               CALCULATE HALF THE DISTANCE OF THE MARKER.
C
        IDISX = 4 * IMRKSZ
        IDISY = 6 * IMRKSZ
C
        IXPOS = IDISX
        IYPOS = IDISY
        IMROR = IMRKOR + 1
C
C       BEGIN_CASE:
C           1:  IMROR  NORMAL
C           2:  IMROR  90 DEG ROT.
C           3:  IMROR 180 DEG ROT.
C           4:  IMROR 270 DEG ROT.
            GO TO (400, 420, 500, 440), IMROR
C
400         IXPOS = -IDISX
            IYPOS = -IDISY
            GO TO 500
C
420         IXPOS = IDISY
            IYPOS = -IDISX
            GO TO 500
C
440         IXPOS = -IDISY
            IYPOS =  IDISX
C       END_CASE:
C
C               CREATE THE MOVE COMMAND, 1/2 THE MARKER LENGTH.
C
500     MACIO( 1) = 18
        MACIO( 2) = IAND(ISHFT(IXPOS, -6), 63)
        MACIO( 3) = IAND(IXPOS,         63)
        MACIO( 4) = IAND(ISHFT(IYPOS, -6), 63)
        MACIO( 5) = IAND(IYPOS, 63)
        CALL MIOUT( 5, 0, 0)
C
C               CREATE THE MARKER TEXT STRING.
C
        MACIO( 1) = 88
        MACIO( 2) = IAND((IMRKSZ -1), 7) + 64
        MACIO( 3) = IAND(IMRKOR, 3) + 64
        MACIO( 4) = MARKER
        MACIO( 5) = 29
        CALL MIOUT( 5, 0, 1)
C
C               CREATE THE MOVE COMMAND FOR 1/2 THE MARKER DISTANCE.
C
        IDISX = 8 * IMRKSZ
        IXPOS = IDISX
        IYPOS = IDISY
C       BEGIN_CASE:
C           1:  IMROR  NORMAL ROTATION.
C           2:  IMROR  90 DEG ROT.
C           3:  IMROR 180 DEG ROT.
C           4:  IMROR 270 DEG ROT.
            GO TO (520, 540, 560, 580), IMROR
C
520         IXPOS = -IDISX
            GO TO 600
C
540         IXPOS = -IDISY
            IYPOS = -IDISX
            GO TO 600
C
560         IYPOS = -IDISY
            GO TO 600
C
580         IXPOS = IDISY
            IYPOS = IDISX
C       END_CASE:
C
600     MACIO( 1) = 18
        MACIO( 2) = IAND(ISHFT(IXPOS, -6), 63)
        MACIO( 3) = IAND( IXPOS,       63)
        MACIO( 4) = IAND(ISHFT(IYPOS, -6), 63)
        MACIO( 5) = IAND( IYPOS,       63)
C
C               TRANSMIT THE COMMANDS.
C
        CALL MIOUT( 5, 0, 0)
C
        RETURN
C
        END
        SUBROUTINE MW2MSR(IDX,IDY)
C
C       INPUT PARAMETERS.
C       =================
C               RELATIVE DISPLACEMENT OF THE DRAW TO COORDINATES.
C
                INTEGER IDX,IDY
C
C       COMMON PARAMETERS:
C       ==================
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C
C       LOCAL VARIABLES:
C       ================
C
C               MODE   - CURRENT 7232 OUTPUT MODE.
C               MSX    - MOST SIGNIFICANT BIT OF IDX.
C               MSY    - MOST SIGNIFICANT BIT OF IDY.
C
                INTEGER MODE,MSX,MSY
C
C-----------------------------------------------------------------------
C
C
C       STACK ROUTINE ID FOR ERROR TRACEBACK.
C
                CALL MIERST(4040)
C
C               CHECK THE VECTOR RANGE.
C
        IF (IDX.GE.-64.AND.IDX.LE.63) GO TO 10
C
C               ERROR -- THE VECTOR IS OUT OF RANGE
C
                        CALL MIERR (7)
                        GO TO 9999
C
C
 10     IF (IDY.GE.-64.AND.IDY.LE.63) GO TO 20
C
C               ERROR -- THE VECTOR IS OUT OF RANGE
C
                        CALL MIERR (7)
                        GO TO 9999
C
C               GET THE CURRENT 7232 OUTPUT MODE
C
 20             CALL MIGVAL(ISYMCM, MODE)
C
C       IF NOT CURRENTLY IN SRV OUTPUT MODE THEN
C               INITIATE SRV MODE BY OUTPUTTING SRV OP CODE AND SIZE.
C
                IF(MODE.EQ.-1) GOTO 100
                        MACIO(1)=25
                        CALL MIGVAL(ISYMSI, MACIO(2))
                        MACIO(2) = IAND((MACIO(2) -1), 7)
                        CALL MIOUT(2,-1,0)
C
C       PUT THE VECTOR INFORMATION INTO THE OUTPUT BUFFER.
C
 100            MSX=ISHFT(IAND(IDX, 64),-4)
                MSY=ISHFT( IAND(IDY, 64),-2)
C
                MACIO(1)= IOR( IOR(32, MSX), MSY)
                MACIO(2)=IAND(IDX,63)
                MACIO(3)=IAND(IDY,63)
C
C       OUTPUT THE VECTOR DATA TO THE 7232, THEN UPDATE CURRENT POSITION
C
                CALL MIOUT(3,-1,0)
C
        IATT(ISYMIX) = IATT(ISYMIX) + IDX * IATT(ISYMSI)
        IATT(ISYMIY) = IATT(ISYMIY) + IDY * IATT(ISYMSI)
C
 9999           RETURN
                END
        SUBROUTINE MW2PEN(IX,IY,IPEN)
C
C
        IF (IPEN.EQ.1) CALL MW2DRW
        IF (IPEN.EQ.0) CALL MW2MOV
C
        RETURN
        END
C
        SUBROUTINE MW2QCO( IX, IY)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
        CALL MIERST(6060)
C
C               CALL THE ORIGIN QUERY ROUTINE.
C               BUT FIRST GET THE CURRENT SEGMENT NAME, EVEN SEG 0.
C
        CALL MIGVAL(ISYMSE, ISEGNM)
        CALL MIQORG(ISEGNM, 2, IX, IY, IZ)
C
        RETURN
C
        END
C
        SUBROUTINE MW2QSO( ISEGNM, IX, IY)
C
        CALL MIERST(6070)
C
C               CALL THE ORIGIN QUERY ROUTINE.
C
        CALL MIQORG(ISEGNM, 2, IX, IY, IZ)
C
        RETURN
C
        END
C
        SUBROUTINE MW2SBM (IGRTYP,IGRNAM,ICALID,IX,IY,IDRAW)
C
C
C               THE COMMON BLOCK M72DST CONTAINS THE FOLLOWING
C               VARIABLE USED IN THIS ROUTINE
C
C                       MACIO  - THE OUTPUT BUFFER
C
C               THE COMMON BLOCK M72NME CONTAINS THE FOLLOWING
C               VARIABLES USED IN THIS ROUTINE
C
C                       ISYMSE - THE SEGMENT INDEX
C                       ISYMSU - THE SUBROUTINE INDEX
C
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C
        NPDATA = 0
C
C               STACK THE ROUTINE CODE
C
        CALL MIERST (2120)
C
        CALL MEGSTD (2,IGRTYP,IGTYPE)
        CALL MIGATT (IGTYPE,IC,ITYPE)
C
C               CHECK FOR AN OPEN SEGMENT
C
        CALL MIGVAL (ISYMSE,ICSEG)
        IF (ICSEG.EQ.0) GO TO 10
C
C               CLOSE IT
C
                        MACIO(1) = 4
                        NPDATA = 1
                        GO TO 20
C
C               CHECK FOR AN OPEN SUBROUTINE
C
 10     CALL MIGVAL (ISYMSU,ICSUB)
        IF (ICSUB.EQ.0) GO TO 20
C
C               CLOSE IT
C
                        MACIO(1) = 36
                        NPDATA = 1
C
C               PREPARE TO REWRITE THE SUBROUTINE
C
 20     MACIO(NPDATA+1) = 5
        MACIO(NPDATA+2) = IAND(ISHFT(IGRNAM, -6), 63)
        MACIO(NPDATA+3) = IAND(IGRNAM, 63)
        MACIO(NPDATA+4) = IAND(ISHFT(ICALID,-12),15)
        IF (ITYPE.EQ.ISYMSU) MACIO(NPDATA+4) = MACIO(NPDATA+4) + 32
        MACIO(NPDATA+5) = IAND(ISHFT(ICALID,-6),63)
        MACIO(NPDATA+6) = IAND(ICALID,63)
        MACIO(NPDATA+7) = 0
        MACIO(NPDATA+8) = 0
        NPDATA = NPDATA + 8
C
        CALL MIOUT (NPDATA,0,0)
C
C               REWRITE THE NEW MOVE OR DRAW COMMAND
C
        MACIO(1) = 16
        ICOTYP = IATT(ISYMCO)
C
        GO TO  (21,21,22,22,23,23,24,24) ICOTYP
C
 21     ICX = IX
        ICY = IY
        GO TO 25
C
 22     ICX = IX
        ICY = IATT(ISYMIY) + IY
        GO TO 25
C
 23     ICX = IX + IATT(ISYMIX)
        ICY = IY
        GO TO 25
C
 24     ICX = IX
        ICY = IY
        MACIO(1) = 18
C
 25     IF (IDRAW.EQ.1) MACIO(1) = MACIO(1) + 1
        MACIO(2) = IAND(ISHFT(ICX,-6),63)
        MACIO(3) = IAND(ICX,63)
        MACIO(4) = IAND(ISHFT(ICY,-6),63)
        MACIO(5) = IAND(ICY,63)
C
C               CLOSE THE SEGMENT IN WHICH THE REWRITE IS BEING
C               DONE
C
        MACIO(6) = 4
        IF (ITYPE.EQ.ISYMSU) MACIO(6) = 36
C
        CALL MIOUT (6,0,0)
C
C               IF A SEGMENT WAS CLOSED IN THIS ROUTINE, REOPEN IT
C
        IF (ICSEG.EQ.0) GO TO 30
C
C               REOPEN THE SEGMENT
C
                        MACIO(1) = 1
                        MACIO(2) = IAND(ISHFT(ICSEG,-6),63)
                        MACIO(3) = IAND(ICSEG,63)
                        GO TO 40
C
C               IF A SUBROUTINE WAS CLOSED IN THIS ROUTINE, REOPEN IT
C
 30     IF (ICSUB.EQ.0) GO TO 9999
C
C               REOPEN THE SUBROUTINE
C
                        MACIO(1) = 33
                        MACIO(2) = IAND(ISHFT(ICSUB, -6), 63)
                        MACIO(3) = IAND(ICSUB,63)
C
C               SEND THE COMMAND
C
 40     CALL MIOUT (3,0,0)
C
 9999   RETURN
        END
        SUBROUTINE MW2SMT(ISEGNM,RMX3X3)
C
C       INPUT PARAMETERS:
C       =================
C               ISEGNM - ID NUMBER OF SEGMENT TO RECEIVE MATRIX VALUES.
C               RMX3X3 - A 3 BY 3 ARRAY CONTAINING THE TRANSFORMATION
C                        MATRIX ELEMENTS TO BE OUTPUT.
C
                INTEGER ISEGNM
                REAL RMX3X3( 3, 3)
C
C       COMMON PARAMETERS:
C       ==================
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C
C       LOCAL VARIABLES:
C       ================
C
C               SEGVAL - SEGMENT EXISTS FLAG, 0 MEANS SEGMENT DOESNT EXI
C               WORDNO - NEXT WORD OF OUTPUT BUFFER TO RECEIVE DATA.
C               INDEX  - INDEX'S LOOP TO TRANSFER DATA TO OUTPUT BUFFER.
C               MTX3X3 - TRANSFORMATION MATRIX WITH BINARY SHIFTS.
C
                INTEGER SEGVAL,WORDNO,INDEX, MTX3X3( 9)
C
C-----------------------------------------------------------------------
C
C
C       STACK ROUTINE ID FOR ERROR TRACEBACK.
C
        CALL MIERST(5000)
C
C       SEE IF SEGMENT 'ISEGNM' EXISTS.
C
        CALL MISSM(ISEGNM,0,0,IERROR)
        IF (IERROR.EQ.1) GO TO 9999
C
C       PUT TRANSFORM ENABLE CODE INTO OUTPUT BUFFER
C
        MACIO(1)=8
        MACIO(2)=IAND(ISHFT(ISEGNM,-6), 63)
        MACIO(3)=IAND(ISEGNM, 63)
        MACIO(4)=48
C
C               PERFORM THE BINARY SHIFTS AND PLACE IN MTX3X3
C
        MTX3X3( 1) = IFIX(0.5 + RMX3X3( 1, 1) * 2048.)
        MTX3X3( 2) = IFIX(0.5 + RMX3X3( 2, 1) * 2048.)
        MTX3X3( 3) = IFIX(0.5 + RMX3X3( 3, 1))
        MTX3X3( 4) = IFIX(0.5 + RMX3X3( 1, 2) * 2048.)
        MTX3X3( 5) = IFIX(0.5 + RMX3X3( 2, 2) * 2048.)
        MTX3X3( 6) = IFIX(0.5 + RMX3X3( 3, 2))
C
C       PUT 2-D TRANSFORM INSTRUCTION AND SEGMENT ID INTO OUTPUT BUFFER.
C
        MACIO(5)=10
        MACIO(6)=MACIO(2)
        MACIO(7)=MACIO(3)
        MACIO(8)=4
C
C       PUT THE MATRIX ELEMENTS INTO THE OUTPUT BUFFER.
C
        WORDNO=6
        DO 200 INDEX=1,6
                WORDNO=WORDNO+3
                MACIO(WORDNO  )=IAND(ISHFT(MTX3X3(INDEX),-12), 15)
                MACIO(WORDNO+1)=IAND(ISHFT(MTX3X3(INDEX),-6), 63)
                MACIO(WORDNO+2)=IAND(MTX3X3(INDEX), 63)
 200    CONTINUE
C
C       OUTPUT THE INSTRUCTION TO THE 7232.
C
        CALL MIOUT(26,0,0)
C
 9999   RETURN
        END
        SUBROUTINE MW2SOR(ISEGNM,IX,IY)
C
C       INPUT PARAMETERS:
C       =================
C
C               ISEGNM - ID NUMBER OF THE SEGMENT THAT THE ORIGIN
C                        VALUES ARE TO BE WRITTEN TO.
C               IX     - ABSOLUTE X COORDINATE OF THE NEW ORIGIN.
C               IY     - ABSOLUTE Y COORDINATE OF THE NEW ORIGIN.
C
C
C       COMMON PARAMETERS:
C       ==================
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C
C
C       LOCAL VARIABLES:
C       ================
C
C               SEGVAL- 0 IF SEGMENT DOESNT EXIST.
C               ERROR NUMBER 5 - SEGMENT DOSEN'T EXITS.
C
                INTEGER SEGVAL
C
C-----------------------------------------------------------------------
C
C
C       STACK ROUTINE ID FOR ERROR TRACEBACK.
C
        CALL MIERST(5140)
C
C       SEE IF SEGMENT 'ISEGNM' EXISTS.
C
        CALL MISSM(ISEGNM,0,0,IERROR)
        IF (IERROR.EQ.1) GO TO 9999
C
C       PUT 'CHANGE SEGMENT XFORM ENABLE' INTO OUTPUT BUFFER.
C
        MACIO(1)=8
        MACIO(2) = IAND(ISHFT(ISEGNM, -6), 63)
        MACIO(3) = IAND( ISEGNM,       63)
        MACIO(4)=49
C
C       PUT IN 'CHANGE SEGMENT XFORM', 'SEGMENT_ID', AND '2D XFORM'.
C
        MACIO(5)=10
        MACIO(6)=MACIO(2)
        MACIO(7)=MACIO(3)
        MACIO(8)=0
C
C       PUT ORIGIN COORDINATES INTO OUTPUT BUFFER.
C
        MACIO(9) = IAND(ISHFT(IX, -6), 63)
        MACIO(10)= IAND( IX,       63)
C
        MACIO(11) = IAND(ISHFT(IY, -6), 63)
        MACIO(12) = IAND( IY,       63)
C
C       SEND THE INSTRUCTION TO THE 7232 AND UPDATE CP.
C
        CALL MIOUT(12,0,0)
 9999   RETURN
        END
C
        SUBROUTINE MW3CAL( ISBNAM, IX, IY, IZ, ISBCTL, ICALID)
C
C                       COMMON.
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               INTERACTION PROMPT BUFFER.
        COMMON /M72PMT/ IPRMPT(10)
C
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
        CALL MIERST( 2110)
C
C               CHECK FOR THE SUBROUTINE NAME IN RANGE ( 0 - 4095 ).
C
        IF(ISBNAM .LT. 0 .AND. ISBNAM .GT. 4095)        GO TO 100
                                                        GO TO 200
C       THEN:
C           ERROR:  THE SUBROUTINE NAME IS OUT OF RANGE ( 0 - 4095 )
100         IERW2 = 9
            GO TO 1000
C       ENDIF:
C
C               PREPARE THE COMMANDS TO READ THE CALL ID.
C
200     IPRMPT( 1) = 2
        IPRMPT( 2) = 124
        IPRMPT( 3) = 64
C
        CALL MEGRCF(KINFL, 7, MACIO, IPRMPT)
C
        IF(IAND(MACIO( 1), 32) .EQ. 32)                 GO TO 500
                                                        GO TO 540
C       THEN:
C           ERROR:  INVALID READ - DATA TERMINATION.
500         IERW2 = 73
            GO TO 1000
C       ENDIF:
C
540     ICALID = ISHFT(IAND(MACIO( 4), 15), 12) +
     1           ISHFT(IAND(MACIO( 5), 63), 6)   +
     2           IAND(MACIO( 6), 63)
C
        IF(ISBCTL .EQ. 0)                               GO TO 660
                                                        GO TO 680
C       THEN:
C           IT'S A MOVE TO THE SUBROUTINE POSITION.
660         CALL MW3MOV( IX, IY, IZ)
            GO TO 700
C       ELSE:
C           IT'S A DRAW
680        CALL MW3DRW( IX, IY, IZ)
C       ENDIF:
C
C       CREATE THE NECESSARY CONTROL COMMANDS.
C
700     MACIO( 1) = 37
        MACIO( 2) = IAND(ISHFT( ISBNAM, -6), 63)
        MACIO( 3) = IAND( ISBNAM, 63)
C
C               SEND THE COMMANDS TO THE 7232
C
        CALL MIOUT( 3, 0, 0)
        GO TO 2000
C
C               CALL THE ERROR ROUTINE
C
1000    CALL MIERR( IERW2)
C
2000    RETURN
C
        END
        SUBROUTINE MW3CMT(RMX4X4)
C
C       INPUT PARAMETERS:
C       =================
C
C               RMX4X4 - A 4 BY 4 ARRAY CONTAINING THE TRANSFORMATION
C                        MATRIX ELEMENTS TO BE OUTPUT.
C
                REAL RMX4X4( 4, 4)
C
C       COMMON PARAMETERS:
C       ==================
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C
C       LOCAL VARIABLES:
C       ================
C
C               MTX4X4 - TRANSFORMATION MATRIX WITH BINARY SHIFTS.
C
                INTEGER MTX4X4( 8)
C
C-----------------------------------------------------------------------
C
C
C       STACK ROUTINE ID FOR ERROR TRACEBACK.
C
        CALL MIERST(5030)
C
C       PUT TRANSFORM ENABLE CODE INTO OUTPUT BUFFER
C
        MACIO(1)=11
        MACIO(2)=48
C
C       PUT 3-D TRANSFORM INSTRUCTION INTO OUTPUT BUFFER.
C
        MACIO(3)=13
        MACIO(4)=5
C
C               PERFORM THE BINARY SHIFTS AND FIX THE MATRIX.
C
        MTX4X4( 1) = IFIX(0.5 + RMX4X4( 1, 1) * 2048.)
        MTX4X4( 2) = IFIX(0.5 + RMX4X4( 2, 1) * 2048.)
        MTX4X4( 3) = IFIX(0.5 + RMX4X4( 4, 1))
        MTX4X4( 4) = IFIX(0.5 + RMX4X4( 1, 2) * 2048.)
        MTX4X4( 5) = IFIX(0.5 + RMX4X4( 2, 2) * 2048.)
        MTX4X4( 6) = IFIX(0.5 + RMX4X4( 4, 2))
        MTX4X4( 7) = IFIX(0.5 + RMX4X4( 3, 1) * 2048.)
        MTX4X4( 8) = IFIX(0.5 + RMX4X4( 3, 2) * 2048.)
C
C       PUT THE MATRIX ELEMENTS INTO THE OUTPUT BUFFER.
C
        INDEX = 2
C
        DO 10 I = 1,8
C
                INDEX = INDEX + 3
                MACIO(INDEX) = IAND(ISHFT(MTX4X4(I), -12), 15)
                MACIO(INDEX+1) = IAND(ISHFT(MTX4X4(I), -6),   63)
                MACIO(INDEX+2) = IAND(MTX4X4(I), 63)
C
 10     CONTINUE
C
C       OUTPUT THE INSTRUCTION TO THE 7232.
C
        CALL MIOUT(28,0,0)
C
        RETURN
        END
        SUBROUTINE MW3COR(IX,IY,IZ)
C
C
C       INPUT PARAMETERS:
C       =================
C               IX - ABSOLUTE X COORDINATE OF NEW ORIGIN WITH RESPECT
C                    TO THE CURRENT ORIGIN.
C               IY - ABSOLUTE Y COORDINATE OF NEW ORIGIN WITH RESPECT
C                    TO THE CURRENT ORIGIN.
C               IZ - ABSOLUTE Z COORDINATE OF NEW ORIGIN WITH RESPECT
C                    TO THE CURRENT ORIGIN.
C
                INTEGER IX,IY,IZ
C
C       COMMON PARAMETERS:
C       ==================
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C
C-----------------------------------------------------------------------
C
C
C       STACK ROUTINE ID FOR ERROR TRACEBACK.
C
        CALL MIERST(5130)
C
C       PUT 'INSERT XFORM ENABLE' INTO OUTPUT BUFFER.
C
            MACIO(1)=11
            MACIO(2)=49
C
C       PUT 'INSERT XFORM', AND '3-D ORIGIN FORMAT' INTO OUTPUT BUFFER.
C
            MACIO(3)=13
            MACIO(4)=1
C
C       PUT ORIGIN COORDINATES INTO THE OUTPUT BUFFER.
C
            MACIO(5) = IAND(ISHFT(IX, -6), 63)
            MACIO(6) = IAND(IX, 63)
C
            MACIO(7) = IAND(ISHFT(IY, -6), 63)
            MACIO(8) = IAND(IY, 63)
C
            MACIO(9) = IAND(ISHFT(IZ, -6), 63)
            MACIO(10) = IAND(IZ, 63)
C
C       SEND INSTRUCTION TO THE 7232 AND UPDATE THE CURRENT POSITION.
C
        CALL MIOUT(10,0,0)
C
        RETURN
        END
        SUBROUTINE MW3DRW(IX,IY,IZ)
C
C       INPUT PARAMETERS:
C       =================
C               COORDINATES TO BE DRAWN TO.
C
                INTEGER IX,IY,IZ
C
C       COMMON PARAMETERS:
C       ==================
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C       LOCAL VARIABLES:
C       ================
C               COTYPE - RECEIVES CURRENT COORDINATE TYPE.
C
                INTEGER COTYPE
C
C-----------------------------------------------------------------------
C
C       STACK ROUTINE ID FOR ERROR TRACEBACK.
C
                CALL MIERST(4030)
C
C       GET CURRENT COORDINATE TYPE INTO 'COTYPE' .
C
                CALL MIGVAL(ISYMCO, COTYPE)
C
C       SET UP THE 7232 OP CODE AND UPDATE THE CURRENT POSITION.
C
        MACIO( 1) = 21
        IF (COTYPE.EQ.7.OR.COTYPE.EQ.8) MACIO(1) = 23
C
C               CONVERT THE COORDINATES
C                       COTYPE = 1 TO 6 ABSOLUTE
C                       COTYPE = 7 OR 8 RELATIVE
C
        ICX = IX
        ICY = IY
        ICZ = IZ
C
        CALL MI3POS (ICX,ICY,ICZ)
C
                MACIO(2)= IAND(ISHFT(ICX,-6), 63)
                MACIO(3)=IAND(ICX, 63)
C
                MACIO(4)= IAND(ISHFT(ICY,-6), 63)
                MACIO(5)= IAND(ICY, 63)
C
                MACIO(6)= IAND(ISHFT(ICZ,-6), 63)
                MACIO(7)= IAND(ICZ, 63)
C
C       OUTPUT THE INSTRUCTION TO THE 7232.
C
                CALL MIOUT(7,0,0)
C
                RETURN
                END
C
        SUBROUTINE MW3DSR( IDX, IDY, IDZ)
C
C                       COMMON.
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
        CALL MIERST( 4070)
C
C               GET THE CURRENT COORDINATE TYPE.
C
        CALL MIGVAL(ISYMCO, ICOTYP)
C
        CALL MIGVAL(ISYMSI, ISIZE)
        CALL MISVAL(ISYMCO, 8)
C
        IX = IDX * ISIZE
        IY = IDY * ISIZE
        IZ = IDZ * ISIZE
C
        CALL MW3DRW(IX, IY, IZ)
C
        CALL MISVAL(ISYMCO, ICOTYP)
C
C                TERMINATE.
C
        RETURN
C
        END
        SUBROUTINE MW3MOV(IX,IY,IZ)
C
C       INPUT PARAMETERS:
C       =================
C               COORDINATES TO BE DRAWN TO.
C
                INTEGER IX,IY,IZ
C
C       COMMON PARAMETERS:
C       ==================
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C       LOCAL VARIABLES:
C       ================
C
C               COTYPE - RECEIVES CURRENT COORDINATE TYPE.
C
                INTEGER COTYPE
C
C-----------------------------------------------------------------------
C
C       STACK ROUTINE ID FOR ERROR TRACEBACK.
C
                CALL MIERST(4010)
C
C
C       GET CURRENT COORDINATE TYPE INTO 'COTYPE' .
        CALL MIGVAL( ISYMCO, COTYPE)
C
        MACIO( 1) = 20
        IF (COTYPE.EQ.7.OR.COTYPE.EQ.8) MACIO(1) = 22
C
C               CONVERT THE COORDINATES
C                       COTYPE = 1 TO 6 ABSOLUTE
C                       COTYPE = 7 OR 8 RELATIVE
C
        ICX = IX
        ICY = IY
        ICZ = IZ
C
        CALL MI3POS (ICX,ICY,ICZ)
C
        MACIO(2)=IAND(ISHFT(ICX,-6), 63)
        MACIO(3)=IAND(ICX, 63)
C
        MACIO(4)= IAND(ISHFT(ICY,-6), 63)
        MACIO(5)= IAND(ICY, 63)
C
        MACIO(6)= IAND(ISHFT(ICZ,-6), 63)
        MACIO(7)= IAND(ICZ, 63)
C
C       OUTPUT THE INSTRUCTION TO THE 7232.
C
                CALL MIOUT(7,0,0)
C
                RETURN
                END
C
        SUBROUTINE MW3MRK( IX, IY, IZ)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               MARKER TABLE.
        COMMON /M72MTB/ MARKTB(16)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
        CALL MIERST(4090)
C
C               GET THE CURRENT MARKER INFORMATION.
        CALL MIGVAL( ISYMMA, IMRKER)
        CALL MIGVAL( ISYMMS, IMRKSZ)
        CALL MIGVAL( ISYMMO, IMRKOR)
C
C               CHECK THE CURRENT MARKER VALUE
C
        MARKER = IAND(MARKTB(IMRKER), 255)
C
        CALL MEGCVT( MARKER, MARKER)
C
C               MOVE TO THE POSITION
C
        CALL MW3MOV (IX,IY,IZ)
C               CALCULATE HALF THE DISTANCE OF THE MARKER.
C
        IDISX = 4 * IMRKSZ
        IDISY = 6 * IMRKSZ
C
        IXPOS = IDISX
        IYPOS = IDISY
        IMROR = IMRKOR + 1
C
C       BEGIN_CASE:
C           1:  IMROR  NORMAL
C           2:  IMROR  90 DEG ROT.
C           3:  IMROR 180 DEG ROT.
C           4:  IMROR 270 DEG ROT.
            GO TO (500, 520, 600, 540), IMROR
C
500         IXPOS = -IDISX
            IYPOS = -IDISY
            GO TO 600
C
520         IXPOS =  IDISY
            IYPOS = -IDISX
            GO TO 600
C
540         IXPOS = -IDISY
            IYPOS =  IDISX
C       END_CASE:
C
C               CREATE THE MOVE COMMAND 1/2 THE MARKER LENGTH.
C
600     MACIO( 1) = 18
        MACIO( 2) = IAND(ISHFT(IXPOS, -6), 63)
        MACIO( 3) = IAND(IXPOS, 63)
        MACIO( 4) = IAND(ISHFT(IYPOS, -6), 63)
        MACIO( 5) = IAND(IYPOS, 63)
        CALL MIOUT( 5, 0, 0)
C
C               CREATE THE MARKER TEXT STRING.
C
        MACIO( 1) = 88
        MACIO( 2) = IAND((IMRKSZ - 1), 7) + 64
        MACIO( 3) = IAND(IMRKOR, 3) + 64
        MACIO( 4) = MARKER
        MACIO( 5) = 29
        CALL MIOUT( 5, 0, 1)
C
C               CREATE THE MOVE COMMAND FOR 1/2 THE MARKER DISTANCE.
C
        IDISX = 8 * IMRKSZ
        IXPOS = IDISX
        IYPOS = IDISY
C       BEGIN_CASE:
C           1:  IMROR  NORMAL ROTATION
C           2:  IMROR  90 DEG ROT.
C           3:  IMROR 180 DEG ROT.
C           4:  IMROR 270 DEG ROT.
            GO TO (620, 640, 660, 680), IMROR
C
620         IXPOS = -IDISX
            GO TO 700
C
640         IXPOS = -IDISY
            IYPOS = -IDISX
            GO TO 700
C
660         IYPOS = -IDISY
            GO TO 700
C
680         IXPOS =  IDISY
            IYPOS =  IDISX
C       END_CASE:
C
700     MACIO( 1) = 18
        MACIO( 2) = IAND(ISHFT(IXPOS, -6), 63)
        MACIO( 3) = IAND(      IXPOS,      63)
        MACIO( 4) = IAND(ISHFT(IYPOS, -6), 63)
        MACIO( 5) = IAND(      IYPOS,      63)
        CALL MIOUT( 5, 0, 0)
C
        RETURN
C
        END
C        ***************************************************************
C        *
C        *
C        *                        MEGATEK WAND 7232
C        *
C        *
C        *        NAME:        MW3MSR.FOR                301-1115
C        *
C        *        ERROR CODE:        4050
C        *
C        *        DESCR:
C        *
C        *                THIS ROUTINE CAUSES A BLANK SHORT RELATIVE
C        *        VECTOR TO BE DRAWN FROM THE CURRENT PEN POSITION TO
C        *        SPECIFIED 3-D COORDINATES.
C        *
C        *        CALLING SEQUENCE:
C        *
C        *                CALL MW3MSR( IDX, IDY, IDZ)
C        *
C        *                        IDX = X COOR RELATIVE DISPLACEMENT.
C        *                        IDY = Y COORD RELATIVE DISPLACEMENT.
C        *                        IDZ = Z COORD RELATIVE DISPLACEMENT.
C        *
C        *        ROUTINES CALLED:
C        *
C        *                MIERST - ROUTINE ID STACKING FOR TRACEBACK.
C        *                MIOUT  - OUTPUT ROUTINE, TO THE 7232.
C        *                MIGVAL - GETS THE CURRENT COORDINATE TYPE
C        *                         AND SRV_SIZE FROM THE CONTROL AREA.
C        *                MIPOS  - UPDATES THE CURRENT POSITION.
C        *
C        *        REVISION HISTORY:
C        *
C        *        REV        DATE                DESCRIPTION
C        *        00        30-JUL-80        PUBLIC RELEASE
C        *
C        *          THIS PROGRAM IS PROPRIETARY TO MEGATEK CORPORATION
C        *          AND IS  DISTRIBUTED  UNDER  A  LICENSE  AGREEMENT.
C        *          REPRODUCTION, DISCLOSURE, OR USE, IN  WHOLE  OR IN
C        *          PART, OTHER THAN AS  SPECIFIED  IN THE LICENSE ARE
C        *          NOT TO BE  UNDERTAKEN  EXCEPT  WITH  PRIOR WRITTEN
C        *          AUTHORIZATION OF MEGATEK CORPORATION.
C        *
C        *                   COPYRIGHT (C) MEGATEK CORP., 1980
C        *                          ALL RIGHTS RESERVED
C        *
C        ***************************************************************
C
        SUBROUTINE MW3MSR( IDX, IDY, IDZ)
C
C                        COMMON.
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C                ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
        CALL MIERST( 4050)
C
C                GET THE CURRENT 7232 COORDINATE TYPE.
C
        CALL MIGVAL(ISYMCO, ICOTYP)
C
        CALL MIGVAL(ISYMSI, ISIZE)
C
        CALL MISVAL(ISYMCO, 8)
C
        IX = IDX * ISIZE
        IY = IDY * ISIZE
        IZ = IDZ * ISIZE
C
        CALL MW3MOV(IX, IY, IZ)
C
        CALL MISVAL(ISYMCO, ICOTYP)
C
        RETURN
C
        END
        SUBROUTINE MW3PEN(IX,IY,IZ,IPEN)
C
C
        IF (IPEN.EQ.1) CALL MW3DRW (IX,IY,IZ)
        IF (IPEN.EQ.0) CALL MW3MOV (IX,IY,IZ)
C
        RETURN
        END
C
        SUBROUTINE MW3QCO( IX, IY, IZ)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
        CALL MIERST(6080)
C
C               CALL THE QUERY ROUTINE, FIRST RETRIEVE THE SEGMENT NAME.
C
        CALL MIGVAL(ISYMSE, ISEGNM)
        CALL MIQORG(ISEGNM, 3, IX, IY, IZ)
C
        RETURN

C
        END
C
        SUBROUTINE MW3QSO( ISEGNM, IX, IY, IZ)
C
        CALL MIERST(6090)
C
C               CALL THE ORIGIN QUERY ROUTINE.
C
        CALL MIQORG(ISEGNM, 3, IX, IY, IZ)
C
        RETURN
C
        END
C
        SUBROUTINE MW3SBM (IGRTYP,IGRNAM,ICALID,IX,IY,IZ,IDRAW)
C
C
C               THE COMMON BLOCK M72DST CONTAINS THE FOLLOWING
C               VARIABLE USED IN THIS ROUTINE
C
C                       MACIO  - THE OUTPUT BUFFER
C
C               THE COMMON BLOCK M72NME CONTAINS THE FOLLOWING
C               VARIABLES USED IN THIS ROUTINE
C
C                       ISYMSE - THE SEGMENT INDEX
C                       ISYMSU - THE SUBROUTINE INDEX
C
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C
        NPDATA = 0
C
C               STACK THE ROUTINE CODE
C
        CALL MIERST (2130)
C
        CALL MEGSTD (2,IGRTYP,IGTYPE)
        CALL MIGATT (IGTYPE,IC,ITYPE)
C               CHECK FOR AN OPEN SEGMENT
C
        CALL MIGVAL (ISYMSE,ICSEG)
        IF (ICSEG.EQ.0) GO TO 10
C
C               CLOSE IT
C
                        MACIO(1) = 4
                        NPDATA = 1
                        GO TO 20
C
C               CHECK FOR AN OPEN SUBROUTINE
C
 10     CALL MIGVAL (ISYMSU,ICSUB)
        IF (ICSUB.EQ.0) GO TO 20
C
C               CLOSE IT
C
                        MACIO(1) = 36
                        NPDATA = 1
C
C               PREPARE TO REWRITE THE SUBROUTINE
C
 20     MACIO(NPDATA+1) = 5
        MACIO(NPDATA+2) = IAND(ISHFT(IGRNAM, -6), 63)
        MACIO(NPDATA+3) = IAND(IGRNAM, 63)
        MACIO(NPDATA+4) = IAND(ISHFT(ICALID,-12),15)
        IF (ITYPE.EQ.ISYMSU) MACIO(NPDATA+4) = MACIO(NPDATA+4) + 32
        MACIO(NPDATA+5) = IAND(ISHFT(ICALID,-6),63)
        MACIO(NPDATA+6) = IAND(ICALID,63)
        MACIO(NPDATA+7) = 0
        MACIO(NPDATA+8) = 0
        NPDATA = NPDATA + 8
C
        CALL MIOUT (NPDATA,0,0)
C
C               REWRITE THE NEW MOVE OR DRAW COMMAND
C
        MACIO(1) = 20
        ICOTYP = IATT(ISYMCO)
C
        GO TO (21,22,23,24,25,26,27,28) ICOTYP
C
 21     ICX = IX
        ICY = IY
        ICZ = IZ
        GO TO 29
C
 22     ICX = IX
        ICY = IY
        ICZ = IZ + IATT(ISYMIZ)
        GO TO 29
C
 23     ICX = IX
        ICY = IY + IATT(ISYMIY)
        ICZ = IZ
        GO TO 29
C
 24     ICX = IX
        ICY = IATT(ISYMIY) + IY
        ICZ = IATT(ISYMIZ) + IZ
        GO TO 29
C
 25     ICX = IATT(ISYMIX) + IX
        ICY = IY
        ICZ = IZ
        GO TO 29
C
 26     ICX = IATT(ISYMIX) + IX
        ICY = IY
        ICZ = IATT(ISYMIZ) + IZ
        GO TO 29
C
 27     ICX = IX
        ICY = IY
        ICZ = IATT(ISYMIZ) - IZ
        MACIO(1) = 22
        GO TO 29
C
 28     ICX = IX
        ICY = IY
        ICZ = IZ
        MACIO(1) = 22
C
 29     IF (IDRAW.EQ.1) MACIO(1) = MACIO(1) + 1
        MACIO(2) = IAND(ISHFT(ICX,-6),63)
        MACIO(3) = IAND(ICX,63)
        MACIO(4) = IAND(ISHFT(ICY,-6),63)
        MACIO(5) = IAND(ICY,63)
        MACIO(6) = IAND(ISHFT(ICZ,-6),63)
        MACIO(7) = IAND(ICZ,63)
C
C               CLOSE THE SEGMENT/SUBROUTINE IN WHICH THE REWRITE WAS
C               DONE
C
        MACIO(8) = 4
        IF (ITYPE.EQ.ISYMSU) MACIO(8) = 36
C
        CALL MIOUT (8,0,0)
C
C               IF A SEGMENT WAS CLOSED IN THIS ROUTINE, REOPEN IT
C
        IF (ICSEG.EQ.0) GO TO 30
C
C               CLOSE THE SEGMENT
C
                        MACIO(1) = 1
                        MACIO(2) = IAND(ISHFT(ICSEG,-6),63)
                        MACIO(3) = IAND(ICSEG,63)
                        GO TO 40
C
C               IF A SUBROUTINE WAS CLOSED IN THIS ROUTINE, REOPEN IT
C
 30     IF (ICSUB.EQ.0) GO TO 9999
C
C               CLOSE THE SUBROUTINE
C
                        MACIO(1) = 33
                        MACIO(2) = IAND(ISHFT(ICSUB, -6), 63)
                        MACIO(3) = IAND(ICSUB,63)
C
C               SEND THE COMMAND
C
 40     CALL MIOUT (3,0,0)
C
 9999   RETURN
        END
        SUBROUTINE MW3SMT(ISEGNM,RMX4X4)
C
C       INPUT PARAMETERS:
C       =================
C               ISEGNM - ID NUMBER OF SEGMENT TO RECEIVE MATRIX VALUES.
C               RMX4X4 - A 4 BY 4 ARRAY CONTAINING THE TRANSFORMATION
C                        MATRIX ELEMENTS TO BE OUTPUT.
C
                INTEGER ISEGNM
                REAL RMX4X4( 4, 4)
C
C       COMMON PARAMETERS:
C       ==================
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C
C       LOCAL VARIABLES:
C       ================
C
C               SEGVAL - SEGMENT EXISTS FLAG, 0 MEANS SEGMENT DOESNT EXI
C               IERW2  - 'SEGMENT DOESNT EXIST' ERROR MESSAGE CODE #.
C               MTX4X4 - TRANSFORMATION MATRIX AFTER BINARY SHIFTS.
C
                INTEGER SEGVAL,IERW2, MTX4X4( 8)
C
C-----------------------------------------------------------------------
C
C
C       STACK ROUTINE ID FOR ERROR TRACEBACK.
C
        CALL MIERST(5010)
C
C       SEE IF SEGMENT 'ISEGNM' EXISTS.
C
        CALL MISSM(ISEGNM,0,0,IERROR)
        IF (IERROR.EQ.1) GO TO 9999
C
C       PUT TRANSFORM ENABLE CODE INTO OUTPUT BUFFER THEN SEND TO 7232.
C
        MACIO(1)=8
        MACIO(2)=IAND(ISHFT(ISEGNM,-6), 63)
        MACIO(3)=IAND(ISEGNM, 63)
        MACIO(4)=48
        CALL MIOUT(4,0,0)
C
C       PUT 3-D TRANSFORM INSTRUCTION AND SEGMENT ID INTO OUTPUT BUFFER.
C
        MACIO(1)=10
        MACIO(2)= IAND(ISHFT(ISEGNM,-6), 63)
        MACIO(3)=IAND(ISEGNM, 63)
        MACIO(4)= 5
C
C               PERFORM BINARY SHIFTS AND FIX TRANSFORMATION MATRIX
C
        MTX4X4( 1) = IFIX(0.5 + RMX4X4( 1, 1) * 2048.)
        MTX4X4( 2) = IFIX(0.5 + RMX4X4( 2, 1) * 2048.)
        MTX4X4( 3) = IFIX(0.5 + RMX4X4( 4, 1))
        MTX4X4( 4) = IFIX(0.5 + RMX4X4( 1, 2) * 2048.)
        MTX4X4( 5) = IFIX(0.5 + RMX4X4( 2, 2) * 2048.)
        MTX4X4( 6) = IFIX(0.5 + RMX4X4( 4, 2))
        MTX4X4( 7) = IFIX(0.5 + RMX4X4( 3, 1) * 2048.)
        MTX4X4( 8) = IFIX(0.5 + RMX4X4( 3, 2) * 2048.)
C
C       PUT THE MATRIX ELEMENTS INTO THE OUTPUT BUFFER.
C
        INDEX = 2
C
        DO 10 I = 1,8
C
                INDEX = INDEX + 3
                MACIO(INDEX)= IAND(ISHFT(MTX4X4(I),-12), 15)
                MACIO(INDEX+1)= IAND(ISHFT(MTX4X4(I),-6), 63)
                MACIO(INDEX+2)= IAND(MTX4X4(I), 63)
C
 10     CONTINUE
C
C       OUTPUT THE INSTRUCTION TO THE 7232.
C
        CALL MIOUT(28,0,0)
C
 9999   RETURN
        END
        SUBROUTINE MW3SOR(ISEGNM,IX,IY,IZ)
C
C       INPUT PARAMETERS:
C       =================
C
C               ISEGNM - ID NUMBER OF THE SEGMENT THAT THE ORIGIN
C                        VALUES ARE TO BE WRITTEN TO.
C               IX     - ABSOLUTE X COORDINATE OF THE NEW ORIGIN.
C               IY     - ABSOLUTE Y COORDINATE OF THE NEW ORIGIN.
C               IZ     - ABSOLUTE Z COORDINATE OF THE NEW ORIGIN.
C
C
C       COMMON PARAMETERS:
C       ==================
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C
C
C       LOCAL VARIABLES:
C       ================
C
C               SEGVAL- 0 IF SEGMENT DOESNT EXIST.
C               ERROR:  SEGMENT DOESN'T EXIST - 360.
                INTEGER SEGVAL
C
C-----------------------------------------------------------------------
C
C
C       STACK ROUTINE ID FOR ERROR TRACEBACK.
C
        CALL MIERST(5150)
C
C       SEE IF SEGMENT 'ISEGNM' EXISTS.
C
        CALL MISSM (ISEGNM,0,0,IERROR)
        IF (IERROR.EQ.1) GO TO 9999
C
C       PUT 'CHANGE SEGMENT XFORM ENABLE' INTO OUTPUT BUFFER.
C
        MACIO(1)=8
        MACIO(2) = IAND(ISHFT(ISEGNM, -6), 63)
        MACIO(3) = IAND( ISEGNM,       63)
        MACIO(4)=49
C
C       PUT IN 'CHANGE SEGMENT XFORM', 'SEGMENT_ID', AND '3D ORIGIN'.
C
        MACIO(5)=10
        MACIO(6)=MACIO(2)
        MACIO(7)=MACIO(3)
        MACIO(8)=1
C
C       PUT ORIGIN COORDINATES INTO OUTPUT BUFFER.
C
        MACIO(9) = IAND(ISHFT(IX, -6), 63)
        MACIO(10) = IAND(IX,       63)
C
        MACIO(11) = IAND(ISHFT(IY, -6), 63)
        MACIO(12) = IAND( IY,       63)
C
        MACIO(13) = IAND(ISHFT(IZ, -6), 63)
        MACIO(14) = IAND( IZ,       63)
C
C       SEND THE INSTRUCTION TO THE 7232 AND UPDATE CP.
C
        CALL MIOUT(14,0,0)
C
 9999   RETURN
        END
        SUBROUTINE MWACHR(ICHAR)
C
C       INPUT PARAMETERS:
C       =================
C
C               ICHAR  - THE CHARACTER TO BE OUTPUT.
C
                INTEGER ICHAR
C
C       COMMON PARAMETERS:
C       ==================
C
C                       COMMON.
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C
C       LOCAL VARIABLES:
C       ================
C
C               CHAR   - CHARACTER EXTRACTED FROM INPUT 'ICHAR'.
C               INDX   - INDEX IN ATTRIBUTE TABLE - RETURNED VALUE.
C               SIZE   - CHARACTER SIZE
C               ANGLE  - CHARACTER ANGLE.
C               MODE   - CURRENT 7232 OUTPUT MODE, 1 FOR TEXT MODE.
C
                INTEGER CHAR,SWAP,INDX,SIZE,ANGLE,MODE
C
C-----------------------------------------------------------------------
C
C
C       STACK ROUTINE ID FOR ERROR TRACEBACK.
C
        CALL MIERST(4200)
C
C               SELECT THE CHARACTER OR REQUEST, EXTRACT IT.
C
        CALL MEG1CH( 1, ICHAR, CHAR)
C
C               CONVERT IT FROM HOST CHARACTER SET TO ASCII.
C
        CALL MEGCVT( CHAR, CHAR)
C
C               TEST FOR A VALID CHARACTER.
C
        IF (CHAR.GE.32.AND.CHAR.LE.126) GO TO 100
C
C               ERROR AN INVALID CHARACTER
C
                        CALL MIERR (21)
                        GO TO 9999
C
C               GET THE CURRENT SIZE AND ANGLE
C
 100    SIZE = IATT(ISYMCS)
        ANGLE = IATT(ISYMCA)
C
C               SET UP THE COMMAND AND SEND IT.
C
        MACIO(1) = 88
        MACIO(2) = IAND((SIZE - 1), 7) + 64
        MACIO(3) = IAND(ANGLE, 3) + 64
        MACIO(4) = CHAR
        MACIO(5) = 29
C
C
        CALL MIOUT (5,1,1)
C
 9999   RETURN
        END
C
        SUBROUTINE MWALDS( IDISP, ISHARE)
C
C
        RETURN
        END
C
C
        SUBROUTINE MWALFB (IUNIT,IPERID)
C
C
C               THE M72PER.CMB COMMON BLOCK CONTAINS THE FOLLOWING
C               VARIABLES USED IN THIS ROUTINE
C
C                       IFBID  - THE FUNCTION BOX ID
C                       IBTID  - THE BUTTONS ID
C                       IVLID  - THE CONTROL DIALS ID
C                       IPPSG  - THE PERIPHERAL INFORMATION ARRAY
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C
        INTEGER IPERID(2)
C
C               CHECK IF THE FUNCITON BOX IS ALREADY ALLOCATED
C
        IF (IPPSG(IFBID,3).NE.1) GO TO 10
C
C               ERROR -- FUNCTION BOX ALREADY ALLOCATED
C
                        CALL MIERR (39)
                        GO TO 9999
C
C               SET THE PERIPHERAL ID AND ALLOCATE
C
 10     IPERID(1) = IBTID
        IPERID(2) = IVLID
C
        IPPSG(IFBID,3) = 1
        IPPSG(IBTID,3) = 1
C
 9999   RETURN
        END
C
C
        SUBROUTINE MWALJO (IUNIT,IPERID)
C
C
C               THE M72PER.CMB COMMON BLOCK CONTAINS THE FOLLOWING
C               VARIABLES USED IN THIS ROUTINE
C
C                       IJYID  - THE JOYSTICK ID
C                       IPPSG  - THE PERIPHERAL INFORMATION ARRAY
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C
        INTEGER IPERID(2)
C
C               CHECK IF THE JOYSTICK HAS ALREADY BEEN ALLOCATED
C
        IF (IPPSG(IJYID,3).NE.1) GO TO 10
C
C               ERROR -- THE JOYSTICK IS ALREADY ALLOCATED
C
                        CALL MIERR (39)
                        GO TO 9999
C
C               SET THE PERIPHERAL ID ARRAY AND ALLOCATE
C
 10     IPERID(1) = IJYID
        IPPSG(IJYID,3) = 1
C
 9999   RETURN
        END
C
C
        SUBROUTINE MWALTA (IUNIT,IPERID)
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C
C               COMMON BLOCK M72PER.CMB CONTAINS THE FOLLOWING
C               VARIABLES USED IN THIS ROUTINE
C
C                       ITBID  - THE DATA TABLET ID NUMBER
C                       IPPSG  - THE PERIPHERAL INFORMATION ARRAY
C
        INTEGER IPERID(2)
C
C               CHECK IF THE PERIPHERAL IS ALREADY ALLOCATED
C
        IF (IPPSG(ITBID,3).NE.1) GO TO 10
C
C               OTHERWISE AN ERROR -- THE DATA TABLET IS ALREADY
C               ALLOCATED
C
                        CALL MIERR (39)
                        GO TO 9999
C
C               SET THE PERIPHERAL ID ARRAY AND ALLOCATE
C
 10     IPERID(1) = ITBID
C
        IPPSG(ITBID,3) = 1
C
C               INITIALIZE THE DATA TABLET.
C
        CALL MWDFTB( 3,'LO', 11, 11, 200)
C
 9999   RETURN
        END
C
C
        SUBROUTINE MWALPK (IUNIT,IPERID)
C
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C               PICK STATUS, VECTOR COUNT AND X, Y COORDINATES.
        COMMON /M72PIK/ IEKO, MIX, MIY, MVECCT, MPIKST,IPKLC
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C
C               THE M72PER.CMB COMMON BLOCK CONTAINS THE FOLLOWING
C               VARIABLES USED IN THIS ROUTINE
C
C                       IPKID  - THE PICK MODULE ID NUMBER
C                       IPPSG  - THE PERIPHERAL INFORMATION ARRAY
C
        INTEGER IPERID(2)
C
C               CHECK IF THE PICK MODULE IS ALREADY ALLOCATED
C
        IF (IPPSG(IPKID,3).NE.1) GO TO 10
C
C               ELSE ERROR -- PICK MODULE ALREADY ALLOCATED
C
                        CALL MIERR (39)
                        GO TO 9999
C
C               SET THE PERIPHERAL ID ARRAY AND ALLOCATE
C
 10     IPERID(1) = IPKID
C
        IPPSG(IPKID,3) = 1
        IPPSG(IPKID,1) = 1
C
        IPKLC = 0
C
 9999   RETURN
        END
C
C
        SUBROUTINE MWALKY (IUNIT,IPERID)
C
C
C               THE M72PER.CMB COMMON BLOCK CONTAINS THE FOLLOWING
C               VARIABLES USED IN THIS ROUTINE
C
C                       IKYID  - THE KEYBOARD ID
C                       IFPID  - THE FUNCTION PAD ID
C                       IPPSG  - THE PERIPHERAL INFORMATION ARRAY
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C
        INTEGER IPERID(2)
C
C               CHECK IF THE KEYBOARD IS ALREADY ALLOCATED
C
        IF (IPPSG(IKYID,3).NE.1) GO TO 10
C
C               ERROR -- THE KEYBOARD IS ALREADY ALLOCATED
C
                        CALL MIERR (39)
                        GO TO 9999
C
C       SET THE PERIPHERAL ID ARRAY AND ALLOCATE
C
 10     IPERID(1) = IKYID
        IPERID(2) = IFPID
C
        IPPSG(IKYID,3) = 1
        IPPSG(IFPID,3) = 1
C
 9999   RETURN
        END
C
C
        SUBROUTINE MWALPR (ITYPE,IUNIT,IPERID)
C
C
C
C               THE COMMON BLOCK M72PER CONTAINS THE FOLLOWING
C               VARIABLES USED IN THIS ROUTINE.
C
C                       IFBID  - THE FUNCTION BOX ID
C                       IKYID  - THE KEYBOARD ID
C                       IJOID  - THE JOYSTICK ID
C                       ITBID  - THE DATA TABLET ID
C                       IPKID  - THE PICK MODULE ID
C
C                       IPTYP  - THE ARRAY WITH THE STANDARDISED
C                                PERIPHERAL TYPE FIELDS.
C
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C
        INTEGER IPERID(2)
C

C               SET IPERID(1) TO -1 FOR ERROR CHECKING
C
        IPERID(1) = -1
C
C               MASK OFF ITYPE TO LEAVE THE FIRST TWO CHARACTERS
C
        CALL MEGSTD (2,ITYPE,INUTYP)
C
C
C               CHECK FOR FUNCTION BOX (FB)
C
        IF (INUTYP.EQ.IPTYP(IFBID)) CALL MWALFB (IUNIT,IPERID)
C
C               CHECK FOR JOYSTICK (JO)
C
        IF (INUTYP.EQ.IPTYP(IJYID)) CALL MWALJO (IUNIT,IPERID)
C
C               CHECK FOR KEYBOARD (KY)
C
        IF (INUTYP.EQ.IPTYP(IKYID)) CALL MWALKY (IUNIT,IPERID)
C
C               CHECK FOR PICK MODULE (PK)
C
        IF (INUTYP.EQ.IPTYP(IPKID)) CALL MWALPK (IUNIT,IPERID)
C
C               CHECK FOR DATA TABLET
C
        IF (INUTYP.EQ.IPTYP(ITBID)) CALL MWALTA (IUNIT,IPERID)
C
C               IF IPERID(1) HAS NOT BEEN CHANGED ITYPE IS IN ERROR
C
        IF (IPERID(1).EQ.-1) CALL MIERR (35)
C
C
        RETURN
        END
C
        SUBROUTINE MWBFSZ( INWRDS)
C
C               STACK THE ROUTINE ID CODE.
        CALL MIERST( 1110)
C
C       ERROR:  THIS ROUTINE IS NOT SUPPORTED BY THE WAND 7232 PACKAGE.
        CALL MIERR( 99)
C
        RETURN
C
        END
C
C
        SUBROUTINE MWBUFR( IBMODE)
C
C                       COMMON.
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               COMPUTER DEPENDENT ELEMENTS
        COMMON /M72CDV/ KTERM, KUCASE, KLCASE, KSUBCH, KSUPCH, KWRTFL
        COMMON /M72CDV/ KRDFL, KOUTFL, KINFL, KWRDSZ, KBYTEL, KCPW
        COMMON /M72CDV/ KSHFTC, KBLKPD, KFILL, KDEL
C
C
C               STACK THE ROUTINE ID CODE.
        CALL MIERST( 1100)
C
        IF(IBMODE .LT. 0 .OR. IBMODE .GT. 2)            GO TO 100
                                                        GO TO 200
C       THEN:
C           ERROR:  THE IBMODE PARAMETER MUST BE BETWEEN 0 AND 2.
100         CALL MIERR( 24)
            GO TO 2000
C       ENDIF:
C
200     IF(IBMODE .EQ. 2)                               GO TO 220
                                                        GO TO 300
C       THEN:
 220        MACIO (1) = 31
            CALL MIOUT (1, 0, 1)
            CALL MEGWCF (KOUTFL, 0, 0)
            CALL MEGWCF (KOUTFL, 1, 29)
            GO TO 2000
C       ENDIF:
C
300     CALL MISVAL(ISYMOB, IBMODE)
C
2000    RETURN
C
        END
C
C
        SUBROUTINE MWCAPP (IAPLEV)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C               ATTRIBUTES - SEGMENT ZERO - DEFAULT.
        COMMON /M72DAT/ IDFATT(16)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C               CHECK FOR AN INCORRECT APPEARANCE LEVEL.
C
        IF (IAPLEV.GE.1.AND.IAPLEV.LE.16) GO TO 5
C
C               ELSE THERE IS AN ERROR
C
                CALL MIERR (66)
                GO TO 9999
 5      IATT (ISYMAP) = IAPLEV
C
C               CHECK FOR SEGMENT ZERO.
C
        ICSEG = IATT(ISYMSE)
        ICSUB = IATT(ISYMSU)
C
        IF (ICSEG.NE.0.OR.ICSUB.NE.0) GO TO 10
C
C               SEGMENT ZERO--UPDATE THE DEFAULT ARRAY
C
        IDFATT(ISYMAP) = IAPLEV
C
C               SET UP THE INSTRUCTIONS
C
 10     MACIO(1) = 11
        MACIO(2) = IAND((IAPLEV-1),15)
C
C               SEND THE INSTRUCTIONS
C
        CALL MIOUT (2,0,0)
C
 9999   RETURN
        END
C
C
        SUBROUTINE MWCBLR (IRATE)
C
C               ATTRIBUTES - SEGMENT ZERO - DEFAULT.
        COMMON /M72DAT/ IDFATT(16)
C
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C               CHECK FOR AN INCORRECT BLINK RATE
C

        IF (IRATE.GE.1.AND.IRATE.LE.16) GO TO 10
C
C               ERROR THE RATE IS TOO LARGE OR TOO SMALL
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               CHANGE THE CURRENT ATTRIBUTE ARRAY
C
 10     IATT(ISYMBL) = IRATE
C
C               CHECK FOR SEGMENT ZERO
C
        ICSEG = IATT(ISYMSE)
        ICSUB = IATT(ISYMSU)
C
        IF (ICSEG.NE.0.OR.ICSUB.NE.0) GO TO 20
C
C               CHANGE THE DEFAULT BLINK RATE
C
                        IDFATT(ISYMBL) = IRATE
C
C               SET UP THE COMMANDS
C
 20     MACIO(1) = 11
        MACIO(2) = IAND(IRATE, 15) + 16
C
        CALL MIOUT (2,0,0)
C
 9999   RETURN
        END
C               THIS ROUTINE CHANGES THE CURRENT VALUE OF THE BEAM
C               PENETRATION DISPLAY COLOR ATTRIBUTE
C
C
        SUBROUTINE MWCBPC (IBPCOL)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C               ATTRIBUTES - SEGMENT ZERO - DEFAULT.
        COMMON /M72DAT/ IDFATT(16)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C               CHECK IF IBPCOL IS IN RANGE (0-15)
C
        IF (IBPCOL.GE.0.AND.IBPCOL.LE.15) GO TO 10
C
C               ERROR -- IBPCOL IS OUT OF RANGE
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               SET THE CURRENT SEGMENT ATTRIBUTE ARRAY
C
 10     IATT(ISYMBP) = IBPCOL
C
        ICSEG = IATT(ISYMSE)
        ICSUB = IATT(ISYMSU)
        IF (ICSEG.NE.0.AND.ICSUB.NE.0) GO TO 20
C
C               SEGMENT ZERO -- UPDATE THE DEFAULT ARRAY
C
                        IDFATT(ISYMBP) = IBPCOL
C
C               SET UP THE COMMAND
C
 20     MACIO(1) = 12
        MACIO(2) = 0
        MACIO(3) = 0
        MACIO(4) = IAND(IBPCOL,15) + 48
C
        CALL MIOUT (4,0,0)
C
 9999   RETURN
        END
C
C
        SUBROUTINE MWCCAN (IANGLE)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTES - SEGMENT ZERO - DEFAULT.
        COMMON /M72DAT/ IDFATT(16)
C
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C               CHECK FOR AN INCORRECT ANGLE VALUE
C
        IF (IANGLE.GE.0.OR.IANGLE.LE.3) GO TO 10
C
C               ELSE IANGLE IS TOO LARGE OR TOO SMALL
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               UPDATE THE CURRENT ATTRIBUTE ARRAY
C
 10     IATT (ISYMCA) = IANGLE
C
C               CHECK FOR SEGMENT ZERO
C
        ICSEG = IATT(ISYMSE)
        ICSUB = IATT(ISYMSU)
C
        IF (ICSEG.NE.0.OR.ICSUB.NE.0) GO TO 9999
C
C               OTHERWISE UPDATE THE DEFAULT ATTRIBUTE ARRAY
C
        IDFATT(ISYMCA) = IANGLE
C
 9999   RETURN
        END
C
C
        SUBROUTINE MWCCSZ (ICSIZE)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTES - SEGMENT ZERO - DEFAULT.
        COMMON /M72DAT/ IDFATT(16)
C
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C               CHECK IF ICSIZE IS IN RANGE 1 TO 8
C
        IF (ICSIZE.GE.1.AND.ICSIZE.LE.8) GO TO 10
C
C               OTHERWISE ICSIZE IS TOO SMALL OR TOO LARGE
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               UPDATE THE CURRENT ATTRIBUTE ARRAY
C
 10     IATT(ISYMCS) = ICSIZE
C
C               CHECK FOR SEGMENT ZERO
C
        ICSEG = IATT(ISYMSE)
        ICSUB = IATT(ISYMSU)
C
        IF (ICSEG.NE.0.OR.ICSUB.NE.0) GO TO 9999
C
C               SEGMENT ZERO--UPDATE THE DEFAULT ARRAY
C
        IDFATT(ISYMCS) = ICSIZE
C
 9999   RETURN
        END
C               THIS ROUTINE IS NOT SUPPORTED IN WAND SERIAL
C
C
        SUBROUTINE MWCCUN (IUNROT)
C
        CALL MIERR (99)
C
        RETURN
        END
C
C
        SUBROUTINE MWCDET (IDETEC)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTES - SEGMENT ZERO - DEFAULT.
        COMMON /M72DAT/ IDFATT(16)
C
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C               CHECK IF IDETEC IS IN RANGE 0 TO 1
C
        IF (IDETEC.EQ.1.OR.IDETEC.EQ.0) GO TO 10
C
C               OTHERWISE IDETEC IS TOO SMALL OF TOO LARGE
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               UPDATE THE CURRENT ATTRIBUTE ARRAY
C
 10     IATT(ISYMDE) = IDETEC
C
C               CHECK FOR SEGMENT ZERO
C
        ICSEG = IATT(ISYMSE)
        ICSUB = IATT(ISYMSU)
C
        IF (ICSEG.NE.0.OR.ICSUB.NE.0) GO TO 20
C
C               OTHERWISE UPDATE THE DEFAULT VALUE
C
                        IDFATT(ISYMDE) = IDETEC
C
C               SET UP THE COMMANDS
C
 20     MACIO(1) = 14
        MACIO(2) = 32 + IAND(IDETEC, 1)
        IECHLV = IATT(ISYMEC) - 1
        MACIO(3) = IAND(IECHLV, 7)
C
        CALL MIOUT (3,0,0)
C
 9999   RETURN
        END
C
C
        SUBROUTINE MWCECH (ILEVEL)
C
C               ATTRIBUTES - SEGMENT ZERO - DEFAULT.
        COMMON /M72DAT/ IDFATT(16)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C
C               CHECK FOR ILEVEL IN RANGE 1 TO 6
C
        IF (ILEVEL.GE.1.AND.ILEVEL.LE.6) GO TO 10
C
C               OTHERWISE ILEVEL IS TOO SMALL OR TOO LARGE
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               UPDATE THE CURRENT ATTRIBUTE ARRAY
C
 10     IATT(ISYMEC) = ILEVEL
C
C               CHECK FOR SEGMENT ZERO
C
        ICSEG = IATT(ISYMSE)
        ICSUB = IATT(ISYMSU)
C
C               UPDATE THE DEFAULT ATTRIBUTE ARRAY
C
        IF (ICSEG.EQ.0.AND.ICSUB.EQ.0) IDFATT(ISYMEC) = ILEVEL
C
C               SET UP THE COMMANDS
C
        MACIO(1) = 14
        MACIO(2) = 16
        MACIO(3) = IAND((ILEVEL-1),7)
C
        CALL MIOUT (3,0,0)
C
 9999   RETURN
        END
C
C
        SUBROUTINE MWCHDR (ITRANS)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTES - SEGMENT ZERO - DEFAULT.
        COMMON /M72DAT/ IDFATT(16)
C
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C               QUERY ROUTINE COMMON BLOCK
        COMMON /M72QRY/ ISEGAD, ISVIS, IHEDTY, IHEADR( 6)
C
C
C               CHECK FOR AN INVALID HEADER TYPE
C
        IF (ITRANS.EQ.1.OR.ITRANS.EQ.0) GO TO 10
C
C               ERROR THE HEADER TYPE IS NOT 1 OR 0
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               UPDATE THE CURRENT ATTRIBUTE ARRAY
C
 10     IATT(ISYMHE) = ITRANS
C
C               UPDATE THE VALUE IN THE QUERY COMMON BLOCK
C
        IHEDTY = 6
        IF (ITRANS.EQ.0) IHEDTY = 5
C
C               CHECK FOR SEGMENT ZERO
C
        ICSEG = IATT(ISYMSE)
        ICSUB = IATT(ISYMSU)
C
        IF (ICSEG.NE.0.OR.ICSUB.NE.0) GO TO 9999
C
C               UPDATE THE DEFAULT ARRAY
C
                        IDFATT(ISYMHE) = ITRANS
C
C
 9999   RETURN
        END
C
C
        SUBROUTINE MWCHIL (IHIGHL)
C
C               ATTRIBUTES - SEGMENT ZERO - DEFAULT.
        COMMON /M72DAT/ IDFATT(16)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C               CHECK IF IHIGHL IS IN RANGE 0 TO 1
C
        IF (IHIGHL.EQ.1.OR.IHIGHL.EQ.0) GO TO 10
C
C               OTHERWISE IHIGHL IS TOO LARGE OF TOO SMALL
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               UPDATE THE CURRENT ATTRIBUTE ARRAY
C
 10     IATT(ISYMHI) = IHIGHL
C
C               CHECK FOR SEGMENT ZERO
C
        ICSEG = IATT(ISYMSE)
        ICSUB = IATT(ISYMSU)
C
        IF (ICSEG.NE.0.OR.ICSUB.NE.0) GO TO 20
C
C               OTHERWISE UPDATE THE DEFAULT ATTRIBUTE ARRAY
C
                        IDFATT(ISYMHI) = IHIGHL
C
C               SET UP THE COMMANDS
C
 20     MACIO(1) = 11
        MACIO(2) = IAND(IHIGHL, 1) + 32
C
        CALL MIOUT (2,0,0)
 9999   RETURN
        END
C
C
        SUBROUTINE MWCLIN (ILINST)
C
C               ATTRIBUTES - SEGMENT ZERO - DEFAULT.
        COMMON /M72DAT/ IDFATT(16)
C
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C               CHECK FOR ILINST IN THE RANGE 0 TO 1
C
        IF (ILINST.EQ.0.OR.ILINST.EQ.1) GO TO 10
C
C               OTHERWISE ILINST IS TOO BIG OR TOO SMALL
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               UPDATE THE CURRENT ATTRIBUTE ARRAY
C
 10     IATT(ISYMLI) = ILINST
C
C               CHECK FOR SEGMENT ZERO
C
        ICSEG = IATT(ISYMSE)
        ICSUB = IATT(ISYMSU)
C
        IF (ICSEG.NE.0.OR.ICSUB.NE.0) GO TO 20
C
C               UPDATE THE DEFAULT ATTRIBUTE ARRAY
C
                        IDFATT(ISYMLI) = ILINST
C
C               SET UP THE COMMANDS
C
 20     MACIO(1) = 11
        MACIO(2) = IAND(ILINST, 1) + 40
C
        CALL MIOUT (2,0,0)
C
 9999   RETURN
        END
C
C
        SUBROUTINE MWCMRK (INDEX)
C
C               ATTRIBUTES - SEGMENT ZERO - DEFAULT.
        COMMON /M72DAT/ IDFATT(16)
C
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C               CHECK FOR INDEX IN RANGE 1 TO 16
C
        IF (INDEX.GE.1.AND.INDEX.LE.16) GO TO 10
C
C               OTHERWISE INDEX IS TOO SMALL OR TOO LARGE
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               UPDATE CURRENT ATTRIBUTE ARRAY
C
 10     IATT(ISYMMA) = INDEX
C
C               CHECK FOR SEGMENT ZERO
C
        ICSEG = IATT(ISYMSE)
        ICSUB = IATT(ISYMSU)
C
        IF (ICSEG.NE.0.OR.ICSUB.NE.0) GO TO 9999
C
C               UPDATE THE DEFAULT ATTRIBUTE ARRAY
C
        IDFATT(ISYMMA) = INDEX
C
 9999   RETURN
        END
C
C
        SUBROUTINE MWCMSZ (IMSIZE)
C
C               ATTRIBUTES - SEGMENT ZERO - DEFAULT.
        COMMON /M72DAT/ IDFATT(16)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C
C               CHECK FOR AN INCORRECT SIZE
C
        IF (IMSIZE.GE.1.AND.IMSIZE.LE.8) GO TO 10
C
C               OTHERWISE IMSIZE IS TOO SMALL OR TOO BIG
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               UPDATE THE CURRENT ATTRIBUTE ARRAY
C
 10     IATT(ISYMMS) = IMSIZE
C
C               CHECK FOR SEGMENT ZERO
C
        ICSEG = IATT(ISYMSE)
        ICSUB = IATT(ISYMSU)
C
        IF (ICSEG.NE.0.OR.ICSUB.NE.0) GO TO 9999
C
C               UPDATE THE DEFAULT ATTRIBUTE ARRAY
C
        IDFATT(ISYMMS) = IMSIZE
C
 9999   RETURN
        END
C
C
        SUBROUTINE MWCPAT (INDEX)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTES - SEGMENT ZERO - DEFAULT.
        COMMON /M72DAT/ IDFATT(16)
C
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C               LINE PATTERN TABLE.
        COMMON /M72LTB/ LNPTTB(16)
C
C
C       CHECK FOR THE INDEX TOO LARGE OR TOO SMALL
C
        IF (INDEX.GE.1.AND.INDEX.LE.16) GO TO 10
C
C               ELSE INDEX IS INCORRECT
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               UPDATE THE CURRENT ATTRIBUTE ARRAY
C
 10     IATT(ISYMPA) = INDEX
C
C               CHECK FOR SEGMENT ZERO
C
        ICSEG = IATT(ISYMSE)
        ICSUB = IATT(ISYMSU)
C
        IF (ICSEG.NE.0.OR.ICSUB.NE.0) GO TO 20
C
C               UPDATE THE DEFAULT ARRAY (SEGMENT ZERO)
C
                        IDFATT(ISYMPA) = INDEX
C
C               SET UP THE COMMANDS
C
 20     LINPAT = LNPTTB(INDEX)
        MACIO(1) = 12
        MACIO(2) = IAND(ISHFT(LINPAT,-12), 15) + 32
        MACIO(3) = IAND(ISHFT(LINPAT,-6), 63)
        MACIO(4) = IAND(LINPAT, 63)
C
        CALL MIOUT (4,0,0)
C
 9999   RETURN
        END
C
C
        SUBROUTINE MWCSIZ (ISIZE)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTES - SEGMENT ZERO - DEFAULT.
        COMMON /M72DAT/ IDFATT(16)
C
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C               CHECK FOR AN INCORRECT SIZE
C
        IF (ISIZE.GE.1.AND.ISIZE.LE.8) GO TO 10
C
C               ERROR THE SIZE IS TOO LARGE OR TOO SMALL
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               CHANGE THE CURRENT ATTRIBUTE ARRAY
C
 10     IATT(ISYMSI) = ISIZE
C
C               CHECK FOR SEGMENT ZERO
C
        ICSEG = IATT(ISYMSE)
        ICSUB = IATT(ISYMSU)
C
        IF (ICSEG.NE.0.OR.ICSUB.NE.0) GO TO 9999
C
C               CHANGE THE DEFAULT SRV SIZE
C
                        IDFATT(ISYMSI) = ISIZE
C
C
 9999   RETURN
        END
C
C
        SUBROUTINE MWCVTY (IVECTY)
C
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C               ATTRIBUTES - SEGMENT ZERO - DEFAULT.
        COMMON /M72DAT/ IDFATT(16)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C               CHECK FOR AN IVALID VECTOR TYPE
C
        IF (IVECTY.GE.1.AND.IVECTY.LE.8) GO TO 10
C
C               ERROR THE VECTOR TYPE IS TOO LARGE OR TOO SMALL
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               UPDATE THE CURRENT ATTRIBUTE ARRAY
C
 10     IATT(ISYMCO) = IVECTY
C
C               CHECK FOR SEGMENT ZERO
C
        ICSEG = IATT(ISYMSE)
        ICSUB = IATT(ISYMSU)
C
        IF (ICSEG.NE.0.OR.ICSUB.NE.0) GO TO 9999
C
C               CHANGE THE DEFAULT VECTOR TYPE
C
                        IDFATT(ISYMCO) = IVECTY
C
C
 9999   RETURN
        END
C
C
        SUBROUTINE MWCVIS (IVISIB)
C
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C               ATTRIBUTES - SEGMENT ZERO - DEFAULT.
        COMMON /M72DAT/ IDFATT(16)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C               CHECK FOR A CORRECT VALUE FOR IVISIB
C
        IF (IVISIB.EQ.1.OR.IVISIB.EQ.0) GO TO 10
C
C               ERROR  TOO LARGE OF TOO SMALL
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               UPDATE THE CURRENT ATTRIBUTE ARRAY
C
 10     IATT(ISYMVI) = IVISIB
C
C               CHECK FOR SEGMENT ZERO
C
        ICSEG = IATT(ISYMSE)
        ICSUB = IATT(ISYMSU)
C
        IF (ICSEG.NE.0.OR.ICSUB.NE.0) GO TO 20
C
C               UPDATE THE DEFAULT VISIBILITY
C
                        IDFATT(ISYMVI) = IVISIB
C
C               SET UP THE COMMANDS
C
 20     MACIO(1) = 8
        MACIO(2) = IAND(ISHFT(ICSEG, -6), 63)
        MACIO(3) = IAND(ICSEG, 63)
        MACIO(4) = IAND(IVISIB, 1) + 56
C
        CALL MIOUT (4,0,0)
C
 9999   RETURN
        END
C               THIS IS ROUTINE CHANGES THE CURRENT VALUE OF THE RASTER
C               MEMORY WRITE PROTECT MASK
C
C
        SUBROUTINE MWCWPR (IWPMSK)
C
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               INTERACTION PROMPT BUFFER.
        COMMON /M72PMT/ IPRMPT(10)
C
C               ATTRIBUTES - SEGMENT ZERO - DEFAULT.
        COMMON /M72DAT/ IDFATT(16)
C
C               COMPUTER DEPENDENT ELEMENTS
        COMMON /M72CDV/ KTERM, KUCASE, KLCASE, KSUBCH, KSUPCH, KWRTFL
        COMMON /M72CDV/ KRDFL, KOUTFL, KINFL, KWRDSZ, KBYTEL, KCPW
        COMMON /M72CDV/ KSHFTC, KBLKPD, KFILL, KDEL
C
        INTEGER E00EX
        DATA E00EX /"160016/
C
C
C               CHECK IWPMSK
C
        IF (IWPMSK.GE.0.AND.IWPMSK.LE.15) GO TO 10
C
C               ERROR -- IWPMSK IS OUT OF RANGE
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               WRITE THE MASK TO THE CURRENT LOCATION IN MEMORY
C
 10     IPRMPT(1) = 7
        IPRMPT(2) = 47 + 64
        IPRMPT(3) = IAND(ISHFT(E00EX,-12),15) + 48 + 64
        IPRMPT(4) = IAND(ISHFT(E00EX,-6),63) + 64
        IPRMPT(5) = IAND(E00EX,63) + 64
C
C               CALCULATE THE MASK
C
        MASK2 = IWPMSK - 16
        M2 = IOR(ISHFT(MASK2,4),15)
        IF (IATT(ISYMDS).EQ.2) MASK2 = M2
        IF (IATT(ISYMDS).EQ.3) MASK2 = IAND(MASK2,M2)
C
        IPRMPT(6) = IAND(ISHFT(MASK2,-12),15)
        IPRMPT(7) = IAND(ISHFT(MASK2,-6),63) + 64
        IPRMPT(8) = IAND(MASK2,63) + 64
C
        CALL MEGRCF (KINFL,2,MACIO,IPRMPT)
C
C               CHANGE THE DEFAULT ARRAYS
C
        IATT(ISYMWP) = IWPMSK
        IF (IATT(ISYMSE).EQ.0.AND.IATT(ISYMSU).EQ.0)
     $                                  IDFATT(ISYMWP) = IWPMSK
C
 9999   RETURN
        END
C               THIS ROUTINE CHANGES THE ATTRIBUTES
C
C
        SUBROUTINE MWCATT (INAME,IVALUE)
C
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
        CALL MIERST (3000)
C
C               STANDARDIZE THE INCOMING CHARACTER STRING
C
        CALL MEGSTD (2,INAME,NAME)
C
        IF (NAME.EQ.IATMOD(ISYMDE)) CALL MWCDET (IVALUE)
        IF (NAME.EQ.IATMOD(ISYMVI)) CALL MWCVIS (IVALUE)
        IF (NAME.EQ.IATMOD(ISYMLI)) CALL MWCLIN (IVALUE)
        IF (NAME.EQ.IATMOD(ISYMHI)) CALL MWCHIL (IVALUE)
        IF (NAME.EQ.IATMOD(ISYMAP)) CALL MWCAPP (IVALUE)
        IF (NAME.EQ.IATMOD(ISYMBL)) CALL MWCBLR (IVALUE)
        IF (NAME.EQ.IATMOD(ISYMEC)) CALL MWCECH (IVALUE)
        IF (NAME.EQ.IATMOD(ISYMSI)) CALL MWCSIZ (IVALUE)
        IF (NAME.EQ.IATMOD(ISYMCS)) CALL MWCCSZ (IVALUE)
        IF (NAME.EQ.IATMOD(ISYMCA)) CALL MWCCAN (IVALUE)
        IF (NAME.EQ.IATMOD(ISYMCO)) CALL MWCVTY (IVALUE)
        IF (NAME.EQ.IATMOD(ISYMMS)) CALL MWCMSZ (IVALUE)
        IF (NAME.EQ.IATMOD(ISYMMA)) CALL MWCMRK (IVALUE)
        IF (NAME.EQ.IATMOD(ISYMHE)) CALL MWCHDR (IVALUE)
        IF (NAME.EQ.IATMOD(ISYMWP)) CALL MWCWPR (IVALUE)
C
        RETURN
        END
        SUBROUTINE MWCCLP(IXMIN,IXMAX,IYMIN,IYMAX)
C
C
C       INPUT PARAMETERS:
C       =================
C
C               IXMIN  - MINIMUM X COORDINATE OF CLIP WINDOW.
C               IXMAX  - MAXIMUM X COORDINATE OF CLIP WINDOW.
C               IYMIN  - MINIMUM Y COORDINATE OF CLIP WINDOW.
C               IYMAX  - MAXIMUM Y COORDINATE OF CLIP WINDOW.
C
                INTEGER IXMIN,IXMAX,IYMIN,IYMAX
C
C       COMMON PARAMETERS:
C       ==================
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C       LOCAL PARAMETERS:
C       =================
C
C               IERW2  - ERROR CODES FOR ERROR REPORTING.
C               HEADTY - HEADER TYPE.
C
                INTEGER IERW2,SEGVAL,HEADTY
C
C-----------------------------------------------------------------------
C
C
C       STACK ROUTINE ID FOR ERROR TRACEBACK
C
        CALL MIERST(5100)
C
C       CHECK FOR AN EXTENDED SEGMENT HEADER.
C
        CALL MIGVAL(ISYMHE, HEADTY)
        IF (HEADTY.EQ.1) GO TO 160
C               ERROR -- THE HEADER IS NOT TRANSFORMED
C
                        CALL MIERR (3)
                        GO TO 9999
C
C       CHECK WINDOW PARAMETERS FOR VALIDITY.
C
160     IF(IXMIN.LT.IXMAX) GOTO 200
C               IXMAX<=IXMIN
                CALL MIERR (36)
                GO TO 9999
C
 200    IF(IYMIN.LT.IYMAX) GOTO 300
C               IYMAX<=IYMIN
                CALL MIERR (37)
                GOTO 9999
C
C       BUILD THE INSTRUCTION. INCLUDES OP_CODE AND FORMAT.
C
 300    MACIO(1)=13
        MACIO(2)=6
C
C       INSERT VIEWPORT PARAMETERS INTO OUTPUT BUFFER.
C
        MACIO(7) = IAND(ISHFT(IXMAX, -6), 63)
        MACIO(8) = IAND( IXMAX,       63)
C
        MACIO(9) = IAND(ISHFT(IYMAX, -6), 63)
        MACIO(10) = IAND( IYMAX,       63)
C
        MACIO(3) = IAND(ISHFT(IXMIN, -6), 63)
        MACIO(4) = IAND( IXMIN,       63)
C
        MACIO(5) = IAND(ISHFT(IYMIN, -6), 63)
        MACIO(6)= IAND( IYMIN,       63)
C
C       SEND THE INSTRUCTION TO THE 7232.
C
        CALL MIOUT(10,0,0)
C
 9999   RETURN
        END
C
        SUBROUTINE MWCLOS
C
C                       COMMON.
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C               ATTRIBUTES - SEGMENT ZERO - DEFAULT.
        COMMON /M72DAT/ IDFATT(16)
C
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C
C                       STACK THE ID CODE FOR TRACEBACK.
        CALL MIERST( 2010)
C
C               CHECK FOR AN OPEN SEGMENT.
C
        IF(IATT(ISYMSE) .EQ. 0 .AND. IATT(ISYMSU) .EQ. 0)
     1                                                  GO TO 100
                                                        GO TO 200
C       THEN:
C           ERROR:  A SEGMENT/SUBROUTINE IS NOT OPEN.
100         CALL MIERR( 30)
            GO TO 2000
C       ENDIF:
C
C               CREATE AND OUTPUT THE CLOSE SEGMENT/SUBROUTINE COMMAND.
C
200     IF(IATT(ISYMSE) .NE. 0)                         GO TO 220
                                                        GO TO 240
C       THEN:
C           IT'S A CLOSE SEGMENT REQUEST.
220         MACIO( 1) = 4
            GO TO 300
C       ELSE:
C           IT'S A CLOSE SUBROUTINE.
240         MACIO( 1) = 36
C       ENDIF:
C
300     CALL MIOUT( 1, 0, 0)
C
C
C                       RESTORE THE DEFAULT PARAMETERS.
C
C       BEGIN_DO:  INDEX I BY 1 FROM 1 UNTIL I > 16
                                                        DO 400 I = 1, 16
            IATT(I) = IDFATT(I)
400                                                     CONTINUE
C       END_DO:
C
        IATT(ISYMSE) = 0
        IATT(ISYMSU) = 0
C
2000    RETURN
C
        END
C
        SUBROUTINE MWCPKY( IUNIT, ICNTL)
C                       STACK THE ID CODE FOR TRACEBACK.
C
        CALL MIERST( 1130)
C               THIS ROUTINE IS NOT SUPPORTED BY THE WAND 7232
C               SOFTWARE SYSTEM.  THE COPY KEY IS ALWAYS ENABLED
C               AND A COPY MAY BE MADE OF DISPLAY 1 BY TYPING THE
C               COPY KEY OR DISPLAY 2 BY TYPING SHIFT COPY.
C
        CALL MIERR( 99)
C
        RETURN
C
        END
C
        SUBROUTINE MWDADS( IDISP)
        RETURN
        END
C
        SUBROUTINE MWDALL( IGRTYP)
C
C
C               THE COMMON BLOCK M72NME CONTAINS THE FOLLOWING
C               VARIABLES USED IN THIS ROUTINE
C
C                       ISYMSE - THE SEGMENT INDEX
C                       ISYMSU - THE SUBROUTINE INDEX
C
C               THE COMMON BLOCK M72DST CONTAINS THE FOLLOWING
C               VARIABLE USED IN THIS ROUTINE
C
C                       MACIO  - THE OUTPUT BUFFER
C
C               THE COMMON BLOCK M72SSS CONTAINS THE FOLLOWING
C               VARIABLES USED IN THIS ROUTINE
C
C                       ISUBST - THE SUBROUTINE BIT MAP
C                       ISEGST - THE SEGMENT BIT MAP
C
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               SEGMENT AND SUBROUTINE DEFINITION - BIT MAPS.
        COMMON /M72SSS/ ISEGST(256), ISUBST(256)
C
C
C               STACK THE ROUTINE CODE
C
        CALL MIERST (2020)
C
C               CHECK THE GROUP TYPE
C
        CALL MEGSTD (2,IGRTYP,IGTYP)
        CALL MIGATT (IGTYP,ISS,IGRT)
        IGRT = IGRT - ISYMSE
        IF (IGRT.EQ.1.OR.IGRT.EQ.0) GO TO 10
C
C               ERROR -- NOT A SEGMENT OR SUBROUTINE
C
                        CALL MIERR (32)
                        GO TO 9999
C
C               CHECK FOR AN OPEN SEGMENT/SUBROUTINE
C               IF THERE IS CLOSE IT
C
 10     CALL MIGVAL (ISYMSE,ICSEG)
        CALL MIGVAL (ISYMSU,ICSUB)
        IF (ICSEG.NE.0.OR.ICSUB.NE.0) CALL MWCLOS
C
C               CHECK FOR A SEGMENT OR A SUBROUTINE
C
        IF (IGRT.EQ.0) GO TO 20
C
C               IT'S A SUBROUTINE (IGRT = 1)
C               SET THE COMMAND WORD
C
        ICMND = 35
C
C               DROP DOWN TO THE COMMON DELETE ROUTINE
C
        GO TO 50
C
C               IT'S A SEGMENT
C               DELETE SEGMENT ZERO
C
 20     ICMND = 3
        MACIO(1) = ICMND
        MACIO(2) = 0
        MACIO(3) = 0
        CALL MIOUT (3,0,0)
C
C               THIS IS THE COMMON DELETION SECTION
C
 50     DO 40 I = 1,256
C
C               EXAMINE EACH WORD IN THE APPROPRIATE BIT MAP
C
            IST = ISEGST(I)
            IF (ICMND.EQ.35) IST = ISUBST(I)
            IF (IST.EQ.0) GO TO 40
C
C               THERE IS AT LEAST ONE SEGMENT/SUBROUTINE TO DELETE
C
                    IBP = 1
                    DO 60 J = 1,16
C
                        IMSK = IAND(IST,IBP)
                        IBP = IBP * 2
C
C               LOOK FOR A PARTICULAR BIT
C
                        IF (IMSK.EQ.0) GO TO 60
C
C               DELETE THE SEGMENT/SUBROUTINE
C
                            ISSNME = ((I - 1) * 16) + J
                            MACIO(1) = ICMND
                            MACIO(2) = IAND(ISHFT(ISSNME, -6), 63)
                            MACIO(3) = IAND(ISSNME, 63)
                            CALL MIOUT (3,0,0)
C
 60                 CONTINUE
C
 40     CONTINUE
C
 9999   RETURN
        END
C
        SUBROUTINE MWDAPR( IPERID)
C
C
C               THE COMMON BLOCK M72PER CONTAINS THE FOLLOWING
C               VARIABLES USED IN THIS ROUTINE.
C
C                       IPPSG  - THE PERIPHERAL INFORMATION ARRAY
C                       IKYID  - THE KEY BOARD ID
C                       IFPID  - THE FUNCTION PAD ID
C                       IBTID  - THE BUTTON ID NUMBER (FUNCTION BOX)
C
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C
        INTEGER IPERID(2)
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
C
        CALL MIERST( 1070)
C
C               WAS THE PERIPHERAL ALLOCATED?
C
        LPER = IPERID(1)
        IF (IPPSG(LPER,3).EQ.1) GO TO 10
C
C               ERROR -- THE PERIPHERAL WAS NOT ALLOCATED
C
                        CALL MIERR (63)
                        GO TO 9999
C
C               DEALLOCATE THE PERIPHERAL
C               IF IT IS THE KEYBOARD ALSO DEALLOCATE THE FUNCION PAD
C               IF IT IS THE FUNCTION BOX, IPERID(1) = IBTID.
C                       CHANGE LPER TO THE FUNCTION BOX ID
C
 10     IF (LPER.EQ.IBTID) LPER = IFBID
        IPPSG(LPER,3) = 0
        IF (LPER.EQ.IKYID) IPPSG(IFPID,3) = 0
C
C
 9999   RETURN
        END
C
        SUBROUTINE MWDEL( IGRTYP, IGRNAM)
C
C
C               THE COMMON BLOCK M72DST CONTAINS THE FOLLOWING
C               VARIABLE USED IN THIS ROUTINE
C
C                       MACIO  - THE OUTPUT BUFFER
C
C               THE COMMON BLOCK M72NME CONTAINS THE FOLLOWING
C               VARIBLE USED IN THIS ROUTINE
C
C                       ISYMSE - THE SEGMENT INDEX
C
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C               STACK THE ROUTINE CODE
C
        CALL MIERST (2030)
C
C               CHECK FOR A VALID GROUP TYPE
C
        CALL MEGSTD (2,IGRTYP,IGRTP)
        CALL MIGATT (IGRTP,ISS,IGRT)
        IGRT = IGRT - ISYMSE
        IF (IGRT.EQ.0.OR.IGRT.EQ.1) GO TO 10
C
C               ERROR -- INVALID GROUP TYPE
C
                        CALL MIERR (32)
                        GO TO 9999
C
C               CHECK FOR AN INVALID SEGMENT/SUBROUTINE
C
 10     IF (IGRNAM.GE.1.AND.IGRNAM.LE.4095) GO TO 20
C
C               ERROR -- IGRNAM OUT OF RANGE
C
                        CALL MIERR (9)
                        GO TO 9999
C
C               CHECK FOR AN OPEN SEGMENT OF SUBROUTINE
C
 20     IF (IGRNAM.EQ.ISS) CALL MWCLOS
C
C               DELETE THE SEGMENT/SUBROUTINE BIT FROM THE
C               THE BIT MAP -- IF IT DOES NOT EXIST IERROR IS
C               SET TO ONE AND THE ERROR IS REPORTED IN MISSM
C
        CALL MISSM (IGRNAM,IGRT,-1,IERROR)
        IF (IERROR.EQ.1) GO TO 9999
C
C               SET UP THE COMMAND
C
        MACIO(1) = 3
        IF (IGRT.EQ.1) MACIO(1) = 35
        MACIO(2) = IAND(ISHFT(IGRNAM, -6), 63)
        MACIO(3) = IAND(IGRNAM, 63)
C
C               SEND THE COMMAND
C
        CALL MIOUT (3,0,0)
 9999   RETURN
        END
C
        SUBROUTINE MWDFTB( IPERID, IMODE, IWIDTH, IHIGHT, IRESOL)
C
C                       COMMON.
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
        CALL MIERST( 7110)
C
C               EDIT THE IMODE PARAMETER, IS IT A DIGITIZER OR A LOCATOR
C
        CALL MEGSTD( 2, IMODE, ITYP)
        CALL MISTRG( ITYP, INDX)
C
C               CHECK THE RETURNED INDEX.
C
        IF(INDX .EQ. -1)                                GO TO 40
                                                        GO TO 80
C       THEN:
40          CALL MIERR( 16)
            GO TO 2000
C       ENDIF:
80      ITABIN( 1) = INDX
C
C               EDIT THE WIDTH, HEIGHT, AND RESOLUTION PARAMETERS.
C
        IF(IWIDTH .LT. 11)                              GO TO 100
                                                        GO TO 120
C       THEN:
C           THE WIDTH IS TO SMALL, USE THE 11 INCH DEFAULT.
100         IWD = 11
            GO TO 200
C       ELSE:
120         IWD = IWIDTH
C       ENDIF:
C
200     IF(IHIGHT .LT. 11)                              GO TO 220
                                                        GO TO 240
C       THEN:
C           THE HEIGHT PARAMETER IS TO SMALL USE THE 11 INCH DEFAULT.
220         IHT = 11
            GO TO 300
C       ELSE:
240         IHT = IHIGHT
C       ENDIF:
C
300     IF(IRESOL .LT. 100)                             GO TO 320
                                                        GO TO 340
C       THEN:
C           THE RESOLUTION IS LESS THEN 100 PER INCH USE 200BPI.
320         IRES = 20
            GO TO 400
C       ELSE:
340         IRES = IRESOL / 10
C       ENDIF:
C
C               FIND THE LARGER OF THE WIDTH AND HEIGHT.
C
400     ILS = IHT
        IF(IWD .GE. IHT)                                GO TO 420
                                                        GO TO 460
C       THEN:
420         ILS = IWD
C       ENDIF:
C
C               FIND THE SCALE
C
460     ISCAL = ILS * IRES
        IF(ISCAL .LT. 307)                              GO TO 500
                                                        GO TO 520
C       THEN:
C           IT'S AN 11 BIT TABLET.
500         IS = 01
            IOXY = 63
            IBITRS = 1
            GO TO 800
C       ENDIF:
C
520     IF(ISCAL .LT. 512)                              GO TO 540
                                                        GO TO 560
C       THEN:
C           IT'S A 12 BIT TABLET.
540         IS = 00
            IOXY = 62
            IBITRS = 2
            GO TO 800
C       ENDIF:
C
560     IF(ISCAL .LT. 1024)                             GO TO 580
                                                        GO TO 590
C       THEN:
C           IT'S A 13 BIT TABLET.
580         IS = 3
            IOXY = 60
            IBITRS = 3
            GO TO 800
C       ENDIF:
C
590     IF(ISCAL .LT. 2048)                             GO TO 594
                                                        GO TO 600
C       THEN:
C           IT'S A 14 BIT TABLET.
594         IS = 2
            IOXY = 56
            IBITRS = 4
            GO TO 800
C       ENDIF:
C
600     IF(ISCAL .LT. 4086)                             GO TO 620
                                                        GO TO 640
C       THEN:
C           IT'S A 15 BIT TABLET.
620         IS = 5
            IOXY = 48
            IBITRS = 5
            GO TO 800
C       ENDIF:
C
C               IT CAN ONLY BE A 16 BIT TABLET.
640     IS = 4
        IOXY = 32
        IBITRS = 6
800     ITABIN( 2) = IBITRS
C
C               LOCATE WHERE THE ORIGIN SHOULD BE.
C
        MACIO( 1) = 55
        MACIO( 2) = 3
        MACIO( 3) = IS
        IF(INDX .EQ. 10)                                GO TO 820
                                                        GO TO 840
C       THEN:
C           IT'S A LOCATOR.
820         MACIO( 4) = IOXY
            MACIO( 5) = 0
            MACIO( 6) = IOXY
            MACIO( 7) = 0
            GO TO 900
C       ELSE:
C           IT'S A DIGITIZER.
840         MACIO( 4) = 0
            MACIO( 5) = 0
            MACIO( 6) = 0
            MACIO( 7) = 0
C       ENDIF:
C
C               CALL THE OUTPUT ROUTINE
C
900     CALL MIOUT( 7, 0, 0)
C
2000    RETURN
C
        END
C
        SUBROUTINE MWDSBU( IPERID, IBUTNM)
C
C                       COMMON.
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
C
        CALL MIERST( 7330)
C
C               CHECK IPERID
C
        IF (IPERID.EQ.IBTID) GO TO 10
C
C               ERROR -- PERIPHERAL IS NOT A BUTTON
C
                        CALL MIERR (11)
                        GO TO 9999
C
C               CHECK THE BUTTON NUMBER
C
 10     IF (IBUTNM.GE.1.AND.IBUTNM.LE.16) GO TO 20
C
C               ERROR -- THE BUTTON NUMBER IS OUT OF RANGE
C
                        CALL MIERR (12)
                        GO TO 9999
C
C               DISABLE THE BUTTON -- THE DEVICE IS ALWAYS ENABLED
C               SIMPLY INDICATED THE DISABLE IN THE PERIPHERAL
C               INFORMATION ARRAY
C
 20     IPER = IPERID + IBUTNM
        IPPSG(IPER,4) = 0
C
 9999   RETURN
        END
C
        SUBROUTINE MWDSEL( IDISP)
C
C
C               THE COMMON BLOCK M72NME CONTAINS THE FOLLOWING
C               VARIABLE USED IN THIS ROUTINE.
C
C                       ISYMDS  - THE DISPLAY INDEX
C
C               THE COMMON BLOCK M72ATT CONTAINS THE FOLLOWING
C               VARIABLE USED IN THIS ROUTINE.
C
C                       IATT    - THE ATTRIBUTE ARRAY
C
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C
C
C               STACK THE ROUTINE IDENTIFIER
C
        CALL MIERST (1050)
C
C               GET THE CURRENT DISPLAY SELECTION FROM THE ATTRIBUTE
C               ARRAY
C
        ISEL = IATT(ISYMDS)
C
C               CHECK FOR IDISP NOT SELECTED
C
        IF (ISEL.EQ.IDISP.OR.ISEL.EQ.3) GO TO 10
C
C               ERROR -- IDISP HAS NOT BEEN SELECTED
C
                        CALL MIERR (19)
                        GO TO 9999
C
C               NOW DESELECT THE DISPLAY
C
 10     IF (IDISP.EQ.ISEL) IATT(ISYMDS) = 0
C
C               AT THIS POINT ISEL MUST = 3 AND IDISP MUST = 1 OR 2
C
        IF (ISEL.EQ.3.AND.IDISP.EQ.1) IATT(ISYMDS) = 2
C
        IF (ISEL.EQ.3.AND.IDISP.EQ.2) IATT(ISYMDS) = 1
C
C
 9999   RETURN
        END
C
        SUBROUTINE MWDSKY( IPERID)
C
C                       COMMON.
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
C
        CALL MIERST( 7340)
C
C               CHECK FOR A CORRECT PERIPHERAL ID
C
        IF (IPERID.EQ.IKYID.OR.IPERID.EQ.IFPID) GO TO 10
C
C               ERROR -- NOT A KEYBOARD OR A FUNCTION PAD
C
                        CALL MIERR (11)
                        GO TO 9999
C
C               WAS THE PERIPERAL ENABLED ?
C
 10     IF (IPPSG(IPERID,4).EQ.1) GO TO 20
C
C               ERROR -- THE DEVICE WAS NOT ENABLED
C
                        CALL MIERR (15)
                        GO TO 9999
C
C               CREATE THE COMMAND
C
 20     MACIO(1) = 49
        MACIO(2) = 0
        IF (IPERID.EQ.IFPID) MACIO(2) = 1
C
        CALL MIOUT (2,0,0)
C
        IPPSG (IPERID,4) = 0
C
 9999   RETURN
        END
C
        SUBROUTINE MWDSLC( IPERID)
C
C                       COMMON.
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
C
        CALL MIERST( 7300)
C
C               CHECK FOR A LOCATOR
C
        IF (IPERID.EQ.IJYID.OR.IPERID.EQ.ITBID) GO TO 10
C
C               ERROR -- THE DEVICE IS NOT A LOCATOR
C
                        CALL MIERR (11)
                        GO TO 9999
C
C               CHECK IF THE DEVICE WAS ENABLED
C
 10     IF (IPPSG(IPERID,4).EQ.1) GO TO 20
C
C               ERROR -- THE DEVICE WAS NOT ENABLED
C
                        CALL MIERR (15)
                        GO TO 9999
C
C               CREATE THE COMMAND
C
 20     MACIO(1) = 49
        MACIO(2) = IPERID
C
        CALL MIOUT (2,0,0)
C
        IPPSG(IPERID,4) = 0
C
 9999   RETURN
        END
C
        SUBROUTINE MWDSPK( IPERID)
C
C                       COMMON.
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C               PICK STATUS, VECTOR COUNT AND X, Y COORDINATES.
        COMMON /M72PIK/ IEKO, MIX, MIY, MVECCT, MPIKST,IPKLC
C
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
C
        CALL MIERST( 7320)
C
C               CHECK FOR A PICK MODULE
C
        IF (IPERID.EQ.IPKID) GO TO 10
C
C               ERROR -- NOT A PICK MODULE
C
                        CALL MIERR (11)
                        GO TO 9999
C
C               CHECK FOR THE PICK MODULE BEING ENABLED
C
 10     IF (IPPSG(IPERID,4).EQ.1) GO TO 20
C
C               ERROR -- PICK MODULE WAS NOT ENABLED
C
                        CALL MIERR (15)
                        GO TO 9999
C
C               CREATE THE COMMANDS
C
 20     MACIO(1) = 49
        MACIO(2) = 4
C
        CALL MIOUT (2,0,0)
C
        IPPSG(IPERID,4) = 0
C
 9999   RETURN
        END
C
        SUBROUTINE MWDSVL( IPERID, IVALNM)
C
C                       COMMON.
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
C
        CALL MIERST( 7310)
C
C               CHECK IPERID
C
        IF (IPERID.EQ.IVLID) GO TO 10
C
C               ERROR -- NOT A VALUATOR
C
                        CALL MIERR (11)
                        GO TO 9999
C
C               CHECK THE VALUATOR NUMBER
C
 10     IF (IVALNM.GE.1.AND.IVALNM.LE.8) GO TO 20
C
C               ERROR -- THE VALUATOR IS OUT OF RANGE
C
                        CALL MIERR (15)
                        GO TO 9999
C
C               THE DEVICE IS ALWAYS ENABLED.  INDICATE THE DISABLE
C               IN THE PERIPHERAL INFORMATION ARRAY
C
 20     IPER = IPERID + IVALNM
        IPPSG(IPER,4) = 0
C
 9999   RETURN
        END
C
        SUBROUTINE MWECCR (IPERID,ISBNAM)
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
C
        CALL MIERST( 7020)
C
C               EDIT THE INPUT PARAMETERS
C
        IF (IPERID.GE.1.AND.IPERID.LE.4) GO TO 10
C
C               ERROR -- INVALID ECHO DEVICE
C
                        CALL MIERR (38)
                        GO TO 9999
C
C               CHECK FOR DEVICE ALLOCATION
C
 10     IF (IPPSG(IPERID,3).EQ.1) GO TO 20
C
C               ERROR -- DEVICE NOT ALLOCATED
C
                        CALL MIERR (63)
                        GO TO 9999
C
C               CHECK FOR SUBROUTINE EXISTENCE -- THE ERROR IS
C               REPORTED IN MISSM
C
 20     CALL MISSM (ISBNAM,1,0,IERROR)
        IF (IERROR.EQ.1) GO TO 9999
C
C               STORE THE INFORMATION
C
        IPPSG(IPERID,2) = ISBNAM
C
C               SET THE CURSOR
C
        MACIO(1) = 54
        MACIO(2) = IPERID
        MACIO(3) = IAND(ISHFT(ISBNAM,-6),63)
        MACIO(4) = IAND(ISBNAM,63)
        CALL MIOUT (4,0,0)
C
 9999   RETURN
        END
C
        SUBROUTINE MWECHO (IPERID,IECTYP)
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
C
        CALL MIERST( 7000)
C
C               CHECK IPERID FOR AN IVALID TYPE
C
        IF (IPERID.GE.1.AND.IPERID.LE.4) GO TO 10
C
C               ERROR -- CANNOT SET AN ECHO
C
                        CALL MIERR (38)
                        GO TO 9999
C
C               CHECK FOR DEVICE ALLOCATED
C
 10     IF (IPPSG(IPERID,3).EQ.1) GO TO 20
C
C               ERROR -- DEVICE NOT ALLOCATED
C
                        CALL MIERR (63)
                        GO TO 9999
C
C               STORE THE ECHO TYPE IN THE PERIPHERAL INFORMATION
C               ARRAY
C
 20     IPPSG(IPERID,1) = IECTYP
C
C               CHECK IF ECHO CURSOR IS 1
C
        IF (IECTYP.NE.1) GO TO 9999
                MACIO(1) = 54
                MACIO(2) = 32 + IPERID
                MACIO(3) = 0
                MACIO(4) = 0
                CALL MIOUT (4,0,0)
 9999   RETURN
        END
C
        SUBROUTINE MWECKY( IPERID, IPARCT, IPARLS)
C
C               THIS ROUTINE IS NOT USED BY WAND 7232.
C               THE IPERID PARAMETER IS EDITED HOWEVER.
C
        INTEGER IPARLS( 1)
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
        CALL MIERST(7040)
C
C               EDIT THE IPERID PARAMETER - KEYBOARD OR FUNCTION PAD.
C
        IF(IPERID .NE. 1 .OR. IPERID .NE. 5)            GO TO 100
                                                        GO TO 200
C       THEN:
C           ERROR:  IPERID DOES NOT SPECIFY A KEYBOARD OR FUNCTION PAD.
100         CALL MIERR( 11)

C       ENDIF:
C
200     RETURN
C
        END
C
        SUBROUTINE MWECPS (IPERID,IX,IY)
C
C
C               THE COMMON BLOCK M72DST CONTAINS THE FOLLOWING VARIABLE
C               USED BY THIS ROUTINE
C
C                       MACIO - THE OUTPUT BUFFER
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
C
        CALL MIERST( 7010)
C
C               CHECK FOR A ECHOABLE DEVICE.
C
        IF (IPERID.GE.2.AND.IPERID.LE.4) GO TO 10
C
C               ERROR -- DEVICE CANNOT BE ECHOED
C
                        CALL MIERR (14)
                        GO TO 9999
C
C               CHECK FOR DEVICE ALLOCATED.
C
 10     IF (IPPSG(IPERID,3).EQ.1) GO TO 20
C
C               ERROR -- DEVICE NOT ALLOCATED
C
                        CALL MIERR (63)
                        GO TO 9999
C
C               CREATE THE COMMAND
C
 20     MACIO( 1) = 53
        MACIO( 2) = IAND(IPERID, 3)
        MACIO( 3) = IAND(ISHFT(IX, -6), 63)
        MACIO( 4) = IAND(IX, 63)
        MACIO( 5) = IAND(ISHFT(IY, -6), 63)
        MACIO( 6) = IAND(IY, 63)
        CALL MIOUT( 6, 0, 0)
 9999   RETURN
        END
C
        SUBROUTINE MWENBU( IPERID, IBUTNM, IACMET)
C
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C
C               STACK THE ROUTINE CODE
C
        CALL MIERST (7230)
C
C               CHECK FOR A CORRECT PERIPHERAL ID
C
        IF (IPERID.EQ.14) GO TO 10
C
C               ERROR -- NOT THE BUTTON ID
C
                        CALL MIERR (11)
                        GO TO 9999
C
C               CHECK FOR AN INCORRECT BUTTON NUMBER
C
 10     IF (IBUTNM.GE.1.AND.IBUTNM.LE.16) GO TO 20
C
C               ERROR -- INVALID BUTTON NUMBER
C
                        CALL MIERR (12)
                        GO TO 9999
C
C               CHECH FOR THE FUNCTION BOX BEING ALLOCATED
C
 20     IF (IPPSG(IFBID,3).EQ.1) GO TO 30
C
C               ERROR -- THE FUNCTION BOX IS NOT ALLOCATED
C
                        CALL MIERR (63)
                        GO TO 9999
C
C               THE FUNCTION BOX IS ALWAYS ENABLED.  INDICATE
C               THE BUTTON IBUTNM IS ENABLED IN THE PERIPHERAL
C               INFORMATION ARRAY
C
 30     IPER = IPERID + IBUTNM
        IPPSG(IPER,4) = 1
C
 9999   RETURN
        END
C
        SUBROUTINE MWENKY( IPERID, IACMET, IECHO)
C
C
C               THE COMMON BLOCK M72DST CONTAINS THE FOLLOWING
C               VARIABLE USED IN THIS ROUTINE.
C
C                       MACIO - THE OUTPUT BUFFER
C
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C
C               STACK THE ROUTINE CODE
C
        CALL MIERST (7240)
C
C               CHECK FOR INVALID PERIPHERAL ID
C
        IF (IPERID.EQ.1.OR.IPERID.EQ.5) GO TO 10
C
C               ERROR -- NOT A FUNCTION PAD OR KEYBOARD
C
                        CALL MIERR (10)
                        GO TO 9999
C
C               CHECK FOR THE KEYBOARD BEING ALLOCATED
C
 10     IF (IPPSG(IPERID,3).EQ.1) GO TO 20
C
C               ERROR -- KEYBOARD NOT ALLOCATED
C
                        CALL MIERR (63)
                        GO TO 9999
C
C               CHECK IF THE KEYBOARD IS ALREADY ENABLED
C
 20     IF (IPPSG(IPERID,4).EQ.0) GO TO 30
C
C               ERROR -- KEYBOARD IS ALREADY ENABLED
C
                        CALL MIERR (16)
                        GO TO 9999
C
C               CREATE THE COMMAND
C
 30     MACIO(1) = 48
C
C               CHECK FOR KEYBOARD OR FUNCTION PAD
C
        IF (IPERID.EQ.5) GO TO 40
C
C               IT'S A KEYBOARD
C
                        MACIO(2) = 0
                        MACIO(3) = IECHO
C
                        NPDATA = 3
                        GO TO 50
C
C               IT'S A FUNCTION PAD
C
 40                     MACIO(2) = 1
C
                        NPDATA = 2
C
C               SEND THE COMMAND
C
 50     CALL MIOUT (NPDATA,0,0)
C
        IPPSG(IPERID,4) = 1
C
 9999   RETURN
        END
C
        SUBROUTINE MWENLC( IPERID, IACMET, IECHO)
C
C
C               THE COMMON BLOCK M72DST.CMB CONTAINS THE FOLLOWING
C               VARIABLE USED IN THIS ROUTINE.
C
C                       MACIO - THE OUTPUT BUFFER
C
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C
C               STACK THE ROUTINE NUMBER
C
        CALL MIERST (7200)
C
C               CHECK FOR AN INVALID PERIPHERAL ID
C
        IF (IPERID.EQ.2.OR.IPERID.EQ.3) GO TO 10
C
C               ERROR -- INVALID PERIPHERAL ID
C
                        CALL MIERR (11)
                        GO TO 9999
C
C               CHECK IF THE LOCATOR IS ALLOCATED
C
 10     IF (IPPSG(IPERID,3).EQ.1) GO TO 20
C
C               ERROR -- DEVICE NOT ALLOCATED
C
                        CALL MIERR (63)
                        GO TO 9999
C
C               CHECK IF DEVICE ALREADY ENABLED
C
 20     IF (IPPSG(IPERID,4).EQ.0) GO TO 30
C
C               ERROR -- DEVICE ALREADY ENABLED
C
                        CALL MIERR (16)
                        GO TO 9999
C
C               SET THE ENABLED FLAG
C
 30     IPPSG(IPERID,4) = 1
        IECO = IPPSG(IPERID,1)
C
C               CREATE THE COMMAND FOR THE ENABLE
C
        MACIO(1) = 48
        MACIO(2) = IPERID
        MACIO(3) = 0
        IF (IECHO.EQ.1) MACIO(3) = 1
C
C               TRANSMIT THE COMMAND
C
        CALL MIOUT (3,0,0)
C
 9999   RETURN
        END
C
        SUBROUTINE MWENPK( IPERID, IACMET, IECHO)
C
C                       COMMON.
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               PICK STATUS, VECTOR COUNT AND X, Y COORDINATES.
        COMMON /M72PIK/ IEKO, MIX, MIY, MVECCT, MPIKST,IPKLC
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
C
        CALL MIERST( 7220)
C
        NPDATA = 0
C               CHECK THE IPERID PARAMETER, MUST = 4
C
        IF (IPERID.EQ.IPKID) GO TO 10
C
C               ERROR -- DEVICE IS NOT A PICK MODULE
C
                        CALL MIERR (11)
                        GO TO 9999
C
C               CHECK IF THE PICK MODULE IS ALREADY ENABLED
C
 10     IF (IPPSG(IPERID,4).EQ.0) GO TO 20
C
C               ERROR -- THE PICK MODULE IS ALREADY ENABLED
C
                        CALL MIERR (16)
                        GO TO 9999
C
C               CREATE THE ENABLE COMMAND
C
C
C               SAVE THE ECHO MODE (IECHO -> IEKO)
C               CHECK FOR ECHOING AND AN ECHO CURSOR
C
 20     IEKO = IECHO
        MACIO(1) = 48
        MACIO(2) = 4
        MACIO(3) = 32
        IF (IPKLC.EQ.0) MACIO(3) = 50
        IF (IECHO.EQ.1) MACIO(3) = MACIO(3) + 1
        CALL MIOUT (3,0,0)
C
        IPPSG(IPERID,4) = 1
 9999   RETURN
        END
C
        SUBROUTINE MWENVL( IPERID, IVLNUM, IACMET, IECHO)
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C
C               ROUTNE IDENTIFIER STACKING FOR TRACEBACK.
C
        CALL MIERST( 7210)
C
C               CHECK FOR A CORRECT PERIPHERAL ID
C
        IF (IPERID.EQ.IVLID) GO TO 10
C
C               ERROR -- INCORRECT PERIPHERAL ID
C
                        CALL MIERR (11)
                        GO TO 9999
C
C               CHECK FOR FUNCTION BOX ALLOCATED
C
 10     IF (IPPSG(IFBID,3).EQ.1) GO TO 20
C
C               ERROR -- THE FUNCTION BOX IS NOT ALLOCATED
C
                        CALL MIERR (63)
                        GO TO 9999
C
C               THE FUNCTION BOX IS ALWAYS ENABLED
C               INDICATE THIS ENABLE IN THE PERIPHERAL INFORMATION
C               ARRAY
C
 20     IPER = IPERID + IVLNUM
        IPPSG(IPER,4) = 1
C
 9999   RETURN
        END
C               THIS ROUTINE WRITES THE ERASE PROTECT MASK IN
C               LOCATION 429 (HEX)
C
C
        SUBROUTINE MWERAS (IMASK)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               INTERACTION PROMPT BUFFER.
        COMMON /M72PMT/ IPRMPT(10)
C
C               THE WRITE PROTECT MASK COMMON BLOCK
C
C
        COMMON/M72ERA/IERAS(11)
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C               COMPUTER DEPENDENT ELEMENTS
        COMMON /M72CDV/ KTERM, KUCASE, KLCASE, KSUBCH, KSUPCH, KWRTFL
        COMMON /M72CDV/ KRDFL, KOUTFL, KINFL, KWRDSZ, KBYTEL, KCPW
        COMMON /M72CDV/ KSHFTC, KBLKPD, KFILL, KDEL
C
C		ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
	COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C
C               CHECK THE IMASK PARAMETER
C
        IF (IMASK.GE.0.AND.IMASK.LE.15) GO TO 10
C
C               ERROR -- THE PARAMETER IS OUT OF RANGE
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               COMPUTE THE NEW MASK AND WRITE TO THE LOCATION
C
 10     MASK2 = IMASK - 16
        M2 = IOR(ISHFT(MASK2,4),15)
        IF (IATT(ISYMDS).EQ.2) MASK2 = M2
        IF (IATT(ISYMDS).EQ.3) MASK2 = IAND(MASK2,M2)
C
        IERAS(9) = IAND(ISHFT(MASK2,-12),15) + 64
        IERAS(10) = IAND(ISHFT(MASK2,-6),63) + 64
        IERAS(11) = IAND(MASK2,63) + 64
C
        CALL MEGRCF (KINFL,2,MACIO,IERAS)
C
 9999   RETURN
        END
C
        SUBROUTINE MWERLG( IERRNO, IERMSG)
C
C               TRACEBACK ROUTINE ID STORAGE.
        COMMON /M72ERR/ INXRC, NRTNS, IREPNT, ITRCE, ICNTU, I2ERW,
     1                  ISZE, IERRBF(10),LINE(20),IUSER
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               COMPUTER DEPENDENT ELEMENTS
        COMMON /M72CDV/ KTERM, KUCASE, KLCASE, KSUBCH, KSUPCH, KWRTFL
        COMMON /M72CDV/ KRDFL, KOUTFL, KINFL, KWRDSZ, KBYTEL, KCPW
        COMMON /M72CDV/ KSHFTC, KBLKPD, KFILL, KDEL
C
C
C
        INTEGER IERMSG(1)
C
C
        I2ERW = IERRNO
        IUSER = 1
C
C               GET THE STRING TERMINATOR
C
        CALL MEG1CH (1,KTERM,ITERM)
C
C               PARSE THE INPUT STRING FOR A TERMINATOR
C
        DO 300 IWORD = 1,20
C
            LINE(IWORD) = IERMSG(IWORD)
C
            DO 200 IBYTE = 1,KCPW
C
                CALL MEG1CH (IBYTE,LINE(IWORD),ICHAR)
                IF (ICHAR.EQ.ITERM.OR.ICHAR.EQ.0) GO TO 400
C
 200        CONTINUE
C
 300    CONTINUE
C
C               FILL THE LATEST WORD WITH BLANKS AND THEN FILL
C               THE REMAINING WORDS WITH BLANKS
C
400     DO 500 I = IBYTE,KCPW
C
            CALL MEG1PK (I,1H ,LINE(IWORD))
C
 500    CONTINUE
C
C               MOVE TO THE NEXT WORD
C
        IWORD = IWORD + 1
C
C               NOW FILL THE REMAINING WORDS WITH BLANKS
C
C
        DO 600 I = IWORD,20
C
            DO 800 J = 1,KCPW
C
                CALL MEG1PK (J,1H ,LINE(I))
C
 800        CONTINUE
C
 600    CONTINUE
C
C               -1 IS A FLAG FOR A USER GENERATED ERROR
C
        CALL MIERR (-1)
C
        RETURN
C
        END
C
        SUBROUTINE MWERPR( IGENRT, ISIZE, IERBUF)
C
C                       COMMON.
C               TRACEBACK ROUTINE ID STORAGE.
        COMMON /M72ERR/ INXRC, NRTNS, IREPNT, ITRCE, ICNTU, I2ERW,
     1                  ISZE, IERRBF(10),LINE(20),IUSER
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C
C               CHECK IF THE ERROR IS TO BE GENERATED
C
        IF (IGENRT.EQ.0) GO TO 9999
C
C               OTHERWISE REPORT THE LAST ERROR
C
C               FIRST SET TERMINAL MODE
C
        MACIO( 1) = 31
        CALL MIOUT (1,0,1)
        CALL MEGWCF (KINFL,0,MACIO)
C
C               NOW REPORT THE LAST ERROR
        CALL MEGERP (IUSER)
C
 9999   RETURN
        END
C
        SUBROUTINE MWERR( IREPRT, ITRACE, ICNTNU)
C
C                       COMMON.
C               TRACEBACK ROUTINE ID STORAGE.
        COMMON /M72ERR/ INXRC, NRTNS, IREPNT, ITRCE, ICNTU, I2ERW,
     1                  ISZE, IERRBF(10),LINE(20),IUSER
C
C
C               ROUTINE IDENTIFIER STACKING FOR ERROR REPORTING.
        CALL MIERST( 1200)
C
C               EDIT THE INCOMING PARAMETERS
C               IF A PARAMETER IS IN ERROR, THE DEFAULT IS SET
C
C               SET AND CHECK THE REPORT SWITCH
C
        IREPNT = IREPRT
        IF (IREPRT.NE.0.AND.IREPRT.NE.1) IREPNT = 1
C
C               SET AND CHECK THE TRACE BACK SWITCH
C
        ITRCE = ITRACE
        IF (ITRACE.NE.0.AND.ITRACE.NE.1) ITRCE = 1
C
C               SET AND CHECK THE CONTINUE SWITCH
C
        ICNTU = ICNTNU
        IF (ICNTNU.LT.0.OR.ICNTNU.GT.2) ICNTNU = 0
C
C
        RETURN
        END
C
        SUBROUTINE MWHCPY( IDISP, IFORM, IWAIT)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               INTERACTION PROMPT BUFFER.
        COMMON /M72PMT/ IPRMPT(10)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C               COMPUTER DEPENDENT ELEMENTS
        COMMON /M72CDV/ KTERM, KUCASE, KLCASE, KSUBCH, KSUPCH, KWRTFL
        COMMON /M72CDV/ KRDFL, KOUTFL, KINFL, KWRDSZ, KBYTEL, KCPW
        COMMON /M72CDV/ KSHFTC, KBLKPD, KFILL, KDEL
C
C
C
C               ROUTINE IDENTIFICATION CODE STACKING FOR TRACEBACK.
        CALL MIERST( 1120)
C
C               CHECK THE IDISP PARAMETER.
C
        IF(IDISP .LT. 1 .OR. IDISP .GT. 3)              GO TO 2000
C       THEN:
C           THE DISPLAY SURFACE IS INVALID - RETURN IGNORE THIS REQUEST.
C       ENDIF:
C
C               CHECK FOR ALLOCATION OF THE DISPLAY.
C
        CALL MIGVAL( ISYMDA, IDISAL)
        IF(IDISAL .NE. 3 .AND. IDISAL .NE. IDISP)       GO TO 100
                                                        GO TO 200
C       THEN:
C           ERROR:  THE DISPLAY HAS NOT BEEN ALLOCATED.
100         IERW2 = 17
            GO TO 1000
C       ENDIF:
C
C               CHECK FOR DISPLAY SELECTION
C
200     CALL MIGVAL( ISYMDS, IDISSL)
        IF(IDISSL .NE. 3. .AND. IDISSL .NE. IDISP)      GO TO 220
                                                        GO TO 300
C       THEN:
C           ERROR:  THE DISPLAY HAS NOT BEEN SELECTED.
220         IERW2 = 19
            GO TO 1000
C       ENDIF:
C
C               CHECK THE FORMS CONTROL.
C
300     IFRM = 4
        IF(IFORM .GE. 0 .OR. IFORM .LE. 3)              GO TO 320
                                                        GO TO 400
C       THEN:
320         IFRM = IFORM + 1
C       ENDIF:
C
C       BEGIN_CASE:  FORMS CONTROL
C           1:  IFRM  NO FORM FEED BEFORE OR AFTER.
C           2:  IFRM  FORM FEED BEFORE THE COPY.
C           3:  IFRM  FORM FEED AFTER THE COPY.
C           4:  IFRM  FORM FEED BEFORE AND AFTER THE COPY.
400         GO TO ( 420, 440, 460, 480), IFRM
C
420         IPRMPT( 3) = 100
            GO TO 500
C
440         IPRMPT( 3) = 116
            GO TO 500
C
460         IPRMPT( 3) = 108
            GO TO 500
C
480         IPRMPT( 3) = 124
C       END_CASE:
C
500     IPRMPT( 1) = 2
        IPRMPT( 2) = 107
C
        IF(IDISP .EQ. 1)                                GO TO 520
                                                        GO TO 540
C       THEN:
520         IPRMPT( 3) = IPRMPT( 3) + 1
C       ENDIF:
C
540     CALL MEGRCF(KINFL, 2, MACIO, IPRMPT)
C
        IF(IAND(MACIO( 1), 2) .GT. 0)                   GO TO 560
                                                        GO TO 600
C       THEN:
C           ERROR:  A ERROR OCCURRED DURING COPY
560         IERW2 = 91
            GO TO 1000
C       ENDIF:
C
600     IF(IDISP .EQ. 3)                                GO TO 620
                                                        GO TO 2000
C       THEN:
C           COPY BOTH DISPLAYS.
620         IPRMPT( 3) = IPRMPT( 3) + 1
            CALL MEGRCF( KINFL, 2, MACIO, IPRMPT)
C
            IF(IAND(MACIO( 1), 2) .GT. 0)               GO TO 640
                                                        GO TO 2000
C           THEN:
640             IERW2 = 91
C           ENDIF:
C       ENDIF:
C
1000    CALL MIERR( IERW2)
C
2000    RETURN
C
        END
C
        SUBROUTINE MWINIT
C
C                       COMMON.
C
C               TRACEBACK ROUTINE ID STORAGE.
        COMMON /M72ERR/ INXRC, NRTNS, IREPNT, ITRCE, ICNTU, I2ERW,
     1                  ISZE, IERRBF(10),LINE(20),IUSER
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C               QUERY ROUTINE COMMON BLOCK
        COMMON /M72QRY/ ISEGAD, ISVIS, IHEDTY, IHEADR( 6)
C
C               SEGMENT AND SUBROUTINE DEFINITION - BIT MAPS.
        COMMON /M72SSS/ ISEGST(256), ISUBST(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C               ATTRIBUTES - SEGMENT ZERO - DEFAULT.
        COMMON /M72DAT/ IDFATT(16)
C
C               COLOR TABLE.
        COMMON /M72COL/ ICOLOR( 3,16)
C
C               MARKER TABLE.
        COMMON /M72MTB/ MARKTB(16)
C
C               LINE PATTERN TABLE.
        COMMON /M72LTB/ LNPTTB(16)
C
C               INTERACTION PROMPT BUFFER.
        COMMON /M72PMT/ IPRMPT(10)
C
C               PICK STATUS, VECTOR COUNT AND X, Y COORDINATES.
        COMMON /M72PIK/ IEKO, MIX, MIY, MVECCT, MPIKST,IPKLC
C
C                       MOVE AND DRAW OP CODES 2-D & 3-D.
        COMMON /M72MDR/ MVDRW( 2, 2, 2)
C
C               MISCELLANEOUS STORAGE.
        COMMON /M72MIS/ IX72, IY72, IZ72,ISGNAM
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C               THE WRITE PROTECT MASK COMMON BLOCK
C
C
        COMMON/M72ERA/IERAS(11)
C               COMPUTER DEPENDENT ELEMENTS
        COMMON /M72CDV/ KTERM, KUCASE, KLCASE, KSUBCH, KSUPCH, KWRTFL
        COMMON /M72CDV/ KRDFL, KOUTFL, KINFL, KWRDSZ, KBYTEL, KCPW
        COMMON /M72CDV/ KSHFTC, KBLKPD, KFILL, KDEL
C
C
C
C
C               INITIALIZE THE COMMON BLOCKS
C
C                       INITAILIZE THE ATTRIBUTES AND MODE NAMES.
        DATA IATMOD/
     1  2HDE, 2HVI, 2HLI, 2HHI, 2HAP, 2HPA, 2HBL, 2HEC,
     2  2HSI, 2HCS, 2HCA, 2HCO, 2HMA, 2HMS, 2HMO, 2HHE,
     3  2HDS, 2HSD, 2HDA, 2HOB, 2HCF, 2HWT, 2HCM, 2HSE,
     4  2HSU, 2HIX, 2HIY, 2HIZ, 2H  , 2H  , 2H  , 2H  ,
     5  2H  , 2H  , 2H  , 2H  , 2H  , 2H  , 2H  , 2H  /
C
C               INITIALIZE THE ATTRIBUTE, MODE, OR VARIABLE NAME INDEXES
        DATA ISYMDE/ 1/, ISYMVI/ 2/, ISYMLI/ 3/, ISYMHI/ 4/, ISYMAP/ 5/,
     1       ISYMPA/ 6/, ISYMBL/ 7/, ISYMEC/ 8/, ISYMSI/ 9/, ISYMCS/10/,
     2       ISYMCA/11/, ISYMCO/12/, ISYMMA/13/, ISYMMS/14/, ISYMMO/15/,
     3       ISYMHE/16/, ISYMDS/17/, ISYMSD/18/, ISYMDA/19/, ISYMOB/20/,
     4       ISYMCF/21/, ISYMWT/22/, ISYMCM/23/, ISYMSE/24/, ISYMSU/25/,
     5       ISYMIX/26/, ISYMIY/27/, ISYMIZ/28/, ISYMBP/29/, ISYMWP/30/
C               INITIALIZE THE PERIPHERAL TYPES.
        DATA IPTYP/
     1  2HKE, 2HJO, 2HTA, 2HPI, 2HPA, 2HFB, 2HVA, 2HLI, 2HPO, 2HLO,
     2  2HDI/
C               PERIPHERAL IDENTIFIERS.
        DATA IKYID/ 1/, IJYID/ 2/, ITBID/ 3/, IPKID/ 4/, IFPID/ 5/
        DATA IFBID/ 6/, IVLID/ 6/, IBTID/14/
C               TABLET INFORMATION AND SCALE FACTORS
C       TABLET DEFAULT LOCATOR WITH 11 BIT RESOLUTION, 200BPI.
        DATA ITABIN/ 10, 1/, SCALE/ 2., 1., .5, .25, .125, .0625/
C               PICK COMPARATOR VERSES LIGHT PEN.
C
C                       INITIALIZATION MOVE AND DRAW OP CODES.
        DATA MVDRW / 16, 17, 20, 21, 18, 19, 22, 23/
C
C                       COMPUTER DEPENDENT VARIABLES.
        DATA KTERM/92/, KRDFL/11/, KOUTFL/ 5/, KINFL/ 5/, KWRDSZ/36/
        DATA KBYTEL/ 7/, KCPW/ 5/, KFILL/'     '/, KDEL/ 127/
C
C       THE COLOR TABLE
C
C
        DATA ICOLOR/  0,  0,100,
     $                24,  0,  0,
     $               37,  0,  0,
     $               55,  0,  0,
     $               75,  0,  0,
     $              125,  0,  0,
     $              150,  0,  0,
     $              180,  0,  0,
     $              210,  0,  0,
     $              240,  0,  0,
     $              275,  0,  0,
     $              290,  0,  0,
     $              330,  0,  0,
     $                0,  0,  0,
     $                0,  0, 30,
     $                0,100,  0/
C               INITIALIZE THE MARKER TABLE.
C
C
        DATA MARKTB/46,43,42,48,88,33,35,36,37,38,63,61,60,62,64,94/
C
        DATA  LNPTTB/  "125252,  "146314,
     $                 "170360,  "176374,
     $                 "126254,  "127256,
     $                 "147316,  "165352,
     $                 "173366, "164353,
     $                 "163346,  "143306,
     $                 "167356,  "166354,
     $                 "174670,  "175372  /
C
C
C
C               INITIALISE THE ERROR CONTROL PARAMETERS
C
        DATA INXRC/ 1/, NRTNS/ 1/, IREPNT/ 1/,ITRCE/ 1/,ICNTU/ 0/,
     1          I2ERW/ 1000/,ISZE/ 10/,IERRBF/ 1000,0,0,0,0,0,0,0,0,0/,
     2          LINE/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0/,IUSER/0/
C
C
C               NUMBER OF ATTRIBUTES, MODES, AND VARIABLES.
C
        NUMATT = 28
        ISZE = 10
C
C               INITIAL ATTRIBUTE AND MODE VALUES.
C
C               IATT( 1) -> DETECTABILITY,        DEFAULT = 1  DE
        IATT( 1) = 1
        IDFATT( 1) = 1
C
C               IATT( 2) ->  VISIBILITY,          DEFAULT = 1 - VISIBLE
        IATT( 2) = 1
        IDFATT( 2) = 1
C
C               IATT( 3) ->  LINESTYLE,           DEFAULT = 1 - SOLID.
        IATT( 3) = 1
        IDFATT( 3) = 1
C
C               IATT( 4) -> HIGHLIGHTING,         DEFAULT = 0 - OFF  HI
        IATT( 4) = 0
        IDFATT( 4) = 0
C
C               IATT( 5) -> APPEARANCE,           DEFAULT =16   AP
        IATT( 5) = 16
        IDFATT( 5) = 16
C
C               IATT( 6) ->  LINE PATTERN,        DEFAULT = 1  PA
        IATT( 6) = 1
        IDFATT( 6) = 1
C
C               IATT( 7) ->  BLINK RATE,          DEFAULT = 1  BL
        IATT( 7) = 1
        IDFATT( 7) = 1
C
C               IATT( 8) ->  ECHO LEVEL,         DEFAULT = 0  EC
        IATT( 8) = 0
        IDFATT( 8) = 0
C
C               IATT( 9) ->  SIZE OF SRV,          DEFAULT = 1  SI
        IATT( 9) = 1
        IDFATT( 9) = 1
C
C               IATT(10) ->  CHARACTER SIZE,      DEFAULT = 4  CS
        IATT(10) = 4
        IDFATT(10) = 4
C
C               IATT(11) ->  CHARACTER ANGLE,     DEFAULT = 0  CA
        IATT(11) = 0
        IDFATT(11) = 0
C
C               IATT(12) ->  COORDINATE TYPE,     DEFAULT = 1  CO
        IATT(12) = 1
        IDFATT(12) = 1
C
C               IATT(13) ->  MARKER,              DEFAULT = 1  MA
        IATT(13) = 1
        IDFATT(13) = 1
C
C               IATT(14) ->  MARKER SIZE,         DEFAULT = 4  MS
        IATT(14) = 4
        IDFATT(14) = 4
C
C               IATT(15) ->  MARKER ORIENTATION,  DEFAULT = 0  MO
        IATT(15) = 0
        IDFATT(15) = 0
C
C               IATT(16) ->  HEADER TYPE,        DEFAULT = 0  HE
        IATT(16) = 0
        IDFATT(16) = 0
C
C               IATT(17) ->  DISPLAY SURFACE,     DEFAULT = 0 - NEITHER
        IATT(17) = 0
C
C               IATT(18) ->  SHARABLE DISPLAY,    DEFAULT = 0 - NON SHAR
        IATT(18) = 0
C
C               IATT(19) ->  DISPLAY ALLOCATION,  DEFAULT = -1 NEITHER O
        IATT(19) = -1
C
C               IATT(20) ->  OUTPUT BUFFER MODE,  DEFAULT = 1 - ON  OB
        IATT(20) = 1
C
C               IATT(21) ->  COMPACTION FLAG,     DEFAULT = 1 - ON  CF
        IATT(21) = 1
C
C               IADD(22) ->  MAXIMUM WAIT TIME,   DEFAULT = 1 SECOND.  W
        IATT(22) = 1
C
C               IATT(23) ->  CURRENT MODE,          DEFAULT = 0   CM
        IATT(23) = 0
C
C               IATT(24) ->  CURRENT SEGMENT NUM,DEFAULT = 0  SE
        IATT(24) = 0
C
C               IATT(25) -> CURRENT SUBROUTINE,  DEFAULT = 0  SU
        IATT(25) = 0
C
C               SET THE X, Y, AND Z COORDINATES TO CENTER SCREEN.
        IATT(26) = 0
        IATT(27) = 0
        IATT(28) = 0
        IATT(29) = 0
        IATT(30) = 0
C
C               INITIALIZE THE PERIPHERAL INFORMATION ARRAY.
C
        DO 20 I = 1,30
C
            IPPSG( I,1) =  0
            IPPSG( I,2) = -1
            IPPSG( I,3) =  0
            IPPSG( I,4) =  0
C
 20     CONTINUE
C
        DO 200 I = 1,8
C
            IVALSW(I) = 1
C
 200    CONTINUE
C
C               INITIALIZE THE SEGMENT AND SUBROUTINE MAPS
C
        DO 50 I = 1,256
C
            ISEGST( I) = 0
            ISUBST( I) = 0
C
 50     CONTINUE
C
C               STANDARDIZE THE TWO CHARACTER STRINGS.
C
        DO 300 I = 1,NUMATT
C
            CALL MEGSTD( 2, IATMOD(I), IATMOD(I))
C
 300    CONTINUE
C
        DO 400 I = 1,11
C
            CALL MEGSTD(2, IPTYP(I), IPTYP(I))
C
 400    CONTINUE
C
C               INITIALIZE THE ERASE PROTECT COMMON BLOCK (M72ERA.CMB)
C
        IERAS(1) = 10
        IERAS(2) = 47 + 64
        IERAS(3) = IAND(ISHFT("2051,-12),15) + 16 + 64
        IERAS(4) = IAND(ISHFT("2051,-6),63) + 63
        IERAS(5) = IAND("2051,63) + 64
        IERAS(6) = IAND(ISHFT("160016,-12),15) + 64
        IERAS(7) = IAND(ISHFT("160016,-6),63) + 64
        IERAS(8) = IAND("160016,63) + 64
C
C               INITIALIZE THE INPUT AND OUTPUT COMMUNICATIONS.
C
        CALL MEGOCF( KINFL, 243, 1)
        CALL MEGOCF( KOUTFL,243, 1)
C
C               START GRAPHICS BY SENDING A 'GS' AND RESET COMMAND.
C
        MACIO( 1) = 29
        MACIO( 2) = 110
        MACIO( 3) =  66
        MACIO( 4) = 29
        CALL MIOUT( 4, 0, 1)
        CALL MIOUT( 0, 0, 0)
C
        RETURN
C
        END
C       CALL SEQUENCE:
C
C               CALL MWGINI
C
C       ROUTINES CALLED:
C
C               MIOUT  - THE OUTPUT ROUTINE
C               MEGSTD - STANDARDISES A CHARACTER STRING
C               MEGOCF - OPENS THE COMMUNICATIONS CHANNELS
C
C
C
        SUBROUTINE MWGINI
C
C                       COMMON.
C
C               TRACEBACK ROUTINE ID STORAGE.
        COMMON /M72ERR/ INXRC, NRTNS, IREPNT, ITRCE, ICNTU, I2ERW,
     1                  ISZE, IERRBF(10),LINE(20),IUSER
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               QUERY ROUTINE COMMON BLOCK
        COMMON /M72QRY/ ISEGAD, ISVIS, IHEDTY, IHEADR( 6)
C
C               SEGMENT AND SUBROUTINE DEFINITION - BIT MAPS.
        COMMON /M72SSS/ ISEGST(256), ISUBST(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C               ATTRIBUTES - SEGMENT ZERO - DEFAULT.
        COMMON /M72DAT/ IDFATT(16)
C
C               COLOR TABLE.
        COMMON /M72COL/ ICOLOR( 3,16)
C
C               MARKER TABLE.
        COMMON /M72MTB/ MARKTB(16)
C
C               LINE PATTERN TABLE.
        COMMON /M72LTB/ LNPTTB(16)
C
C                       MOVE AND DRAW OP CODES 2-D & 3-D.
        COMMON /M72MDR/ MVDRW( 2, 2, 2)
C
C               MISCELLANEOUS STORAGE.
        COMMON /M72MIS/ IX72, IY72, IZ72,ISGNAM
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C               THE WRITE PROTECT MASK COMMON BLOCK
C
C
        COMMON/M72ERA/IERAS(11)
C               COMPUTER DEPENDENT ELEMENTS
        COMMON /M72CDV/ KTERM, KUCASE, KLCASE, KSUBCH, KSUPCH, KWRTFL
        COMMON /M72CDV/ KRDFL, KOUTFL, KINFL, KWRDSZ, KBYTEL, KCPW
        COMMON /M72CDV/ KSHFTC, KBLKPD, KFILL, KDEL
C
C
C
C
C               INITIALIZE THE COMMON BLOCKS
C
C                       INITAILIZE THE ATTRIBUTES AND MODE NAMES.
        DATA IATMOD/
     1  2HDE, 2HVI, 2HLI, 2HHI, 2HAP, 2HPA, 2HBL, 2HEC,
     2  2HSI, 2HCS, 2HCA, 2HCO, 2HMA, 2HMS, 2HMO, 2HHE,
     3  2HDS, 2HSD, 2HDA, 2HOB, 2HCF, 2HWT, 2HCM, 2HSE,
     4  2HSU, 2HIX, 2HIY, 2HIZ, 2H  , 2H  , 2H  , 2H  ,
     5  2H  , 2H  , 2H  , 2H  , 2H  , 2H  , 2H  , 2H  /
C
C               INITIALIZE THE ATTRIBUTE, MODE, OR VARIABLE NAME INDEXES
        DATA ISYMDE/ 1/, ISYMVI/ 2/, ISYMLI/ 3/, ISYMHI/ 4/, ISYMAP/ 5/,
     1       ISYMPA/ 6/, ISYMBL/ 7/, ISYMEC/ 8/, ISYMSI/ 9/, ISYMCS/10/,
     2       ISYMCA/11/, ISYMCO/12/, ISYMMA/13/, ISYMMS/14/, ISYMMO/15/,
     3       ISYMHE/16/, ISYMDS/17/, ISYMSD/18/, ISYMDA/19/, ISYMOB/20/,
     4       ISYMCF/21/, ISYMWT/22/, ISYMCM/23/, ISYMSE/24/, ISYMSU/25/,
     5       ISYMIX/26/, ISYMIY/27/, ISYMIZ/28/, ISYMBP/29/, ISYMWP/30/
C                       INITIALIZATION MOVE AND DRAW OP CODES.
        DATA MVDRW / 16, 17, 20, 21, 18, 19, 22, 23/
C
C                       COMPUTER DEPENDENT VARIABLES.
        DATA KTERM/92/, KRDFL/11/, KOUTFL/ 5/, KINFL/ 5/, KWRDSZ/36/
        DATA KBYTEL/ 7/, KCPW/ 5/, KFILL/'     '/, KDEL/ 127/
C
C       THE COLOR TABLE
C
C
        DATA ICOLOR/  0,  0,100,
     $                24,  0,  0,
     $               37,  0,  0,
     $               55,  0,  0,
     $               75,  0,  0,
     $              125,  0,  0,
     $              150,  0,  0,
     $              180,  0,  0,
     $              210,  0,  0,
     $              240,  0,  0,
     $              275,  0,  0,
     $              290,  0,  0,
     $              330,  0,  0,
     $                0,  0,  0,
     $                0,  0, 30,
     $                0,100,  0/
C               INITIALIZE THE MARKER TABLE.
C
C
        DATA MARKTB/46,43,42,48,88,33,35,36,37,38,63,61,60,62,64,94/
C
        DATA  LNPTTB/  "125252,  "146314,
     $                 "170360,  "176374,
     $                 "126254,  "127256,
     $                 "147316,  "165352,
     $                 "173366,  "164353,
     $                 "163346,  "143306,
     $                 "167356,  "166354,
     $                 "174670,  "175372  /
C
C
C
C               INITIALISE THE ERROR CONTROL PARAMETERS
C
        DATA INXRC/ 1/, NRTNS/ 1/, IREPNT/ 1/,ITRCE/ 1/,ICNTU/ 0/,
     1          I2ERW/ 1000/,ISZE/ 10/,IERRBF/ 1000,0,0,0,0,0,0,0,0,0/,
     2          LINE/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0/,IUSER/0/
C
C
C               NUMBER OF ATTRIBUTES, MODES, AND VARIABLES.
C
        NUMATT = 28
        ISZE = 10
C
C               INITIAL ATTRIBUTE AND MODE VALUES.
C
C               IATT( 1) -> DETECTABILITY,        DEFAULT = 1  DE
        IATT( 1) = 1
        IDFATT( 1) = 1
C
C               IATT( 2) ->  VISIBILITY,          DEFAULT = 1 - VISIBLE
        IATT( 2) = 1
        IDFATT( 2) = 1
C
C               IATT( 3) ->  LINESTYLE,           DEFAULT = 1 - SOLID.
        IATT( 3) = 1
        IDFATT( 3) = 1
C
C               IATT( 4) -> HIGHLIGHTING,         DEFAULT = 0 - OFF  HI
        IATT( 4) = 0
        IDFATT( 4) = 0
C
C               IATT( 5) -> APPEARANCE,           DEFAULT =16   AP
        IATT( 5) = 16
        IDFATT( 5) = 16
C
C               IATT( 6) ->  LINE PATTERN,        DEFAULT = 1  PA
        IATT( 6) = 1
        IDFATT( 6) = 1
C
C               IATT( 7) ->  BLINK RATE,          DEFAULT = 1  BL
        IATT( 7) = 1
        IDFATT( 7) = 1
C
C               IATT( 8) ->  ECHO LEVEL,         DEFAULT = 0  EC
        IATT( 8) = 0
        IDFATT( 8) = 0
C
C               IATT( 9) ->  SIZE OF SRV,          DEFAULT = 1  SI
        IATT( 9) = 1
        IDFATT( 9) = 1
C
C               IATT(10) ->  CHARACTER SIZE,      DEFAULT = 4  CS
        IATT(10) = 4
        IDFATT(10) = 4
C
C               IATT(11) ->  CHARACTER ANGLE,     DEFAULT = 0  CA
        IATT(11) = 0
        IDFATT(11) = 0
C
C               IATT(12) ->  COORDINATE TYPE,     DEFAULT = 1  CO
        IATT(12) = 1
        IDFATT(12) = 1
C
C               IATT(13) ->  MARKER,              DEFAULT = 1  MA
        IATT(13) = 1
        IDFATT(13) = 1
C
C               IATT(14) ->  MARKER SIZE,         DEFAULT = 4  MS
        IATT(14) = 4
        IDFATT(14) = 4
C
C               IATT(15) ->  MARKER ORIENTATION,  DEFAULT = 0  MO
        IATT(15) = 0
        IDFATT(15) = 0
C
C               IATT(16) ->  HEADER TYPE,        DEFAULT = 0  HE
        IATT(16) = 0
        IDFATT(16) = 0
C
C               IATT(17) ->  DISPLAY SURFACE,     DEFAULT = 0 - NEITHER
        IATT(17) = 0
C
C               IATT(18) ->  SHARABLE DISPLAY,    DEFAULT = 0 - NON SHAR
        IATT(18) = 0
C
C               IATT(19) ->  DISPLAY ALLOCATION,  DEFAULT = -1 NEITHER O
        IATT(19) = -1
C
C               IATT(20) ->  OUTPUT BUFFER MODE,  DEFAULT = 1 - ON  OB
        IATT(20) = 1
C
C               IATT(21) ->  COMPACTION FLAG,     DEFAULT = 1 - ON  CF
        IATT(21) = 1
C
C               IADD(22) ->  MAXIMUM WAIT TIME,   DEFAULT = 1 SECOND.  W
        IATT(22) = 1
C
C               IATT(23) ->  CURRENT MODE,          DEFAULT = 0   CM
        IATT(23) = 0
C
C               IATT(24) ->  CURRENT SEGMENT NUM,DEFAULT = 0  SE
        IATT(24) = 0
C
C               IATT(25) -> CURRENT SUBROUTINE,  DEFAULT = 0  SU
        IATT(25) = 0
C
C               SET THE X, Y, AND Z COORDINATES TO CENTER SCREEN.
        IATT(26) = 0
        IATT(27) = 0
        IATT(28) = 0
        IATT(29) = 0
        IATT(30) = 0
C
C               INITIALIZE THE SEGMENT AND SUBROUTINE MAPS
C
        DO 50 I = 1,256
C
            ISEGST( I) = 0
            ISUBST( I) = 0
C
 50     CONTINUE
C
C               STANDARDIZE THE TWO CHARACTER STRINGS.
C
        DO 300 I = 1,NUMATT
C
            CALL MEGSTD( 2, IATMOD(I), IATMOD(I))
C
 300    CONTINUE
C
C               INITIALIZE THE ERASE PROTECT COMMON BLOCK (M72ERA.CMB)
C
        IERAS(1) = 10
        IERAS(2) = 47 + 64
        IERAS(3) = IAND(ISHFT("2051,-12),15) + 16 + 64
        IERAS(4) = IAND(ISHFT("2051,-6),63) + 63
        IERAS(5) = IAND("2051,63) + 64
        IERAS(6) = IAND(ISHFT("160016,-12),15) + 64
        IERAS(7) = IAND(ISHFT("160016,-6),63) + 64
        IERAS(8) = IAND("160016,63) + 64
C
C               INITIALIZE THE INPUT AND OUTPUT COMMUNICATIONS.
C
        CALL MEGOCF( KINFL, 243, 1)
        CALL MEGOCF( KOUTFL,243, 1)
C
C               START GRAPHICS BY SENDING A 'GS' AND RESET COMMAND.
C
        MACIO( 1) = 29
        MACIO( 2) = 110
        MACIO( 3) =  66
        MACIO( 4) = 29
        CALL MIOUT( 4, 0, 1)
        CALL MIOUT( 0, 0, 0)
        RETURN
        END
C
        SUBROUTINE MWLABL( ILABEL)
C
C                       COMMON.
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
        CALL MIERST( 4300)
C
        MACIO( 1) = 12
        MACIO( 2) = IAND(ISHFT(ILABEL, -12), 15) + 16
        MACIO( 3) = IAND(ISHFT(ILABEL, - 6), 63)
        MACIO( 4) = IAND(ILABEL, 63)
C
        CALL MIOUT( 4, 0, 0)
C
        RETURN
C
        END
C
        SUBROUTINE MWLCWD( IPERID, IXMIN, IXMAX, IYMIN, IYMAX)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
C
        CALL MIERST( 7070)
C
C               CHECK FOR A LOCATOR DEVICE
C
        IF (IPERID.EQ.2.OR.IPERID.EQ.3) GO TO 10
C
C               ERROR -- THE DEVICE IS NOT A LOCATOR
C
                        CALL MIERR (11)
                        GO TO 9999
C
C               CHECK FOR THE DEVICE BEING ALLOCATED
C
 10     IF (IPPSG(IPERID,3).EQ.1) GO TO 20
C
C               ERROR -- DEVICE NOT ALLOCATED
C
                        CALL MIERR (63)
                        GO TO 9999
C
C               EDIT THE COORDINATE PARAMETERS.
C                   CHECK THE X COORDINATES FIRST.
C
 20     IF (IXMIN.LE.IXMAX) GO TO 30
C
C               ERROR -- THE MIN X VALUE IS GREATER THAN THE MAX
C                        X VALUE
C
                        CALL MIERR (36)
                        GO TO 9999
C
C                   CHECK THE Y COORDINATES.
C
 30     IF (IYMIN.LE.IYMAX) GO TO 40
C
C               ERROR -- THE MIN Y VALUE IS GREATER THAN THE MAX
C                        Y VALUE
C
                        CALL MIERR (37)
                        GO TO 9999
C
C               CREATE THE NECESSARY COMMANDS.
C
 40     MACIO( 1) = 52
        MACIO( 2) = IAND(IPERID, 3)
        MACIO( 3) = IAND(ISHFT(IXMIN, -6), 63)
        MACIO( 4) =  IAND(IXMIN, 63)
        MACIO( 5) = IAND(ISHFT(IYMIN, -6), 63)
        MACIO( 6) =   IAND(IYMIN, 63)
        MACIO( 7) = IAND(ISHFT(IXMAX, -6), 63)
        MACIO( 8) =  IAND(IXMAX, 63)
        MACIO( 9) = IAND(ISHFT(IYMAX, -6), 63)
        MACIO(10) =  IAND(IYMAX, 63)
        CALL MIOUT( 10, 0, 0)
 9999   RETURN
        END
C
        SUBROUTINE MWOPEN( IGRTYP, IGRNAM)
C
C
C               THE COMMON BLOCK M72DST CONTAINS THE FOLLOWING
C               VARIABLE USED IN THIS ROUTINE
C
C                       MACIO  - THE OUTPUT BUFFER
C
C               THE COMMON BLOCK M72NME CONTAINS THE FOLLOWING
C               VARIABLES USED IN THIS ROUTINE
C
C                       ISYMSE - THE SEGMENT INDEX
C                       ISYMHE - THE HEADER TYPE INDEX
C                       ISYMSU - THE SUBROUTINE INDEX
C                       ISYMDS - THE DISPLAY SELECT INDEX
C                       ISYMVI - THE VISIBILITY INDEX
C
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               INTERACTION PROMPT BUFFER.
        COMMON /M72PMT/ IPRMPT(10)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C               COMPUTER DEPENDENT ELEMENTS
        COMMON /M72CDV/ KTERM, KUCASE, KLCASE, KSUBCH, KSUPCH, KWRTFL
        COMMON /M72CDV/ KRDFL, KOUTFL, KINFL, KWRDSZ, KBYTEL, KCPW
        COMMON /M72CDV/ KSHFTC, KBLKPD, KFILL, KDEL
C
C
C
C               ROUTINE IDENTIFIER STACKING FOR ERROR TRACEBACK.
C
        CALL MIERST( 2000)
C
C               EDIT THE INPUT PARAMETERS FOR CORRECTNESS.
C
        CALL MEGSTD( 2, IGRTYP, IGRTP)
        CALL MIGATT( IGRTP, IVAL, INDX)
        INDX = INDX - ISYMSE
        IF (INDX.EQ.0.OR.INDX.EQ.1) GO TO 10
C
C               ERROR -- INVALID TYPE
C
                        CALL MIERR (32)
                        GO TO 9999
C
C               CHECK FOR IGRNAM IN CORRECT RANGE
C
 10     IF (IGRNAM.GE.1.AND.IGRNAM.LE.4095) GO TO 20
C
C               ERROR -- SUBROUTINE/SEGMENT NOT IN RANGE
C
                        CALL MIERR (9)
                        GO TO 9999
C
C               CHECK FOR AN OPEN SEGMENT/SUBROUTINE
C
 20     CALL MIGVAL (ISYMSE,ICSEG)
        CALL MIGVAL (ISYMSU,ICSUB)
        IF (ICSEG.EQ.0.AND.ICSUB.EQ.0) GO TO 30
C
C               ERROR -- THERE IS AN OPEN SEGMENT OR SUBROUTINE
C
                        CALL MIERR (49)
                        GO TO 9999
C
C               CHECK FOR A SELECTED DISPLAY
C
 30     CALL MIGVAL (ISYMDS,IDISP)
        IF (IDISP.GE.1.AND.IDISP.LE.3) GO TO 40
C
C               ERROR -- DISPLAY NOT SELECTED
C
                        CALL MIERR (19)
                        GO TO 9999
C
C               SET THE CURRENT SEGMENT OR SUBROUTINE NUMBER AND
C               INSERT IT IN THE BIT MAP. IF THE SEGMENT/SUBROUTINE
C               ALREADY EXISTS, THE ERROR WILL BE REPORTED AND THE
C               FLAG IERROR WILL BE SET TO 1.
C
 40     CALL MISATT (IGRTP,IGRNAM)
        CALL MISSM (IGRNAM,INDX,1,IERROR)
        IF (IERROR.EQ.1) GO TO 9999
C
C               CREATE THE APPROPIATE COMMAND
C
        IF (INDX.EQ.0) GO TO 50
C
C               ITS A SUBROUTINE
C
        MACIO(1) = 32
        MACIO(2) = IAND(ISHFT(IGRNAM, -6), 63)
        MACIO(3) = IAND(IGRNAM,63)
        CALL MIOUT (3,0,0)
        GO TO 9999
C
C               ITS A SEGMENT
C               GET THE HEADER TYPE AND VISIBILITY, USE IDISP FROM
C               ABOVE
C
 50     CALL MIGVAL (ISYMHE,ISEGTY)
        CALL MIGVAL (ISYMVI,IVISIB)
C
        MACIO(1) = 0
        MACIO(2) = IAND((ISHFT(IDISP,2) + ISHFT(ISEGTY,1) +
     1                  IVISIB), 15)
        MACIO(3) = IAND(ISHFT(IGRNAM, -6), 63)
        MACIO(4) = IAND(IGRNAM, 63)
        CALL MIOUT (4,0,0)
C
C               SEND THE WRITE PROTECT MASK
C
        MASK = IATT(ISYMWP)
        MASK = MASK - 16
        M2 = IOR(ISHFT(MASK,4),15)
        IF (IATT(ISYMDS).EQ.2) MASK = M2
        IF (IATT(ISYMDS).EQ.3) MASK = IAND(MASK,M2)
C
        IPRMPT(1) = 7
        IPRMPT(2) = 47 + 64
        IPRMPT(3) = IAND(ISHFT("160016,-12),15) + 48 + 64
        IPRMPT(4) = IAND(ISHFT("160016,-6),63) + 64
        IPRMPT(5) = IAND("160016,63) + 64
        IPRMPT(6) = IAND(ISHFT(MASK,-12),15) + 64
        IPRMPT(7) = IAND(ISHFT(MASK,-6),63) + 64
        IPRMPT(8) = IAND(MASK,63) + 64
C
        CALL MEGRCF (KINFL,2,MACIO,IPRMPT)
C
C
 9999   RETURN
        END
C
        SUBROUTINE MWPKCM( IPERID, ILOCID, IDELTX, IDELTY)
C
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C               PICK STATUS, VECTOR COUNT AND X, Y COORDINATES.
        COMMON /M72PIK/ IEKO, MIX, MIY, MVECCT, MPIKST,IPKLC
C
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
C
        CALL MIERST( 7060)
C
C               CHECK FOR A CORRECT PERIPERAL ID
C
        IF (IPERID.EQ.IPKID) GO TO 10
C
C               ERROR -- DEVICE NOT A PICK MODULE
C
                        CALL MIERR (11)
                        GO TO 9999
C
C               CHECK FOR THE PICK MODULE ALLOCATED
C
 10     IF (IPPSG(IPERID,3).EQ.1) GO TO 20
C
C               ERROR -- PICK MODULE NOT ALLOCATED
C
                        CALL MIERR (17)
                        GO TO 9999
C
C               CHECK THE LOCATOR ID
C
 20     IF (ILOCID.EQ.IJYID.OR.ILOCID.EQ.ITBID) GO TO 30
C
C               ERROR -- NOT A JOYSTICK OR A TABLET
C
                        CALL MIERR (11)
                        GO TO 9999
C
C               CHECK THE THRESHHOLD PARAMETERS
C
 30     IF (IDELTX.GE.0.AND.IDELTY.GE.0) GO TO 40
C
C               ERROR -- ONE OF THE THRESHHOLD VALUES NEGATIVE
C
                        CALL MIERR (50)
                        GO TO 9999
C
C               CHECK IF THE LOCATOR IS ALLOCATED
C
 40     IF (IPPSG(ILOCID,3).EQ.1) GO TO 50
C
C               ERROR -- LOCATOR NOT ALLOCATED
C
                        CALL MIERR (17)
                        GO TO 9999
C
C               CREATE THE COMMAND AND SEND
C
C 50    MACIO(1) = 54
C       MACIO(2) = ILOCID + 32
C       MACIO(3) = 0
C       MACIO(4) = 0
 50     MACIO(1) = 55
        MACIO(2) = 4
        MACIO(3) = IAND(ILOCID, 3)
        MACIO(4) = IAND(ISHFT(IDELTX, -6), 63)
        MACIO(5) = IAND(IDELTX,63)
        MACIO(6) = IAND(ISHFT(IDELTY, -6), 63)
        MACIO(7) = IAND(IDELTY, 63)
C
C               SET THE ECHO CURSER
C
        CALL MIOUT( 7, 0, 0)
        IPKLC = 1
C
 9999   RETURN
        END
C
        SUBROUTINE MWPKIN( IPERID, IX, IY, INVCTR, IPKSTS)
C
C                               COMMON
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               PICK STATUS, VECTOR COUNT AND X, Y COORDINATES.
        COMMON /M72PIK/ IEKO, MIX, MIY, MVECCT, MPIKST,IPKLC
C
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
        CALL MIERST( 7560)
C
        IX = MIX
        IY = MIY
        INVCTR = MVECCT
        IPKSTS = MPIKST
C
        RETURN
C
        END
C
        SUBROUTINE MWPRBU( IPERID, IBUMSK, ICOUPL, ITOGGL,
     1                     ISWVAL, ILIGHT)
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
C       CALL MIERST( 7050)
C
C               CHECK, IS THE IPERID VALUE CORRECT?
        IF (IPERID.EQ.IBTID) GO TO 10
C
C               ERROR -- NOT A BUTTON
C
                        CALL MIERR (11)
                        GO TO 9999
C
C               IS THE DEVICE ALLOCATED
C
 10     IF (IPPSG(IPERID,3).EQ.1) GO TO 20
C
C               ERROR -- THE DEVICE IS NOT ALLOCATED
C
                        CALL MIERR (63)
                        GO TO 9999
C
C
C               CREATE THE NECESSARY DATA AND TRANSMIT IT.
C
 20     MACIO(1) = 55
        MACIO( 2) = 6
        NPDATA = 0
        IBVAL = 0
C
        IF (ICOUPL) 50,40,30
C
 30     IBVAL = 16
 40     IBVAL = IBVAL + 32
C
 50     IF(ITOGGL) 80, 70, 60
C
 60     IBVAL = IBVAL + 4
 70     IBVAL = IBVAL + 8
C
 80     IF(ISWVAL) 110, 100, 90
C
 90     IBVAL = IBVAL + 1
 100    IBVAL = IBVAL + 2
C
C
C
 110    MACIO(3) = IAND(ISHFT(IBUMSK, -12), 15)
        MACIO(4) = IAND(ISHFT(IBUMSK, -6), 63)
        MACIO(5) = IAND(IBUMSK, 63)
        MACIO(6) = IBVAL
        IF (ILIGHT.EQ.-1) ILIGHT = -4
        MACIO(7) = IAND((ILIGHT+4), 7)
C
C
        CALL MIOUT(7, 0, 0)
C
 9999   RETURN
        END
C
        SUBROUTINE MWPRIO( ILIST)
C
C               ROUTINE IDENTIFIER STACKING FOR ERROR TRACEBACK.
        CALL MIERST( 1090)
C
C               THIS ROUTINE IS NOT SUPPORTED BY WAND 7232
C
        CALL MIERR( 99)
C
        RETURN
C
        END
C
        SUBROUTINE MWQ2SM( ISEGNM, RMX3X3)
C
        REAL RMX3X3( 3, 3)
C
        CALL MIERST(6100)
C
C               CALL THE QUERY SEGMENT MATRIX ROUTINE.
C
        CALL MIQMTX(ISEGNM, 2, RMX3X3,RMX4X4)
C
        RETURN
C
        END
C
        SUBROUTINE MWQ3SM( ISEGNM, RMX4X4)
C
        REAL RMX4X4( 4, 4)
C
        CALL MIERST(6110)
C
C               CALL THE MATRIX QUERY ROUTINE
C
        CALL MIQMTX(ISEGNM, 3, RMX3X3,RMX4X4)
C
        RETURN
C
        END
C
        SUBROUTINE MWQCAT( INAME, IVALUE)
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
        CALL MIERST( 6000)
C
C               EDIT THE INAME 'ATTRIBUTE' PARAMETER.
        CALL MEGSTD( 2, INAME, INME)
        CALL MIGATT( INME, IVALUE, INDX)
        IF(INDX .LT. 1 .OR. INDX .GT. 16)               GO TO 100
                                                        GO TO 2000
C       THEN:
C           ERROR:  THE ATTRIBUTE NAME IS INVALID.
100         CALL MIERR( 160)
C       ENDIF:
C
2000    RETURN
        END
C
        SUBROUTINE MWQCCP( IXMIN, IXMAX, IYMIN, IYMAX)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
        CALL MIERST(6040)
C
C               GET THE CURRENT SEGMENT NUMBER.
C
        CALL MIGVAL(ISYMSE, ISEGNM)
C
C               CALL THE RETRIVE CLIP BOUNDARY ROUTINE.
C
        CALL MIQCLP(ISEGNM, IXMIN, IXMAX, IYMIN, IYMAX)
C
        RETURN
C
        END
C
        SUBROUTINE MWQCOL( INDEX, IHUE, IWHITE, IBLACK)
C
C               COLOR TABLE.
        COMMON /M72COL/ ICOLOR( 3,16)
C
C
        CALL MIERST(6030)
C
C               CHECK THE INDEX.
C
        IF(INDEX .LT. 0 .OR. INDEX .GT. 16)             GO TO 100
                                                        GO TO 200
C       THEN:
C           ERROR:  THE INDEX IS OUT OF RANGE.
100         CALL MIERR( 52)
            GO TO 2000
C       ENDIF:
C
200     IHUE   = ICOLOR( 1,INDEX)
        IWHITE = ICOLOR( 2, INDEX)
        IBLACK = ICOLOR( 3, INDEX)
C
2000    RETURN
C
        END
C
        SUBROUTINE MWQSAT( ISEGNM, INAME, IVALUE)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C               QUERY ROUTINE COMMON BLOCK
        COMMON /M72QRY/ ISEGAD, ISVIS, IHEDTY, IHEADR( 6)
C
C               COMPUTER DEPENDENT ELEMENTS
        COMMON /M72CDV/ KTERM, KUCASE, KLCASE, KSUBCH, KSUPCH, KWRTFL
        COMMON /M72CDV/ KRDFL, KOUTFL, KINFL, KWRDSZ, KBYTEL, KCPW
        COMMON /M72CDV/ KSHFTC, KBLKPD, KFILL, KDEL
C
C
C
        CALL MIERST(6010)
C
C               CHECK THE RANGE OF THE SEGMENT NAME.
C
        IF(ISEGNM .LT. 0 .OR. ISEGNM .GT. 4095)         GO TO 100
                                                        GO TO 200
C       THEN:
C           ERROR:  THE SEGMENT NAME IS OUT OF RANGE.
100         IERW2 = 9
            GO TO 1000
C       ENDIF:
C
C               GET THE ATTRIBUTE INDEX.
C
200     CALL MEGSTD(2, INAME, INME)
        CALL MIGATT(INME, IVALUE, INDX)
        IF(INDX .LT. 1 .OR. INDX .GT. 8)                GO TO 220
                                                        GO TO 300
C       THEN:
C           ERROR:  THE ATTRIBUTE NAME IS INVALID.
220         IERW2 = 22
            GO TO 1000
C       ENDIF:
C
C               CALL THE INTERNAL QUERY ROUTINE.
C
300     CALL MIQURY( ISEGNM, IERW2)
        IF(IERW2 .NE. 0)                                GO TO 1000
C       THEN:
C           ERROR: AN ERROR HAS OCURRED.
C       ENDIF:
C
C               CHECK FOR HEADER TYPE REQUEST.
C
        IF(INDX .EQ. ISYMHE)                            GO TO 700
C       THEN:
C           IT'S A HEADER TYPE REQUEST GO TO 700
C       ENDIF:
C
C       BEGIN_CASE: INDX
C           1.  INDX  = DE
C           2.  INDX  = VI
C           3.  INDX  = LI
C           4.  INDX  = HI
C           5.  INDX  = AP
C           6.  INDX  = PA
C           7.  INDX  = BL
C           8.  INDX  = EC
            GO TO (400, 440, 480, 520, 560, 600, 640, 680), INDX
C
C               DETECTABILITY.
400         IVALUE = IAND(ISHFT(IHEADR( 1), -6), 1)
            GO TO 2000
C
C           VISIBILITY.
440     IVALUE = ISVIS
            GO TO 2000
C
C           LINE STYLE.
480         IVALUE = IAND(ISHFT(IHEADR( 3), -13), 1)
            GO TO 2000
C
C           HIGHLIGHTING.
520         IVALUE = IAND(ISHFT(IHEADR( 3), -12), 1)
            GO TO 2000
C
C           APPEARANCE.
560         IVALUE = IAND(ISHFT(IHEADR( 6), -12), 15)
            GO TO 2000
C
C           LINE PATTERN.
600         IVALUE = IHEADR( 5)
            IF(KWRDSZ .GT. 16)                          GO TO 610
                                                        GO TO 2000
C           THEN:
C               CHECK FOR SIGN BIT PROPAGATION.
610             IF(IVALUE .GT. 32767)                   GO TO 620
                                                        GO TO 2000
C               THEN:
C                   THE SIGN BIT NEEDS TO BE PROPAGATED.
620                 IVALUE = IVALUE -32767
                    IVALUE = IVALUE - 32767
                    IVALUE = IVALUE - 2
C               ENDIF:
C           ENDIF:
            GO TO 2000
C
C           BLINK RATE
640         IVALUE = IAND(IHEADR( 6), 15) + 1
            GO TO 2000
C
C           ECHO LEVEL.
680         IVALUE = IAND(ISHFT(IHEADR( 1), -3), 7)
            GO TO 2000
C
C       END_CASE:
C
C               GET THE HEADER TYPE.
C
700     IVALUE = 0
        IF(IHEDTY .EQ. 6) IVALUE = 1
C       THEN:
C           IT'S A TRANSFORMED HEADER SET IVALUE TO 1
C       ENDIF:
        GO TO 2000
C
C               CALL THE ERROR ROUTINE.
C
1000    CALL MIERR( IERW2)
C
2000    RETURN
C
        END
C       :                       IXMAX  = MAXIMUM X VALUE RETURNED.
C
        SUBROUTINE MWQSCP( ISEGNM, IXMIN, IXMAX, IYMIN, IYMAX)
C
        CALL MIERST(6050)
C
C               CALL THE QUERY SEGMENT HEADER ROUTINE.
C
        CALL MIQCLP(ISEGNM, IXMIN, IXMAX, IYMIN, IYMAX)
C
        RETURN
C
        END
C
        SUBROUTINE MWQTAB( ITABLE, INDEX, IVALUE)
C
C               MARKER TABLE.
        COMMON /M72MTB/ MARKTB(16)
C
C               LINE PATTERN TABLE.
        COMMON /M72LTB/ LNPTTB(16)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
        CALL MIERST(6020)
C
C               CHECK FOR A VALID INDEX.
C
        IF(INDEX .LT. 0 .OR. INDEX .GT. 16)             GO TO 40
                                                        GO TO 80
C       THEN:
C           ERROR:  INDEX OUT OF RANGE.
40          IERW2 = 54
            GO TO 1000
C       ENDIF:
C               WHICH TABLE IS IT?
C
80      CALL MEGSTD( 2, ITABLE, ITBL)
        CALL MIGATT(ITBL, IVALUE, INDX)
        IF(INDX .NE. ISYMBL)                            GO TO 100
                                                        GO TO 600
C       THEN:
C           CHECK ANOTHER TABLE.
100         IF(INDX .NE. ISYMPA)                        GO TO 120
                                                        GO TO 500
C           THEN:
C               CHECK THE LAST TABLE.
120             IF(INDX .NE. ISYMMA)                    GO TO 140
                                                        GO TO 400
C               THEN:
C                   ERROR:  THE TABLE REQUESTED IS IN ERROR.
140                 IERW2 = 53
                    GO TO 1000
C               ELSE:
400                 IVALUE = MARKTB(INDEX)
                    GO TO 2000
C               ENDIF:
C           ELSE:
500             IVALUE = LNPTTB(INDEX)
                GO TO 2000
C           ENDIF:
C       ELSE:
600         IVALUE = INDEX -1
C       ENDIF:
C       GO TO 2000
C
C               CALL THE ERROR ROUTINE.
C
1000    CALL MIERR( IERW2)
C
2000    RETURN
C
        END
C
        SUBROUTINE MWRDAR( IPERID, IBVALA, IBPOSA, ILGHTA)
C
C
C               THE COMMON BLOCK M72DST CONTAINS THE FOLLOWING
C               VARIABLE USED IN THIS ROUTINE
C
C                       MACIO  - THE OUTPUT BUFFER
C
C               THE COMMON BLOCK M72PMT CONTAINS THE FOLLOWING
C               VARIABLE USED IN THIS ROUTINE
C
C                       IPRMPT - THE PROMPT BUFFER
C
C               THE COMMON BLOCK M72PER CONTAINS THE FOLLOWING
C               VARIABLE USED IN THIS ROUTINE
C
C                       IPPSG  - THE PERIPHERAL INFORMATION ARRAY
C
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               INTERACTION PROMPT BUFFER.
        COMMON /M72PMT/ IPRMPT(10)
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C
        INTEGER IBVALA( 1), IBPOSA( 1), ILGHTA( 1)
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
C
        CALL MIERST( 7450)
C
C               CHECK FOR AN INCORRECT ID
C
        IF (IPERID.EQ.IBTID) GO TO 10
C
C               ERROR -- NOT THE BUTTON DEVICE
C
                        CALL MIERR (54)
                        GO TO 9999
C
C               CHECK, IS THE PERIPHERAL ALLOCATED??
C
 10     IF (IPPSG(IPERID,3).EQ.1) GO TO 20
C
C               ERROR -- BUTTON DEVICE NOT ALLOCATED
C
                        CALL MIERR (63)
                        GO TO 9999
C
C               CREATE THE READ COMMANDS AND SEND THEM.
C
 20     IPRMPT( 1) = 5
        IPRMPT( 2) = 115
        IPRMPT( 3) = 70
        IPRMPT( 4) = 79
        IPRMPT( 5) = 63
        IPRMPT( 6) = 63
C
C               TRANSMIT AND RECEIVE THE DATA.
C
        CALL MEGRCF( KINFL, 10, MACIO, IPRMPT)
C
C               REDUCE THE DATA TO A USABLE FORM.
C
        ISWPOS = ISHFT(IAND(MACIO( 1), 15), 12) +
     1           ISHFT(IAND(MACIO( 2), 63),  6) +
     2                 IAND(MACIO( 3), 63)
        ISWVAL = ISHFT(IAND(MACIO( 4), 15), 12) +
     1           ISHFT(IAND(MACIO( 5), 63),  6) +
     2                 IAND(MACIO( 6), 63)
        ILITVL = ISHFT(IAND(MACIO( 7), 15), 12) +
     1           ISHFT(IAND(MACIO( 8), 63),  6) +
     2                 IAND(MACIO( 9), 63)
C
        DO 30 I = 1,16
C
            IBVALA(I) = IAND(ISWVAL, 1)
            IBPOSA(I) = IAND(ISWPOS, 1)
            ILGHTA(I) = IAND(ILITVL, 1)
            ISWPOS = ISHFT(ISWPOS, -1)
            ISWVAL = ISHFT(ISWVAL, -1)
            ILITVL = ISHFT(ILITVL, -1)
C
 30     CONTINUE
C
 9999   RETURN
        END
C
        SUBROUTINE MWRDBU( IPERID, IBUTNM, IBUVAL, IBUPOS, ILIGHT)
C
C
C               THE COMMON BLOCK M72DST CONTAINS THE FOLLOWING
C               VARIABLE USED IN THIS ROUTINE
C
C                       MACIO  - THE OUTPUT BUFFER
C
C               THE COMMON BLOCK M72PMT CONTAINS THE FOLLOWING
C               VARIABLE USED IN THIS ROUTINE
C
C                       IPRMPT - THE PROMPT BUFFER
C
C               THE COMMON BLOCK M72PER CONTAINS THE FOLLOWING
C               VARIABLE USED IN THIS ROUTINE
C
C                       IPPSG  - THE PERIPHERAL INFORMATION ARRAY
C                       IBTID  - THE BUTTON ID
C
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               INTERACTION PROMPT BUFFER.
        COMMON /M72PMT/ IPRMPT(10)
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
C
        CALL MIERST( 7420)
C
C               EDIT IPERID AND IBUTNM.
C
        IF (IPERID.EQ.IBTID) GO TO 10
C
C               ERROR -- THE PERIPHERAL ID IS INCORRECT
C
                        CALL MIERR (11)
                        GO TO 9999
C
C               CHECK THE IBUTNM PARAMETER.
C
 10     IF (IBUTNM.GE.1.AND.IBUTNM.LE.16) GO TO 20
C
C               ERROR -- THE BUTTON NUMBER IS NOT IN RANGE (1 - 16)
C
                        CALL MIERR (12)
                        GO TO 9999
C
C               CHECK IF THE DEVICE IS ALLOCATED
C
 20     IF (IPPSG(IPERID,3).EQ.1) GO TO 30
C
C               ERROR -- BUTTONS NOT ALLOCATED
C
                        CALL MIERR (63)
                        GO TO 9999
C
C               CREATE AND SEND THE COMMAND TO READ THE BUTTON.
C
 30     IBUT = ISHFT(1, IBUTNM -1)
        IPRMPT( 1) = 5
        IPRMPT( 2) = 115
        IPRMPT( 3) =  70
        IPRMPT( 4) = IAND(ISHFT(IBUT, -12), 15) + 64
        IPRMPT( 5) = IAND(ISHFT(IBUT,  -6), 63) + 64
        IPRMPT( 6) = IAND(IBUT, 63) + 64
C
C               TRANSMIT AND RECEIVE THE DATA.
C
        CALL MEGRCF( KINFL, 10, MACIO, IPRMPT)
C
        MACIO( 1) = IAND(ISHFT( IAND(MACIO( 1), 15), 12) +
     1                   ISHFT( IAND(MACIO( 2), 63),  6) +
     2                          IAND(MACIO( 3), 63), IBUT)
        MACIO( 4) = IAND(ISHFT( IAND(MACIO( 4), 15), 12) +
     1                   ISHFT( IAND(MACIO( 5), 63),  6) +
     2                          IAND(MACIO( 6), 63), IBUT)
        MACIO( 7) = IAND(ISHFT( IAND(MACIO( 7), 15), 12) +
     1                   ISHFT( IAND(MACIO( 8), 63),  6) +
     2                          IAND(MACIO( 9), 63), IBUT)
        IBUPOS = IAND( ISHFT(MACIO( 1), -IBUTNM+1), 1)
        IBUVAL = IAND( ISHFT(MACIO( 4), -IBUTNM+1), 1)
        ILIGHT = IAND( ISHFT(MACIO( 7), -IBUTNM+1), 1)
C
 9999   RETURN
        END
C
        SUBROUTINE MWRDKY (IPERID,IECHO,IBUFSZ,IKYBUF,IBUFCT,IACTCT)
C
C
C               THE COMMON BLOCK M72DST
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               INTERACTION PROMPT BUFFER.
        COMMON /M72PMT/ IPRMPT(10)
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C               COMPUTER DEPENDENT ELEMENTS
        COMMON /M72CDV/ KTERM, KUCASE, KLCASE, KSUBCH, KSUPCH, KWRTFL
        COMMON /M72CDV/ KRDFL, KOUTFL, KINFL, KWRDSZ, KBYTEL, KCPW
        COMMON /M72CDV/ KSHFTC, KBLKPD, KFILL, KDEL
C
C
C
        INTEGER IKYBUF( 1)
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
C
        CALL MIERST( 7440)
C
        IBUFCT = 0
        IACTCT = 0
C
C               CHECK THE PERIPHERAL ID
C
        IF (IPERID.EQ.1.OR.IPERID.EQ.5) GO TO 10
C
C               ERROR -- NOT A KEYBOARD OR FUNCTION PAD
C
                        CALL MIERR (11)
                        GO TO 9999
C
C               IS THE KEYBOARD ALLOCATED
C
 10     IF (IPPSG(IPERID,3).EQ.1) GO TO 20
C
C               ERROR -- THE KEYBOARD IS NOT ALLOCATED
C
                        CALL MIERR (63)
                        GO TO 9999
C
C               IS THE KEYBOARD ENABLED
C
 20     IF (IPPSG(IPERID,4).EQ.0) GO TO 30
C
C               ERROR -- THE KEYBOARD IS ALREADY ENABLED
C
                        CALL MIERR (16)
                        GO TO 9999
C
C               CREATE THE PROMPT COMMAND
C
 30     IF (IPERID.EQ.5) GO TO 40
C
C               IT'S A KEYBOARD
C
                        IPRMPT(1) = 3
                        IPRMPT(2) = 51 + 64
                        IPRMPT(3) = 64
                        IPRMPT(4) = 64
                        IF (IECHO.EQ.1.AND.IPPSG(IPERID,1).NE.0)
     1                          IPRMPT(4) = 65
                        GO TO 50
C
C               IT'S A FUNCTION PAD
C
 40                     IPRMPT(1) = 2
                        IPRMPT(2) = 51 + 64
                        IPRMPT(3) = 65
C
C               TRANSMIT AND RECEIVE THE DATA
C
 50     CALL MEGRCF (KINFL,243,MACIO,IPRMPT)
C
C               CHECK FOR AN EMPTY BUFFER
C
        IF (IAND(MACIO(1),8).EQ.1) GO TO 9999
C
C               PREPARE TO FILL THE CHARACTER BUFFER IKYBUF
C
        IF (IPERID.EQ.1) GO TO 60
C
C               IT'S A FUNCTION PAD
C
        CALL MEGCVT (MACIO(2),ICHAR)
        ICHAR = ICHAR + 64
        IF (ICHAR.GE.144.AND.ICHAR.LE.158) ICHAR = ICHAR + 49
        IF (ICHAR.GE.176.AND.ICHAR.LE.190) ICHAR = ICHAR + 49
        IKYBUF(1) = ICHAR
        IACTCT = 1
        IBUFCT = 1
        GO TO 9999
C
C               IT'S A KEYBOARD
C
 60     IACTCT = ISHFT(IAND(MACIO(1),3),6) + IAND(MACIO(2),63) - 1
        ICHCNT = 2
        IBGPOS = 3
C
C               PACK THE CHARACTERS INTO THE BUFFER IKYBUF
C
        INCHR = IACTCT + IBGPOS - 1
        IBUFCT = IACTCT
        IF (IACTCT.LE.IBUFSZ) GO TO 80
C
C               IF THE NUMBER OF CHARACTERS RECEIVED EXCEEDS THE
C               SIZE OF THE BUFFER ADJUST THE BUFFER COUNT
C
                        INCHR = IBUFSZ + IBGPOS - 1
                        IBUFCT = IBUFSZ
C
C               REPORT THE OVERFLOW
C
                        CALL MIERR (58)
C
C               THE CHARACTERS ARE PACKED IN ONE AT A TIME
C               THE LOOP INDEXES THE CHARACTERS IN THE INPUT
C               BUFFER.  WHEN A DELETE CHARACTER IS FOUND, DELETE
C               THE PREVIOUS CHARACTER AND IGNORE THE DELETE CHARACTER.
C                       MBYTE - POINTS TO THE NEXT CHARACTER SLOT
C                       IKYIND - POINTS TO THE CURRENT WORD IN THE
C                                OUTPUT BUFFER
C                       IBGPOS - THE FIRST INPUT CHARACTER POSITION
C                       INCHR  - THE LAST INPUT CHARACTER POSITION
C
C
 80     MBYTE = 1
        IKYIND = 1
C
        DO 90 I = IBGPOS,INCHR
C
C               CHECK FOR A DELETE CHARACTER
C
            IF (MACIO(I).NE.KDEL) GO TO 100
                MBYTE = MBYTE - 1
                IF (MBYTE.NE.0) GO TO 90
                    MBYTE = KCPW
                    IKYIND = IKYIND - 1
                    IF (IKYIND.NE.0) GO TO 90
                        IKYIND = 1
                        MBYTE = 1
C
C               NOW PACK THE CHARACTER
C
 100        CALL MEGCVT (MACIO(I),ICHAR)
            CALL MEG1PK (MBYTE,ICHAR,IKYBUF(IKYIND))
C
C               INCREMENT THE BYTE AND WORD POINTERS
C
            MBYTE = MBYTE + 1
            IF (MBYTE.NE.(KCPW + 1)) GO TO 90
                MBYTE = 1
                IKYIND = IKYIND + 1
C
 90     CONTINUE
C
C               FILL THE REST OF THE BUFFER WITH BLANKS
C
        IF (MBYTE.EQ.1) GO TO 110
C
        ICHAR = IAND(KFILL,255)
C
C               FILL THE REMAINING BYTES OF THE CURRENT WORD
C
        DO 120 I = MBYTE,KCPW
C
                CALL MEG1PK (I,ICHAR,IKYBUF(IKYIND))
C
 120    CONTINUE
C
        IKYIND = IKYIND + 1
C
C               FILL THE REMAINING WORDS
C
 110    NWORDS = IBUFSZ / 4
        NWRDCH = MOD(IBUFSZ,4)
        IF (NWRDCH.NE.0) NWORDS = NWORDS + 1
C
        DO 130 I = IKYIND,NWORDS
C
                IKYBUF(NWORDS) = KFILL
C
 130    CONTINUE
C
 9999   RETURN
        END
C
        SUBROUTINE MWRDLC( IPERID, IECHO, IX, IY, ILCSTS)
C
C
C               THE COMMON BLOCK M72DST CONTAINS THE FOLLOWING
C               VARIABLE USED IN THIS ROUTINE.
C
C                       MACIO  - THE OUTPUT BUFFER
C
C               THE COMMON BLOCK M72PER CONTAINS THE FOLLOWING
C               VARIABLES USED IN THIS ROUTINE.
C
C                       IPPSG  - THE PERIPHERAL INFORMATION ARRAY
C
C               THE COMMON BLOCK M72PMT CONTAINS THE FOLLOWING
C               VARIABLE USED IN THIS ROUTINE
C
C                       IPRMPT - THE PROMPT BUFFER
C
C               THE COMMON BLOCK GSA CONTAINS THE FOLLOWING VARIABLES
C               USED IN THIS ROUTINE
C
C                       KINFL  - THE INPUT CHANNEL
C
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C               INTERACTION PROMPT BUFFER.
        COMMON /M72PMT/ IPRMPT(10)
C
C               COMPUTER DEPENDENT ELEMENTS
        COMMON /M72CDV/ KTERM, KUCASE, KLCASE, KSUBCH, KSUPCH, KWRTFL
        COMMON /M72CDV/ KRDFL, KOUTFL, KINFL, KWRDSZ, KBYTEL, KCPW
        COMMON /M72CDV/ KSHFTC, KBLKPD, KFILL, KDEL
C
C
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
C
        CALL MIERST( 7400)
C
C               EDIT THE IPERID PARAMETER.
C
        NPDATA = 0
C
        IF (IPERID.EQ.2.OR.IPERID.EQ.3) GO TO 10
C
C               ERROR -- THE PERIPHERAL IS NOT A LOCATOR
C
                        CALL MIERR (14)
                        GO TO 9999
C
C               CHECK FOR AN ALLOCATED LOCATOR
C
 10     IF (IPPSG(IPERID,3).EQ.1) GO TO 20
C
C               ERROR -- THE DEVICE IS NOT ALLOCATED
C
                        CALL MIERR (63)
                        GO TO 9999
C
C               CHECK FOR THE DEVICE ALREADY ENABLED
C
 20     IF (IPPSG(IPERID,4).EQ.0) GO TO 30
C
C               ERROR -- THE IS ALREADY ENABLED
C
                        CALL MIERR (16)
                        GO TO 9999
C
C               SET UP THE PROMPT COMMAND
C
 30     IPRMPT(1) = 3
        IPRMPT(2) = 51 + 64
        IPRMPT(3) = IPERID + 64
C
C               SET THE ECHOING
C
        IPRMPT(4) = 64
        IF (IECHO.EQ.1) IPRMPT(4) = 65
C
 50     CALL MEGRCF (KINFL,10,MACIO,IPRMPT)
C
        IF (IAND(MACIO(1),1).EQ.0) GO TO 50
C               RESTRUCTURE THE DATA
C
        IF (IPERID.EQ.3) GO TO 60
C
C               IT'S A JOYSTICK
C
            ILCSTS = ISHFT(IAND(MACIO( 6), 63), 1) +
     1               IAND(MACIO( 1), 1)
            IX = ISHFT(IAND(MACIO( 2), 63), 6) +
     1           IAND(MACIO( 3), 63)
            IY = ISHFT(IAND(MACIO( 4), 63), 6) +
     1           IAND(MACIO( 5), 63)
                GO TO 100
C
C               IT'S A DATA TABLET
C
 60         ILCSTS = IAND(MACIO( 1), 15)
            IX = ISHFT(IAND(MACIO( 2), 15), 12) +
     1           ISHFT(IAND(MACIO( 3), 63), 6) +
     2           IAND(MACIO( 4), 63)
            IY = ISHFT(IAND(MACIO( 5), 15), 12) +
     1           ISHFT(IAND(MACIO( 6), 63), 6) +
     2           IAND(MACIO( 7), 63)
            IBITRS = ITABIN( 2)
C
C               POSITION DATA BASED ON NUMBER OF BITS OF RESOLUTION.
C
            IX = ISHFT(IX, IBITRS-6)
            IY = ISHFT(IY, IBITRS-6)
C
C               SCALE DATA TO SCREEN COORDINATES.
C
            IX = FLOAT(IX) * SCALE(IBITRS)
            IY = FLOAT(IY) * SCALE(IBITRS)
            IF (ITABIN(1).NE.10) GO TO 9999
C
C               PROPAGATE THE SIGN BIT.
C
 100    IF(IX .GT. 2047) IX = IX - 4096
        IF(IY .GT. 2047) IY = IY - 4096
C
 9999   RETURN
        END
C
        SUBROUTINE MWRDPK( IPERID, IECHO, IDSTAK, IADSTK)
C
C               COMMON
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               INTERACTION PROMPT BUFFER.
        COMMON /M72PMT/ IPRMPT(10)
C
C               PICK STATUS, VECTOR COUNT AND X, Y COORDINATES.
        COMMON /M72PIK/ IEKO, MIX, MIY, MVECCT, MPIKST,IPKLC
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C               COMPUTER DEPENDENT ELEMENTS
        COMMON /M72CDV/ KTERM, KUCASE, KLCASE, KSUBCH, KSUPCH, KWRTFL
        COMMON /M72CDV/ KRDFL, KOUTFL, KINFL, KWRDSZ, KBYTEL, KCPW
        COMMON /M72CDV/ KSHFTC, KBLKPD, KFILL, KDEL
C
C
C
        INTEGER IDSTAK( 1), IADSTK( 1)
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
C
        CALL MIERST( 7430)
C
        NPDATA = 0
C
C               CHECK IF THE DEVICE IS A PICK MODULE
C
        IF (IPERID.EQ.IPKID) GO TO 10
C
C               ERROR -- NOT A PICK MODULE
C
                        CALL MIERR (11)
                        GO TO 9999
C
C               CHECK IF THE PICK MODULE IS ALREADY ENABLED
C
 10     IF (IPPSG(IPERID,4).EQ.0) GO TO 20
C
C               ERROR -- PICK MODULE IS ALREADY ENABLED
C
                        CALL MIERR (16)
                        GO TO 9999
C
C               CREATE THE PROMPT COMMAND
C
 20     IPRMPT( 1) = 3
        IPRMPT( 2) = 115
        IPRMPT( 3) = 68
        IPRMPT( 4) = 64
        IF (IPKLC.EQ.0) IPRMPT(4) = 82
        IF (IECHO.EQ.1) IPRMPT(4) = IPRMPT(4) + 1
C
C               TRANSMIT AND RECEIVE THE DATA.
C
        CALL MEGRCF( KINFL, 63, MACIO, IPRMPT)
C
        INDX = 0
C
        DO 40 I = 7,37,6
C
            INDX = INDX + 1
            IDSTAK(INDX) = ISHFT(IAND(MACIO(I),   15), 12) +
     1                     ISHFT(IAND(MACIO(I+1), 63),  6) +
     2                           IAND(MACIO(I+2), 63)
            IADSTK(INDX) = ISHFT(IAND(MACIO(I+3), 15), 12) +
     1                     ISHFT(IAND(MACIO(I+4), 63),  6) +
     2                           IAND(MACIO(I+5), 63)
C
 40     CONTINUE
C
C               UPDATE THE X, Y, VECTOR COUNT AND PICK STATUS.
C
        MPIKST = IAND(MACIO( 1), 15)
C
        MVECCT = 0
        IF (IDSTAK(1).EQ.0) GO TO 50
C
            MVECCT = ISHFT(IAND(MACIO( 4), 15), 12) +
     1               ISHFT(IAND(MACIO( 5), 63),  6) +

     2                     IAND(MACIO( 6), 63)
C
 50     IF (IECHO.EQ.0.OR.IPPSG(IPERID,1).EQ.0) GO TO 60
C
C           IT ECHOES, USE THE CURSOR COORDINATES.
C
            MIX = ISHFT(IAND(MACIO(50), 63), 6) +
     1                  IAND(MACIO(51), 63)
            MIY = ISHFT(IAND(MACIO(53), 63), 6) +
     1                  IAND(MACIO(54), 63)
            GO TO 70
C
C           IT'S NOT ECHOING, USE PICK VALUES.
C
 60         MIX = ISHFT(IAND(MACIO(56), 63),  6) +
     1                  IAND(MACIO(57), 63)
            MIY = ISHFT(IAND(MACIO(59), 63),  6) +
     1                  IAND(MACIO(60), 63)
C
C               CHECK, ARE EITHER X, OR Y NEGATIVE.
C
 70     IF(MIX .GT. 2047) MIX = MIX - 4096
        IF(MIY .GT. 2047) MIY = MIY - 4096
C
 9999   RETURN
        END
C
        SUBROUTINE MWRDVL( IPERID, IVALNM, IECHO,IBUNUM, IVLVAL)
C
C               COMMON
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               INTERACTION PROMPT BUFFER.
        COMMON /M72PMT/ IPRMPT(10)
C
C               COMPUTER DEPENDENT ELEMENTS
        COMMON /M72CDV/ KTERM, KUCASE, KLCASE, KSUBCH, KSUPCH, KWRTFL
        COMMON /M72CDV/ KRDFL, KOUTFL, KINFL, KWRDSZ, KBYTEL, KCPW
        COMMON /M72CDV/ KSHFTC, KBLKPD, KFILL, KDEL
C
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
        CALL MIERST( 7410)
C
C               EDIT THE IVALNM PARAMETER ( 1 - 8 ).
C
        IF (IVALNM.GE.1.AND.IVALNM.LE.8) GO TO 10
C
C               ERROR -- THE DIAL NUMBER IS NOT IN RANGE
C
                        CALL MIERR (13)
                        GO TO 9999
C
C               CREATE THE READ COMMAND
C
 10     IPRMPT( 1) = 4
        IPRMPT( 2) = 115
        IPRMPT( 3) =  69
        IPRMPT( 4) = IAND((IVALNM - 1), 7) + 64
        IPRMPT( 5) = IAND((IBUNUM - 1), 15) + 64
C
C               TRANSMIT AND RECEIVE THE DATA.
C
        CALL MEGRCF( KINFL, 4, MACIO, IPRMPT)
C
C               RESTRUCTURE THE DATA.
C
        IVLVAL = ISHFT(IAND(MACIO( 1), 15), 12) +
     1           ISHFT(IAND(MACIO( 2), 63), 6) +
     2           IAND(MACIO( 3), 63)
C               CHECK THE WORD SIZE, SIGN BIT PROPAGATION.
C
        IF (KWRDSZ.LE.16) GO TO 9999
                IF (IVLVAL.LE.32767) GO TO 9999
C
C               IT'S A NEGATIVE VALUE PROPAGATE THE SIGN BIT.
C               WATCH FOR OPTIMIZING COMPILERS.
C
                IVLVAL = IVLVAL - 32767
                IVLVAL = IVLVAL - 32767
                IVLVAL = IVLVAL - 2
C
 9999   RETURN
        END
C
        SUBROUTINE MWRFSH( IREFRT)
C
C                       COMMON.
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
        CALL MIERST( 1080)
C
C               EDIT THE REFRESH RATE.
C
        IF(IREFRT .LT. 0)                               GO TO 20
                                                        GO TO 40
C       THEN:
C           ERROR:  THE REFRESH RATE IS IN ERROR.
20          CALL MIERR( 57)
            GO TO 2000
C       ENDIF:
C
C
C               CREATE THE NECESSARY COMMANDS.
C
40      MACIO( 1) = 45
        MACIO( 3) = 0
        MACIO( 4) = 0
        MACIO( 5) = 0
C
        IF(IREFRT .EQ. 0)                               GO TO 100
                                                        GO TO 200
C       THEN:
100         MACIO( 2) = 0
            GO TO 500
C       ENDIF:
C
200     IF(IREFRT .EQ. 1)                               GO TO 300
                                                        GO TO 400
C       THEN:
300         MACIO( 2) = 1
            GO TO 500
C       ELSE:
400         MACIO( 2) = 3
            MACIO( 3) = IAND(ISHFT(IREFRT, -12), 15)
            MACIO( 4) = IAND(ISHFT(IREFRT,  -6), 63)
            MACIO( 5) =  IAND(IREFRT, 63)
C       ENDIF:
C
500     CALL MIOUT( 5, 0, 0)
C
2000    RETURN
C
        END
C
        SUBROUTINE MWRNAM (IGRTYP,IOLDNM,INEWNM)
C
C
C               THE COMMON BLOCK M72DST CONTAINS FOLLOWING
C               VARIABLE USED IN THIS ROUTINE
C
C                       MACIO  - THE OUTPUT BUFFER
C
C               THE COMMON BLOCK M72NME CONTAINS THE FOLLOWING
C               VARIABLES USED IN THIS ROUTINE
C
C                       ISYMSE - THE SEGMENT INDEX
C                       ISYMSU - THE SUBROUTINE INDEX
C
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
        NPDATA = 0
C
C               STACK THE ROUTINE CODE
C
        CALL MIERST (2040)
C
C               CHECK THE IGRTYP PARAMETER ('SE' OR 'SU')
C
        CALL MEGSTD (2,IGRTYP,IGRTP)
        CALL MIGATT (IGRTP,IVAL,ISS)
        ISS = ISS - ISYMSE
        IF (ISS.EQ.0.OR.ISS.EQ.1) GO TO 10
C
C               ERROR -- INVALID GROUP TYPE
C
                        CALL MIERR (32)
                        GO TO 9999
C
C               DELETE THE OLD SUBROUTINE/SEGMENT REFERENCE IN
C               THE BIT MAP.  IF IT DIDN'T EXIST MISSM WILL SET
C               IERROR TO 1.
C
 10     CALL MISSM (IOLDNM,ISS,-1,IERROR)
        IF (IERROR.EQ.1) GO TO 9999
C
C               INSERT THE NEW SUBROUTINE/SEGMENT REFERENCE IN THE
C               BIT MAP.  IF IT ALREADY EXISTED, MISSM WILL SET
C               IERROR TO 1.
C
        CALL MISSM (INEWNM,ISS,1,IERROR)
        IF (IERROR.EQ.1) GO TO 9999
C
C               CHECK FOR AN OPEN SEGMENT
C
        CALL MIGVAL (ISYMSE,ICSEG)
        IF (ICSEG.EQ.0) GO TO 20
C
C               CLOSE IT
C
                        MACIO(1) = 4
                        NPDATA = 1
                        GO TO 30
C
C               CHECK FOR AN OPEN SUBROUTINE
C
 20     CALL MIGVAL (ISYMSU,ICSUB)
        IF (ICSUB.EQ.0) GO TO 30
C
C               CLOSE IT
C
                        MACIO(1) = 36
                        NPDATA = 1
C
C               CREATE THE COMMAND
C
 30     MACIO(NPDATA+1) = 6
        IF (ISS.EQ.1) MACIO(NPDATA+1) = 38
        MACIO(NPDATA+2) = IAND(ISHFT(IOLDNM, -6), 63)
        MACIO(NPDATA+3) = IAND(IOLDNM,63)
        MACIO(NPDATA+4) = IAND(ISHFT(INEWNM, -6), 63)
        MACIO(NPDATA+5) = IAND(INEWNM, 63)
        NPDATA = NPDATA + 5
C
C               IF A SEGMENT OR SUBROUTINE WAS CLOSED IN THIS ROUTINE
C               REOPEN IT
C
        IF (ICSEG.EQ.0) GO TO 40
C
C               REOPEN A SEGMENT
C
                        MACIO(NPDATA+1) = 1
                        MACIO(NPDATA+2) = IAND(ISHFT(ICSEG, -6),63)
                        MACIO(NPDATA+3) = IAND(ICSEG,63)
                        NPDATA = NPDATA + 3
                        GO TO 50
C
C               CHECK FOR A SUBROUTINE CLOSED IN THIS ROUTINE
C
 40     IF (ICSUB.EQ.0) GO TO 50
C
C               REOPEN A SUBROUTINE
C
                        MACIO(NPDATA+1) = 33
                        MACIO(NPDATA+2) = IAND(ISHFT(ICSUB, -6), 63)
                        MACIO(NPDATA+3) = IAND(ICSUB, 63)
                        NPDATA = NPDATA + 3
C
C               SEND THE COMMAND(S)
C
 50     CALL MIOUT (NPDATA,0,0)
C
 9999   RETURN
        END
C
        SUBROUTINE MWSATT( ISEGNM, INAME, IVALUE)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C
        CALL MIERST (3010)
C
C               STANDARDIZE THE CHARACTER STRING
C
        CALL MEGSTD (2,INAME,NAME)
C
        IF (NAME.EQ.IATMOD(ISYMDE)) CALL MWSDET (ISEGNM,IVALUE)
        IF (NAME.EQ.IATMOD(ISYMVI)) CALL MWSVIS (ISEGNM,IVALUE)
        IF (NAME.EQ.IATMOD(ISYMLI)) CALL MWSLIN (ISEGNM,IVALUE)
        IF (NAME.EQ.IATMOD(ISYMHI)) CALL MWSHIL (ISEGNM,IVALUE)
        IF (NAME.EQ.IATMOD(ISYMAP)) CALL MWSAPP (ISEGNM,IVALUE)
        IF (NAME.EQ.IATMOD(ISYMPA)) CALL MWSPAT (ISEGNM,IVALUE)
        IF (NAME.EQ.IATMOD(ISYMBL)) CALL MWSBLR (ISEGNM,IVALUE)
        IF (NAME.EQ.IATMOD(ISYMEC)) CALL MWSECH (ISEGNM,IVALUE)
        IF (NAME.EQ.IATMOD(ISYMWP)) CALL MWSWPR (ISEGNM,IVALUE)
C
        RETURN
        END
C
C
        SUBROUTINE MWSAPP (ISEGNM,IAPLEV)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C               CHECK FOR A VALID SEGMENT NAME
C
        IF (ISEGNM.GE.0.AND.ISEGNM.LE.4095) GO TO 10
C
C               ERROR -- SEGMENT NAME TOO BIG OR TOO SMALL
C
                        CALL MIERR (9)
                        GO TO 9999
C
C               CHECK IF SEGMENT EXISTS (SEGMENT ZERO ALWAYS EXISTS)
C
 10     IF (ISEGNM.EQ.0) GO TO 20
C
                CALL MISSM (ISEGNM,0,0,IEXIS)
                IF (IEXIS.EQ.1) GO TO 9999
C       CHECK FOR THE CORRECT RANGE
C
 20     IF (IAPLEV.GE.1.AND.IAPLEV.LE.16) GO TO 30
C
C               OTHERWISE THE ATTRIBUTE VALUE IS TOO SMALL OR TOO LARGE
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               SET UP THE COMMAND
C
 30     MACIO(1) = 8
        MACIO(2) = IAND(ISHFT(ISEGNM, -6), 63)
        MACIO(3) = IAND(ISEGNM, 63)
        MACIO(4) = IAND((IAPLEV-1), 15)
C
C               SEND THE COMMAND AND RETURN
C
        CALL MIOUT (4,0,0)
C
 9999   RETURN
        END
C
C
        SUBROUTINE MWSBLR (ISEGNM,IRATE)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C
C               CHECK FOR A VALID SEGMENT NAME
C
        IF (ISEGNM.GE.0.AND.ISEGNM.LE.4095) GO TO 10
C
C               ERROR -- SEGMENT NAME TOO BIG OR TOO SMALL
C
                        CALL MIERR (9)
                        GO TO 9999
C
C               CHECK IF SEGMENT EXISTS (SEGMENT ZERO ALWAYS EXISTS)
C
 10     IF (ISEGNM.EQ.0) GO TO 20
C
                CALL MISSM (ISEGNM,0,0,IEXIS)
                IF (IEXIS.EQ.1) GO TO 9999
C
C       CHECK FOR THE CORRECT RANGE
C
 20     IF (IRATE.GE.1.AND.IRATE.LE.16) GO TO 30
C
C               OTHERWISE THE ATTRIBUTE VALUE IS TOO SMALL OR TOO LARGE
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               SET UP THE COMMAND
C
 30     MACIO(1) = 8
        MACIO(2) = IAND(ISHFT(ISEGNM, -6), 63)
        MACIO(3) = IAND(ISEGNM, 63)
        MACIO(4) = (IAND(IRATE, 15) - 1) + 16
C
C               SEND THE COMMAND AND RETURN
C
        CALL MIOUT (4,0,0)
C
 9999   RETURN
        END
C               THIS ROUTINE CHANGES THE CURRENT VALUE OF THE
C               BEAM PENATRATION DISPLAY COLOR ATTRIBUTE
C
C
        SUBROUTINE MWSBPC (ISEGNM,IBPCOL)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C               CHECK FOR A VALID SEGMENT NUMBER
C
        IF (ISEGNM.GE.0.AND.ISEGNM.LE.4095) GO TO 10
C
C               ERROR -- SEGMENT NAME OUT OF RANGE
C
                        CALL MIERR (9)
                        GO TO 9999
C
C               CHECK IF THE SEGMENT EXITS (SEGMENT ZERO ALWAYS
C               EXITS)
C
 10     IF (ISEGNM.EQ.0) GO TO 20
        CALL MISSM(ISEGNM,0,0,IEXIS)
        IF (IEXIS.EQ.1) GO TO 9999
C
C               CHECK IF IBPCOL IS IN RANGE
C
 20     IF (IBPCOL.GE.0.AND.IBPCOL.LE.15) GO TO 30
C
C               ERROR -- IBPCOL IS OUT OF RANGE
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               SET UP THE COMMAND
C
 30     MACIO(1) = 9
        MACIO(2) = IAND(ISHFT(ISEGNM,-6),63)
        MACIO(3) = IAND(ISEGNM,63)
        MACIO(4) = 0
        MACIO(5) = 0
        MACIO(6) = IAND(IBPCOL,15) + 48
C
        CALL MIOUT (6,0,0)
C
 9999   RETURN
        END
C
C
        SUBROUTINE MWSDET (ISEGNM,IDETEC)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C
C               CHECK FOR A VALID SEGMENT NAME
C
        IF (ISEGNM.GE.0.AND.ISEGNM.LE.4095) GO TO 10
C
C               ERROR -- SEGMENT NAME TOO BIG OR TOO SMALL
C
                        CALL MIERR (9)
                        GO TO 9999
C
C               CHECK IF SEGMENT EXISTS (SEGMENT ZERO ALWAYS EXISTS)
C
 10     IF (ISEGNM.EQ.0) GO TO 20
C
                CALL MISSM (ISEGNM,0,0,IEXIS)
                IF (IEXIS.EQ.1) GO TO 9999
C
C       CHECK FOR THE CORRECT RANGE
C
 20     IF (IDETEC.EQ.0.OR.IDETEC.EQ.1) GO TO 30
C
C               OTHERWISE THE ATTRIBUTE VALUE IS TOO SMALL OR TOO LARGE
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               SET UP THE COMMAND
C
 30     MACIO(1) = 9
        MACIO(2) = IAND(ISHFT(ISEGNM, -6), 63)
        MACIO(3) = IAND(ISEGNM, 63)
        MACIO(4) = 16
        MACIO(5) = 32 + IAND(IDETEC, 1)
        MACIO(6) = 0
C
C               SEND THE COMMAND AND RETURN
C
        CALL MIOUT (6,0,0)
C
 9999   RETURN
        END
C
C
        SUBROUTINE MWSECH (ISEGNM,ILEVEL)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C
C               CHECK FOR A VALID SEGMENT NAME
C
        IF (ISEGNM.GE.0.AND.ISEGNM.LE.4095) GO TO 10
C
C               ERROR -- SEGMENT NAME TOO BIG OR TOO SMALL
C
                        CALL MIERR (9)
                        GO TO 9999
C
C               CHECK IF SEGMENT EXISTS (SEGMENT ZERO ALWAYS EXISTS)
C
 10     IF (ISEGNM.EQ.0) GO TO 20
C
                CALL MISSM (ISEGNM,0,0,IEXIS)
                IF (IEXIS.EQ.1) GO TO 9999
C
C       CHECK FOR THE CORRECT RANGE
C
 20     IF (ILEVEL.GE.1.AND.ILEVEL.LE.6) GO TO 30
C
C               OTHERWISE THE ATTRIBUTE VALUE IS TOO SMALL OR TOO LARGE
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               SET UP THE COMMAND
C
 30     MACIO(1) = 9
        MACIO(2) = IAND(ISHFT(ISEGNM, -6), 63)
        MACIO(3) = IAND(ISEGNM, 63)
        MACIO(4) = 16
        MACIO(5) = 16
        MACIO(6) = IAND((ILEVEL-1),7)
C
C               SEND THE COMMAND AND RETURN
C
        CALL MIOUT (6,0,0)
C
 9999   RETURN
        END
C
C
        SUBROUTINE MWSHIL (ISEGNM,IHIGHL)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C
C               CHECK FOR A VALID SEGMENT NAME
C
        IF (ISEGNM.GE.0.AND.ISEGNM.LE.4095) GO TO 10
C
C               ERROR -- SEGMENT NAME TOO BIG OR TOO SMALL
C
                        CALL MIERR (9)
                        GO TO 9999
C
C               CHECK IF SEGMENT EXISTS (SEGMENT ZERO ALWAYS EXISTS)
C
 10     IF (ISEGNM.EQ.0) GO TO 20
C
                CALL MISSM (ISEGNM,0,0,IEXIS)
                IF (IEXIS.EQ.1) GO TO 9999
C
C       CHECK FOR THE CORRECT RANGE
C
 20     IF (IHIGHL.EQ.1.OR.IHIGHL.EQ.0)  GO TO 30
C
C               OTHERWISE THE ATTRIBUTE VALUE IS TOO SMALL OR TOO LARGE
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               SET UP THE COMMAND
C
 30     MACIO(1) = 8
        MACIO(2) = IAND(ISHFT(ISEGNM, -6), 63)
        MACIO(3) = IAND(ISEGNM, 63)
        MACIO(4) = IAND(IHIGHL, 1) + 32
C
C               SEND THE COMMAND AND RETURN
C
        CALL MIOUT (4,0,0)
C
 9999   RETURN
        END
C
C
        SUBROUTINE MWSLIN (ISEGNM,ILINST)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C
C               CHECK FOR A VALID SEGMENT NAME
C
        IF (ISEGNM.GE.0.AND.ISEGNM.LE.4095) GO TO 10
C
C               ERROR -- SEGMENT NAME TOO BIG OR TOO SMALL
C
                        CALL MIERR (9)
                        GO TO 9999
C
C               CHECK IF SEGMENT EXISTS (SEGMENT ZERO ALWAYS EXISTS)
C
 10     IF (ISEGNM.EQ.0) GO TO 20
C
                CALL MISSM (ISEGNM,0,0,IEXIS)
                IF (IEXIS.EQ.1) GO TO 9999
C
C       CHECK FOR THE CORRECT RANGE
C
 20     IF (ILINST.EQ.1.OR.ILINST.EQ.0) GO TO 30
C
C               OTHERWISE THE ATTRIBUTE VALUE IS TOO SMALL OR TOO LARGE
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               SET UP THE COMMAND
C
 30     MACIO(1) = 8
        MACIO(2) = IAND(ISHFT(ISEGNM, -6), 63)
        MACIO(3) = IAND(ISEGNM, 63)
        MACIO(4) = IAND(ILINST, 1) + 40
C
C               SEND THE COMMAND AND RETURN
C
        CALL MIOUT (4,0,0)
C
 9999   RETURN
        END
C
C
        SUBROUTINE MWSPAT (ISEGNM,INDEX)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               LINE PATTERN TABLE.
        COMMON /M72LTB/ LNPTTB(16)
C
C
C               CHECK FOR A VALID SEGMENT NAME
C
        IF (ISEGNM.GE.0.AND.ISEGNM.LE.4095) GO TO 10
C
C               ERROR -- SEGMENT NAME TOO BIG OR TOO SMALL
C
                        CALL MIERR (9)
                        GO TO 9999
C
C               CHECK IF SEGMENT EXISTS (SEGMENT ZERO ALWAYS EXISTS)
C
 10     IF (ISEGNM.EQ.0) GO TO 20
C
                CALL MISSM (ISEGNM,0,0,IEXIS)
                IF (IEXIS.EQ.1) GO TO 9999
C
C       CHECK FOR THE CORRECT RANGE
C
 20     IF (INDEX.GE.1.AND.INDEX.LE.16) GO TO 30
C
C               OTHERWISE THE ATTRIBUTE VALUE IS TOO SMALL OR TOO LARGE
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               SET UP THE COMMAND
C
 30     LINPAT = LNPTTB(INDEX)
        MACIO(1) = 9
        MACIO(2) = IAND(ISHFT(ISEGNM, -6), 63)
        MACIO(3) = IAND(ISEGNM, 63)
        MACIO(4) = IAND(ISHFT(LINPAT, -12), 15) + 32
        MACIO(5) = IAND(ISHFT(LINPAT, -6), 63)
        MACIO(6) = IAND(LINPAT, 63)
C
C               SEND THE COMMAND AND RETURN
C
        CALL MIOUT (6,0,0)
C
 9999   RETURN
        END
C
C
        SUBROUTINE MWSVIS (ISEGNM,IVISIB)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C
C               CHECK FOR A VALID SEGMENT NAME
C
        IF (ISEGNM.GE.0.AND.ISEGNM.LE.4095) GO TO 10
C
C               ERROR -- SEGMENT NAME TOO BIG OR TOO SMALL
C
                        CALL MIERR (9)
                        GO TO 9999
C
C               CHECK IF SEGMENT EXISTS (SEGMENT ZERO ALWAYS EXISTS)
C
 10     IF (ISEGNM.EQ.0) GO TO 20
C
                CALL MISSM (ISEGNM,0,0,IEXIS)
                IF (IEXIS.EQ.1) GO TO 9999
C
C
C       CHECK FOR THE CORRECT RANGE
C
 20     IF (IVISIB.EQ.1.OR.IVISIB.EQ.0) GO TO 30
C
C               OTHERWISE THE ATTRIBUTE VALUE IS TOO SMALL OR TOO LARGE
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               SET UP THE COMMAND
C
 30     MACIO(1) = 8
        MACIO(2) = IAND(ISHFT(ISEGNM, -6), 63)
        MACIO(3) = IAND(ISEGNM, 63)
        MACIO(4) = IAND(IVISIB, 1) + 56
C
C               SEND THE COMMAND AND RETURN
C
        CALL MIOUT (4,0,0)
C
 9999   RETURN
        END
C               THIS ROUTINE CHANGES THE CURRENT VALUE OF THE RASTER
C               MEMORY WRITE PROTECT MASK IN THE SPECIFIED SEGMENT
C
C
        SUBROUTINE MWSWPR (ISEGNM,IWPMSK)
C
        DIMENSION IERPMT(11)
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C               INTERACTION PROMPT BUFFER.
        COMMON /M72PMT/ IPRMPT(10)
C
C               COMPUTER DEPENDENT ELEMENTS
        COMMON /M72CDV/ KTERM, KUCASE, KLCASE, KSUBCH, KSUPCH, KWRTFL
        COMMON /M72CDV/ KRDFL, KOUTFL, KINFL, KWRDSZ, KBYTEL, KCPW
        COMMON /M72CDV/ KSHFTC, KBLKPD, KFILL, KDEL
C
C
C
C               CHECK THE IWPMSK PARAMETER
C
        IF (IWPMSK.GE.0.AND.IWPMSK.LE.15) GO TO 10
C
C               ERROR -- THE PARAMETER IS OUT OF RANGE
C
                        CALL MIERR (66)
                        GO TO 9999
C
C               CHECK IF THE SEGMENT EXISTS
C
 10     IF (ISEGNM.EQ.0) GO TO 20
        CALL MISSM (ISEGNM,0,0,IEXIS)
        IF (IEXIS.EQ.1) GO TO 9999
C
C               FIND THE SEGMENT STARTING ADDRESS
C
 20     IPRMPT(1) = 3
        IPRMPT(2) = 59 + 64
        IPRMPT(3) = IAND(ISHFT(ISEGNM,-6),63) + 64
        IPRMPT(4) = IAND(ISEGNM,63) + 64
C
        CALL MEGRCF (KINFL,4,MACIO,IPRMPT)
C
C               RESTRUCTURE THE STARTING ADDRESS
C
        ISTADD = IAND(ISHFT(MACIO(1),12),15) +
     $           IAND(ISHFT(MACIO(2),6),63) +
     $           IAND(MACIO(3),63)
C
        IHDADD = ISTADD + 1
C
C               READ LOCATION IHDADD TO DETERMINE THE HEADER TYPE
C
        IPRMPT(1) = 4
        IPRMPT(2) = 47 + 64
        IPRMPT(3) = IAND(ISHFT(IHDADD,-12),15) + 64
        IPRMPT(4) = IAND(ISHFT(IHDADD,-6),63) + 64
        IPRMPT(5) = IAND(IHDADD,63) + 64
C
        CALL MEGRCF (KINFL,7,MACIO,IPRMPT)
C
C               ISOLATE THE TRANSFORM ENABLE/DISABLE BITS
C
        ITRANS = IAND(MACIO(4),15)
C
        IOFFST = 3
        IF (ITRANS.EQ.6) IOFFST = 10
C
C               COMPUTE THE ADDRESS FOR THE WRITE PROTECT MASK
C
        IWPADD = ISTADD + IOFFST
C
C               WRITE THE NEW MASK AT THE CALCULATED ADDRESS
C
        MASK2 = IWPMSK - 16
        M2 = IOR(ISHFT(MASK2,4),15)
        IF (IATT(ISYMDS).EQ.2) MASK2 = M2
        IF (IATT(ISYMDS).EQ.3) MASK2 = IAND(MASK2,M2)
C
        IERPMT(1) = 10
        IERPMT(2) = 47 + 64
        IERPMT(3) = IAND(ISHFT(IWPADD,-12),15) + 16 + 64
        IERPMT(4) = IAND(ISHFT(IWPADD,-6),63) + 64
        IERPMT(5) = IAND(IWPADD,63) + 64
        IERPMT(6) = IAND(ISHFT("160016,-12),15) + 64
        IERPMT(7) = IAND(ISHFT("160016,-6),63) + 64
        IERPMT(8) = IAND("160016,63) + 64
        IERPMT(9) = IAND(ISHFT(MASK2,-12),15) + 64
        IERPMT(10) = IAND(ISHFT(MASK2,-6),63) + 64
        IERPMT(11) = IAND(MASK2,63) + 64
C
        CALL MEGRCF (KINFL,2,MACIO,IERPMT)
C
 9999   RETURN
        END
C
        SUBROUTINE MWSBCH( IGRTYP,IGRNAM, ICALID, INEWNM)
C
C                       COMMON.
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
C
        CALL MIERST( 2140)
C
        CALL MEGSTD (2,IGRTYP,IGTYPE)
        CALL MIGATT (IGTYPE,IC,ITYPE)
        NPDATA = 0
C
C               CHECK FOR A CURRENTLY OPEN SEGMENT OR SUBROUTINE
C               IF FOUND, CLOSE IT.
C
        CALL MIGVAL( ISYMSE, ICSEG)
        IF (ICSEG.EQ.0) GO TO 10
C
C           A SEGMENT WAS OPEN CLOSE IT.
C
                MACIO(1) = 4
                NPDATA = 1
                GO TO 20
10      CALL MIGVAL (ISYMSU,ICSUB)
        IF (ICSUB.EQ.0) GO TO 20
C
C               A SUBROUTINE IS OPEN -- CLOSE IT
C
                MACIO(1) = 36
                NPDATA = 1
C
C               PREPARE THE REWRITE COMMANDS.
C
 20     MACIO(NPDATA+1) = 5
        MACIO(NPDATA+2) = IAND(ISHFT(IGRNAM,-6),63)
        MACIO(NPDATA+3) = IAND(IGRNAM,63)
        MACIO(NPDATA+4) = IAND(ISHFT(ICALID, -12), 15)
        IF (ITYPE.EQ.ISYMSU) MACIO(NPDATA+4) = MACIO(NPDATA+4) + 32
        MACIO(NPDATA+5) = IAND(ISHFT(ICALID, -6), 63)
        MACIO(NPDATA+6) =  IAND(ICALID, 63)
        MACIO(NPDATA+7) = 0
        MACIO(NPDATA+8) = 2
C
        NPDATA = NPDATA + 8
C               REWRITE THE NEW SUBROUTINE NAME, IE CALL IT.
C
        MACIO(NPDATA+1) = 37
        MACIO(NPDATA+2) = IAND(ISHFT(INEWNM, -6), 63)
        MACIO(NPDATA+3) =  IAND(INEWNM, 63)
C
C               CLOSE THE REWRITE
C
        MACIO(NPDATA+4) = 4
        IF (ITYPE.EQ.ISYMSU) MACIO(NPDATA+4) = 36
C
        NPDATA = NPDATA + 4
C               REOPEN THE OLD SEGMENT/SUBROUTINE FOR APPEND.
C
        IF (ICSEG.EQ.0) GO TO 30
C
C               A SEGMENT WAS OPEN -- REOPEN IT
C
                MACIO(NPDATA+1) = 1
                MACIO(NPDATA+2) = IAND(ISHFT(ICSEG, -6), 63)
                MACIO(NPDATA+3) =  IAND(ICSEG, 63)
                NPDATA = NPDATA + 3
                GO TO 40
C
 30     IF (ICSUB.EQ.0) GO TO 40
C
C           A SUBROUTINE WAS OPEN, REOPEN IT FOR APPEND.
C
                MACIO(NPDATA+1) = 33
                MACIO(NPDATA+2) = IAND(ISHFT(ICSUB, -6), 63)
                MACIO(NPDATA+3) = IAND(ICSUB, 63)
                NPDATA = NPDATA + 3
C               WRITE THE BUFFERED COMMANDS.
C
 40     CALL MIOUT( NPDATA, 0, 0)
C
        RETURN
        END
C
        SUBROUTINE MWSCLP(ISEGNM,IXMIN,IXMAX,IYMIN,IYMAX)
C
C
C       INPUT PARAMETERS:
C       =================
C
C               ISEGNM - ID NUMBER OF SEGMENT THAT CLIP PARAMETERS
C                        ARE TO BE WRITTEN TO.
C               IXMIN  - MINIMUM X COORDINATE OF CLIP WINDOW.
C               IXMAX  - MAXIMUM X COORDINATE OF CLIP WINDOW.
C               IYMIN  - MINIMUM Y COORDINATE OF CLIP WINDOW.
C               IYMAX  - MAXIMUM Y COORDINATE OF CLIP WINDOW.
C
                INTEGER ISEGNM,IXMIN,IXMAX,IYMIN,IYMAX
C
C       COMMON PARAMETERS:
C       ==================
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               QUERY ROUTINE COMMON BLOCK
        COMMON /M72QRY/ ISEGAD, ISVIS, IHEDTY, IHEADR( 6)
C
C
C       LOCAL PARAMETERS:
C       =================
C
C               IERW2  - ERROR CODES FOR ERROR REPORTING.
C               SEGVAL - 'SEGMENT_DEFINED' PARAMETER, 0 IF SEGMENT
C                        'ISEGNM' HAS NOT BEEN CREATED.
C
                INTEGER IERW2,SEGVAL
C
C-----------------------------------------------------------------------
C
C
C       STACK ROUTINE ID FOR ERROR TRACEBACK
C
        CALL MIERST(5110)
C
C               CHECK FOR A SEGMENT ZERO CHANGE.
C
        IF(ISEGNM .EQ. 0)                               GO TO 100
C       THEN:
C           IT'S SEGMENT ZERO GO TO 100
C       ENDIF:
C
C       SEE IF SEGMENT ISEGNM EXISTS.
C
        CALL MISSM(ISEGNM,0,0,IERROR)
        IF (IERROR.EQ.1) GO TO 9999
C
C               QUERY THE SEGMENT HEADER, IS IT EXTENDED?
C
        CALL MIQURY (ISEGNM,IERW2)
        IF (IERW2.EQ.1) GO TO 9999
        IF (IHEDTY.EQ.6) GO TO 100
C           ERROR:  IT'S NOT AN EXTENDED HEADER.
                CALL MIERR (3)
                GO TO 9999
C       CHECK WINDOW PARAMETERS FOR VALIDITY.
C
 100    IF(IXMIN.LE.IXMAX) GOTO 200
C               IXMAX<=IXMIN
                CALL MIERR (36)
                GO TO 9999
C
 200    IF(IYMIN.LE.IYMAX) GOTO 300
C               IYMAX<=IYMIN
                CALL MIERR (37)
                GO TO 9999
C
C       BUILD THE INSTRUCTION. INCLUDES OP_CODE, SEGMENT_ID, AND FORMAT.
C
 300    MACIO(1)=10
        MACIO(2)=IAND(ISHFT(ISEGNM, -6), 63)
        MACIO(3)=IAND(ISEGNM, 63)
        MACIO(4)=6
C
C       INSERT VIEWPORT PARAMETERS INTO OUTPUT BUFFER.
C
        MACIO( 9) = IAND(ISHFT(IXMAX, -6), 63)
        MACIO(10) = IAND( IXMAX, 63)
C
        MACIO(11) = IAND(ISHFT(IYMAX, -6), 63)
        MACIO(12) = IAND( IYMAX,       63)
C
        MACIO( 5) = IAND(ISHFT(IXMIN, -6), 63)
        MACIO( 6) = IAND( IXMIN,       63)
C
        MACIO( 7) = IAND(ISHFT(IYMIN, -6), 63)
        MACIO( 8) = IAND( IYMIN,       63)
C
C       SEND THE INSTRUCTION TO THE 7232.
C
        CALL MIOUT(12,0,0)
 9999   RETURN
        END
C
        SUBROUTINE MWSCOL( INDEX, IHUE, IWHITE, IBLACK)
C
C                       COMMON.
C               COLOR TABLE.
        COMMON /M72COL/ ICOLOR( 3,16)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C               STACK THE ROUTINE IDENTIFIER FOR TRACEBACK.
C
        CALL MIERST( 3030)
C
C               EDIT THE INCOMING PARAMETERS.
C
        IF (INDEX.GE.1.AND.INDEX.LE.16) GO TO 10
C
C               ERROR -- THE COLOR INDEX IS OUT OF RANGE
C
                        CALL MIERR (52)
                        GO TO 9999
C
C               CHECK THE HUE
C
 10     IF (IHUE.GE.0.AND.IHUE.LE.360) GO TO 20
C
C               ERROR -- THE HUE IS OUT OF RANGE
C
                        CALL MIERR (60)
                        GO TO 9999
C
C               CHECK THE WHITENESS
C
 20     IF (IWHITE.GE.0.AND.IWHITE.LE.100) GO TO 30
C
C               ERROR -- THE WHITENESS IS OUT OF RANGE
C
                        CALL MIERR (61)
                        GO TO 9999
C
C               CHECK THE BLACKNESS
C
 30     IF (IBLACK.GE.0.AND.IBLACK.LE.100) GO TO 40
C
C               ERROR -- BLACKNESS IS OUT OF RANGE
C
                        CALL MIERR (62)
                        GO TO 9999
C
C               UPDATE THE VALUES WITHIN THE COLOR TABLE
C
 40     ICOLOR( 1,INDEX) = IHUE
        ICOLOR( 2,INDEX) = IWHITE
        ICOLOR( 3,INDEX) = IBLACK
C
C               UPDATE THE RASTER TABLE OR TABLES.
C
        CALL MIGVAL(ISYMDS, IDISP)
        NDISP = IDISP - 1
        IF (IDISP.EQ.3) NDISP = 0
 50     NPDATA = 0
C
            CALL MIGCLR( INDEX,IRED,IGREEN,IBLUE,INTEN)
            MACIO(NPDATA+1) = 44
            MACIO(NPDATA+2) = NDISP
            MACIO(NPDATA+3) = INDEX - 1
            MACIO(NPDATA+4) = IRED
            MACIO(NPDATA+5) = IGREEN
            MACIO(NPDATA+6) = IBLUE
            MACIO(NPDATA+7) = INTEN
            NPDATA = NPDATA + 7
C
C
        CALL MIOUT (NPDATA,0,0)
C
C               IF IDISP = 3 SEND THE UPDATE TO THE SECOND
C               RASTER TABLE
C
        NDISP = NDISP + 1
C
        IF (IDISP.EQ.3.AND.IDISP.EQ.1) GO TO 50
C
 9999   RETURN
        END
C
        SUBROUTINE MWSLCT( IDISP)
C
C
C               THE COMMON BLOCK M72NME CONTAINS THE FOLLOWING VARIABLE
C               USED IN THIS ROUTINE
C
C                       ISYMDS  - THE DISPLAY INDEX TO THE ATTRIBUTE
C                                 ARRAY
C
C
C               THE COMMON BLOCK M72ATT CONTAINS THE FOLLOWING VARIABLE

C               USED IN THIS ROUTINE.
C
C                       IATT   - THE ATTRIBUTE ARRAY
C
C               THE COMMON BLOCK M72DST CONTAINS THE FOLLOWING VARIABLE
C               USED IN THIS ROUTINE.
C
C                       MACIO  - THE OUTPUT BUFFER
C
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C               ATTRIBUTE, MODE, AND VARIABLE STORAGE.
        COMMON /M72ATT/ NUMATT, IATT(40), IATMOD(40)
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C
C               STACK THE ROUTINE CODE
C
        CALL MIERST (1040)
C
C               CHECK THE IDISP PARAMETER
C
        IF (IDISP.GE.1.AND.IDISP.LE.3) GO TO 10
C
C               ERROR -- IDISP OUT OF RANGE
C
                        CALL MIERR (25)
                        GO TO 9999
C
C               CHECK IF DISPLAY IDISP IS ALREADY SELECTED
C
 10     ISEL = IATT(ISYMDS)
C
        IF (ISEL.NE.IDISP.AND.ISEL.NE.3) GO TO 20
C
C               ERROR -- DISPLAY IDISP IS ALREADY SELECTED
C
                        CALL MIERR (17)
                        GO TO 9999
C
C               SELECT THE DISPLAY
C
 20     IATT(ISYMDS) = IDISP
C
C               IF THE CURRENT SELECTION IS NOT -1 THEN WITH THIS
C               SELECTION BOTH DISPLAYS ARE NOW SELECTED.
C
        IF (ISEL.NE.0) IATT(ISYMDS) = 3
C
C               SEND THE COLOR TABLE.  IF IDISP = 3 TWO TABLES MUST
C               BE TRANSMITED.
C
        NDISP = IDISP - 1
        IFLAG = 0
        IF (IDISP.EQ.3) NDISP = 0
        IF (IDISP.NE.3) IFLAG = 1
C
 40     NPDATA = 0
        IFLAG = IFLAG + 1
C
        DO 30 I = 1,16
C
            CALL MIGCLR (I,IRED,IGREEN,IBLUE,INTEN)
            MACIO(NPDATA+1) = 44
            MACIO(NPDATA+2) = NDISP
            MACIO(NPDATA+3) = I - 1
            MACIO(NPDATA+4) = IRED
            MACIO(NPDATA+5) = IGREEN
            MACIO(NPDATA+6) = IBLUE
            MACIO(NPDATA+7) = INTEN
C
            NPDATA = NPDATA + 7
C
 30     CONTINUE
C
C               SEND THE TABLE
C
        CALL MIOUT (NPDATA,0,0)
C
C               CHECK IF ANOTHER TABLE SHOULD BE SENT
C
        NDISP = NDISP + 1
        IF (IFLAG.EQ.1) GO TO 40
C
C
 9999   RETURN
        END
C
        SUBROUTINE MWSMAR( IPERID, IBVALA, IBPOSA, ILGHTA)
C
C               COMMON
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               INTERACTION PROMPT BUFFER.
        COMMON /M72PMT/ IPRMPT(10)
C
C               COMPUTER DEPENDENT ELEMENTS
        COMMON /M72CDV/ KTERM, KUCASE, KLCASE, KSUBCH, KSUPCH, KWRTFL
        COMMON /M72CDV/ KRDFL, KOUTFL, KINFL, KWRDSZ, KBYTEL, KCPW
        COMMON /M72CDV/ KSHFTC, KBLKPD, KFILL, KDEL
C
C
C
        INTEGER IBVALA( 1), IBPOSA( 1), ILGHTA( 1)
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
        CALL MIERST( 7550)
C
        IPRMPT( 1) =  3
        IPRMPT( 2) = 114
        IPRMPT( 3) =  70
C
C               BEGIN SAMPLING THE BUTTONS.
C
        DO 600 I = 1,16
C
            IPRMPT( 4) = I + 63
C
C               TRANSMIT THE REQUEST FOR INFORMATION.
C
            CALL MEGRCF(KINFL, 2, MACIO, IPRMPT)
            IBVALA(I) = IAND(ISHFT(MACIO( 1), -2), 1)
            IBPOSA(I) = IAND(ISHFT(MACIO( 1), -3), 1)
            ILGHTA(I) = IAND(      MACIO( 1),      3)
C
 600    CONTINUE
C
        RETURN
C
        END
C
        SUBROUTINE MWSMBU( IPERID, IBUTNM, IBUVAL, IBUPOS, ILIGHT)
C
C
C               THE COMMON BLOCK M72DST CONTAINS THE FOLLOWING
C               VARIABLE USED IN THIS ROUTINE
C
C                       MACIO  - THE OUTPUT BUFFER
C
C               THE COMMON BLOCK M72PMT CONTAINS THE FOLLOWING
C               VARIABLE USED IN THIS ROUTINE
C
C                       IPRMPT - THE PROMPT BUFFER
C
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               INTERACTION PROMPT BUFFER.
        COMMON /M72PMT/ IPRMPT(10)
C
C
C               ROUTINE IDENTIFIER STORAGE FOR TRACEBACK.
C
        CALL MIERST( 7520)
C
C               EDIT THE IBUTNM PARAMETER, MUST BE BETWEEN 1 - 16.
C
        IF (IBUTNM.GE.1.AND.IBUTNM.LE.16) GO TO 10
C
C               ERROR -- THE BUTTON IS OUT OF RANGE (1 - 16)
C
                        CALL MIERR (12)
                        GO TO 9999
C
C               THE DEVICE IS ALWAYS ENABLED SO DON'T CHECK
C
C               CREATE THE SAMPLE COMMANDS
C
 10     IPRMPT(1) = 3
        IPRMPT(2) = 114
        IPRMPT(3) = 70
        IPRMPT(4) = IAND((IBUTNM - 1), 15) + 64
C
C               TRANSMIT AND RECEIVE THE DATA
C
        CALL MEGRCF (KINFL,2,MACIO,IPRMPT)
C
        IBUVAL = IAND(ISHFT(MACIO( 1), -2), 1)
        IBUPOS = IAND(ISHFT(MACIO( 1), -3), 1)
        ILIGHT =       IAND(MACIO( 1), 3)
C
 9999   RETURN
        END
C
        SUBROUTINE MWSMKY( IPERID, IBUFSZ, IKYBUF, IBUFCT, IACTCT)
C
C
C               THE COMMON BLOCK M72DST CONTAINS THE FOLLOWING
C               VARIABLE USED IN THIS ROUTINE
C
C                       MACIO  - THE OUTPUT BUFFER
C
C               THE COMMON BLOCK M72PMT CONTAINS THE FOLLOWING
C               VARIABLE USED IN THIS ROUTINE
C
C                       IPRPMT - THE PROMPT BUFFER
C
C               THE COMMON BLOCK M72PER CONTAINS THE FOLLOWING
C               VARIABLE USED IN THIS ROUTINE
C
C                       IPPSG  - THE PERIPHERAL INFORMATION ARRAY
C
C               THE COMMON BLOCK GSA CONTAINS THE FOLLOWING VARIABLES
C               USED IN THIS ROUTINE
C
C                       KINFL  - THE INPUT CHANNEL
C                       KCPW   - THE NUMBER OF CHARACTERS PER WORD
C                       KFILL  - THE FILL CHARACTER (A WHOLE WORD)
C
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               INTERACTION PROMPT BUFFER.
        COMMON /M72PMT/ IPRMPT(10)
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C               COMPUTER DEPENDENT ELEMENTS
        COMMON /M72CDV/ KTERM, KUCASE, KLCASE, KSUBCH, KSUPCH, KWRTFL
        COMMON /M72CDV/ KRDFL, KOUTFL, KINFL, KWRDSZ, KBYTEL, KCPW
        COMMON /M72CDV/ KSHFTC, KBLKPD, KFILL, KDEL
C
C
C
        INTEGER IKYBUF( 1)
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
C
        CALL MIERST( 7540)
C
C               CHECK FOR A CORRECT PERIPHERAL ID
C
        IF (IPERID.EQ.1.OR.IPERID.EQ.5) GO TO 10
C
C               ERROR -- NOT A KEYBOARD OR FUNCTION PAD
C
                        CALL MIERR (11)
                        GO TO 9999
C
C               CHECK FOR THE PERIPHERAL ENABLED
C
 10     IF (IPPSG(IPERID,4).EQ.1) GO TO 20
C
C               ERROR -- KEYBOARD OR FUNCTION PAD NOT ENABLED
C
                        CALL MIERR (64)
                        GO TO 9999
C
C               CREATE THE SAMPLE COMMAND
C
 20     IPRMPT(1) = 2
        IPRMPT(2) = 114
        IPRMPT(3) = 64
        IF (IPERID.EQ.5) IPRMPT(3) = 65
C

C               TRANSMIT AND RECEIVE THE DATA
C
        CALL MEGRCF (KINFL,243,MACIO,IPRMPT)
C
C               CHECK FOR AN EMPTY BUFFER
C
C       IF (IAND(MACIO(1),8).GT.0) GO TO 9999
        IF (IPERID.EQ.1.AND.IAND(MACIO(1),8).GT.0) GO TO 9999
        IF (IPERID.EQ.5.AND.IAND(MACIO(1),15).EQ.0) GO TO 9999
C
C               FILL THE OUTPUT BUFFER 'IKYBUF'
C
        IF (IPERID.EQ.1) GO TO 30
C
C               IT'S A FUNCTION PAD
C
                        CALL MEGCVT (MACIO(2),ICHAR)
                        ICHAR = ICHAR + 64
                        IF (ICHAR.GE.144.AND.ICHAR.LE.158)
     $                                  ICHAR = ICHAR + 49
                        IF (ICHAR.GE.176.AND.ICHAR.LE.190)
     $                                  ICHAR = ICHAR + 49
                        IKYBUF(1) = ICHAR
                        IBUFCT = 1
                        IACTCT = 1
                        GO TO 9999
C
C               IT'S A KEYBOARD
C
 30     IACTCT = IAND(MACIO(1), 3) * 64 + IAND(MACIO(2), 63)
        ICHCNT = 2
        IBGPOS = 3
        INCHR = IACTCT + IBGPOS - 1
        IF (IACTCT.GT.IBUFSZ) INCHR = IBUFSZ + IBGPOS - 1
C
C               PACK THE INCOMING CHARACTERS INTO IKYBUF
C
        MBYTE = 1
        IKYIND = 1
C
        DO 40 I = IBGPOS,INCHR
C
                CALL MEGCVT (MACIO(I),ICHAR)
                CALL MEG1PK (MBYTE,ICHAR,IKYBUF(IKYIND))
                MBYTE = MBYTE + 1
                IF (MBYTE.NE.(KCPW + 1)) GO TO 40
C
C                       THE END OF A WORD
C
                        MBYTE = 1
                        IKYIND = IKYIND + 1
C
 40     CONTINUE
C
C               FILL ANY REMAINING BYTES IN THE CURRENT WORD
C               WITH BLANKS
C
        IF (MBYTE.EQ.1) GO TO 55
        ICHAR = IAND(KFILL,255)
C
        DO 50 I = MBYTE,KCPW
C
                CALL MEG1PK (I,ICHAR,IKYBUF(IKYIND))
C
 50     CONTINUE
C
        IKYIND = IKYIND + 1
C
C               FILL THE REST OF THE BUFFER
C
 55     NWORDS = IBUFSZ / 4
        NWRDCK = MOD(IBUFSZ,4)
        IF (NWRDCK.NE.0) NWORDS = NWORDS + 1
C
        DO 60 I = IKYIND,NWORDS
C
                IKYBUF(I) = KFILL
C
 60     CONTINUE
C
C
        IBUFCT = IACTCT
        IF (IACTCT.GT.IBUFSZ) IBUFCT = IBUFSZ
C
 9999   RETURN
        END
        SUBROUTINE MWSMLC( IPERID, IX, IY, ILCSTS)
C
C               COMMON.
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               INTERACTION PROMPT BUFFER.
        COMMON /M72PMT/ IPRMPT(10)
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C               COMPUTER DEPENDENT ELEMENTS
        COMMON /M72CDV/ KTERM, KUCASE, KLCASE, KSUBCH, KSUPCH, KWRTFL
        COMMON /M72CDV/ KRDFL, KOUTFL, KINFL, KWRDSZ, KBYTEL, KCPW
        COMMON /M72CDV/ KSHFTC, KBLKPD, KFILL, KDEL
C
C
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
        CALL MIERST( 7500)
C
C               CHECK, IS IT THE CORRECT DEVICE AND IS IT ENABLED?
C
        IF (IPERID.EQ.2.OR.IPERID.EQ.3) GO TO 10
C
C               ERROR -- NOT A LOCATOR
C
                        CALL MIERR (11)
                        GO TO 9999
C
C               CHECK IF THE LOCATOR IS ENALBED
C
 10     IF (IPPSG(IPERID,4).EQ.1) GO TO 20
C
C               ERROR -- NOT ENABLED
C
                        CALL MIERR (64)
                        GO TO 9999
C
C               CREATE THE SAMPLE COMMANDS.
C
 20     IPRMPT( 1) =  2
        IPRMPT( 2) = 114
        IPRMPT( 3) = IPERID + 64
C
C               TRANSMIT AND RECEIVE THE DATA
C
        CALL MEGRCF( KINFL, 10, MACIO, IPRMPT)
C
C               RESTORE THE INCOMING DATA TO A READABLE FORM.
C
        IF (IPERID.EQ.3) GO TO 30
C
C               IT'S A JOYSTICK -- RESTORE THE DATA
C
            ILCSTS = ISHFT(IAND(MACIO( 6), 63), 1) +
     1               IAND(MACIO( 1), 1)
            IX = ISHFT(IAND(MACIO( 2), 63), 6) +
     1           IAND(MACIO( 3), 63)
            IY = ISHFT(IAND(MACIO( 4), 63), 6) +
     1           IAND(MACIO( 5), 63)
            GO TO 40
C
C               IT'S A DATA TABLET -- RESTORE THE DATA
C
 30         IX = ISHFT(IAND(MACIO( 2), 15), 12) +
     1           ISHFT(IAND(MACIO( 3), 63), 6) +
     2                 IAND(MACIO( 4), 63)
            IY = ISHFT(IAND(MACIO( 5), 15), 12) +
     1           ISHFT(IAND(MACIO( 6), 63), 6) +
     2                 IAND(MACIO( 7), 63)
C
            ILCSTS = IAND(MACIO( 1), 15)
            IBITRS = ITABIN( 2)
C
C               POSITION DATA BASED ON NUMBER OF BITS OF RESOLUTION.
C
            IX = ISHFT(IX, IBITRS - 6)
            IY = ISHFT(IY, IBITRS - 6)
C
C               SCALE DATA TO SCREEN COORDINATES.
C
            IX = FLOAT(IX) * SCALE(IBITRS)
            IY = FLOAT(IY) * SCALE(IBITRS)
C               CHECK FOR DIGITIZER MODE.
            IF (ITABIN(1).NE.10) GO TO 9999
C
C               PROPAGATE THE SIGN BIT IF NECESSARY.
C
 40     IF(IX .GT. 2047) IX = IX - 4096
        IF(IY .GT. 2047) IY = IY - 4096
C
 9999   RETURN
        END
C
        SUBROUTINE MWSMPK( IPERID, IDSTAK, IADSTK)
C
C               COMMON.
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               INTERACTION PROMPT BUFFER.
        COMMON /M72PMT/ IPRMPT(10)
C
C               PICK STATUS, VECTOR COUNT AND X, Y COORDINATES.
        COMMON /M72PIK/ IEKO, MIX, MIY, MVECCT, MPIKST,IPKLC
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C               COMPUTER DEPENDENT ELEMENTS
        COMMON /M72CDV/ KTERM, KUCASE, KLCASE, KSUBCH, KSUPCH, KWRTFL
        COMMON /M72CDV/ KRDFL, KOUTFL, KINFL, KWRDSZ, KBYTEL, KCPW
        COMMON /M72CDV/ KSHFTC, KBLKPD, KFILL, KDEL
C
C
C
        INTEGER IADSTK( 1), IDSTAK( 1)
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
C
        CALL MIERST( 7530)
C
C               CHECK IF THE DEVICE IS A PICK MODULE
C
        IF (IPERID.EQ.IPKID) GO TO 10
C
C               ERROR -- NOT A PICK MODULE
C
                        CALL MIERR (11)
                        GO TO 9999
C
C               CHECK IF THE PICK MODULE IS ENABLED
C
 10     IF (IPPSG(IPERID,4).EQ.1) GO TO 20
C
C               ERROR -- PICK MODULE IS NOT ENABLED
C
                        CALL MIERR (64)
                        GO TO 9999
C
C               CREATE THE SAMPLE COMMAND AND SEND IT
C
 20     IPRMPT( 1) =  2
        IPRMPT( 2) = 114
        IPRMPT( 3) =  68
C
C               TRANSMIT AND RECEIVE THE DATA.
C
        CALL MEGRCF(KINFL, 98, MACIO, IPRMPT)
C
C               PLACE THE RESPECTIVE DATA IN THE TWO ARRAYS.
C
        INDX = 0
C
        DO 30 I = 7,37,6
C
            INDX = INDX + 1
            IDSTAK(INDX) = ISHFT(IAND(MACIO(I),   15), 12) +
     1                     ISHFT(IAND(MACIO(I+1), 63),  6) +
     2                           IAND(MACIO(I+2), 63)
            IADSTK(INDX) = ISHFT(IAND(MACIO(I+3), 15), 12) +
     1                     ISHFT(IAND(MACIO(I+4), 63),  6) +
     2                           IAND(MACIO(I+5), 63)
C
 30     CONTINUE
C
C               UPDATE X, Y, VECTOR COUNT AND STATUS.
C
        MPIKST = IAND(MACIO( 1), 15)
        MVECCT = 0
        IF (IDSTAK(1).EQ.0) GO TO 40
C
            MVECCT = ISHFT(IAND(MACIO( 4), 15), 12) +
     1               ISHFT(IAND(MACIO( 5), 63),  6) +
     2                     IAND(MACIO( 6), 63)
 40     IF (IEKO.EQ.0.OR.IPPSG(IPERID,1).EQ.0) GO TO 50
C
C           IT ECHOES, USE THE CURSOR COORDINATES.
            MIX = ISHFT(IAND(MACIO(50), 63), 6) +
     1                  IAND(MACIO(51), 63)
            MIY = ISHFT(IAND(MACIO(53), 63), 6) +
     1                  IAND(MACIO(54), 63)
            GO TO 60
C
C           IT'S NOT ECHOING, USE PICK VALUES.
C
 50         MIX = ISHFT(IAND(MACIO(56), 63), 6) +
     1                  IAND(MACIO(57), 63)
            MIY = ISHFT(IAND(MACIO(59), 63), 6) +
     1                  IAND(MACIO(60), 63)
C
C               CHECK, ARE EITHER X, OR Y NEGATIVE?
C
 60     IF(MIX .GT. 2047) MIX = MIX - 4096
        IF(MIY .GT. 2047) MIY = MIY - 4096
C
 9999   RETURN
        END
C
        SUBROUTINE MWSMVL( IPERID, IVALNM, IVLVAL)
C
C               COMMON.
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C               INTERACTION PROMPT BUFFER.
        COMMON /M72PMT/ IPRMPT(10)
C
C               COMPUTER DEPENDENT ELEMENTS
        COMMON /M72CDV/ KTERM, KUCASE, KLCASE, KSUBCH, KSUPCH, KWRTFL
        COMMON /M72CDV/ KRDFL, KOUTFL, KINFL, KWRDSZ, KBYTEL, KCPW
        COMMON /M72CDV/ KSHFTC, KBLKPD, KFILL, KDEL
C
C
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
C
        CALL MIERST( 7510)
C
C               CHECK IF DEVICE IS A VALUATOR
C
        IF (IPERID.EQ.IVLID) GO TO 10
C
C               ERROR -- NOT A VALUATOR
C
                        CALL MIERR (11)
                        GO TO 9999
C
C               CHECK IF A CORRECT DIAL NUMBER
C
 10     IF (IVALNM.GE.1.AND.IVALNM.LE.8) GO TO 20
C
C               ERROR -- DIAL NUMBER IS OUT OF RANGE
C
                        CALL MIERR (13)
                        GO TO 9999
C
C               CREATE THE NECESSARY SAMPLE COMMANDS.
C
 20     IPRMPT( 1) = 3
        IPRMPT( 2) = 114
        IPRMPT( 3) =  69
        IPRMPT( 4) = IAND((IVALNM -1), 7) + 64
C
C               TRANSMIT AND RECEIVE THE DATA.
C
        CALL MEGRCF(KINFL, 4, MACIO, IPRMPT)
C
C               RECREATE THE DATA.
C
        IVLVAL = ISHFT(IAND(MACIO( 1), 15), 12) +
     1           ISHFT(IAND(MACIO( 2), 63),  6) +
     2                  IAND(MACIO( 3), 63)
C               CHECK THE WORD SIZE FOR SIGN BIT PROPAGATION.
C
        IF (KWRDSZ.LE.16) GO TO 9999
C
        IF (IVLVAL.LE.32767) GO TO 9999
C               THE WORD SIZE IS LARGER THAN 16 BITS -- PROPAGATE THE
C               SIGN
C
                IVLVAL = IVLVAL - 32767
                IVLVAL = IVLVAL - 32767
                IVLVAL = IVLVAL - 2
C
 9999   RETURN
        END
C
        SUBROUTINE MWSTAB( ITABLE, INDEX, IVALUE)
C
C                       COMMON.
C               LINE PATTERN TABLE.
        COMMON /M72LTB/ LNPTTB(16)
C
C               MARKER TABLE.
        COMMON /M72MTB/ MARKTB(16)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
        CALL MIERST( 3020)
C
C               CHECK, IS THE TABLE REQUESTED CORRECT?
C
        CALL MEGSTD(2, ITABLE, ITAB)
C
C               CHECK THE INDEX VALUE.
C
        IF (INDEX.GE.1.AND.INDEX.LE.16) GO TO 10
C
C               ERROR -- THE INDEX IS OUT OF RANGE
C
                        CALL MIERR (54)
                        GO TO 9999
C
C               LINE PATTERN OR MARKER
C
 10     CALL MIGATT(ITAB, IVAL, ITINDX)
        IF (ITINDX.EQ.ISYMPA) LNPTTB(INDEX) = IVALUE
        IF (ITINDX.EQ.ISYMMA) MARKTB(INDEX) = IVALUE
C
 9999   RETURN
        END
C
        SUBROUTINE MWTERM
C
C                       COMMON.
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C               COMPUTER DEPENDENT ELEMENTS
        COMMON /M72CDV/ KTERM, KUCASE, KLCASE, KSUBCH, KSUPCH, KWRTFL
        COMMON /M72CDV/ KRDFL, KOUTFL, KINFL, KWRDSZ, KBYTEL, KCPW
        COMMON /M72CDV/ KSHFTC, KBLKPD, KFILL, KDEL
C
C
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
        CALL MIERST( 1010)
C
C               CHECK FOR A OPEN SEGMENT OR SUBROUTINE.
C
C
        CALL MIGVAL(ISYMSE, ICSEG)
        CALL MIGVAL(ISYMSU, ICSUB)
        IF (ICSEG.NE.0.OR.ICSUB.NE.0) CALL MWCLOS
C
C               SET UP THE TERMINATE COMMAND.
C
        MACIO( 1) = 31
C
        CALL MIOUT( 1, 0, 1)
C
C               FLUSH THE BUFFER.
C
        CALL MEGWCF(KOUTFL, 0, MACIO)
C
C               RELEASE THE COMMUNICATIONS FILES.
C
        CALL MEGCCF(KINFL)
        CALL MEGCCF(KOUTFL)
C
        RETURN
C
        END
C
C
        SUBROUTINE MWGTER
C
            CALL MWTERM
C
        RETURN
        END
        SUBROUTINE MWTEXT(ISTRNG)
C
C       INPUT PARAMETERS:
C       =================
C               ISTRNG - CHARACTER STRING TO BE OUTPUT. ISTRNG MAY BE
C                        UP TO 132 CHARACTERS LONG, AND MUST BE
C                        TERMINATED BY THE 'KTERM' TERMINATOR CHARACTER.
C
                INTEGER ISTRNG(1)
C
C       COMMON PARAMETERS:
C       =================
C
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               COMPUTER DEPENDENT ELEMENTS
        COMMON /M72CDV/ KTERM, KUCASE, KLCASE, KSUBCH, KSUPCH, KWRTFL
        COMMON /M72CDV/ KRDFL, KOUTFL, KINFL, KWRDSZ, KBYTEL, KCPW
        COMMON /M72CDV/ KSHFTC, KBLKPD, KFILL, KDEL
C
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C       LOCAL VARIABLES:
C       ================
C               MAXCHR - MAXIMUM LENGTH OF 'ISTRNG' IN CHARACTERS.
C               WORD   - CURRENT WORD OF 'ISTRNG' BEING FORMATTED.
C               CHAR   - CONTENTS OF CURRENT WORD BEING FORMATTED.
C               ICHAR  - BUFFER TO HOLD CURRENT CHARACTER.
C               NCHARS - CURRENT NUMBER OF CHARACTERS IN OUTPUT BUFFER.
C               SIZE   - CURRENT CHARACTER SIZE.
C               ANGLE  - CURRENT CHARACTER ANGLE.
C               INDEX  - INDEXS CHARACTER PROCESSING LOOP
C
                INTEGER MAXCHR,WORD,NCHARS,SIZE,ANGLE,INDEX
                INTEGER CHAR
C
C-----------------------------------------------------------------------
C
C       STACK ROUTINE ID FOR ERROR TRACEBACK.
C
        CALL MIERST(4210)
C
C       GET CURRENT VALUES OF CHAR_SIZE AND CHAR_ANGLE.
C
        CALL MIGVAL(ISYMCS, SIZE)
        CALL MIGVAL(ISYMCA, ANGLE)
C
C       INITIATE TEXT MODE BY SENDING OP_CODE, CHAR_SIZE, CHAR_ANGLE.
C
        MACIO(1)= 88
        MACIO(2)= IAND((SIZE - 1), 7) + 64
        MACIO(3)= IAND(ANGLE, 3) + 64
C
C       OUTPUT THE CHARACTER STRING. UP TO MAXCHR CHARACTERS ARE OUTPUT
C       ONE TIME OR UNTIL THE STRING TERMINATOR IS FOUND.
        MAXCHR = 132
        WORD=0
C
        NCHARS=3
C
C       BEGIN_DO:  INDEX INDEX BY KCPW FROM 1 UNTIL INDEX > MAXCHR
                                        DO 200 INDEX=1,MAXCHR,KCPW
C
            WORD=WORD+1
            CHAR=ISTRNG(WORD)
C
C           BEGIN_DO:  INDEX IPOS BY 1 FROM 1 UNTIL J > KCPW
                                                DO 100 IPOS = 1, KCPW
                NCHARS = NCHARS + 1
C
C               CALL THE UNPACK ROUTINE
                CALL MEG1CH(IPOS, CHAR, ICHAR)
C
C               CHECK, IS IT A TERMINATOR CHARACTER?
                IF(ICHAR .EQ. KTERM)                    GO TO 20
                                                        GO TO 40
C               THEN:
C                   IT'S A TERMINATOR.
20                  MACIO(NCHARS) = 29
                    GO TO 500
C               ENDIF:
C               CALL THE CPU INTERNAL TO ASCII ROUTINE.
C
40              CALL MEGCVT(ICHAR, MACIO(NCHARS))
C
C               CHECK, IS IT A VALID ASCII CHARACTR (32 - 126).
C
                IF(MACIO(NCHARS) .LT. 32 .OR.
     1             MACIO(NCHARS) .GT. 126)              GO TO 60
                                                        GO TO 100
C               THEN:
C                   IT'S NOT A VALID CHARACTER - IGNORE IT.
60                  NCHARS = NCHARS - 1
C               ENDIF:
100                                                     CONTINUE
C
C           END_DO:
C
200                                                     CONTINUE
C       END_DO:
C
C               UNTERMINATED TEXT STRING,
C               TERMINATE IT AND CALL THE ERROR ROUTINE.
C
                MACIO(NCHARS+1) = 29
                CALL MIOUT(NCHARS+1, 1, 1)
                CALL MISVAL(ISYMCM, 0)
                CALL MIERR(68)
                GOTO 1000
C
 500    CONTINUE
C       OUTPUT REMAINING CHARACTERS.
C
        CALL MIOUT(NCHARS,1,1)
        CALL MISVAL(ISYMCM, 0)
C
1000    RETURN
        END
C
        SUBROUTINE MWVLLM(IPERID,IVLNUM,IVLMIN,IVLMAX,IVLGAN,IVLCUR)
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               PERIPHERAL INFORMATION STORAGE.
        COMMON /M72PER/ IPTYP(11), IPPSG(30, 5), IVALSW( 8),
     1                  IKYID, IJYID, ITBID, IPKID, IFPID, IFBID,
     2                  IVLID, IBTID, SCALE( 6), ITABIN( 2),IBITRS
C
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
C
        CALL MIERST( 7080)
C
C               CHECK FOR CORRECT PERIPHERAL ID.
C
        IF (IPERID.EQ.IVLID) GO TO 10
C
C               ERROR -- NOT A VALUATOR
C
                        CALL MIERR (11)
                        GO TO 9999
C
C               CHECK IF A CORRECT DIAL NUMBER
C
 10     IF (IVLNUM.GE.1.AND.IVLNUM.LE.8) GO TO 20
C
C               ERROR -- THE DIAL NUMBER IS OUT OF RANGE
C
                        CALL MIERR (15)
                        GO TO 9999
C
C               CHECK THE MAXIMUM AND MINIMUM VALUATOR VALUES
C
 20     IF (IVLMIN.LE.IVLMAX) GO TO 30
C
C               ERROR -- THE MIN IS > THE MAX
C
                        CALL MIERR (70)
                        GO TO 9999
C
C               CREATE AND TRANSMIT THE COMMANDS.
C
 30     MACIO( 1) = 55
        MACIO( 2) =  5
        MACIO( 3) = IAND((IVLNUM - 1), 7)
        MACIO( 4) = IAND(ISHFT(IVLMIN, -12), 15)
        MACIO( 5) = IAND(ISHFT(IVLMIN, - 6), 63)
        MACIO( 6) = IAND(      IVLMIN,       63)
        MACIO( 7) = IAND(ISHFT(IVLMAX, -12), 15)
        MACIO( 8) = IAND(ISHFT(IVLMAX, - 6), 63)
        MACIO( 9) = IAND(      IVLMAX,       63)
        MACIO(10) = IAND(ISHFT(IVLGAN, -12), 15)
        MACIO(11) = IAND(ISHFT(IVLGAN, - 6), 63)
        MACIO(12) = IAND(      IVLGAN,       63)
        MACIO(13) = IAND(ISHFT(IVLCUR, -12), 15)
        MACIO(14) = IAND(ISHFT(IVLCUR, - 6), 63)
        MACIO(15) = IAND(      IVLCUR,       63)
C
C               TRANSMIT.
C
        CALL MIOUT(15, 0, 0)
C
 9999   RETURN
        END
C
        SUBROUTINE MWVLTH( IPERID, IVLNUM, IVLTHR)
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
        CALL MIERST( 7100)
C
C                       THIS ROUTINE IS NOT SUPPORTED BY 7232.
C
        CALL MIERR(99)
C
        RETURN
C
        END
C
        SUBROUTINE MWWAIT( IWATIM)
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
        CALL MIERST( 1140)
C
C               EDIT THE WAIT TIME PARAMETER, CAN'T BE LESS THEN 1.
C
        IF(IWATIM .GE. 1)                               GO TO 100
                                                        GO TO 200
C       THEN:
100         CALL MISATT( 2HWT, IWATIM)
C       ENDIF:
C
200     RETURN
        END
C
        SUBROUTINE MWXTND( IGRTYP, IGRNAM)
C
C                       COMMON.
C               INTERNAL I/O DATA STORAGE, TEMPORARY DATA ONLY.
        COMMON /M72DST/ MACIO(256)
C
C               ATTRIBUTE, MODE, AND VARIABLE NAME INDEXES.
        COMMON /M72NME/ ISYMDE, ISYMVI, ISYMLI, ISYMHI, ISYMAP, ISYMPA,
     1                  ISYMBL, ISYMEC, ISYMSI, ISYMCS, ISYMCA, ISYMCO,
     2                  ISYMMA, ISYMMS, ISYMMO, ISYMHE, ISYMDS, ISYMSD,
     3                  ISYMDA, ISYMOB, ISYMCF, ISYMWT, ISYMCM, ISYMSE,
     4                  ISYMSU, ISYMIX, ISYMIY, ISYMIZ, ISYMBP, ISYMWP
C
C               ROUTINE IDENTIFIER STACKING FOR TRACEBACK.
C
        CALL MIERST( 2050)
C
C               EDIT THE INCOMING PARAMETERS FOR VALIDITY.
C
        CALL MEGSTD( 2, IGRTYP, IGRTP)
        CALL MIGATT( IGRTP, ICSESU, ISSINX)
        INDX = ISSINX - ISYMSE
        IF (INDX.EQ.0.OR.INDX.EQ.1) GO TO 10
C
C               ERROR -- IGRTYP NOT 'SE' OR 'SU'
C
                        CALL MIERR (32)
                        GO TO 9999
C
C               CHECK FOR IGRNAM IN CORRECT RANGE
C
 10     IF (IGRNAM.GE.1.AND.IGRNAM.LE.4095) GO TO 20
C
C               ERROR -- IGRNAM OUT OF RANGE 1 TO 4095
C
                        CALL MIERR (9)
                        GO TO 9999
C
C               CHECK IF SEGMENT/SUBROUTINE EXISTS
C
 20     CALL MISSM (IGRNAM,INDX,0,IERROR)
        IF (IERROR.EQ.1) GO TO 9999
C
C               CHECK, IS A SEGMENT OR SUBROUTINE OPEN?  IF SO CLOSE IT.
C
        CALL MIGVAL (ISYMSE,ICSEG)
        CALL MIGVAL (ISYMSU,ICSUB)
        IF (ICSEG.NE.0.OR.ICSUB.NE.0) CALL MWCLOS
C
C               CREATE THE COMMAND
C
        MACIO(1) = 1
        IF (INDX.EQ.1) MACIO(1) = 33
        MACIO(2) = IAND(ISHFT(IGRNAM, -6), 63)
        MACIO(3) = IAND(IGRNAM, 63)
        CALL MIOUT (3,0,0)
C
C               UPDATE THE CURRENT SUBROUTINE OR SEGMENT NAME
C
        CALL MISVAL (ISSINX,IGRNAM)
C
 9999   RETURN
        END
